<?php
/**
 * LocalSettings_Appearance.php
 *
 * This file is intended to group all constants to
 * make it easier for the site administrator to change the script, and manage all sensitive information
 */
 
/********* Setting up these web pages
To set up an information only website you need to :

* In the "public_html" directory, unzip the TFR installation
* In a browser, load cr_install.php
** eg: http://localhost/engenic_app_root/administration/cr_install.php
* Follow the steps
* Once fully installed, remove the administration account
* Finally, edit .htaccess and put it to the root
---
DirectoryIndex relay_index.php index.php index.html index.htm
IndexIgnore * 
---
**********/
 
// Constants
$cSysName			= 'teleflow-access';
// Set copyright notice (This software is copyright engenic)
$webCopyright		= 'Copyright &copy; '.date("Y").' engenic';

$webMetaDescription	= "Voice and Web solutions powered by TeleFlow";
//$webMetaDescription  = "Empower: Voice and Web solutions powered by TeleFlow";
$webMetaKeywords	= "IVR, CTI, Virtual PBX, Telephony, Hosted, Medical, Business Solutions, Assistance";


// Will return full path:  eg:  /file:/C:/company/workspace/engenic_app_root/MedicalRelay/mr_why.php
$appSysUri			= rtrim($_SERVER['PHP_SELF'], "/\\");
// Find determine the IP location for the system
if (isset($_SERVER['HTTP_HOST']))
{
	// We have a webname
	$appSysHost			= $_SERVER['HTTP_HOST'];
	// Determine if we are running in HTTP or CMD
	define("HTTP_MODE", true);  
}
else
{
	// In CMD mode
	define("HTTP_MODE", false);  
}

// Logo at top of page (see CSS for details)
$webLogoWidth		= 274;
$webLogoHeight		= 57;

///////////////
// SYSTEM OPERATING MODE
///////////////
// LIVE mode used by clients
define("MODE_LIVE",  	1);  
// TEST mode used by clients to test live mode
define("MODE_TEST",  	2);  
// DEMO mode used by us to hopefully get new clients
define("MODE_DEMO",  	3);  
// OFFLINE for maintenance etc.  When set, the page will not show login
// - Note: When in off line mode, browser refresh will happen every 2 minutes 
define("MODE_OFFLINE",  4);  
$cGlobalMode 			= MODE_LIVE; // MODE_OFFLINE; //MODE_LIVE; //TEST = charon; //DEMO = halley;
$cGlobalMessage 		= '';

define("DEMONSTRATION_DATA",  $cGlobalMode);  // DEMO mode to mangle data a little

///////////////
// DEBUG MODE
///////////////
// - Used to not force HTTPS, and other directs 
$cGlobalDebug = TRUE;

///////////////
// Database location
///////////////
define("DATABASE_LOCAL",	"YES");

///////////////
// HTTPS  MODE?
///////////////
$cGlobalSecure = !$cGlobalDebug;  // change TRUE or FALSE above

///////////////
// Marketing Mode
///////////////
// Define the system we want to display
define("SYSTEM_DEMO",   			"YES");


///////////////
// Front Door security
///////////////
// Section will test for login attempts from the IP address
define("LOGINLOCKATTEMPTS", 		3);
define("LOGINLOCKINRANGEMINS", 		5);
define("LOGINLOCKTESTMETHOD", 		2); // 0 = No test; 1 = IP addess (recommended for wide access); 2 = Session_Id (recommended for internal solutions)
define("LOGINLOCKOUTMETHOD", 		1); // 1 = Wait LoginLockOutMins;  2 = Permanent / wait for Admin
define("LOGINLOCKOUTMINS", 			120);
// Automatic timeouts 
define("LOGINSESSIONMAXSECONDS",	28800); // Force a logout after x seconds:  Should be an amount of 3600 or more
define("LOGINSESSIONHTTPTIMEOUT", 	14400); // Force a page refresh after x seconds.  Use -1 to prevent this check from occuring (see Header.php)
// Enforce system wide access only to list of IP addresses as follows?
define("LOGINACCESSLIMITEDTOIP", 	true); // True will limit to the list below, and local ips only

// Other display elements
// -- Include marketing details?
define("LOGINPAGEMARKETING", 		false); // Setting the value to true will show marketing details


// Application Log Files
// -- Errors, General writes etc
define("SYSTEM_LOGFILES",			'cr_log_files/');
define("SYSTEM_TEMPFILES",			'cr_temporary_files/');
// Sub systems
define("SYSTEM_SR_ASSISTANT",		false);
define("SYSTEM_FILESECTION",		true);
define("SYSTEM_INSTALLCODES",		'bc,mr,sr');  // Two letter system codes (only bc is included in demo)
// Allow self sign up by users?
define("SYSTEM_USERSELFSIGNUP",		false);
// Setting the value to true will enable users to create their own client (this will create a new database for the client)
define("SYSTEM_CLIENTSELFREGISTER",	true); 
// Will Admin Invite user send an email? (normally true - if false, the admin will need to manually send links)
define("SYSTEM_INVITEUSEREMAIL",	false); 
// Minimum password size
define("SYSTEM_PASSWORDMINLENGTH",	6); // Mandetory definition
define("SYSTEM_PAYCLIENTS",			true); // Website includes option pay clients

// eg: if ((defined("SYSTEM_PAYCLIENTS")) && (SYSTEM_PAYCLIENTS == true))


// STOP access for all but the following IP addresses  (note: Local IP ranges are allowed access as programmed in session.php)
// -- For automatic assignation of Clients by IP address or range, see client_ip_access
$cLocationAccess   					 = ''; 


/////////////////////////
// PATHS for user files 
// -- Note: Relative to cr_main
/////////////////////////
// User created and managed content
define("CLIENT_FILE_AREA",      	"cr_client_documents");
define("CLIENT_MEDIA_AREA",     	"cr_client_media");

/////////////////////////
// TeleFlow Server 
// -- Note: This will only apply to installations for a TeleFlow Server
/////////////////////////
define("TELEFLOW_WINDOWS_INSTALL",	false);
// TeleFlow Servers create relative to TFR root.  eg: c:\TeleFlowRelay\cr_client_media
// -- Note: This is the ONLY path that should exist... until TeleFlow Server is given a DocumentRootMedia mechanism
define("TELEFLOW_CLIENT_MEDIA_AREA","c:\TeleFlowRelay\Media");
// Media management
// -- How long should media files be allowed to remain on the TeleFlow Server computer for?
define("TELEFLOW_CLIENT_MEDIA_MAXDAYS",	10);
// -- Media file names extension
define("FTPXFEREXT",				'.wa1');
define("FTPWAVEXT",					'.wav');


// Default server info
define("HOME_AREA_CODE",    		"604");
define("HOME_UTC_OFFSET",   		"-8");


// for callout systems, deterine what the call out ranges should be
// - Note: Must be 24 hr format
define("CALLOUT_MIN_WEEK",  "09:30:00");
define("CALLOUT_MAX_WEEK",  "20:30:00");
define("CALLOUT_MIN_SAT",   "11:30:00");
define("CALLOUT_MAX_SAT",   "17:30:00");
define("CALLOUT_MIN_SUN",   "11:30:00");
define("CALLOUT_MAX_SUN",   "17:00:00");


// General web information
$providerFederalTaxYN		= true;
$providerFederalTaxName		= "GST";
$providerFederalTaxNumber	= "213141515";
$providerFederalTaxRate		= 5.0;
$providerStateTaxYN			= true;
$providerStateTaxName		= "PST";
$providerStateTaxNumber		= "8745674";
$providerStateTaxRate		= 7.0;

// Phrases and messages
define("VEXT_CODE",			'VExt');


// Keys provided by twitter for the twitter interface service (removed for demo... you will have to get your own)
// -- Similar for facebook and other social networking sites
define("CONSUMER_KEY",		"xxxxx");
define("CONSUMER_SECRET",	"xxxxx"); 


// Default General Information (this is generally found in cr_reference.php)
if (defined("SYSTEM_DEMO")) 
{
	$appCompanySvcCode   = "TeleFlowRelay";  // (MUST BE 4 Chars) Used to link the application to the service 
	$appMarketingName    = "TeleFlowRelay";
	$webLogo             = "images/tr-logo.jpg"; // "images/vconx-logo.jpg"; //
	$webCSS              = "include/medicalrelay.css";
	$webCSSMenuGraphic   = "images/mr_tb_span.gif"; // Wrapper graphic for menu option (see the CSS for other information)
	$webTitleOverride    = "TeleFlowRelay Solutions";
	$webTagLine          = "Medical Appointment Reminders, Dictation & Patient Communications";
	$webInfoSite         = "mr_infoweb/";
	$webAdminSite        = "eng_medicalrelay/";
	$webTopMenuPage		 = "mr_topmenu.php";
	$webMainPage         = $webInfoSite."mr_index.php";
	$webSignUpPage       = $webAdminSite."mr_signup_step1.php";
	$websiteName         = "TeleFlowRelay";
	$webTelephone        = '1.888.XXX.XXXX';
	$webTelephone800     = '1.888.XXX.XXXX';    // Same as webTelephone if not available
	$webMailTo           = 'sales@nowhere.com';
	$webMailToSupport    = 'support@nowhere.com';
	$webMailToCancel     = 'cancel@nowhere.com'; 
	$webClickTo          = 'http://nowhere.com';
	$webOnlineDoc        = 'http://nowhere.com';
	$webEmailSubject     = 'TeleFlowRelay Question';   	
}


/////////// TELEFLOWRELAY - Override ////////////
if (defined("SYSTEM_TR"))
{
	$appCompanySvcCode  = "TeleFlowRelay";  // Used to link the application to the service. See: tfr_db->client.client_name
	$appMarketingName   = "TeleFlowRelay";
	$webLogo            = "images/tr-logo.jpg";
	$webCSS             = "include/teleflowrelay.css";
	$webCSSMenuGraphic  = "images/tr_tb_span.gif"; // Wrapper graphic for menu option (see the CSS for other information)
	$webTitleOverride   = "TeleFlowRelay Solutions";
	$webTagLine         = "TeleFlow Communications Solutions";
	$webInfoSite        = "tr_infoweb/";
	$webTopMenuPage		= "tr_topmenu.php";
	$webMainPage        = $webInfoSite."tr_index.php";
	$websiteName        = "TeleFlowRelay";
	$webTelephone       = '604.639.6391';
	$webTelephone800    = $webTelephone;    // Same as webTelephone if not available
	$webMailTo          = 'sales@engenic.com';
	$webMailToSupport   = 'support@engenic.com';
	$webMailToCancel    = 'cancel@engenic.com'; 
	$webClickTo         = 'http://teleflowrelay.com';
	$webOnlineDoc       = 'http://teleflowrelay.com';
	$webEmailSubject    = 'TeleFlowRelay Question';   
}
/////////// BARCODE ////////////
else if (defined("SYSTEM_BC"))
{
	$appCompanySvcCode	= "UPC1";  // Used to link the application to the service. See: tfr_db->client.client_name
	$appMarketingName	= "UPC-Cheap-Barcode";
	$webLogo   			= "images/bc-logo.jpg";
	$webLogoWidth 		= 460;
	$webLogoHeight 		= 65;
	$webCSS             = "include/upcbarcode.css";
	$webCSSMenuGraphic  = "images/bc_tb_span.gif"; // Wrapper graphic for menu option (see the CSS for other information)
	$webTitleOverride   = "UPC-Cheap-Barcode - Inexpensive UPC UUC Barcodes and Free Graphics for Amazon eBay etc UCC";
	$webTagLine         = "Barcodes for eBay and Amazon";
	$webInfoSite        = "bc_infoweb/";
	$webTopMenuPage		= "bc_topmenu.php";
	$webMainPage        = "bc_index.php"; // $webInfoSite.
	$websiteName        = "UPC-Cheap-Barcode";
	$webTelephone       = '604-555-1234 x501';
	$webTelephone800    = $webTelephone;    // Same as webTelephone if not available
	$webMailTo          = 'todd@nowhere.ca';
	$webMailToSupport   = 'support@nowhere.com';
	$webMailToCancel    = 'cancel@nowhere.com'; 
	$webClickTo         = 'http://cheap-upc-barcode.com';
	$webOnlineDoc       = 'http://cheap-upc-barcode.com';
	$webEmailSubject    = 'Barcode Question';   
}


////// LINKED PAGES //////
// If  we are in web mode, then determine other pages
if (HTTP_MODE)
{
	// Create the definition for the activation page 
	$thisWebPage = basename($_SERVER['REQUEST_URI']);  // gets the filename (eg: cr_main.php)

	if (strpos($thisWebPage, "?") !== false) 
	{
		$thisWebPage = reset(explode("?", $thisWebPage));
	}
	// eg: 192.168.3.55/engenic_app_root/test/
	$serverRootPath = str_replace($thisWebPage, '', $_SERVER['SERVER_NAME'].$_SERVER['PHP_SELF']);

	// Determine the locations for user access programs
	// NOTE: Windows IIS requires that referencing the current directory must not be a blank.  It must be ./
	$mAdjust = '/';
	if (isset($incPath) && ($incPath <> './'))
	{
		$mAdjust = $incPath;
	}
	// We are running code up in a folder by one level
	$activatePage 		= 'http://'.$serverRootPath. $mAdjust. 'cr_activate.php';
	$invitePage			= 'http://'.$serverRootPath. $mAdjust. 'cr_invite.php';
	$setPassPage		= 'http://'.$serverRootPath. $mAdjust. 'cr_setpassword.php';
	$logoutPage			= 'http://'.$serverRootPath. $mAdjust. 'cr_process.php';

	// Links to standard pages
	$appDocTermsService 	= $incPath.'marketing/system_termsofservice.php';
	$appDocPrivacyPolicy 	= $incPath.'marketing/system_privacypolicy.php';
	$appDocPricing			= '';
}
else
{
	$activatePage 		= '';
	$invitePage			= '';
	$setPassPage		= '';
	$logoutPage			= '';
}


////////// Master Email Server - Fill in if you are going to invite or validate users by email
define("EMAIL_SMTP",      		"mail.nowhere.com");	// BLANK OUT FOR TEST MODE
define("EMAIL_PORT",      		25);
define("EMAIL_TESTMODE",        "TEST"); // Undefine this to email LIVE
define("EMAIL_STMP_USER", 		"noreply+nowhere.com");
define("EMAIL_STMP_PASS", 		"xxxxx");
define("EMAIL_FROM_NAME", 		"No Reply");
define("EMAIL_FROM_ADDR", 		"noreply@nowhere.com");
define("EMAIL_ADMIN_ADDR", 		"vbaker@nowhere.com"); // System administor or group.  Used for occasional system tests

define("EMAIL_WEBACTIVATE",     $activatePage);
define("EMAIL_WEBINVITE",       $invitePage);
define("EMAIL_WEBSETPASS",      $setPassPage);
define("EMAIL_WEBCLICKTO",   	$webClickTo);
define("EMAIL_MARKETINGNAME",   $appMarketingName);
define("EMAIL_WEBTELEPHONE",	$webTelephone800);
define("EMAIL_WEBTAGLINE",		$webTagLine);


////// SUPPORT PAGES //////
$cTeleFlowHelpKB	= 'http://teleflow.org/wiki/index.php';
$cTeleFlowStepsXML	= 'tf_steps_eng.xml';
$cAccessCommand		= '/Monitor?Request=SEND_UPDATE';

////// Words, Phrases & Languages //////
include("LocalSettings_Language.php");
?>
