<?php
/**
 * LocalSettings_EmailTemplates.php
 *
 * This file is used to create the email template for email communications with the system to its users
 * make it easier for the site administrator to change the script, and manage all sensitive information
 */

/* IMPORANT
This emailer uses SwiftEmailer to send with.  It means you can send HTML
*/
 
// User has signed up for the sites Primary Service
function CreateEmailBody_UserRegistration($pNameFirst, $pNameLast, $pURL, &$pEmailTitle)
{
	// Title
	$pEmailTitle = EMAIL_MARKETINGNAME." Account Confirmation";

	// TXT version
	$msg = 'Dear '.$pNameFirst.',<br /><br />
Thank you for signing up with '.EMAIL_MARKETINGNAME.'. In order to validate your account, please click here: <br />
<a href="'.$pURL.'">'.$pURL.'</a><br /><br />
Note: You may need to copy and paste this URL into the address bar of your web browser.<br /><br />
Warning: You must confirm this account within 24 hours, or the sign up will expire.<br /><br />'.
EMAIL_MARKETINGNAME.'<br />'.
EMAIL_WEBCLICKTO.'<br />'.
EMAIL_WEBTELEPHONE.'<br />'.
'"'.EMAIL_WEBTAGLINE.'"<br />';

	return $msg;
} // CreateEmailBody_UserRegistration
  
  
  
// User has been invited to service by a Company Administrator
function CreateEmailBody_UserInvitation($pNameFirst, $pNameLast, $pURL, &$pEmailTitle)
{
	$pEmailTitle = EMAIL_MARKETINGNAME." Invitation to Join";

	// TXT version
	//$message = new Swift_Message("Join Now!", "You need to click on this link to join.  ((link))");
	// HTML version	
	$msg = 'Dear '.$pNameFirst.',<br /><br />
A group administrator has sent you an invitation to join '.EMAIL_MARKETINGNAME.'. To accept this invitation, 
you need to activate this account and choose your password.  To do this, please click here: <br />
<a href="'.$pURL.'">'.$pURL.'</a><br /><br />
Note: You may need to copy and paste this URL into the address bar of your web browser.<br /><br />'.
EMAIL_MARKETINGNAME.'<br />'.
EMAIL_WEBCLICKTO.'<br />'.
EMAIL_WEBTELEPHONE.'<br />'.
'"'.EMAIL_WEBTAGLINE.'"<br />';

	return $msg;
} // CreateEmailBody_UserInvitation
  
  

// User Requested Password Reset
function CreateEmailBody_UserPasswordReset($pNameFirst, $pNameLast, $pURL, &$pEmailTitle)
{
	$pEmailTitle = EMAIL_MARKETINGNAME." Account Password Reset";

	// TXT version
	//$message = new Swift_Message("Join Now!", "You need to click on this link to join.  ((link))");
	// HTML version	
	$msg = 'Dear '.$pNameFirst.',<br /><br />
You have requested a password reset for '.EMAIL_MARKETINGNAME.'. In order to confirm your intention to reset the 
password for this account, please click here: <br />
<a href="'.$pURL.'">'.$pURL.'</a><br /><br />
Note: You may need to copy and paste this URL into the address bar of your web browser.<br /><br />
If you did not request a password reset, ignor this message. <br /><br />'.
EMAIL_MARKETINGNAME.'<br />'.
EMAIL_WEBCLICKTO.'<br />'.
EMAIL_WEBTELEPHONE.'<br />'.
'"'.EMAIL_WEBTAGLINE.'"<br />';

	return $msg;
} // CreateEmailBody_UserPasswordReset
  
