<?php
// Assume an XML document, and process...
$doc = new DOMDocument();

// Create the Result XML document
$domobject = new DOMDocument('1.0', 'utf-8');
// Wrap the request
$elementHolder  = $domobject->createElement("Response", "");
 //$request_Command); 
// Default 

function validate($xml)
{
    libxml_use_internal_errors(true);

    $doc = new DOMDocument('1.0', 'utf-8');
    $doc->loadXML($xml);

    $errors = libxml_get_errors();
    if (empty($errors))
    {
        return true;
    }

    $error = $errors[0];
    if ($error->level < 3)
    {
        return true;
    }

    return true;
} // validate


$error   = 'ERROR';
$success = 'SUCCESS';
// Types --
$db      = 'DB';
$cmd     = 'CMD';

$request_Command = '';

// Did the user actually send a request?
$fatalFailure = 0; 

if ($data <> '')
{
	if(!validate($data))
	{		
		$responsecode = "Invalid XML";	
		$elementFailure  = $domobject->createElement("FAILURE");	
		$elementFailure->appendChild($domobject->createTextNode($responsecode));			
		$elementHolder->appendChild($elementFailure);	
		
		$request_Command = "";
		$fatalFailure = 1; 
	}	
	else
	{	
		$doc->loadXML($data);
		// XML Command request
		// -- Find out what the command is (Must be a REQUEST)
		$theFile = $doc->getElementsByTagName('REQUEST')->item(0);

		if ($theFile->hasAttribute('action'))
		{
			$request_Command  	= GetSQLSafeValues(GetNonEmptyValue($theFile->getAttribute('action'), ''));
			$clientNo 			= GetSQLSafeValues(GetNonEmptyValue($theFile->getAttribute('client_id'), -1)); 
			
			$db_selected  = $database->selectClientDatabaseByMasterClientId($clientNo);// select the right client database. 			
		}
	}
}
$dbResponse = "SUCCESS";


// Review the requested Command
if ($request_Command <> "") 
{  	
		/* GetSuperMenu example:
		<REQUEST action="GetSuperMenu" client_id="11" level="1"></REQUEST>

		<Response action="GetSuperMenu" level="1" Response_code="SUCCESS" Item_Timeout="1" Final_Timeout="2500" Menu_Loop="1" Error_Loop="3" 
		Menu_Type="Option">
			<Menu_Item count="1" type_in="C" get_back="Cabs" connect=""></Menu_Item>
			<Menu_Item count="2" type_in="P" get_back="Pizza" connect=""></Menu_Item>
			<Menu_Item count="3" type_in="T" get_back="Twityax" connect="TF_App"></Menu_Item>
		</Response>
	*/	
	if ($request_Command == "GetSuperMenu")//First Request
	/////////////////////////////////////////////////////////
	{		
		$elementHolder->setAttribute("action", "$request_Command");			
		$error = 0;
		
		//should have level
		if($theFile->hasAttribute('level'))
		{ 							
			$superMenuLevel = GetSQLSafeValues(GetNonEmptyValue($theFile->getAttribute('level'), ''));		
			//@@@should be a play_code somewhere. 			
			$dbQuery= 
"SELECT
	Item_Timeout,
	Final_Timeout,
	Menu_Loop,
	Menu_Type,
	Play_Code,
	Error_Loop	
FROM
	menu_level
WHERE
	Level = '$superMenuLevel'";
			
			$Info = mysql_query($dbQuery, $database->connectionClient) or $dbResponse = "FAILURE";			
			
			$elementHolder->setAttribute("action", $request_Command); 			
			$elementHolder->setAttribute("level",$superMenuLevel);
			
			if($dbResponse <> "FAILURE")
			{
				$rowArray = mysql_fetch_assoc($Info);
				$superMenuLevelQuery = "";
				
				if (($superMenuLevel >= 2) && ($theFile->hasAttribute('limit')))
				{
					$superMenuLimit 		= GetSQLSafeValues(GetNonEmptyValue($theFile->getAttribute('limit'), ''));
					$superMenuLevelQuery 	= "AND Menu_Limit = '$superMenuLimit'";
				}			
				
				$dbQuery= "
SELECT
	TypeIn,
	GetBack,
	Connect
FROM
	menu_details 
WHERE
	Level = '$superMenuLevel' " . $superMenuLevelQuery;
				
				$Info = mysql_query($dbQuery, $database->connectionClient) or $dbResponse = "FAILURE";			
				
				if($dbResponse <> "FAILURE")
				{
					//set all attributes from previous query
					$elementHolder->setAttribute("Response_code",	$dbResponse); 
					$elementHolder->setAttribute("Item_Timeout",	$rowArray['Item_Timeout']);
					$elementHolder->setAttribute("Final_Timeout",	$rowArray['Final_Timeout']);
					$elementHolder->setAttribute("Menu_Loop",		$rowArray['Menu_Loop']);
					$elementHolder->setAttribute("Error_Loop",		$rowArray['Error_Loop']);
					$elementHolder->setAttribute("Menu_Type",		$rowArray['Menu_Type']);
					$elementHolder->setAttribute("Play_Code",		trim($rowArray['Play_Code']));
					
					$counter = 1; 
					//$query = "SELECT media_file FROM menu_code WHERE media_code = ''";
					//$menuCode = mysql_query($query,$database->connectionClient); 
					
					while ($rowResult = mysql_fetch_assoc($Info))
					{								
						$element = $domobject->createElement('Menu_Item');
						$element->setAttribute("count",		$counter); 
											
						$element->setAttribute("type_in",	$rowResult['TypeIn']);
						$element->setAttribute("type_say",	substr($rowResult['TypeIn'],0,1).".wav");
						$element->setAttribute("type_key",	TTLetterDigits($rowResult['TypeIn'][0]));

						$element->setAttribute("get_back",	$rowResult['TypeIn'] . ".wav");
						$element->setAttribute("connect",	$rowResult['Connect']);					
				
						$elementHolder->appendChild($element); 
						$counter++;
					}								
				}				
			}
			else
			{
				$error = "DB Connect Error " .mysql_error() ;
				$elementHolder->setAttribute("Response_code",	$dbResponse);				
				$elementHolder->setAttribute("action", 			$request_Command); 
				$elementHolder->setAttribute("error_msg",		$error); 					
			}											
		}	
		else 
		{
			$dbResponse = "FAILURE";
			$error = "Missing Level Attribute";
			$elementHolder->setAttribute("Response_code",	$dbResponse);				
			$elementHolder->setAttribute("action",			$request_Command); 
			$elementHolder->setAttribute("error_msg", 		$error); 			
		}
	} //GetSuperMenu..		
}
else
{
	if($fatalFailure != 1)
	{
		$dbResponse = "FAILURE";
		$error = "ERROR: No Command Provided";
		$elementHolder->setAttribute("Response_code",		$dbResponse);				
		$elementHolder->setAttribute("action",				$request_Command); 
		$elementHolder->setAttribute("error_msg",			$error); 	
	}
}

// Put it all together
//$elementHolder->appendChild($elementResult);
$domobject->appendChild($elementHolder);
// Save to Log dir .. if there was a request
if ($request_Command <> "") 
{
    // No saving for this app.  Its not creating new info really
    //$domobject->save($resf);
}

?>
