<?php
// Assume an XML document, and process...
$doc = new DOMDocument();

// Create the Result XML document
$domobject = new DOMDocument('1.0', 'utf-8');
// Wrap the request
$elementHolder  = $domobject->createElement("Response", "");
 //$request_Command); 
// Default 

function validate($xml)
{
    libxml_use_internal_errors(true);

    $doc = new DOMDocument('1.0', 'utf-8');
    $doc->loadXML($xml);

    $errors = libxml_get_errors();
    if (empty($errors))
    {
        return true;
    }

    $error = $errors[0];
    if ($error->level < 3)
    {
        return true;
    }

    return true;
} // validate


$error   = 'ERROR';
$success = 'SUCCESS';
// Types --
$db      = 'DB';
$cmd     = 'CMD';

$request_Command = '';

// Did the user actually send a request?
$fatalFailure = 0; 

if ($data <> '')
{
	if(!validate($data))
	{		
		$responsecode = "Invalid XML";	
		$elementFailure  = $domobject->createElement("FAILURE");	
		$elementFailure->appendChild($domobject->createTextNode($responsecode));			
		$elementHolder->appendChild($elementFailure);	
		
		$request_Command = "";
		$fatalFailure = 1; 
	}	
	else
	{	
		$doc->loadXML($data);
		// XML Command request
		// -- Find out what the command is (Must be a REQUEST)
		$theFile = $doc->getElementsByTagName('REQUEST')->item(0);

		if ($theFile->hasAttribute('action'))
		{
			$request_Command	= GetSQLSafeValues(GetNonEmptyValue($theFile->getAttribute('action'),''));
			$clientNo			= GetSQLSafeValues(GetNonEmptyValue($theFile->getAttribute('client_id'),'')); 
			
			$db_selected = $database->selectClientDatabaseByMasterClientId($clientNo);// select the right client database. 			
		}
	}
}
$dbResponse = "SUCCESS";


// Review the requested Command
if ($request_Command <> "") 
{  	
		/* GetSuperMenu example:
		<REQUEST action="GetSuperMenu" client_id="11" level="1"></REQUEST>

		<Response action="GetSuperMenu" level="1" Response_code="SUCCESS" Item_Timeout="1" Final_Timeout="2500" Menu_Loop="1" Error_Loop="3" 
		Menu_Type="Option">
			<Menu_Item count="1" type_in="C" get_back="Cabs" connect=""></Menu_Item>
			<Menu_Item count="2" type_in="P" get_back="Pizza" connect=""></Menu_Item>
			<Menu_Item count="3" type_in="T" get_back="Twityax" connect="TF_App"></Menu_Item>
		</Response>
	*/	
	if ($request_Command == "ConnectUserTo")//First Request
	/////////////////////////////////////////////////////////
	{		
		$elementHolder->setAttribute("action", "$request_Command");			
		$error = 0;
		
		// Do we have what we need?
		if (($theFile->hasAttribute('phone_number')) && 
			($theFile->hasAttribute('selection_code')))
		{ 							
			$connectUserTo_phone_number		= GetSQLSafeValues(GetNonEmptyValue($theFile->getAttribute('phone_number'),''));			
			$connectUserTo_selection_code	= GetSQLSafeValues(GetNonEmptyValue($theFile->getAttribute('selection_code'),''));

			// May or may not exist
			$connectUserTo_u_id								= 0;
			$connectUserTo_connect_to_vendor_id				= 0;
			$connectUserTo_connect_to_vendor_desc			= '';
			$connectUserTo_connect_to_vendor_phone_number	= '';
			
			// If we have the values, get them
			if ($theFile->hasAttribute('u_id'))
			{
				$connectUserTo_u_id						= GetSQLSafeValues(GetNonEmptyValue($theFile->getAttribute('u_id'),-1));		
			}
			if ($theFile->hasAttribute('connect_to_vendor_id'))
			{
				$connectUserTo_connect_to_vendor_id		= GetSQLSafeValues(GetNonEmptyValue($theFile->getAttribute('connect_to_vendor_id'), -1));	
			}
			if ($theFile->hasAttribute('connect_to_vendor_desc'))
			{
				$connectUserTo_connect_to_vendor_desc	= GetSQLSafeValues(GetNonEmptyValue($theFile->getAttribute('connect_to_vendor_desc'),''));
			}
			if ($theFile->hasAttribute('connect_to_vendor_phone_number'))
			{
				$connectUserTo_connect_to_vendor_phone_number	= GetSQLSafeValues(GetNonEmptyValue($theFile->getAttribute('connect_to_vendor_phone_number'),''));
			}
			
			// Insert
			$dbInsert= 
"INSERT INTO user_connect
(
	u_id,
	phone_number,
	selection_code,
	connect_to_vendor_id,
	connect_to_vendor_desc,
	connect_to_vendor_phone_number
)
VALUES
(
	".$connectUserTo_u_id.",
	".$connectUserTo_phone_number.",
	'".$connectUserTo_selection_code."',
	".$connectUserTo_connect_to_vendor_id.",
	'".$connectUserTo_connect_to_vendor_desc."',
	'".$connectUserTo_connect_to_vendor_phone_number."'
)";

			$result = mysql_query($dbInsert, $database->connectionClient) or $dbResponse = "FAILURE";			
			
			// What happened?
			if ($result == FALSE) 
			{
				$responsecode = "Failed to Insert Record";
				$elementHolder->setAttribute("action", $request_Command); 
				$elementHolder->setAttribute("result", $error); 
				$elementHolder->setAttribute("type",   $db); 
				// Add verbose TEST 
				$elementHolder->appendChild($domobject->createTextNode($responsecode));
				// If debug
				if ($OutPutMode)
				{
					$elementHolder->appendChild($domobject->createElement("DEBUG", $qInsert));			
				}				
			} 
			else
			{
				//  SUCCESSFULLY Inserted log data
				$elementHolder->setAttribute("action", $request_Command); 
				$elementHolder->setAttribute("result", $success); 
				$elementHolder->setAttribute("type",   $db); 
			}
		}	
		else 
		{
			$dbResponse = "FAILURE";
			$error = "Missing Attributes (phone_number,selection_code)";
			$elementHolder->setAttribute("Response_code",	$dbResponse);				
			$elementHolder->setAttribute("action",			$request_Command); 
			$elementHolder->setAttribute("error_msg", 		$error); 			
		}
	} //GetSuperMenu..		
}
else
{
	if($fatalFailure != 1)
	{
		$dbResponse = "FAILURE";
		$error = "ERROR: No Command Provided";
		$elementHolder->setAttribute("Response_code",		$dbResponse);				
		$elementHolder->setAttribute("action",				$request_Command); 
		$elementHolder->setAttribute("error_msg",			$error); 	
	}
}

// Put it all together
//$elementHolder->appendChild($elementResult);
$domobject->appendChild($elementHolder);
// Save to Log dir .. if there was a request
if ($request_Command <> "") 
{
    // No saving for this app.  Its not creating new info really
    //$domobject->save($resf);
}

?>
