<?php
// Will check for the files that need to be found in order to assume the test has completed
// - NOTE: All code must be contained to this file... at least until the system tests to see that the code does exist
require("cr_reference.php");

function output($pLine)
{
	echo($pLine."<br />\n");
}

// Find the local crypt key
function getCryptKey($pFile)
{
	$mKey = '';
	$xml = simplexml_load_file($pFile);

	//echo $xml->getName() . "<br />";
	foreach($xml->children() as $child)
	{
		//echo $child->getName() . ": " . $child . "<br />";
		foreach($child->attributes() as $a => $b) 
		{
			//echo $a,'=',$b,"<br />";
			if (stristr("DataBaseKey",$a))
			{
				$mKeyFile = $b;
				$mKey = $b;
				
				// Load the crypt key
				// Open the Log file
				$mCryptFile = $b;
				// Open or create the index file
				if (File_Exists($mCryptFile))
				{
					$handleIdx  = fopen($mCryptFile, "r");  // Open for Read
					// Load the Key
					$mKey = fgets($handleIdx, 1024*16);
					fclose($handleIdx);
				}				
			}
		}
	}	
	return $mKey;
} // getCryptKey


// NOTE: If you see nothing, it may be because you have PHP set to show no errors
// - find the php.ini files (using phpinfo();)
// - display_errors = On
// Restart Apache / IIS

output('<h2>TeleFlowRelay Install - Start</h2>');
output('SUCCESS: Displaying something to screen');
output('-- Note: This test is not completed until you see: <b>** COMPLETE **</b>');

// Local Settings
$mFile = $incPath."LocalSettings.php";
if (file_exists($mFile))
{
	output('SUCCESS: Found '.$mFile);
}
else
{
	output('ERROR: Cannot find: '.$mFile);
	die;
}

// Local Settings for Database
$mFile = $incPath."../LocalSettings_Database.php";
if (file_exists($mFile))
{
	output('SUCCESS: Found '.$mFile);
}
else
{
	output('ERROR: Cannot find: '.$mFile);
	die;
}


$mFile = $incPath."../LocalSettings_Host.xml";
if (file_exists($mFile))
{
	output('SUCCESS: Found '.$mFile);
	output('TESTING: Crypt key load');
	$cKey=getCryptKey($mFile);
}
else
{
	output('ERROR: Cannot find: '.$mFile);
	die;
}

// Local Settings for Appearance
$mFile = $incPath."../LocalSettings_Appearance.php";
if (file_exists($mFile))
{
	output('SUCCESS: Found '.$mFile);
	// Get the variables now
	include($mFile);
}
else
{
	output('ERROR: Cannot find: '.$mFile);
	die;
}


// Do we have a crypt key?
if ($cKey <> '')
{
	output('SUCCESS: Found crypt key');  // Never display it EVER
	//echo "GOT",$cKey,"<br />"; <---- Dont do this.
}
else
{
	output('ERROR: Crypt key not defined');
	die;
}

// Do we have crypt class
$mFile = 'Crypt/Blowfish.php';
output('TESTING: Finding crypt class: '.$mFile);
output("-- Note: If you see nothing after this note, check:");
output("-- * That 'pear' is installed on the system ");
output("-- * That the 'pear' folder is found in the 'include_path' (defined in php.ini)");
if (require_once($mFile) ) // Crypto class
{
	output('SUCCESS: Found crypt class '.$mFile);
}
else
{
	output('ERROR: Cannot find crypt class: '.$mFile);
	output('-- HOW TO FIX: There is a <b>pear.zip</b> file included in the package.  Unzip that into your PHP home directory.');
	output('-- After installing, you will see <b>c:\...\php\PEAR\Crypt\Blowfish.php</b> for example.');
	die;
}

// Attempt to create folders (start with log file as this is important)
if ((is_dir('../'.SYSTEM_LOGFILES)) || (mkdir('../'.SYSTEM_LOGFILES)))
{
	output('SUCCESS: Found or created: '.SYSTEM_LOGFILES);
}
else
{
	output('ERROR: Could not create: '.SYSTEM_LOGFILES);
	output('-- You need to create this folder manually or resolve why it didnt create');
}

if ((is_dir('../'.SYSTEM_TEMPFILES)) || (mkdir('../'.SYSTEM_TEMPFILES)))
{
	output('SUCCESS: Found or created: '.SYSTEM_TEMPFILES);
}
else
{
	output('ERROR: Could not create: '.SYSTEM_TEMPFILES);
	output('-- You need to create this folder manually or resolve why it didnt create');
}


// We are done
output("SUCCESS: System Installation Test 1 passed all tests.");
output(' ');
output('<b>** COMPLETE **</b>');
output(' ');
output('The next step is to test database connections. When ready, <a href="cr_install_database.php">click here</a>.');
output('WARNING: Click only once, and wait for up to 30 seconds for the next page to appear.');

?>