<?php
// Will check for the files that need to be found in order to assume the test has completed
// - NOTE: All code must be contained to this file... at least until the system tests to see that the code does exist

require("cr_reference.php");
require_once($incPath.'LocalSettings.php'); 
require($incPath."include/session_nodb.php"); // no DB at this point
$_SESSION['IncPath'] = $incPath;
require_once($websiteLibrary.'calcWorkUnit.php'); 


//include($incPath."include/session.php");
//$mFile = $incPath."../LocalSettings_Database.php";
//require_once($mFile);

function output($pLine)
{
	echo($pLine."<br />\n");
}

// Roll through a SQL command and clean it up, so that it can be passed to the SQL executor
function SQLCommandsListChopArray($pCommand)
{
	$mCommandList = array();
	// Get to the folder where the files are to be worked from
	$mString = '';
	$mCommandLines = explode(chr(10), $pCommand );
	foreach ($mCommandLines as $mCommandLine)
	{
		// Clean it
		$mText = trim($mCommandLine);
		$mLine = '';
		
		// No comments
		if ((substr($mText,0,2)  == '--') ||
			(substr($mText,0,2)  == '/*') ||
			(substr($mText,0,15) == 'CREATE DATABASE') ||
			(substr($mText,0,3)  == 'USE') ||
			(substr($mText,0,1)  == '#'))
		{
			// comments etc
		}
		else
		{
			//echo(substr($mText,0,2));
			if (trim($mText) <> '')
			{
				$mLine = trim(stripBetweenTwoPoints($mText, '/*', '*/'));
				$mString .= $mLine."\n";
				// echo $mLine."<br />";
			}
		}
		
		// Do we have a completed command?
		if (rightstr($mLine,1) == ';')
		{
			// echo $mString."<br />"."<br />";
			$mCommandList[] = $mString;
			// Clear, and get ready for the next one
			$mString = '';
		}
		
	}	
	
	return $mCommandList;
} // SQLCommandClean



// NOTE: If you see nothing, it may be because you have PHP set to show no errors
// - find the php.ini files (using phpinfo();)
// - display_errors = On
// Restart Apache / IIS

output('<h2>TeleFlowRelay Install - Database</h2>');
output('-- Note: This test is not completed until you see: <b>** COMPLETE **</b>');
output('-- IMPORTANT: Check database settings in <u>LocalSettings_Database.php</u> file');
output(' ');
output('SUCCESS: Required includes found');
output('TESTING: Testing database connection to <b>'.SYS_DB_HOST.'</b>');
output('-- Database Type: <b>'.SYS_DATABASE_SYSTEM.'</b>');
output('-- User: <b>'.SYS_DB_USER.'</b>');

if (defined('SYS_DATABASE_SYSTEM'))
{
	if (SYS_DATABASE_SYSTEM == "SQLServer")
	{
		// SQL Server
		//first parameter is server name, 2nd username 'root', 3rd is password
		$rst = mssql_connect(SYS_DB_HOST, SYS_DB_USER, SYS_DB_PASS);
		if (!$rst)
		{
			output('FAILURE: Unable to connect to database manager');
			die('Could not connect: ' . mssql_error());
		} 
		else 
		{
			output('SUCCESS: Connected to Microsoft SQL Server Database Manager');
		}
	}
	else if (SYS_DATABASE_SYSTEM == "MS_PHP_SQLSvr")
	{
		// SQL Server 
		// $connectionInfo = array("UID" => $uid, "PWD" => $pwd, "Database"=>"AdventureWorks");
		// $conn = sqlsrv_connect( $serverName, $connectionInfo);
		$rst = sqlsrv_connect(SYS_DB_HOST);
		if (!$rst)
		{
			output('FAILURE: Unable to connect to database manager');
			die('Could not connect: ' . mssql_error());
		} 
		else 
		{
			output('SUCCESS: Connected to Microsoft SQL Server Database Manager');
		}
	}	
	else
	{
		// MySQL
		//first parameter is server name, 2nd username 'root', 3rd is password
		$rst = mysql_connect(SYS_DB_HOST, SYS_DB_USER, SYS_DB_PASS);
		if (!$rst)
		{
			output('FAILURE: Unable to connect to database manager');
			die('Could not connect: ' . mysql_error());
		} 
		else 
		{
			output('SUCCESS: Connected to MySQL Database Manager');
		}

		if (! @mysql_select_db("mysql") )
		{
			output('FAILURE: Unable to connect to database...');
			die('Could not connect: ' . mysql_error());
		} 
		else 
		{
			output('SUCCESS: Connected to MySQL Database "MYSQL"');
		}
		
		// If we have got this far, we are about to install the Master database 
		output('TESTING: Connecting to master database: <b>'.DATABASE_MASTER.'</b>');
		if (! @mysql_select_db(DATABASE_MASTER) )
		{
			output('TESTING: Searching for master database install scripts');
			// Major structures etc
			$mInstallScript = $incPath.'cr_sql_statements/top_level/Create_TFRelay_Database.sql';
			output('-- File: '.$mInstallScript);
			if (file_exists($mInstallScript))
			{
				output('SUCCESS: Searching for master database install scripts');
				// Clean the input so that the commands dont trip
				//$mCommandsList = SQLCommandClean(implode(chr(10), file($mInstallScript)));
				$mCommandsList = SQLCommandsListChopArray(implode(chr(10), file($mInstallScript)));

				$msql = mysql_query('CREATE DATABASE `'.DATABASE_MASTER.'`', $rst);
				if ($msql)
				{
					output('SUCCESS: Created database');
					if (! @mysql_select_db(DATABASE_MASTER) )
					{
						output('FAILURE: Unable to select database');
						die('Database selection error');
					}
				}
				
				// Loop through all the commands
				output('INSTALL: Installating master database: '.DATABASE_MASTER);
				$mCount = 0;
				foreach($mCommandsList as $mSQLCommand) 
				{
					$mCount++;
					output('RUNNING: Running SQL Statement #'.$mCount);
					//output($mSQLCommand);
				
					$msql = mysql_query($mSQLCommand, $rst);
					if (!$msql)
					{
						output('FAILURE: Unable to process SQL statements');
						die('SQL statement failure');
					}
					
				}
				
				// Set up default system client.
				output('INSTALL: Creating System Client');
				$mSQLCommand = "insert into `client` (`client_name`,`client_status`) values ('SYSTEM','SYSTEM')";				
				$msql = mysql_query($mSQLCommand, $rst);
				if (!$msql)
				{
					output('FAILURE: Unable to create System Client entry');
					die('SQL statement failure');
				}
			}
			else
			{
				output('FAILURE: Unable to find database creation script');
				die('Missing file');
			}		
			
			// Demo Data 
			$mInstallScript = $incPath.'cr_sql_statements/top_level/Create_TFRelay_DemoData.sql';
			output('-- File: '.$mInstallScript);
			if (file_exists($mInstallScript))
			{
				output('SUCCESS: Searching for demonstration data scripts');
				// Clean the input so that the commands dont trip
				//$mCommandsList = SQLCommandClean(implode(chr(10), file($mInstallScript)));
				$mCommandsList = SQLCommandsListChopArray(implode(chr(10), file($mInstallScript)));
				
				// Loop through all the commands
				output('INSTALL: Running data inserts to: '.DATABASE_MASTER);
				$mCount = 0;
				foreach($mCommandsList as $mSQLCommand) 
				{
					$mCount++;
					output('RUNNING: Running SQL Statement #'.$mCount);
					//output($mSQLCommand);
				
					$msql = mysql_query($mSQLCommand, $rst);
					if (!$msql)
					{
						output('FAILURE: Unable to process SQL statements');
						die('SQL statement failure');
					}
					
				}
				
			}
			else
			{
				output('FAILURE: Unable to find data insert script');
				die('Missing file');
			}		
			
		}
		else
		{
			output('SUCCESS: Connected to MySQL Database '.DATABASE_MASTER);
		}
		
	}
}
else
{
	output('FAILURE: SYS_DATABASE_SYSTEM has not been defined');
	die('System not defined');
}
	

// We are done
output("SUCCESS: System Installation Test 2 passed all tests.");
output(' ');
output('<b>** COMPLETE **</b>');
output(' ');

// Are we doing email invites?
if ((defined("SYSTEM_INVITEUSEREMAIL")) && (SYSTEM_INVITEUSEREMAIL == true))
{
	output('OPTION: The next step is to test email connections. This step is not essential, and is only
	needed for sending emails for user sign-up authentication etc.  When ready, 
	<a href="cr_install_emailer.php">
	click here</a>.');
}
else
{
	output('OPTION: The system is currently configured to not require email for 
	user sign-up and authentication.  However, if you would like to test it anyway, 
	<a href="cr_install_emailer.php">
	click here</a>.');	
}
output('-- Note: This setting is found as SYSTEM_INVITEUSEREMAIL in <u>LocalSettings_Appearance.php</u> file');
output(' ');
output('To continue configuring the system and a default administration user, 
		<a href="'.$incPath.'/cr_signup/cr_signup_step1.php">click here</a>.');

?>