<?php
require_once("cr_reference.php");
require_once($incPath.'LocalSettings.php'); 
require($incPath.$sessionphp);

require_once($websiteLibrary.'calcWorkUnit.php'); 


// Zip classes
require_once($websiteLibrary.'zipWorkUnit.php'); 

// Including all required classes
require('class/BCGFont.php');
require('class/BCGColor.php');
require('class/BCGDrawing.php'); 

// Including the barcode technology
include('class/BCGupca.barcode.php'); 

// Barcode standard files
require_once("bc_barcode_lib.php");



function mod10check($pNum)
{
    $dig = toCharArray($pNum); 
    $numdig = sizeof ($dig); 
    $j = 0; 
    for ($i=($numdig-2); $i>=0; $i-=2){ 
        $dbl[$j] = $dig[$i] * 2; 
        $j++; 
    }     
    $dblsz = sizeof($dbl); 
    $validate =0; 
    for ($i=0;$i<$dblsz;$i++){ 
        $add = toCharArray($dbl[$i]); 
        for ($j=0;$j<sizeof($add);$j++){ 
            $validate += $add[$j]; 
        } 
    $add = ''; 
    } 
    for ($i=($numdig-1); $i>=0; $i-=2){ 
        $validate += $dig[$i]; 
    } 
	
	return $validate;
}



// Load up parameters passed from CLI
// eg:  thisprogram.php --File=Hello.txt
// $parms = (getArgs($_SERVER['argv']));
// echo $parms['hello']
// output:  Hello.txt
function getArgs($args) {
 $out = array();
 $last_arg = null;
    for($i = 1, $il = sizeof($args); $i < $il; $i++) {
        if( (bool)preg_match("/^--(.+)/", $args[$i], $match) ) {
         $parts = explode("=", $match[1]);
         $key = preg_replace("/[^a-z0-9]+/", "", $parts[0]);
            if(isset($parts[1])) {
             $out[$key] = $parts[1];   
            }
            else {
             $out[$key] = true;   
            }
         $last_arg = $key;
        }
        else if( (bool)preg_match("/^-([a-zA-Z0-9]+)/", $args[$i], $match) ) {
            for( $j = 0, $jl = strlen($match[1]); $j < $jl; $j++ ) {
             $key = $match[1]{$j};
             $out[$key] = true;
            }
         $last_arg = $key;
        }
        else if($last_arg !== null) {
         $out[$last_arg] = $args[$i];
        }
    }
 return $out;
}


//$mBarCode = '05632767323'; // Test

// Default mode
$mMode = 'CLI';

// Defaults
$mBarCode  		= '';
$mQuantity 		= '';
$mPayment		= '';
$mClientName	= '';

$parms = (getArgs($_SERVER['argv']));
if (isset($parms['barcode']))
{
	$mBarCode  		= $parms['barcode'];
}
if (isset($parms['quantity']))
{
	$mQuantity 		= $parms['quantity'];  // How many
}	
if (isset($parms['payment']))
{
	$mPayment		= $parms['payment'];
}
if (isset($parms['clientname']))
{
	$mClientName	= $parms['clientname'];
}

// If nothing was passed on the CLI, then check for web parms
if (($mBarCode == '') && ($mClientName == ''))
{
	$mMode = 'WEB';
	if (isset($_GET['barcode']))
	{
		$mBarCode 		= $_GET['barcode'];
	}
	if (isset($_GET['quantity']))
	{
		$mQuantity   	= $_GET['quantity'];
	}
	if (isset($_GET['payment']))
	{
		$mPayment		= $_GET['payment'];
	}
	if (isset($_GET['clientname']))
	{
		$mClientName	= $_GET['clientname'];
	}

	// if we still got noting
	if (($mBarCode == '') && ($mClientName == ''))
	{
		decho($mMode, "USAGE:  ".$_SERVER['argv'][0]."  --barcode={11 digit number} [-quantity=x]");
		die;
	}
}


// Make sure we have been passed good parameters
if (($mClientName <> '') && ($mBarCode <> ''))
{
	// Only if we have a client name
	decho($mMode, 'ERROR: Purchases may only have "quantity", "payment" and "clientname" defined');
	decho($mMode, "USAGE:  ".$_SERVER['argv'][0]."  --quantity=x --payment=nn.nn --clientname=text ");
	die;
}


// How many 
if (!is_numeric($mQuantity))
{
	$mQuantity = 1;
}


// We can only generate so many at a time  (200 is max due to a memory error with the Zip file stuff)
if (($mQuantity > 200))
{
	// Only if we have a client name
	decho($mMode, 'ERROR: Due to a memory limitation with Zip, and to prevent timeouts, a maximum of 200 is set');
	decho($mMode, "USAGE:  ".$_SERVER['argv'][0]."  --quantity=x --payment=nn.nn --clientname=text ");
	die;
}



// Find important files
$dir = 'barcodes/';
$mPurchaseDir = 'purchase/';
$mPurchaseFile = 'barcodes_purchased.csv';

// C:\xampp\php\php.exe bc_barcode_create.php --barcode=62858610152 --quantity=2 --payment=19.95 --client="Bob's Space"	
//decho($mMode, $mBarCode."\n"); die;


// If a client name is being provided, we are purchasing
if ($mClientName <> '') 
{
	$mBarCode = GetNextBarCode($mPurchaseDir.$mPurchaseFile);
}


// Do some checking 
if ((strlen($mBarCode) == 11) 
	&& (is_numeric($mBarCode)))
{
	decho($mMode, 'Starting with -'.$mBarCode.'-');
	
	// Generate the bar codes, and return the file name
	$mZipFile = generatePurchasedBarcodeRange($mMode, 
										$mPurchaseFile, 
										$mPurchaseDir,
										$mBarCode, 
										$mQuantity, 
										$dir,
										$mPayment, 
										$mClientName);  // Must be filled for a purchase to occur
	
	decho($mMode, 'File: <b><a href="'.$mZipFile.'">'.$mZipFile.'</a></b>');
	decho($mMode, 'Done.');

}
else
{
	decho($mMode, "USAGE:  ".$_SERVER['argv'][0]."  --barcode={11 digit number} [-quantity=x]");
	die;	
}



?>