<?php


// Checksum for Barcode
function modBarcodeCheckSum($pNum)
{
    $dig = toCharArray($pNum);
	$mCheckSum = 10-(($dig[1]+$dig[3]+$dig[5]+$dig[7]+$dig[9])+(($dig[0]+$dig[2]+$dig[4]+$dig[6]+$dig[8]+$dig[10])*3)) % 10;
	// Single digit only
	if ($mCheckSum == 10)
	{
		$mCheckSum = 0;
	}
	
	return $mCheckSum;
}


// Find the highest purchased barcode
function GetNextBarCode($pBarcodePurchaseFile)
{
	// Determine what the index file should be named
	$mTextFile = $pBarcodePurchaseFile;

	$foundBarCode = 62858610149;  // Our earliest number
	$ic_buffer  = 1024*16;
	$ic_recs    = 0;

	// Open or create the index file
	if (File_Exists($mTextFile))
	{
		$handleIdx  = fopen($mTextFile, "r");  // Open for Read
		// Load the index
		do
		{
			$buffer = fgets($handleIdx, $ic_buffer);

			$parts = explode(",", $buffer);
			// AddLogRow($ic,ftell($handle),'Row',substr($buffer,0,23),substr($buffer,26,200));
			// echo ($parts[1]."\n");
			if (isset($parts[1]) && ($parts[1] > $foundBarCode))
			{
				$foundBarCode = $parts[1];
			}
			
			$ic_recs++;
		} while (!feof($handleIdx));
		fclose($handleIdx);
	}    
	// Add one  for the nxt
	$foundBarCode++;
	return $foundBarCode;
} // GetNextBarCode



// Log the barcode entry to the purhchase file
function LogBarcodePurchased($pBarcodePurchaseFile, $pBarCode, $pBarCodeCheckSum, $pQuantity, $pPayment, $pClientName)
{
	$textFile = $pBarcodePurchaseFile; //$incPath.SYSTEM_LOGFILES."bc_ajax_barcode-".Date('Y-m-d').".log";
	$fh = fopen($textFile, 'a') or die("can't open file");
	//echo($textFile	);
	$stringData = Date('Y-m-d_G:i:s').','.$pBarCode.','.$pBarCodeCheckSum.','.$pQuantity.','.$pPayment.',"'.$pClientName.'"'."\n";
	fwrite($fh, $stringData);
	fclose($fh);
}


///////////// Barcode Details //////////////
function generateBarcode($pBarcodeNum, $pSize, $pDir, &$varBarFilePng, &$varBarFileJpg)
{
	//echo ($pBarcodeNum .'-'. $pSize.'-'. $pDir.'-'. $varBarFilePng.'-'. $varBarFileJpg."\n");

	// Loading Font
	if ($pSize == 1)
	{
		$font = new BCGFont('./class/font/Arial.ttf', 9);
		$mSizeName = 'small';
	}
	else if ($pSize == 2)
	{
		$font = new BCGFont('./class/font/Arial.ttf', 18);
		$mSizeName = 'medium';
	}
	else if ($pSize == 3)
	{
		$font = new BCGFont('./class/font/Arial.ttf', 24);
		$mSizeName = 'large';
	}

	// The arguments are R, G, B for color.
	$color_black = new BCGColor(0, 0, 0);
	$color_white = new BCGColor(255, 255, 255); 

	$code = new BCGupca();
	$code->setScale($pSize); // Resolution 1,2,3
	$code->setThickness(30); // Thickness
	$code->setForegroundColor($color_black); // Color of bars
	$code->setBackgroundColor($color_white); // Color of spaces
	$code->setFont($font); // Font (or 0)
	$code->parse($pBarcodeNum); // Text

	// Get the check sum
	$checkSum = modBarcodeCheckSum($pBarcodeNum);

	// Define names to  Convert to a JPG from the original PNG
	$imgname = $pDir.'bc_'.$pBarcodeNum.$checkSum.'_'.$mSizeName.'.png';
	$imgout  = $pDir.'bc_'.$pBarcodeNum.$checkSum.'_'.$mSizeName.'.jpg';

	// Return the names we created
	$varBarFilePng = $imgname;
	$varBarFileJpg = $imgout;
	
	/* Here is the list of the arguments
	1 - Filename (empty : display on screen)
	2 - Background color */
	$drawing = new BCGDrawing($imgname, $color_white);
	$drawing->setBarcode($code);
	$drawing->draw();
	// Header that says it is an image (remove it if you save the barcode to a file)
	//header('Content-Type: image/png');
	// Draw (or save) the image into PNG format.
	$drawing->finish(BCGDrawing::IMG_FORMAT_PNG);

	//echo $imgout;
	
	$im = @imagecreatefrompng($imgname);
	//header ("Content-type: image/jpeg");
	$quality = 100; // Quality should be between 0 and 100
	imagejpeg($im, $imgout , $quality);
} // generateBarcode


// A quick way to turn on or off output
function decho($pMode, $pString)
{
	if ($pMode == 'CLI')
	{
		echo ($pString."\n");
	}
	else if ($pMode == 'WEB')
	{
		echo ($pString."<br />");
	}	
}

// Generate Purchased barcodes
function generatePurchasedBarcodeRange($pOutputMode, 
										$pPurchaseFile, 
										$pPurchaseDir,
										$pBarCode, 
										$pQuantity, 
										$pBarCodeDir, 
										$pPaymentAmount, 
										$pClientName)  // Must be filled for a purchase to occur
{
	// Get ready to ZIP them
	$zipname = 'Barcodes-'.$pBarCode.modBarcodeCheckSum($pBarCode).'_qty_'.$pQuantity.'.zip';
	$zipfile = new zipfile();
	//$dirfiles=make_tree('folder');
	
	for ($mLoop = 0; $mLoop < $pQuantity; $mLoop += 1)
	{
		decho($pOutputMode, 'Generating Barcode: '.$pBarCode);

		$mPng = '';
		$mJpg = '';
		// Generate All Sizes
		
		// Must be a string when passed
		$pBarCode = strval($pBarCode);
		
		generateBarcode( $pBarCode, 3, $pBarCodeDir, $mPng, $mJpg  );  // Large
		//Add a File in the zip
		$fd = file_get_contents($mPng);
		$zipfile -> add_file($fd, $mPng);
		$fd = file_get_contents($mJpg);
		$zipfile -> add_file($fd, $mJpg);
		
		generateBarcode( $pBarCode, 2, $pBarCodeDir, $mPng, $mJpg  ); // Medium
		//Add a File in the zip
		$fd = file_get_contents($mPng);
		$zipfile -> add_file($fd, $mPng);
		$fd = file_get_contents($mJpg);
		$zipfile -> add_file($fd, $mJpg);

		generateBarcode( $pBarCode, 1, $pBarCodeDir, $mPng, $mJpg  ); // Small
		//Add a File in the zip
		$fd = file_get_contents($mPng);
		$zipfile -> add_file($fd, $mPng);
		$fd = file_get_contents($mJpg);
		$zipfile -> add_file($fd, $mJpg);
		
		// Log the purchcase
		if ($pClientName <> '')
		{
			// Only if we have a client name
			decho($pOutputMode, '-- Purchased for : '.$pClientName);
			LogBarcodePurchased($pPurchaseDir.$pPurchaseFile, 
								$pBarCode, 
								modBarcodeCheckSum($pBarCode),
								$pQuantity, 
								$pPaymentAmount, 
								$pClientName);
		}
		
		// Next
		$pBarCode = strval($pBarCode+1);
	}
		
	// Save the zip file
	$fd = fopen ($pPurchaseDir.$zipname, "wb");
	$out = fwrite ($fd, $zipfile -> file());
	fclose ($fd);
	
	return $pPurchaseDir.$zipname;
} // generatePurchasedBarcodeRange

?>