<?php 
/*
* Barcode
*
* Copyright (C) 2008 engenic (engenic.com)
* 
* ATTENTION: This is NOT Open Source software
* Commercial license must be acquired from engenic.com
*/
require_once("cr_reference.php");
require_once($incPath.'LocalSettings.php'); 
require($incPath.$sessionphp);

include($incPath."include/header.php"); 
// JavaScript goes here + + +
?>
<link rel="stylesheet" type="text/css" media="screen" href="bc_barcodes.css">

<script language="javascript">
// Required 
var monthName = new Array("January","February","March","April","May","June","July","August", "September","October","November","December");
var dayName   = new Array('Sunday,', 'Monday,', 'Tuesday,', 'Wednesday,', 'Thursday,', 'Friday,', 'Saturday,');

// Name of the file the user wants to download
var downloadFile = '';

function cancelButtons()
{
	$("#add").show();
	$("#add").attr("disabled", "true"); // Disable it 
	
	// Remove the help
	$("#inputHelp").attr("style","display:none");
	$("#spinner").attr("style","display:none");	
}	

// Clear edit fields 
function clearEditFields()
{
	// Clear the fields
	$('#barcode').val('');
	$('#barcodes_image_container').hide();
}


// Generate the field for a table
function generateField(pClone, pId, pClass, pValue)
{
	pClone.find(pId).removeClass().addClass(pClass).text(pValue+' ');  // Space ensures that IE draws a box
}
function generateFieldHTML(pClone, pId, pClass, pValue)
{
	pClone.find(pId).removeClass().addClass(pClass).html(pValue+' ');  // Space ensures that IE draws a box
}

// Build a line to drop into the table
function buildLine(pCloneRow, pDoc, pFile)
{
	// Put in a tracker attribute so we can find later
	pCloneRow.attr("style",""); // Make visible
	
	// Add the values to the Radio button for reference later 	
	pCloneRow.find("input").attr("attr_barcode_id", 			$(pDoc).attr('imagefile'));
	pCloneRow.find("input").attr("attr_barcode_imagesmall", 	$(pDoc).attr('imagefilesmall'));
	pCloneRow.find("input").attr("attr_barcode_zip", 			pFile);
	
	// Do some creation of the fields
	generateFieldHTML(pCloneRow, "#tblFld01", "tblFld01", '<img src="'+$(pDoc).attr('imagefilesmall')+'"/>');
} // buildLine


//  Set up jQuery - Now is a good timeto see if it will fly / load up the libraries	
//  Interact with PHP system using AJAX
$(document).ready(function()
{
	<?php include('../cr_javascript_graphics.php'); ?>
	
	////////////////////////////////////////////////////////
	// Set up the environment - runs once
	////////////////////////////////////////////////////////
	$(function()
	{
		// Do some set up


		
		// Test call number
		$("#barcode").mask("99999999999");
		
		$("#add").attr("disabled", "true");
	});

	
	// Cancel button pressed
	$("#cancel").click(function()
	{
		// Setup the cancel buttons
		cancelButtons();
		// Clear the fields
		clearEditFields();
		
		$('#barcode').focus();
		$("#spacer").hide();
 		return false; //not to post the  form physically
	});  	
	

	// User is moving through fields
	// - This system is a simple little help environment
	$("input").focus( function()
	{
		var mName=$(this).attr("id");
		var mText="";
		
		// Regular input
		if 	(mName=="barcode")  mText="Enter an 11 digit barcode... ";
		
		if (mText!="")
		{
			$("#inputHelp").removeClass().addClass('inputinfodiv').text(mText).fadeIn(10);
		}
		
	});	
	
	$("#barcode").keyup(function(e)
	{
		// Show help
		//alert('hi'+$("#barcode").val());  
		// @@@ Something odd occurs when you press A.  Tried time instead of parseInt
		var mCount = strlen(parseInt($("#barcode").val()));
		
		var mText = 'One more digit to go!';
		//alert(mCount);
		if (mCount < 10)
		{
			mText = (11 - mCount)+' numbers to go';
			$("#add").attr("disabled", "true");
		}
		else if (mCount == 11)
		{
			mText = 'Almost there! Click "Create My Barcode!"';
			$("#add").removeAttr("disabled");		
		}

		$("#inputHelp").removeClass().addClass('inputinfodiv').text(mText).fadeIn(10);
		

		//alert('hi');
	});

		
	////////////////////////////////////////////////////////
	// Create Barcode
	////////////////////////////////////////////////////////
	$("#add").click(function()
	{
		// Display work
		$("#spinner").show();
		// Show the report box
	    $("#barcoderesults_report_box").show();	
		//alert('he'+$('#txt_updatedate').val());
		$('#barcodes_image_container').fadeOut(50);
		
		// Zip file
		var mZip='bc_'+$('#barcode').val()+'.zip';
		
		
		///////////////////////////////////
		// Now, get the XML for post etc
		///////////////////////////////////			
		$.ajax({ type: "POST", 
				url: "bc_ajax_barcodes_commands.php", 
				data: { command:'GenerateBarCode',
						barcode:$('#barcode').val(),
						zipfilename:mZip,
						gettype:'XML', 
						nocache_rand:Math.random() }, 
				dataType: "xml", 
				success: function(data)
				{	
					// Populate Barcodes Information
					$(data).find('RESPONSE').each(function()
					{
						// Did we get something
						if ( $(this).attr('result') == 'ERROR')
						{
							//alert("Error");
							$("#msgbox").removeClass().addClass('messageboxerror').text('Failed to create barcode').fadeIn(10);
						}
						else
						{
							mCount=0;
							$(data).find('BARCODE').each(function()
							{
								//alert( $(this).attr('imagefile') );
								mText = '<br /><img src="'+$(this).attr('imagefile')+'"/><br /><br />';
								$('#barcodes_image_container').html(mText).fadeIn(1000);					
								
								//////////////////////
								//Report Line
								//////////////////////
								$("#inputHelp").removeClass().addClass('inputinfodiv').text('Ready for use!').fadeIn(10);

								// Remove the value
								$('#barcode').val('');
								// Focus the cursor back on the add field
								$("#barcode").focus();

								
								
								//////////////////////
								//Report Line
								//////////////////////
								// Draw a smaller version below
								// *** Clone node assign ID attribute and fade in
								var cloneRow = $("#barcode_report_table tr:last").clone(true);
								cloneRow.attr("id", "barcode_report_entry_clone");
								
								// Put in a tracker attribute so we can find later
								cloneRow.attr("track_id", $(this).attr('barcode'));
								// Put in a tracker attribute so we can find later

								// Set up the report line with data and styles etc
								buildLine(cloneRow, $(this), mZip);
								
								$("#barcode_report_table").append(cloneRow).fadeIn("fast");
		
								// Display the area
								$("#spacer").show();
							
								// Display the download button
								$("#download").show();
								$("#download").attr("disabled", "true"); // Disable it  for now
								$("#spinner").attr("style","display:none");
						    });

						}
					});		
					
				},
				error: function (xhr, desc, exceptionobj) 
				{
					//alert(xhr.responseText);					
					$("#spinner").attr("style","display:none");					
				}

		});
 		return false; //not to post the  form physically
	});
	
	
	// Selected barcode 
	$("input[name=barcode_report_item]").click(function()
	{
		// Get the elment that was checked 
		mElem=$("input[name=barcode_report_item]:checked");
		downloadFile = 'barcodes/'+(mElem.attr("attr_barcode_zip"));			

		//alert('File '+ downloadFile);
		$("#download").removeAttr("disabled");		
	});
	
	// And if they clicked
	$("#download").click(function(e) {
		e.preventDefault();  //stop the browser from following
		window.location.href = downloadFile;
	});

	$(".buybutton").hover(function(){
		$(".buybutton")
			// first jump 
			.animate({top:"-10px"}, 100).animate({top:"-4px"}, 100)
			// second jump
			.animate({top:"-7px"}, 100).animate({top:"-4px"}, 100)
			// the last jump
			.animate({top:"-3px"}, 100).animate({top:"-4px"}, 100);
	});

}
);
</script>
<?php



include($incPath."include/header_divs.php"); 
include($webTopMenuPage); 
?>

<div id="frontpage">
<div id="maintext">

<!--------------------------->
<!-- Liquid Start -->
<!--------------------------->
<div class="colmask rightmenu">
<div class="colleft">

<!--------------------------->
<!-- Column 1 start -->
<!--------------------------->
<div class="col1">			
<?php include(str_replace('.', '_contents.', $filename = array_pop(explode('/', $_SERVER['PHP_SELF'])))); ?>
</div>
<!--------------------------->
<!-- Column 1 end -->
<!--------------------------->
		
		
<!--------------------------->
<!-- Column 2 start -->
<!--------------------------->
<div class="col2">
<?php include('bc_sidepanel.php'); ?>
</div>
<!--------------------------->
<!-- Column 2 end -->
<!--------------------------->

</div>
</div>
<!--------------------------->
<!-- Liquid End -->
<!--------------------------->


<!-- Footer standard -->
</div> <!-- maintext -->
</div> <!-- frontpage -->
<?php 
include($incPath."include/footer.php");
?>