<?php
/*
* xml_barcodes_cmd.php
*
* Copyright (C) 2009 connectrelay
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with this program; if not, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
* http://www.gnu.org/copyleft/gpl.html
*/

/*
==About the Database==

==USAGE==
Basic command
* http://localhost/engenic_app_root/eng_medicalrelay_xml/xml_medicalcmd.php

Command with debug information
* http://localhost/engenic_app_root/eng_medicalrelay_xml/xml_medicalcmd.php?DEBUG=YES

===Hello===
This will determine if the system is alive with database operations
* http://localhost/engenic_app_root/eng_medicalrelay_xml/xml_medicalcmd.php
* BODY:  
	<REQUEST action="Hello"></REQUEST>

===LogEvent===
This will add an entry to the Log Table
* http://localhost/engenic_app_root/eng_medicalrelay_xml/xml_medicalcmd.php
* BODY:
	<REQUEST action="LogEvent"
	evt_code="START"
	call_start="12314.000"
	call_elapse="3.000"
	tf_app="TF_ABSENCETRACKER"
	log_date="2008/10/09"
	log_time="17:22:59"
	evt_port="1"
	site_code=""
	region_code=""
	evt_type=""
	evt_data1="0"
	evt_data2=""
	evt_data3="NULL">
	</REQUEST>


==Examples==
 <REQUEST action="Hello"></REQUEST>
	Will provide:
 <RESPONSE action="Hello"><RESULT>Hi back: We are here to serve</RESULT></RESPONSE>

 */
// Headers must be provided here, as this is a non-GUI application, and will only be returning XML (or text) 
header('Content-Type: text/xml');
header("Cache-Control: no-cache, must-revalidate");
//A date in the past
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");

//  Start like any other program
require_once("cr_reference.php");
require_once($incPath.'LocalSettings.php'); 
require($incPath.$sessionphp);

require_once($websiteLibrary.'calcWorkUnit.php');     
require_once($websiteLibrary.'httpWorkUnit.php');     
// Zip classes
require_once($websiteLibrary.'zipWorkUnit.php'); 



// Tables used in this system
define("TABLE_EVENTLOG",  'event_log'); 


/////////////////////////// BARCODES FUNCTIONS ///////////////////////////////
// NOTE: This is a holder for the functions that are referenced in body
include('xml_barcodes_cmd_functions.php');
/////////////////////////// BARCODES FUNCTIONS ///////////////////////////////



/////////////////////////// MAIN ///////////////////////////////
// NOTE: This section is where data is passed. 
// Get the full request for POST
$data         = file_get_contents("php://input");
//$data         = file_get_contents("test_sendtest.xml");  // Debug

// See if we are GETTING
//$get_cmd=htmlspecialchars($_GET['cmd'],ENT_QUOTES);



/////////////////////////// BARCODES BODY ///////////////////////////////
// NOTE: This section works with the value in $data
include('xml_barcodes_cmd_body.php');
/////////////////////////// BARCODES BODY ///////////////////////////////



/////////////////////////// FINAL ///////////////////////////////
// NOTE: Determine what to return (see Body for values)
// Return results
echo '<?xml version="1.0" encoding="ISO-8859-1"?>';
// Displays out to the screen
echo $domobject->saveHTML();   
?>