<?php
// Responses provided by the PHP program
$responsecode = "";


// Date and Time defaults
$teleflowDate = Date("Y/m/d");
$teleflowTime = Date("H:i:s");
     // yyyy/mm/dd ==> mm/dd/yyyy
$webDate      = Date("m/d/Y");

$mMode = '';
//echo("<BR><BR>".$data."<BR><BR>");
decho($mMode, "STARTED at ".teleflowNowDate()." ".teleflowNowTime()." (".$webDate.")<BR>");

// Set up file names
$stmp        = date("Y-m-d_H-i-s");
$fold        = "log/";
// Create the log folder
if (!is_dir($fold))
{
    mkdir($fold);
}
$reqf  = $fold.$cSysName."_".$stmp."_request.xml";
$resf  = $fold.$cSysName."_".$stmp."_response.xml";


// Assume an XML document, and process...
$doc = new DOMDocument();

$request_Command = '';
// Did the user actually send a request?
if ($data <> '')
{
   $doc->loadXML($data);
   // save it for later review
   //$doc->save($reqf);

   // XML Command request
   // -- Find out what the command is (Must be a REQUEST)
   $theFile = $doc->getElementsByTagName('REQUEST')->item(0);

   if ($theFile->hasAttribute('action'))
   {
      $request_Command = $theFile->getAttribute('action');
   }
}

// Create the Result XML document
$domobject = new DOMDocument('1.0', 'utf-8');

// Wrap the request
$elementHolder  = $domobject->createElement("RESPONSE", "");
// Default 

$error   = 'ERROR';
$success = 'SUCCESS';
// Types --
$db		= 'DB';
$cmd 	= 'CMD';
$read	= 'READ';

// Review the requested Command
if ($request_Command <> "") 
{
	{

	  /////////////////////////////////////////////////////////
	  if ($request_Command == "Hello")
	  /////////////////////////////////////////////////////////
	  {
		$responsecode = "Hi back: We are here to serve";
				
		$elementSuccess  = $domobject->createElement("SUCCESS");
		$elementSuccess->setAttribute("action", $request_Command); 
		$elementSuccess->setAttribute("result", $success); 
		$elementSuccess->setAttribute("type",   $read); 
		// Add verbose TEST 
		$elementSuccess->appendChild($domobject->createTextNode($responsecode));
		// Add to the complete list
		$elementHolder->appendChild($elementSuccess);		
		
	  }

	  /////////////////////////////////////////////////////////
	  else if ($request_Command == "Sleep")
	  /////////////////////////////////////////////////////////
	  {
		$seconds      = GetNonEmptyValue($theFile->getAttribute('seconds'), -1);
		$responsecode = "Sleeping for ".$seconds." seconds.";
		//sleep for x seconds
		sleep($seconds);

				
		$elementSuccess  = $domobject->createElement("SUCCESS");
		$elementSuccess->setAttribute("action", $request_Command); 
		$elementSuccess->setAttribute("result", $success); 
		$elementSuccess->setAttribute("type",   $read); 
		// Add verbose TEST 
		$elementSuccess->appendChild($domobject->createTextNode($responsecode));
		// Add to the complete list
		$elementHolder->appendChild($elementSuccess);		
		
	  }
		  
	  /////////////////////////////////////////////////////////
	  else if ($request_Command == "GenerateBarCode")
	  /////////////////////////////////////////////////////////
	  {
		if(($theFile->hasAttribute('barcode'))
		)
		{
			$mBarCode      = GetNonEmptyValue($theFile->getAttribute('barcode'), -1);
			$dir = 'barcodes/';
			
			$mPng1 = '';
			$mJpg1 = '';
			$mPng2 = '';
			$mJpg2 = '';
			$mPng3 = '';
			$mJpg3 = '';
						
			///////////// Barcode Details //////////////
			generateBarcode( $mBarCode, 3, $dir, $mPng1, $mJpg1  );  // Large
			generateBarcode( $mBarCode, 2, $dir, $mPng2, $mJpg2  ); // Medium
			generateBarcode( $mBarCode, 1, $dir, $mPng3, $mJpg3  ); // Small

			
			// Get ready to ZIP them
			if(($theFile->hasAttribute('zipfilename')))
			{
				//$zipname = 'Barcodes-'.$mBarCode.modBarcodeCheckSum($mBarCode).'_single.zip';
				$zipfilename = $dir.$theFile->getAttribute('zipfilename');
				$zipfile = new zipfile();
				
				//Add the three file to a zip
				$fd = file_get_contents($mPng1);
				$zipfile -> add_file($fd, $mPng1);
				$fd = file_get_contents($mJpg1);
				$zipfile -> add_file($fd, $mJpg1);

				$fd = file_get_contents($mPng2);
				$zipfile -> add_file($fd, $mPng2);
				$fd = file_get_contents($mJpg2);
				$zipfile -> add_file($fd, $mJpg2);

				$fd = file_get_contents($mPng3);
				$zipfile -> add_file($fd, $mPng3);
				$fd = file_get_contents($mJpg3);
				$zipfile -> add_file($fd, $mJpg3);
				
				// Save the zip file
				$fd = fopen ($zipfilename, "wb");
				$out = fwrite ($fd, $zipfile -> file());
				fclose ($fd);
			}
			/*			
			//sleep for x seconds
			//sleep(1);
			*/
			
			$elementSuccess  = $domobject->createElement("BARCODE");
			$elementSuccess->setAttribute("action", $request_Command); 
			$elementSuccess->setAttribute("result", $success); 
			$elementSuccess->setAttribute("type",   $read); 
			$elementSuccess->setAttribute("barcode",   $mBarCode); 
			$elementSuccess->setAttribute("imagefile",   $mJpg1 ); 
			$elementSuccess->setAttribute("imagefilesmall",   $mJpg3 ); 
			
			// Add verbose TEST 
			$elementSuccess->appendChild($domobject->createTextNode($responsecode));
			// Add to the complete list
			$elementHolder->appendChild($elementSuccess);	
			
		}
	  }
		  

	  /////////////////////////////////////////////////////////
	  else if ($request_Command == "DiskSpace")
	  /////////////////////////////////////////////////////////
	  {
		$di      = GetNonEmptyValue($theFile->getAttribute('drive'), -1);

		if(($theFile->hasAttribute('drive'))
		)
		{
			$request_drive		= $theFile->getAttribute('drive');	

			$free = 0;
			$total = 0;
			if (getDiskSpaceImage($request_drive.":",0,'',$free,$total))
			{
				$elementSuccess  = $domobject->createElement("SUCCESS");
				// Add verbose TEST 
				
				$elementSuccess->setAttribute("units",	'GB'); 
				$elementSuccess->setAttribute("disksize", $total); 
				$elementSuccess->setAttribute("diskfree", $free); 
				
				$elementSuccess->appendChild($domobject->createTextNode($responsecode));
				// Add to the complete list
				$elementHolder->setAttribute("action", $request_Command); 
				$elementHolder->setAttribute("result", $success); 
				$elementHolder->setAttribute("type",   $read); 
				$elementHolder->appendChild($elementSuccess);					
			}
			else
			{
				$responsecode = "Failed to determine diskspace";
				$elementHolder->setAttribute("action", $request_Command); 
				$elementHolder->setAttribute("result", $error); 
				$elementHolder->setAttribute("type",   $read); 
				// Add verbose TEST 
				$elementHolder->appendChild($domobject->createTextNode($responsecode));
			}
		}
		else
		{
			// Missing parameters
			$responsecode = "Mandetory parameters are missing";
			$elementHolder->setAttribute("action", $request_Command); 
			$elementHolder->setAttribute("result", $error); 
			$elementHolder->setAttribute("type",   $read); 
			// Add verbose TEST 
			$elementHolder->appendChild($domobject->createTextNode($responsecode));		
		}		
		
	  }
	  /////////////////////////////////////////////////////////
	  else
	  /////////////////////////////////////////////////////////
 	  {
			decho($mMode,"BAD COMMAND<BR>");
			$elementHolder->setAttribute("action", $request_Command);
			// Final results
			$responsecode = "Unknown Command";
			$elementResult  = $domobject->createElement("ERROR", $responsecode);
			$elementHolder->appendChild($elementResult);			
	  }
	}
}
else
{
	decho($mMode,"NO COMMAND Provided<BR>");
	$elementHolder->setAttribute("action", "NotDefined");
	// Final results
	$responsecode = "ERROR: No Command Provided";
	$elementResult  = $domobject->createElement("RESULT", $responsecode);
}

// Put it all together
//$elementHolder->appendChild($elementResult);
$domobject->appendChild($elementHolder);
// Save to Log dir .. if there was a request
if ($request_Command <> "") 
{
    // No saving for this app.  Its not creating new info really
    //$domobject->save($resf);
}
?>