<?php
// Including all required classes
require('class/BCGFont.php');
require('class/BCGColor.php');
require('class/BCGDrawing.php'); 

// Including the barcode technology
include('class/BCGupca.barcode.php'); 

require_once("bc_barcode_lib.php");


//XML post in a Stream, so that the program will timeout, and continue without holding the user forever
function XMLPostStream( $url, $postdata) 
{
    $url_parsed = parse_url($url);
    if ( empty($url_parsed['scheme']) ) {
        $url_parsed = parse_url('http://'.$url);
    }
    $rtn['url'] = $url_parsed;

    $port = $url_parsed["port"];
    if ( !$port ) {
        $port = 80;
    }
    $rtn['url']['port'] = $port;
    
    $path = $url_parsed["path"];
    if ( empty($path) ) {
            $path="/";
    }
    if ( !empty($url_parsed["query"]) ) {
        $path .= "?".$url_parsed["query"];
    }
    $rtn['url']['path'] = $path;
    $host = $url_parsed["host"];
    $foundBody = false;

    $out =  "POST $path HTTP/1.0\r\n";
    $out .= "Host: $host\r\n";
    $out .= "Content-Length: ".strlen($postdata)."\r\n";
    $out .= "Connection: keep-alive: 3\r\n\r\n";
	
	// Read socket - timeout 10 seconds
    if ( !$fp = @fsockopen($host, $port, $errno, $errstr, 5) ) 
	{
        $rtn['errornumber'] = $errno;
        $rtn['errorstring'] = $errstr;
        return $rtn;
    }
    stream_set_timeout($fp, 5);
    fwrite($fp, $out);
    fwrite($fp, $postdata);
	
	// The \r\n\r\n breaks up the body from the head
    $res = split("\r\n\r\n",fread($fp, 2000));

	// Go with the default
	$body = '<?xml version="1.0" encoding="ISO-8859-1"?><RESPONSE><FAILURE result="INVALID">Invalid response</FAILURE></RESPONSE>';
	foreach ($res as $line)
	{
		// Only take 
		if (strpos('!'.$line,'<?xml') == 1)
		{
			$body = $line;
		}
	}

    $info = stream_get_meta_data($fp);
    fclose($fp);

	// How did we get here?
    if ($info['timed_out']) 
	{
		// Connection timed out!
		$body = '<?xml version="1.0" encoding="ISO-8859-1"?><RESPONSE><FAILURE result="TIMEOUT">Timeout</FAILURE></RESPONSE>';
    }
	return $body;

}

// Form the data in an email
function BoldWrapIndent($pRow)
{
	return '<br />&nbsp;&nbsp;&nbsp;<b>'.$pRow.'</b><br /><br />';
}



// Constants
$cSysName   = 'xml_barcodes_cmd';


$cResult = "Result";



// Determine how much output we should see
$OutPutMode   = FALSE;
if(isset($_GET['DEBUG']))
{
	$OutPutMode   = TRUE;
}

?>