<?php
//example in main.php
class Conversations
{	
	private $dbConnect = -1;	
	private $dbQuery = -1;
	private $convoThread = array(array());	//holds all conversation extracted from the Mysql DataBase.		
	private $currentParent = array(); 		// Specifies if it is a top-level parent or a child reply
											// if 0 -> it is a top-level parent conversation
											// Otherwise it is a child conversation and specifies 
											// the conversation ID of its parent. 
	private $currentChildNode = 0; 	  		// Used to indicate the current node in the IterateChild function. 
	private $currentParentNode = 0;  		// Used to indicate the current node in the IterateParent function. 
	
	private $database;// = new MySQLDB;
	
	//set up the DB connection
	public function __construct($clientNo, MySQLDB $database)
	{
		$this->database = $database; 
		$this->dbConnect = $this->database->selectClientDatabaseByMasterClientId($clientNo);	
		
		if(!$this->dbConnect)
		{
			die("No connection could be established " . mysql_error()); 
		}			 
	}
	
	//Function:GetConversationRootPtr
	//-retrieves the first top-level parent node conversation for the media file entry and returns a
	// a node pointer to this node. 
	public function GetConversationRootPtr()
	{
		if(end($this->currentParent) == -1)
		{
			return -1; 
		}
		else
		{
			return $nodeHandle = end($this->currentParent); //root is always the first Conversation in the thread for now. 
		}
	}
	
	//Function:GetValue
	//-returns the value at one of the following types
	//media_reply_id,conversation_id,conversation_data,conversation_title,conversation_username,date_time.
	public function GetValue($nodePtr, $type)
	{
		return $this->convoThread[$nodePtr][$type];
	}
	
	//Function:GetArray
	//-Retrieves the array at a node specified by the nodePtr. 
	public function GetArray($nodePtr)
	{
		return $this->convoThread[$nodePtr];
	}
	
	//Function: IterateParent
	//-Retrieves the top-level conversations that belong to a certain media file entry.
	public function IterateParent(/*$nodePtr*/)
	{	
		//$currentParentNode = $nodePtr; 		
		if($this->currentParentNode >= sizeof($this->convoThread))
		{			
			return -1;
		}
				
		for($i = $this->currentParentNode; $i < sizeof($this->convoThread); ++$i)
		{
			if(end($this->currentParent) == $this->convoThread[$i]['media_reply_id'])
			{				
				$this->currentParentNode = $i + 1;			
				//echo "currentParentnode = $this->currentParentNode <br>, handle = $i<br>, currentparent =". end($this->currentParent)."<br>";
				return $i;
			}			
		}
		
		return -1;
	}
	
	//Function:GetFirstChild
	//-Retrieves the first reply to a Parent Conversation
	//note:$nodePtr is the pointer to a parent node. 
	public function GetFirstChild($nodePtr)
	{
		$conversationID = $this->convoThread[$nodePtr]['conversation_id'];				
		array_push($this->currentParent, $conversationID);		
		
		for($i = $this->currentChildNode; $i < sizeof($this->convoThread); $i++)
		{
			if(end($this->currentParent) == $this->convoThread[$i]['media_reply_id'])
			{	
				$this->currentChildNode = $i+1;//start searching for the next child element, one element ahead of the current element. 
				//echo "currentCHildnode = $this->currentChildNode <br>, child handle = $i<br>, currentparent = $conversationID<br>";
				return $i; 
			}
		}			
		
		array_pop($this->currentParent);
		return -1;
	}
	
	//Function:IterateChild
	//-Retrieves the consecutive replies to the first reply of a Parent Conversation. 
	public function IterateChild(/*$nodePtr*/)
	{	
		if($this->currentChildNode >= sizeof($this->convoThread))
		{						
			$this->currentChildNode = 0; 
			array_pop($this->currentParent);//Go up one level to the current parent conversation
			return -1;
		}
						
		for($i = $this->currentChildNode; $i < sizeof($this->convoThread); $i++)
		{   
			if(end($this->currentParent) == $this->convoThread[$i]['media_reply_id'])
			{					
				$this->currentChildNode = $i + 1;
				//echo "currentChildnode = $this->currentChildNode <br>, Childhandle = $i<br>, currentparent =". end($this->currentParent)."<br>";
				return $i; //return the current node
			}
		}		
		
		$this->currentChildNode  = 0; //reset the memner var, for the next interation of a parent conversation. 
		array_pop($this->currentParent);
		
		return -1;
	}
	
	//Completed!
	//$result = $convo->AddConversation(1,"Tesla","A SAMPLE CONVO A SAMPLE CONVO","Just a Title"); 
	//$result = $convo->AddConversation(1,"Tesla",'Third Comment of the TwitYax',"Just a Title"); 
	public function AddConversation($topicId, $userName, $data, $title, $replyId = 0)
	{		
		mysql_real_escape_string($userName);//Needs to be linked to the database for some reason. 
		mysql_real_escape_string($data); 
		mysql_real_escape_string($title);		
		$currentDate =  date('o-m-d G:i:s');
		
					
		$this->dbQuery = "INSERT INTO media_conversation ( media_reply_id, media_topic_id,conversation_data,
																 conversation_title,conversation_username, date_time) 
																 VALUES( '". $replyId . "','" . $topicId . "','" . $data . 
																 "','" . $title . "','" . $userName . "','" . $currentDate . "');";
			
		if(mysql_query($this->dbQuery))
		{			
			return TRUE;
		}
		else
		{	
			return FALSE;
		}																 
		
	}
	
	
	//Loads all comments from the DB based on the $topicId. 
	//$topicId corresponds to the media_file_id in the media_file table
	//Completed!
	public function LoadConversations($topicId)
	{
		$this->dbQuery = "Select media_reply_id, media_topic_id,conversation_id, conversation_data,
							conversation_title,conversation_username, date_time FROM media_conversation 
							WHERE media_topic_id = '$topicId' ORDER BY conversation_id";								
			
		if($query = mysql_query($this->dbQuery))
		{						
			if (mysql_num_rows($query) == 0) 
			{
				array_push($this->currentParent,-1);
				return false; 					
			}  
				
			$i=0;			
			while($conversation = mysql_fetch_assoc($query))
			{								
				$this->convoThread[$i] = $conversation;
				$i++;
			}
 		} 
		else
		{
			array_push($this->currentParent,-1);
			return false;  
		}		
		
		array_push($this->currentParent,0); //First comment starts always at parent = 0
		
		return $this->convoThread; 
	}
	
	public function DeleteConversationThread($topicId)
	{
		$this->dbQuery = "DELETE FROM media_conversation WHERE (media_topic_id = $topicId)";
	
		if(mysql_query($this->dbQuery))
		{
			return TRUE;
		}
		else
		{	
			return FALSE;
		}
	}				
	
	public function DeleteComment($topicId, $commentId)
	{
		$errorFlag = 0; 
		$this->dbQuery = "DELETE FROM media_conversation WHERE media_topic_id = $topicId AND media_reply_id = $commentId"; //delete all replies for the comment
	
		if(!mysql_query($this->dbQuery))
		{	
			return FALSE;
		}
		
		//delete the comment itself
		$this->dbQuery = "DELETE FROM media_conversation WHERE media_topic_id = $topicId AND conversation_id = $commentId";
		
		if(mysql_query($this->dbQuery))
		{
			return TRUE;
		}
		else
		{	
			return FALSE;
		}
	}
	
	public function DeleteCommentReply($topicId, $commentId)
	{  
		$this->dbQuery = "DELETE FROM media_conversation WHERE conversation_id = $commentId";
	//media_topic_id = $topicId AND 
		if(mysql_query($this->dbQuery))
		{
			return TRUE;
		}
		else
		{	
			return FALSE;
		}
	}
	
	public function VerifyUserName($username,$conversation_id)
	{
		$this->dbQuery = "SELECT * FROM media_conversation WHERE conversation_id = $conversation_id AND conversation_username = \"$username\"";
	
		if($q = mysql_query($this->dbQuery))
		{
			if (mysql_num_rows($q) == 0) 
			{				
				return FALSE; 					
			}
			else
			{
				return TRUE;
			}
		}
		else
		{	
			return FALSE;
		}
	}
	
	
	
}

?>
