<?php
/**
 * cr_access_client.php
 *
 * This is the Admin Center page. Only administrators
 * are allowed to view this page. This page displays the
 * database table of users and banned users. Admins can
 * choose to delete specific users, delete inactive users,
 * ban users, update user levels, etc.
 *
 * Original by: Jpmaster77 a.k.a. The Grandmaster of C++ (GMC)
 * Overhauled and Extended by: vbaker@engenic.com
 * Last Updated: April 20, 2009
 */
 
// Determine relative location for paths
require("cr_reference.php");
require_once($incPath.'LocalSettings.php'); 
require($incPath."include/session.php");
$_SESSION['IncPath'] = $incPath;

require_once($websiteLibrary.'calcWorkUnit.php');   

// Take the logged in client id
$mClient_id = $session->sessionActiveClientSecurity();


// Check to see if we have just registered someone new (add / invite)
if ((isset($_SESSION['regsuccess'])) and ($_SESSION["new_user_id"] > 0)) 
{
	unset($_SESSION['regsuccess']);
	unset($_SESSION['reguname']);
	header(sprintf("Location: %s", "cr_admin_invite.php"));      
}


/* Display requested user information */
$req_user_info = $database->getUserInfo($session->username);
/* Get company info */
//$req_company_info = $database->getCompanyInfoByID($req_user_info['company_id']);
/* Get client info */
$req_client_info  = $database->getClientInfo($req_user_info['client_id']);

// Are we allowed to be here? 
// -- User level must be at least 99 - Super admin
if ($req_user_info['u_permissions_level'] < SUPER_ADMIN_LEVEL)
{
	// return to main
	header(sprintf("Location: %s", "cr_main.php"));      
}


// If the ID of the client was passed into this page, and the client is SUPER_ADMIN_LEVEL, then, do the following
if (isset($_GET['id']))
{
	$mSelectClient_Id = $_GET['id'];
	
	//if (!$database->switchToSystemDatabase())
	
	// Create, or activate the current SUPER ADMIN user in a different client
	if ($database->adminUserCreateOrReactivateToClient($mSelectClient_Id, $req_user_info))
	{
		// This will set the database client id etc
		if ($session->checkLogin())
		{
			// Log that we have done an admin override
			$database->logAccess($_SERVER['REMOTE_ADDR'],session_id(),'AdminOverride',$_SESSION['useruid'], $_SESSION['userclientid'],'',$_SESSION['username']);
			
			//echo '---Client---'.$_SESSION['userclientid'].'   and ....'.$database->db_client_id; die;		
			// Go to main 
			header(sprintf("Location: %s", "cr_main.php"));      
		}		
	}
	// If we have been successful with the override, we wont get to here
}


/**
 * displayUsers - Displays the users database table in
 * a nicely formatted html table.
 */
function displayClients($ClientId)
{
	global $database;

	// Can we connect the System Database?
	if ($database->connectionSystem)
	{
		//echo("HERE!"); //.'  ---  '.$query_rsMenuItems);
	}
	
	// Switch to it
	if (!$database->switchToSystemDatabase())
	{
		echo ('Could not select database: Menus are offline.');
	}
	
	$q = "
SELECT 
	c.client_id client_id,
	client_name,
	a.app_type_name app_type_name,
	app_type_display,
	app_type_desc
FROM
	client c,
	application_type a,
	client_application_subscription b
WHERE
	a.app_type_name = b.app_type_name
AND b.client_id  = c.client_id
AND b.subscription_status = 'ACTIVE'
AND a.app_type_status = 'ACTIVE'
ORDER BY client_name
";
	//echo $q; die;
	$result = $database->sqlConvert_sql_query($q, $database->connectionSystem); // or die(mysql_error());

	/* Error occurred, return given name by default */
	$num_rows = $database->sqlConvert_sql_numrows($result);
	if(!$result || ($num_rows < 0))
	{
		echo "Error displaying info";
		return;
	}
	if($num_rows == 0)
	{
		echo "Database table empty";
		return;
	}
	
	$mDisplay = '';	
	$mDisplay .= "<table width=\"650\" border=\"0\" cellspacing=\"1\" cellpadding=\"1\" bgColor=#ffffff>\n";
	$mDisplay .= "<tr>
			<td bgcolor=\"#29386B\" span class=\"style13\">Company</td>
			<td colspan=\"2\" bgcolor=\"#29386B\" span class=\"style13\">Subscriptions</td>
			<td width=\"50\" bgcolor=\"#29386B\" span class=\"style13\">Admin</td>
		 </tr>\n";

	$mLastClient_Id = 0;
	for($i=0; $i<$num_rows; $i++)
	{
		$client_id  		= $database->sqlConvert_sql_result($result,$i,"client_id");
		$client_name  		= $database->sqlConvert_sql_result($result,$i,"client_name");
		$app_type_name 		= $database->sqlConvert_sql_result($result,$i,"app_type_name");
		$app_type_display  	= $database->sqlConvert_sql_result($result,$i,"app_type_display");
		$app_type_desc   	= $database->sqlConvert_sql_result($result,$i,"app_type_desc");

		// Determine if we display the client
		if ($client_id <> $mLastClient_Id)
		{
			// Client line
			$mLastClient_Id = $client_id;
	
			// Start with a blank line
			$mDisplay .= '<tr><td colspan="4">&nbsp;</td></tr>';		
									

			$mDisplay .= '<tr><td colspan="3">'.displayCompanyNameTitle(1,$client_name.' ('.$client_id.')').'</td>';		
			$mDisplay .= "<td>"; 
			$mDisplay .= '<input name="'.$client_id.'" type="button" class="smallbtn" id="btnClient'.$i.'" value="Select" onclick="selectClient(this.id)"/>';
			$mDisplay .= "</td></tr>";			
		}
		else
		{
			// Display the menu item, but with no link
			$mMenu = menuItemBuild('', 
									$app_type_display, 
									$app_type_desc,
									'');
			$mDisplay .= '<tr><td>&nbsp;</td><td colspan="2">'.($mMenu).'</td></tr>';
		}
		
			   
		// Put in an edit button
		
		$mDisplay .= "\n";
				
	}
	$mDisplay .= "</table><br />\n";
	return $mDisplay;
} // DisplayUsers


include($_SESSION['IncPath']."include/header.php"); 
// JavaScript goes here + + +
?>
<script type="text/javascript"> 
//  Set up jQuery - Now is a good timeto see if it will fly / load up the libraries
$(document).ready(function()
{
	// Cancel buttons
	$("#cancel").click(function()
	{	
		window.location = "cr_main.php"
	}); 

	// Cancel buttons
	$("#edit").click(function()
	{	
		window.location = "cr_useredit.php"
	});
	
	<?php
	include('cr_javascript_graphics.php');
	?>	
})

function selectClient(x)
{
	var c = document.getElementById(x).name;
	var e = document.getElementById(x).value;
		
	//alert(c);
	window.location = "cr_access_client.php?id="+c;
}
</script>
<?php
include($_SESSION['IncPath']."include/header_divs.php"); 

// Start - TOP MENU 
// Default names that are replaced from the database
$mDefaultDisplay 	= 'System Administration';
$mDefaultDesc 		= 'Select a Client to Administer';
$database->getApplicationNameForWebpage($thisWebPage, $mDefaultDisplay, $mDefaultDesc);
?>
<div id="topbar">
<a class="active"><span><div id="bartitle"><?php echo($mDefaultDisplay);?></div></span></a>	
<?php
echo CheckMenuText($mDefaultDesc );
//echo CheckCurrentMenu($appSysUri, 'cr_register.php', 'Sign Up',  $incPath.'images/tb_span.png');
?>
</div>
<?php
//include($incPath."include/contact_links.php");
// END - TOP MENU
?>
<div id="frontpage" >
<div id="maintext">

<table cellpadding="5" border="0">
<tbody>
<tr>
	<td>
	<table align="left" border="0" cellspacing="5" cellpadding="5">
	<tr>
		<td>
		<?php echo(displayContainerOutline('<h1>Super Admin Center</h1>'));?>
		</td>
	</tr> 

<?php
	if ($form->num_errors > 0)
	{
		echo '<tr><td>';
		echo "<font class=dataError>".$form->num_errors." error(s) found</font>";
		echo '</td></tr>';
	}
?>
	<tr>
		<td>
<?php
		echo(displayContainerHeader(1,''));
?>
	
		<TABLE align=center cellSpacing=0 cellPadding=1 width=99% border=0>
		<TR>
			<TD width=115><span class="style5">Name</span></TD>
			<TD><span class="style5"><b><?php echo($req_user_info['u_full_name']); ?></b></span></TD>
		</TR>
		<TR>
			<TD><span class="style5">Company</span></TD>
			<TD><span class="style5"><?php echo(displayCompanyNameTitle(1,$_SESSION['userclientname'])); ?></span></TD>
		</TR>
		<TR>
			<TD><span class="style5">&nbsp;</span></TD>
			<TD></TD>
		</TR>
		</TABLE>	

		</td>
	</tr>

	
	<tr>
		<td>
<?php
////////////////////// USERS ///////////////////////////
/**
 * Display Users Table
 */
		$mDisplay = "<h2>Active & Administrable Clients </h2>";
		
		// Display the works
		echo (displayContainerOutline($mDisplay.  //
				displayBullet().'&nbsp;Click "Select" to login as an administrator for that client<br />'.
				displayBullet().'&nbsp;Note that your user information will be created as an Admin User within the client<br />'.
				displayBullet().'&nbsp;Logout to leave the accessed client<br />'.
				'<br />'.
				displayClients($req_user_info['client_id'])
			));
?>
		</td>
	</tr>

	<tr>
		<td>
		<hr />
		</td>
	</tr>
</tr>


<tr>
	<td>
	<hr />
	</td>
</tr>

</table>
</TD></TR>


</tbody>
</table>


<!-- Footer standard -->
</div> <!-- maintext -->
</div> <!-- frontpage -->
<?php 
include($_SESSION['IncPath']."include/footer.php");
?>