<?php
/**
 * cr_register_step3.php
 * 
 * Displays the registration form if the user needs to sign-up,
 * or lets the user know, if he's already logged in, that he
 * can't register another name.
 *
 * Extended by: vbaker@engenic.com
 * Last Updated: July 8, 2008
 */
$incPath = '';
require_once($incPath.'LocalSettings.php'); 
include($incPath."include/session.php");
$_SESSION['IncPath'] = $incPath;
require_once($websiteLibrary.'calcWorkUnit.php');   


include("include/header.php"); 
// JavaScript goes here
?>
<script language="javascript">
<!--
$(document).ready(function()
{
	// JavaScript standard components
	<?php include('cr_javascript_graphics.php'); ?>
})
//-->
</script>
<?php
include("include/header_divs.php"); 


// See if there was information passed in
// What was sent
$hash     = $_GET['hash'];	// Password saved at the client database user_details
$stamp    = $_GET['stamp'];	// Timestamp
$id       = $_GET['id'];	// System level user_master pk
$level    = 0;

// Set the links for fowarding
// -- Define the links to improve flow
$req_user = '';

// ALL values filled
if (($hash == '') && ($stamp == '') && ($id == ''))
{
	// Missing info
	$level = 5;
}
else
{
	// Attempt to active the user
	$level = $session->activateUser($id, $hash, base64_decode($stamp));
	
	// Make it easier for users who are successful
	if (($level == 1) || ($level == 2))
	{
		// Add the user paste into the links
		$req_user = $database->getUserFromMasterByUserId($id);
	}
}

// Determine what the messages should be
$mImage = '';
$mError = ' (00'.$level.')';
// Successfully activated
if ($level == 1)
{
	$mTitle = $sys_static_text['cr'][1600]; //'Activation Completed!';
	$mHead  = $sys_static_text['cr'][1601]; //'Your Account has been Confirmed';
	$mNext  = $sys_static_text['cr'][1602]; //'The Next Step is to Start Using '.$appMarketingName;
	$mConf  = $sys_static_text['cr'][1603].' '.displayClientAccessLink($req_user).' '.$sys_static_text['cr'][1604]; //; //'Your account is confirmed, and you can sign on at the '.displayClientAccessLink($req_user).' page.';
	$mImage = '<img src="images/done-setup.gif" width="87" height="50" />';
	$mExp   = $sys_static_text['cr'][1605]; //'This account in now confirmed, and you will be able to sign on with the email address and password you selected.';
}
// Already activated
else if ($level == 2)
{
	$mTitle = $sys_static_text['cr'][1610]; //''Previously Activated';
	$mHead  = $sys_static_text['cr'][1611].' '.$mError; //''Your Account has been Confirmed '.$mError;
	$mNext  = $sys_static_text['cr'][1612]; //''The Next Step is to Start Using '.$appMarketingName;
	$mConf  = $sys_static_text['cr'][1613].' '.displayClientAccessLink($req_user).' '.$sys_static_text['cr'][1614]; //' ; //''Your account is already confirmed. You can sign on at the '.displayClientAccessLink($req_user).' page.';
	$mImage = '';
	$mExp   = $sys_static_text['cr'][1615]; //'This account was previously confirmed. You do not need to do anything more to start using this system.';
}
// Too late: Attempted to activate after 24 hours
else if ($level == 3)
{
	$mTitle = $sys_static_text['cr'][1620]; // Activation Too Late
	$mHead  = $sys_static_text['cr'][1621].' '.$mError; //'Your Confirmation Expired '.$mError;
	$mNext  = $sys_static_text['cr'][1622]; // You need to sign up again for '.$appMarketingName;
	$mConf  = $sys_static_text['cr'][1623].' '.displayClientAccessLink($req_user).' '.$sys_static_text['cr'][1624]; //'You can sign up again on the '.displayClientAccessLink($req_user).' page.';	
	$mImage = '<img src="images/expired.gif" width="87" height="50" />';
	$mExp   = $sys_static_text['cr'][1625]; // We did not receive the account confirmation...

}
// Hash mismatch
else if ($level == 4)
{
	$mTitle = $sys_static_text['cr'][1630]; // Activation Mismatch
	$mHead  = $sys_static_text['cr'][1631].' '.$mError; // 'Your Account Cannot be Confirmed '.$mError;
	$mNext  = $sys_static_text['cr'][1632]; // 'Unable to Confirm Account for '.$appMarketingName;
	$mConf  = $sys_static_text['cr'][1633].' '.displayClientAccessLink($req_user).' '.$sys_static_text['cr'][1634]; //''You can sign up on the '.displayClientAccessLink($req_user).' page.';	
	$mImage = '';
	$mExp   = $sys_static_text['cr'][1633]; // 'Due to a mismatch in the activation URL, we cannot activate...
	
}
// Missing parameters
else if ($level == 5)
{
	$mTitle = $sys_static_text['cr'][1640]; // Parameters Missing';
	$mHead  = $sys_static_text['cr'][1641].' '.$mError; // 'Your Account Cannot be Confirmed '.$mError;
	$mNext  = $sys_static_text['cr'][1642]; //'Unable to Confirm Account for'.$appMarketingName;
	$mConf  = $sys_static_text['cr'][1643].' '.displayClientAccessLink($req_user).' '.$sys_static_text['cr'][1644]; // 'You can sign up on the '.displayClientAccessLink($req_user).' page.';	
	$mImage = '';
	$mExp   = $sys_static_text['cr'][1643]; // 'Due to missing parameters in the activation URL, we cannot activate this account...
	
}
// Failed
else
{
	$mTitle = $sys_static_text['cr'][1650]; //'Activation Error';
	$mHead  = $sys_static_text['cr'][1651].' '.$mError; // 'Your Account was not Confirmed '.$mError;
	$mNext  = $sys_static_text['cr'][1652]; // unable to Confirm Account for '.$appMarketingName;
	$mConf  = $sys_static_text['cr'][1653].' '.displayClientAccessLink($req_user).' '.$sys_static_text['cr'][1654]; // 'You can sign up on the '.displayClientAccessLink($req_user).' page.';	
	$mImage = '';
	$mExp   = $sys_static_text['cr'][1653]; // Due to a problem with this process, we cannot activate this account...
}

?>
<div id="topbar">
    <a class="active"><span><div id="bartitle"><?php echo $mTitle;?></div></span></a>
    <a><span><?php echo $mNext;?></span></a>
</div>

<div id="frontpage">
<div id="maintext">


<TABLE cellPadding=5 border=0>
<TBODY>
<TR>
<TD>

<table width="750" align="left" border="0" cellspacing="0" cellpadding="3">

<tr>
  <td width="180">&nbsp;</td>
  <td width="180">&nbsp;</td>
  <td width="180">&nbsp;</td>
  <td width="20">&nbsp;</td>
  <td>&nbsp;</td>
</tr>

<tr>
  <td colspan="3"><h2><?php echo $mHead;?></h2></td>
  <td>&nbsp;</td>
  <td><div align="right"><?php echo $mImage;?></div></td>
</tr>

<tr>
  <td colspan="5">
  <?php echo $mExp;?>
  </td>
</tr>

<tr>
  <td colspan="5">
  &nbsp;
  </td>
</tr>

<tr>
  <td colspan="5">
  <?php echo $mConf;?>
  </td>
</tr>

<tr>
  <td colspan="5">
  &nbsp;
  </td>
</tr>
  
</table>
</form>


</td></tr>

</table>

</TD>
</TR>
</TBODY>
</TABLE>

<!-- Footer standard -->
</div>	
</div>
<?php 
include("include/footer.php");
?>