<?php
/**
 * cr_main.php
 *
 * Users are be able to login and optionally sign up
 *
 * Written by (teleflow / web access updates) : javakinetic@gmail.com
 * Last Updated: Jan 13, 2009
 
 NOTE: For an explanation of how logging in works, see: session.php
 
*/
// Determine relative location for paths
require("cr_reference.php");
require_once($incPath.'LocalSettings.php'); 
require($incPath."include/session.php");
$_SESSION['IncPath'] = $incPath;
require_once($websiteLibrary.'calcWorkUnit.php'); 


// Other includes for creation of forms
require_once('cr_form_content.php');

// Ensure any previous settings of autologin are gone - This only needs to be located on this page.
unset($_SESSION['CLIENTID_BY_IP_ADDR']); 

//echo '---Client---'.$_SESSION['userclientid'].'   and ....'.$database->db_client_id; die;		

// This is a secure page, so redirect if needed
if ($cGlobalSecure) 
{
	redirectToHTTPS();
}

// Is this website locked down to access from only specific IPs ($cLocationAccess)
// See if we are allowed to access this program from the IP address we are trying from
if (defined("LOGINACCESSLIMITEDTOIP"))
{
	if ((LOGINACCESSLIMITEDTOIP == true) &&
		(!allowAccessForIPListOrLocalIPs($cLocationAccess)))
	{
		// Stop dead if nothing is supposed to follow this
		die;
	}
}

// Always reset the user when we get here
$subLocation = '';
$_SESSION["new_user_id"] = 0; // This is set in session.pnp in "register" function

/**
 * User has already logged in, so display relavent links, including
 * a link to the admin center if the user is an administrator.
 */

include($incPath."include/header.php"); 
// JavaScript goes here + + +
?>
<script language="javascript">
//  Set up jQuery - Now is a good timeto see if it will fly / load up the libraries
$(document).ready(function()
{	
	<?php include('cr_javascript_graphics.php'); ?>
	
	$("#portfolio_items").hide();
	$("#portfolio_items").fadeIn(500);
	$("#portfolio_items_company").hide();
	$("#portfolio_items_company").fadeIn(500);
	$("#portfolio_items_second").hide();
	$("#portfolio_items_second").fadeIn(1000);
}
)
</script>
<?php 
include($incPath."include/header_divs.php"); 

// Start - TOP MENU 
?>
<div id="topbar">
<?php
if (!$session->logged_in)
{
	// Login message
	echo CheckCurrentMenu($appSysUri, 'cr_main.php', providePhrase('cr', 160),  $incPath .$webCSSMenuGraphic);

	// Check to see what options we are providing
	if ((defined("SYSTEM_USERSELFSIGNUP")) && (SYSTEM_USERSELFSIGNUP == true))
	{
		echo CheckMenuText(providePhrase('cr', 164));
		$mClient_Id = -1;
		if ($appCompanySvcCode <> '')
		{
			// See if the database can match the client id
			$mClient_Id = $database->getClientIdByClientName($appCompanySvcCode);
		}

		// Are we good to allow registration?
		if ((defined("SYSTEM_USERSELFSIGNUP")) && 
			(SYSTEM_USERSELFSIGNUP == true) && 
			($mClient_Id <> -1)) 
		{		
			// User sign up
			echo CheckCurrentMenu($appSysUri, 'cr_register.php', providePhrase('cr', 161),  $incPath .$webCSSMenuGraphic);
		}
		else
		{
			// Company signup
			echo CheckCurrentMenu($appSysUri, $webSignUpPage, providePhrase('cr', 161),  $incPath .$webCSSMenuGraphic);		
		}
	}
	else
	{
		// only login
		echo CheckMenuText(providePhrase('cr', 165));
	}
}
else
{
	// Main menu
	echo CheckCurrentMenu($appSysUri, 'cr_main.php', providePhrase('cr', 162),  $incPath .$webCSSMenuGraphic);
}
?>
</div>
<?php
// Show the contacts information
include($incPath ."include/contact_links.php"); 
// END - TOP MENU

?>
<div id="frontpage">
<div id="maintext">


<?php
// If we are not in Maintenance Mode
if ($cGlobalMode !== MODE_OFFLINE)
{
	// ******************************
	// LOGGED IN SECTION
	// ******************************

	// NOTE:  Login functions are performed by "cr_process.php" called from "cr_main_signup.php" with POST of "sublogin"
	if ($session->logged_in)
	{
		// Gather user information from the login 

		// Must be up front
		// Note: This sets $_SESSION['userclientname']
		$req_client_info  = $database->getClientInfo($_SESSION['userclientid']);
		// Provide a menu solution that we can quickly update
		$AccountID = $req_client_info['client_id'];

		// Make sure we have an account associated with the user
		if ($AccountID <> "")
		{	
			$docroot  = $incPath.CLIENT_FILE_AREA;
			$menufile = $docroot.'/cr_menu_'.zeroFill($AccountID,5).'.html';
			//echo $menufile."<br />";
			if (!file_exists($menufile))
			{
				// Create the document dir if not exist
				if (!file_exists($docroot))
				{
					mkdir($docroot);
				}
				
				// Create the client area if it doesnt exist
				$docClientRoot  = $docroot.'/client_'.zeroFill($AccountID,5);
				// Does it exist?
				if (!is_dir($docClientRoot))
				{
					// Does now
					mkdir($docClientRoot);
				}
				
				// Create the menu file
				if ($fh = fopen($menufile, 'a'))
				{
					$stringData =
						('For information about other solutions, click <a href="'.$webClickTo.'">here.</a>'.
						"<!-- Created: ".Date('Y:m:d')." - ".Date('G:i:s')." -->\n\n");
					fwrite($fh, $stringData);
					fclose($fh);	
				}
			}
		}	
?>
<!--------------------------->
<!-- Liquid Start -->
<!--------------------------->
<div class="colmask rightmenu">
<div class="colleft">
<!--------------------------->
<!-- Column 1 start -->
<!--------------------------->
<div class="col1">
	
<?php 
		// Display the normal contents
		include(str_replace('.', '_contents.', $filename = array_pop(explode('/', $_SERVER['PHP_SELF']))));

		// Add the menu system into place
		if (file_exists($menufile))
		{
			// Portfolio Contents Section 
			// -- 'Custom Applications & Useful Links'
			echo(displayContainerHeader(1, providePhrase('cr', 163)));
			echo(displayContainerFileContent($menufile)); 
			echo(displayContainerFooter());
		}
?>	
</div>

<!--------------------------->
<!-- Column 1 end -->
<!--------------------------->
		
		
<!--------------------------->
<!-- Column 2 start -->
<!--------------------------->
<div class="col2">
	<?php 
	include('cr_sidepanel.php'); 
	?>
</div>
<!--------------------------->
<!-- Column 2 end -->
<!--------------------------->

</div>
</div>
<!--------------------------->
<!-- Liquid End -->
<!--------------------------->

<?php
	}
	// ******************************
	// ********* SIGN-UP and SIGN-UP SECTION
	// ******************************
	else
	{
?>
<!--------------------------->
<!-- Liquid Start -->
<!--------------------------->
<div class="colmask rightmenu">
<div class="colleft">
<!--------------------------->
<!-- Column 1 start -->
<!--------------------------->
<div class="col1 world">
	<?php 
	$mServerName = explode('/', $_SERVER['PHP_SELF']);
	$mIncFilename = str_replace('.', '_signup.', array_pop($mServerName));
	include($mIncFilename); 
	?>
	
	<?php
	// See if we have any marketing data to put here
	$mIncFilename = ('marketing/cr_main_marketing.php');
	if (file_exists($mIncFilename))
	{
		include($mIncFilename); 
	}
	?>
</div>
<!--------------------------->
<!-- Column 1 end -->
<!--------------------------->

<!--------------------------->
<!-- Column 2 start -->
<!--------------------------->
<div class="col2">
	<?php 
	include('cr_sidepanel.php'); 
	?>
</div>
<!--------------------------->
<!-- Column 2 end -->
<!--------------------------->

</div>
</div>
<!--------------------------->
<!-- Liquid End -->
<!--------------------------->
<?php
	} // Logged in
} 
else
{
	// ******************************
	// ********* MAINTENANCE MODE
	// ******************************
?>
<TABLE cellPadding=5 border=0>
<TBODY>
<TR>
<TD width=250>	

<div id="portfolio_items_company" style="display:none;">
<div class="mini_portfolio_item">
<div class="block_inside">
<?php // Portfolio Contents Section ?>
<table width="100%"> 
<?php
	// Provide the opportunity for the user to call support and get an unlock out
	$mLockoutMessage = 	providePhrase('cr', 180);
	// - See cr_form_content.php
	maintenanceDisplay(	$mLockoutMessage, $cGlobalMessage); 
?>
</table>
<?php // End of Portfolio Section ?>
</div>
</div>
</div>

</TD>
</TR>
</TBODY>
</TABLE>	
<?php
}
?>


<!-- Footer standard -->
</div> <!-- maintext -->
</div> <!-- frontpage -->
<?php 
include($incPath ."include/footer.php");
?>
