<?php
/**
 * cr_register.php
 * 
 * Displays the registration form if the user needs to sign-up,
 * or lets the user know, if he's already logged in, that he
 * can't register another name.
 *
 * by: vbaker@engenic.com
 * Last Updated: March 6, 2007
 */
require("cr_reference.php");
require_once($incPath.'LocalSettings.php'); 
include($incPath."include/session.php");
$_SESSION['IncPath'] = $incPath;
require_once($websiteLibrary.'calcWorkUnit.php');   

// Determine if the system is configured to allow users to register
// - check defined SYSTEM_USERSELFSIGNUP
// - See if code in $appCompanySvcCode exists
$mClient_Id = -1;
if ($appCompanySvcCode <> '')
{
	// See if the database can match the client id
	$mClient_Id = $database->getClientIdByClientName($appCompanySvcCode);
}

// Are we good to allow registration?
if (!((defined("SYSTEM_USERSELFSIGNUP")) && (SYSTEM_USERSELFSIGNUP == true)) ||
	($mClient_Id == -1))
{
	header(sprintf("Location: %s", "cr_main.php"));      
}

// Check to see if we have just registered someone new
if ((isset($_SESSION['regsuccess'])) && ($_SESSION["new_user_id"] > 0)) 
{
   unset($_SESSION['regsuccess']);
   // Note - $_SESSION['reguname'] is set with the persons first name
   header(sprintf("Location: %s", "cr_register_step2.php"));      
}

include("include/header.php"); 
// JavaScript goes here
?>
<script language="javascript">
function testOkayToSubmit()
{
	$mOkay=true;
	
	// Show the details, and make sure the password is at least 5 chars long
	if (PassWordStrength($("#pass").val(), 5) == 0)
	{
		$mOkay=false;	
	}
	
	if (!PassMatchTest($("#pass").val(), $("#pass2").val()))
	{
		$mOkay=false;
	}
	
	// If a name is not entered
	if ($("#namefirst").val() == '')
	{
		$mOkay=false;
	}
	if ($("#namelast").val() == '')
	{
		$mOkay=false;
	}

	
	if (!$mOkay)
	{
		// We are good to go
		$("#createbutton").removeAttr("disabled", "false").attr("disabled", "true");
	}
	else
	{
		$("#createbutton").removeAttr("disabled", "false");
	}
};


$(document).ready(function()
{
	// First time through
	jQuery(function($){
	
		$("#createbutton").attr("disabled", "true");
		
		// Ensure the user types in correctly
		$("#namefirst").mask("**?*************", {placeholder:" "});
		$("#namemiddle").mask("?*", {placeholder:" "});
		$("#namelast").mask("?****************", {placeholder:" "});
		
		// Make sure there is something to test
		if ($("#pass").val() !== "")
		{
			PassWordStrength($("#pass").val(), 1);
			PassMatchTest($("#pass").val(), $("#pass2").val());
		}
	});
	
	$("#email").keyup(function()
	{
		testOkayToSubmit();
	});
	
	$("#email").blur(function()
	{
		// Populate the user with the email address.  This is going ot represent their user.
		$("#user").val($("#email").val());
	});
	
	$("#pass").keyup(function()
	{
		testOkayToSubmit();
	});
	
	$("#pass2").keyup(function()
	{
		testOkayToSubmit();
	});
	
	
	$("#namefirst").keyup(function()
	{
		testOkayToSubmit();
	});	
	
	$("#namelast").keyup(function()
	{
		testOkayToSubmit();
	});	
	
	// JavaScript standard components
	<?php include('cr_javascript_graphics.php'); ?>
});


<!-- Header standard -->
</script>	
<?php
include("include/header_divs.php"); 
?>

<div id="topbar">
<?php 
echo CheckCurrentMenu($appSysUri, 'cr_register.php', 'Registration',  $_SESSION['IncPath'].$webCSSMenuGraphic);
echo CheckMenuText('Create Your '.$appMarketingName.' User Profile');
?>
</div>

<div id="frontpage">
<div id="maintext">
<?php

// See if a company code is being passed
$companycode = $appCompanySvcCode;  // was '' 
$form->setValue("company", $companycode);

if (isset($_SESSION['company_added'])) 
{
   $companycode = $_SESSION['company_added']; 
   $form->setvalue("user", $companycode."admin");
   $form->setvalue("company", $companycode);
   $form->setvalue("pass", '');
}
?>

<TABLE cellPadding=5 border=0>
<TBODY>
<TR>
<TD>
<?php
/**
 * The user is already logged in, not allowed to register.
 */
if(($session->logged_in) and ($companycode == ''))
{
	// Run a bit of javascript to update the title
?>
<script language="JavaScript" type="text/JavaScript">
document.getElementById("bartitle").innerHTML="Registration Failed";
</script>
<?php
   echo "<p>We're sorry <b>$session->username</b>, but your id is already registered. "
       ."<a href=\"cr_main.php\">Main</a>.</p>";
}
/**
 * The user has submitted the registration form and the
 * results have been processed.
 */
else if(isset($_SESSION['regsuccess']))
{
   /* Registration failed */
   if(!$_SESSION['regsuccess'])
   {
?>

<script language="JavaScript" type="text/JavaScript">
document.getElementById("bartitle").innerHTML="Registration Failed";
</script>

<?php
      echo "<p>We're sorry, but an error has occurred and your registration for the username <b>".$_SESSION['reguser']."</b>, "
          ."could not be completed.<br><br>Please try again at a later time.</p>";
   }
   unset($_SESSION['regsuccess']);
   unset($_SESSION['reguser']);
}
/**
 * The user has not filled out the registration form yet.
 * Below is the page with the sign-up form, the names
 * of the input fields are important and should not
 * be changed.
 */
else
{
	if($form->num_errors > 0)
	{
	   //echo "<tr><td class=dataError>".$form->num_errors." error(s) found</font></td>";
	   echo "<font class=dataError>".$form->num_errors." error(s) found</font>";
	}

	// ====================================================
	// NOTE:  PROCESS = This will create the User Identification 
	// ====================================================
	/*
	Notes: 
	   This process, internally will call $this->procRegister();  if(isset($_POST['subjoin']))
	   This, in turn calls:  $session->register(fields)
	   This, in turn calls:  $database->addNewUser(fields)
	   
	   // Removed
	<tr>  
	  <td><span class="style5"><?php echo $appMarketingName;?> Username</td>
	  <td><input type="text" name="user" maxlength="30" value="<?php echo $form->value("user"); ?>"></td>
	  <td>&nbsp;</td>
	  <td><?php echo $form->error("user"); ?></td>
	  <td>&nbsp;</td>
	</tr>
*/
?>
<form action="cr_process.php" method="POST">
<table width="750" align="left" border="0" cellspacing="0" cellpadding="3">
<tr>
  <td width="180">&nbsp;</td>
  <td width="180">&nbsp;</td>
  <td width="10">&nbsp;</td>
  <td width="180">&nbsp;</td>
  <td>&nbsp;</td>
</tr>

<tr>
  <td colspan="3">To sign up with <?php echo $appMarketingName;?>, enter your email address and select a password.  
  <?php echo $appMarketingName;?> uses your email address as a username, so ensure you are using an appropriate email
  address for this service.
  <br /><br />
  If you already have an account, you can sign on at the <a href="cr_main.php"><u>Client Access</u></a> page.</td>
  <td>&nbsp;</td>
  <td><div align="right"><img src="images/30second-setup.gif" width="87" height="50" /></div></td>
</tr>

<tr>
  <td>&nbsp;</td>
  <td colspan="4"><h2>Account Login Details</h2></td>
</tr>

<tr>
  <td><span class="style5">Email Address </td>
  <td><input type="text" name="email" id="email"  maxlength="50" size="30" value="<?php echo $form->value("email"); ?>"></td>
  <td>&nbsp;</td>
  <td><?php echo $form->error("email"); ?></td>
  <td>&nbsp;</td>
</tr>

<tr>
  <td><span class="style5">Password</td>
  <td>
	<input type="password" name="pass" id="pass" maxlength="30" size="10" value="<?php echo $form->value("pass"); ?>">
	<span id="password_strength"></span>
  </td>
  <td>&nbsp;</td>
  <td><?php echo $form->error("pass"); ?></td>
  <td>&nbsp;</td>
</tr>
<tr>
  <td><span class="style5">Retype Password</td>
  <td>
	<input type="password" name="pass2" id="pass2" maxlength="30" size="10" value="<?php echo $form->value("pass2"); ?>">
	<span id="password_match"></span>
  </td>  
  <td>&nbsp;</td>
  <td>&nbsp;</td>
  <td>&nbsp;</td>
</tr>

<?php
if (strtoupper($appMarketingName) == strtoupper("twitYAX"))
{
?>
<tr>
  <td>&nbsp;</td>
  <td colspan="4"><h2>The Name Your Friends Know You By</h2></td>
</tr>
<?php
}
else
{
?>
<tr>
  <td>&nbsp;</td>
  <td colspan="4"><h2>Your Name</h2></td>
</tr>
<?php
}
?>

<tr>
  <td><span class="style5">First Name</td>
  <td><input type="text" name="namefirst"  id="namefirst"   maxlength="25"  size="20" value="<?php echo $form->value("namefirst"); ?>"></td>
  <td>&nbsp;</td>
  <td><?php echo $form->error("namefirst"); ?></td>
  <td>&nbsp;</td>
</tr>

<tr>
  <td><span class="style5">Middle</td>
  <td><input type="text" name="namemiddle" id="namemiddle" maxlength="1"   size="1"  value="<?php echo $form->value("namemiddle"); ?>"></td>
  <td>&nbsp;</td>
  <td>&nbsp;</td>
  <td>&nbsp;</td>
</tr>

<tr>
  <td><span class="style5">Last Name</td>
  <td><input type="text" name="namelast"  id="namelast"  maxlength="50"  size="20" value="<?php echo $form->value("namelast"); ?>"></td>
  <td>&nbsp;</td>
  <td><?php echo $form->error("namelast"); ?></td>
  <td>&nbsp;</td>
</tr>

<tr>
  <td>&nbsp;</td>
  <td colspan="2" align="left">
  <input type="hidden" name="subjoin" value="1">
  <input type="hidden" name="user" id="user"  value="">
  <input type="submit" name="createbutton" id="createbutton"  value="Create Identify"></td>
  <td colspan="2"><h3><?php echo(CREDITCARD_MESSAGE);?></h3>
  </td>  
</tr>

<tr>
  <td colspan="5"></td>
</tr>

</table>
</form>
<?php
}

?>
</TD>
</TR>
</TBODY>
</TABLE>


<!-- Footer standard -->
</div>	
</div>
<?php 
include("include/footer.php");
?>