<?php
/**
 * cr_register_step3.php
 * 
 * Displays the registration form if the user needs to sign-up,
 * or lets the user know, if he's already logged in, that he
 * can't register another name.
 *
 * Extended by: vbaker@engenic.com
 * Last Updated: July 8, 2008
 */
require("cr_reference.php");
require_once($incPath.'LocalSettings.php'); 
include($incPath."include/session.php");
$_SESSION['IncPath'] = $incPath;
require_once($websiteLibrary.'calcWorkUnit.php');   

// This is a secure page, so redirect if needed
if ($cGlobalSecure) 
{
  redirectToHTTPS();
}

// Check to see if we have just registered someone new
if (isset($_SESSION['regsuccess']))
{
   unset($_SESSION['regsuccess']);
   unset($_SESSION['hash']);
   unset($_SESSION['stamp']);
   unset($_SESSION['id']);

   header(sprintf("Location: %s", "cr_setpassword2.php"));  
}


// Include all the standard JavaScript files
include("include/header.php"); 
?>
<script type="text/JavaScript">
function testOkayToSubmit()
{
	$mOkay=true;
	
	// See if anything exists
	if ( $('#pass').length ) 
	{
		// Show the details, and make sure the password is at least 5 chars long
		if (PassWordStrength($("#pass").val(), 5) == 0)
		{
			$mOkay=false;	
		}
		
		if (!PassMatchTest($("#pass").val(), $("#pass2").val()))
		{
			$mOkay=false;
		}
		
		//////////////////////////////////////
		// Override
		// - This system will ignor password changes if the fields are blank
		if (($("#pass").val() == '') && ($("#pass2").val() == ''))
		{
			$mOkay=true;
		}
		
		// Add further tests here!!!  (( Following the blank test ))
		
		if (!$mOkay)
		{
			// We are good to go
			$("#setpassbutton").removeAttr("disabled", "false").attr("disabled", "true");
		}
		else
		{
			$("#setpassbutton").removeAttr("disabled", "false");
		}
	}
}

$(document).ready(function()
{
	// First time through
	jQuery(function($){
		if ( $('#pass').length ) 
		{
			// Make sure there is something to test
			if ($("#pass").val() !== "")
			{
				PassWordStrength($("#pass").val(), 1);
				PassMatchTest($("#pass").val(), $("#pass2").val());
			}
		}
	});
	
	$("#pass").keyup(function()
	{
		testOkayToSubmit();
	});
	
	$("#pass2").keyup(function()
	{
		testOkayToSubmit();
	});
	
	// JavaScript standard components
	<?php include('cr_javascript_graphics.php'); ?>	
});
</script>
<?php

include("include/header_divs.php"); 
?>

<?php
//echo $_SESSION['id'].' @@@A@@@@ '.$_SESSION['hash'].' @@@@@@A@@@@ '.base64_decode($_SESSION['stamp']);

// If we have set the link, the we do not need to read the parameters again
if(isset($_POST['setnewpass']))
{
	// - We need to only get a response of 2 (already active) to allow a password change.
	//$level = $session->activateUser($_SESSION['id'], $_SESSION['hash'], base64_decode($_SESSION['stamp']));	
}
else if ($form->num_errors > 0)
{
	// Errors .. do nothing
	$level = 2;
}
else
{

	if (! isset($_SESSION['hash']))
	{	
		// See if there was information passed in
		// What was sent
		$_SESSION['hash']     = $_GET['hash'];
		$_SESSION['stamp']    = $_GET['stamp'];
		$_SESSION['id']       = $_GET['id'];
	}
	
	$level    = 0;

	//echo $id.'<br />'.$hash.'<br />'.base64_decode($stamp).'<br />'; 

	// ALL values filled
	if (($_SESSION['hash'] == '') && ($_SESSION['stamp'] == '') && ($_SESSION['id']  == ''))
	{
		// Missing info
		$level = 5;
	}
	else
	{
		//echo $id.'<br />'.$hash.'<br />'.base64_decode($stamp).'<br />'; // $id.
		
		// Attempt to active the user (to see if we can allow a password change
		// - We need to only get a response of 2 (already active) to allow a password change.
		// -  A response of 4 is a hash mismatch.  If the user change their password somehow since the email request it will happen here.
		$level = $session->activateUser($_SESSION['id'], $_SESSION['hash'], base64_decode($_SESSION['stamp']));
		//echo ' @@@@@@ '.$level.'<br />';
	}
}

	
// The only way we will allow a password to be reset is if the user is active already
if ($level == 2)
{
	$mTitle = 'Password Reset';
	$mHead  = 'Enter Your New Password';
	$mNext  = 'Enter Your New Password for '.$appMarketingName;
	$mConf  = 'If you no longer need your password reset, sign on at the <a href="cr_main.php"><u>Client Access</u></a> page.';
	$mExp   = 'Double enter your new password in the fields below.
';
}
// Failed
else
{
	$mTitle = 'Request Error';
	$mHead  = 'Reset Request not Granted ('.$level.')';
	$mNext  = 'Unable to Confirm Account for '.$appMarketingName;
	$mConf  = 'You can sign up on the <a href="cr_main.php"><u>Client Access</u></a> page.';	
	$mExp   = 'Due to a problem with this process, we cannot provide you with a password reset for this account.
Please check that you have the URL exactly the same is it was sent in your email.  It must 
be identical in order for the account to enable a password reset. If this remains a problem, 
please email support.
';
}

?>

<div id="topbar">
    <a class="active"><span><div id="bartitle"><?php echo $mTitle;?></div></span></a>
    <a><span><?php echo $mNext;?></span></a>
</div>

<div id="frontpage">
<div id="maintext">


<TABLE cellPadding=5 border=0>
<TBODY>
<TR>
<TD>

<form action="cr_process.php" method="POST">
<table width="750" align="left" border="0" cellspacing="0" cellpadding="3">

<?php
if ($form->num_errors > 0)
{
?>
<tr>
  <td colspan="4"><font class=dataError><?php echo $form->num_errors; ?> error(s) found</font></td>
  <td>&nbsp;</td>
</tr>
<?php
}
?>

<tr>
  <td width="180">&nbsp;</td>
  <td width="180">&nbsp;</td>
  <td width="180">&nbsp;</td>
  <td width="20">&nbsp;</td>
  <td>&nbsp;</td>
</tr>

<tr>
  <td colspan="4"><h2><?php echo $mHead;?></h2></td>
  <td>&nbsp;</td>
</tr>

<tr>
  <td colspan="5">
  <?php echo $mExp;?>
  </td>
</tr>

<tr>
  <td colspan="5">
  <?php echo $mConf;?>
  </td>
</tr>

<tr>
  <td colspan="5">
  &nbsp;
  </td>
</tr>

<?php
// Allow the user to change the password if the account was active
if ($level == 2)
{
?>

<tr>
  <td><span class="style5">Password</td>
  <td>
	<input type="password" name="pass" id="pass" maxlength="30" size="10" value="<?php echo $form->value("pass"); ?>">
	<span id="password_strength"></span>
  </td>
  <td colspan="3"><?php echo $form->error("pass"); ?></td>
</tr>

<tr>
  <td><span class="style5">Retype Password</td>
  <td>
	<input type="password" name="pass2" id="pass2" maxlength="30" size="10" value="<?php echo $form->value("pass2"); ?>">
	<span id="password_match"></span>
  </td>
  <td>&nbsp;</td>
  <td>&nbsp;</td>
  <td>&nbsp;</td>
</tr>

<tr>
  <td colspan="5">
  &nbsp;
  </td>
</tr>

<tr>
  <td>&nbsp;</td>
  <td colspan="1" align="left">
  <input type="hidden" name="setnewpass" value="1">
  <input type="hidden" name="userid" value="<?php echo $_SESSION['id']; ?>">
  <input type="submit" name="setpassbutton" id="setpassbutton" value="Set Password"></td>
  <td colspan="3"><h3>Be sure to remember your new password</h3>
  </td>  
</tr>

<?php
} // if Level 2
?>

<tr>
  <td colspan="5">
  &nbsp;
  </td>
</tr>

</table>
</form>


</td></tr>

</table>

</TD>
</TR>

<?php


?>
</TBODY>
</TABLE>


<!-- Footer standard -->
</div>	
</div>
<?php 
include("include/footer.php");
?>