<?php	

// Display a total and complete failure in a way that is at least somewhat respectable.  Send email to admin
// Note: $pProgrammerInfo is not to be seen by the user... its just notes from the program to help resolve
function UniveralSignUp_CriticalError($pServiceCode, $pErrorCode, $pDescription, $pProgrammerInfo = '')
{
	// Weve got a whole lot here... because, we are essentially running the webpage out of sync... to get a half decent looking error page
	global	$session;

	$session->SessionErrorPageDisplay(true, $pServiceCode, $pErrorCode, $pDescription, 
							(providePhrase('cr', 1415)), // 'We understand that this is probably very frustrating... 
							$pProgrammerInfo);
							
	// IMPORTANT: The very next code following this function call must be:
	/*
	die();
	exit();
	*/
} // UniveralSignUp_CriticalError


// Universal Company Signup - Page 1
/*
The way this works is when a user presses 'submit', process.php is fired which in turn checks for errors on the page via 'form' and 'session'.  
Errors will display so that the user can fix, and if none are encountered, then the program should move the user through to the next page.
*/
function UniveralSignUp_CompanyDetails( $pServiceMode,
								$pMarketingName,
								$pWebPrivacyPolicy,
								$pWebTermsService,
								$pFldcompany,
                                $pFldgmt_offset_early,
								$pFldclientobservesdst,
                                $pFldcontact_name_first,
                                $pFldcontact_name_last,
                                $pFldcontact_name_initial, 
                                $pFldphone,
                                $pFldemail,
                                $pFldemail2,
								$pFldpasslen,
                                $pFldpassword ,			
                                $pFldpassword2 ,			
                                $pFldsales_login,
								$pBtnContinueText)
{
	// Get errors from forms
	global $form;
	
	
	// Display the title descriptions
	$mDescription	= (providePhrase($pServiceMode, 1550)); // Company
	$mDescName		= (providePhrase($pServiceMode, 1551)); // Your company name
	
	// Describe the company type in a title	
	echo (displayContainerOutline('<h2>'.(providePhrase($pServiceMode, 1552)).'</h2>'));
	echo (displayContainerShadedHeader(true));
	
?>
<table width="100%" border="0" cellspacing="0" cellpadding="2">
  <tr>
    <td colspan="2">&nbsp;</td>
  </tr>
  
  <tr>  
    <td width="54%"><?php echo($mDescName);?></td>
    <td><label>
      <input name="company" type="text" id="company" size="30" value="<?php echo $pFldcompany; ?>"/>
    </label></td>
  </tr>
    
  <tr>
    <td valign="middle"><?php echo(providePhrase($pServiceMode, 1560)); //Office telephone number ?></td>
    <td valign="middle"><input name="phone" type="text" id="phone" size="15" value="<?php echo $pFldphone; ?>"/></td>
  </tr>

  <tr>
    <td valign="middle"><?php echo(providePhrase($pServiceMode, 1561)); //Local time zone ?></td>
    <td valign="middle">
		<select name="gmt_offset_early" id="gmt_offset_early">
		  <option value="-8" <?php if($pFldgmt_offset_early == -8){ echo "Selected = 'selected'";}?>>Pacific</option>
		  <option value="-7" <?php if($pFldgmt_offset_early == -7){ echo "Selected = 'selected'";}?>>Mountain</option>
		  <option value="-6" <?php if($pFldgmt_offset_early == -6){ echo "Selected = 'selected'";}?>>Central</option>
		  <option value="-5" <?php if($pFldgmt_offset_early == -5){ echo "Selected = 'selected'";}?>>Eastern</option>
		  <option value="-4" <?php if($pFldgmt_offset_early == -4){ echo "Selected = 'selected'";}?>>Atlantic</option>
		</select>
	</td>
  </tr>

  <tr>
    <td valign="middle">&nbsp;</td>
    <td valign="middle">
		<input name="txtObserveDST" type="checkbox" id="txtObserveDST" 
			<?php echo($pFldclientobservesdst); ?> />
			<?php echo(providePhrase($pServiceMode, 1562)); //Observe Daylight Savings Time? ?>	
	</td>
  </tr>
  			
  <tr>
    <td><?php echo(providePhrase($pServiceMode, 1563)); //First name (Contact) ?></td>
    <td><label>
      <input name="contact_name_first" type="text" id="contact_name_first" size="20" maxlength="25" value="<?php echo $pFldcontact_name_first; ?>"/>
    </label></td>
  </tr>

  <tr>
    <td><?php echo(providePhrase($pServiceMode, 1564)); //Last name (Contact) ?></td>
    <td><label>
      <input name="contact_name_last" type="text" id="contact_name_last" size="20" maxlength="30" value="<?php echo $pFldcontact_name_last; ?>"/>
    </label></td>
  </tr>

  <tr>
    <td><?php echo(providePhrase($pServiceMode, 1565)); //Middle initial (Contact) ?></td>
    <td><label>
      <input name="contact_name_initial" type="text" id="contact_name_initial" size="1" maxlength="1" value="<?php echo $pFldcontact_name_initial; ?>"/>
    </label></td>
  </tr>

  <tr>
    <td>&nbsp;</td>
    <td>&nbsp;</td>
  </tr>
  
  <tr>
    <td><?php echo(providePhrase($pServiceMode, 1566)); // Email (Your new username / sign-on) ?></td>
    <td><input name="email" type="text" id="email" size="30" value="<?php echo $pFldemail; ?>"/></td>
  </tr>
  
  <tr>
    <td><?php echo(providePhrase($pServiceMode, 1567)); //Retype email ?></td>
    <td><input name="email2" type="text" id="email2" size="30" value="<?php echo $pFldemail2; ?>"/></td>
  </tr>

	<?php  
	// Put any error messages in the blank line following the emails
	if(($form->num_errors > 0) && ($form->error("email")))
	{
	?>
		<tr class="style5">
		  <td>&nbsp;</td>
		  <td><?php echo $form->error("email"); ?></td>
		</tr>
	<?php   
	}
	else
	{
	?>
		<tr>
		  <td>&nbsp;</td>
		  <td>&nbsp;</td>
		</tr>
	<?php   
	}
	?>
  
  <tr>
    <td><?php echo(providePhrase($pServiceMode, 1568)); //Create Password (At least x characters) ?></td>
    <td>
		<input name="pass" type="password" id="pass" size="15" value="<?php echo $pFldpassword; ?>"/>
		<span id="password_strength"></span>
	</td>
  </tr>
  
  <tr>
    <td><?php echo(providePhrase($pServiceMode, 1569)); //Retype Password ?></td>
    <td>
		<input name="pass2" type="password" id="pass2" size="15" value="<?php echo $pFldpassword2; ?>"/>
		<span id="password_match"></span>
	</td>
  </tr>
  
  <tr>
    <td>&nbsp;</td>
    <td>&nbsp;</td>
  </tr>    
  
  <tr>
    <td><?php echo(providePhrase($pServiceMode, 1570)); //Promotional Code (REQUIRED for Trial) ?></td>
    <td><input name="sales_login" type="text" id="sales_login" size="2" maxlength="3" value="<?php echo $pFldsales_login; ?>"/></td>
  </tr>

  <tr>
    <td>&nbsp;</td>
    <td>&nbsp;</td>
  </tr>
  
  <tr>
    <td><?php echo(providePhrase($pServiceMode, 1571)); //How did you hear about us ?></td>
    <td><label>
    <select name="select" >
		<?php echo(providePhrase($pServiceMode, 1572)); // Options for dropdown ?>
    </select>
    </label>
	</td>
  </tr>
  
  <tr>
    <td colspan="2">&nbsp;</td>
  </tr>
  
  <tr>
    <td colspan="2"><label>
        <div align="left">
        <input name="updates" type="checkbox" id="updates" value="receive-updates" checked="checked" value="<?php echo $pFldupdates; ?>"/>
          &nbsp;
			<?php echo(providePhrase($pServiceMode, 1573)); // Receive newsletters via email? ?>
			<!--  <input name="client_package" type="hidden" id="client_package" value="trial" /> -->
        <span class="bodytxtblu">
        <input name="triallength" type="hidden" id="triallength" value="10" />
        </span>&nbsp; 
			(<a href="<?php echo($pWebPrivacyPolicy);?>" target="_blank">
			<?php echo(providePhrase($pServiceMode, 126)); // Review Privacy Policy ?></a>)
		</div>
        </label>
    </td>
  </tr>
  
  
  <tr>
	  <table width="100%" border="0" cellpadding="2" cellspacing="0">
	    <tr>
	      <td colspan="4">
		  <p>
	      <input name="updates2" id="updates2" type="checkbox" value="terms_accepted" />
	      &nbsp;
			<?php echo(providePhrase($pServiceMode, 123)); // I have read the ?>
			<a href="<?php echo($pWebTermsService);?>" target="_blank">
				<?php echo(providePhrase($pServiceMode, 124)); // "Terms of Service"?>
			</a>
			<?php echo(providePhrase($pServiceMode, 125)); // , and agree to them.?>&nbsp;
          </p>
          </td>
	    </tr>
	    <tr>
	      <td colspan="2" class="bodytxtblu">&nbsp;</td>
	      <td width="20%" class="bodytxtblu">&nbsp;</td>
	      <td width="26%"><label> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
	      <input name="continuesignup" id="continuesignup" type="submit" disabled="true" value="<?php echo($pBtnContinueText);?>" />
          <input name="MM_insert" type="hidden" value="form1" />
	      </label></td>
	    </tr>
	    <tr>
	      <td colspan="3">&nbsp;
		  </td>
		  <td>
			<div id="ajax-loader" class="ajax-loaderdiv" style="display:none">
				<img height="32" width="32" border="0" alt="Working..." src="../images/ajax-loader.gif"/>
				<?php echo(providePhrase($pServiceMode, 1580)); // 30 seconds ?>
			</div>
          </td>
	    </tr>
		
	  </table>
  </tr>
  
<?php	
	echo (displayContainerShadedFooter());

?>  
</table> 
<?php
}



// Universal Credit Card signup
/*
Credit card details need to be saved by a process in the main program.  This method simply manages details for the singup
*/
function UniveralSignUp_CreditCard( $pServiceMode,
								$pClientId,
								$pButtonLabel,
								$pMarketingName,
								$pWebPrivacyPolicy,
								$pWebTermsService,
								$pWebTermsServiceDescription,
								$pCardname,
								$pCcnumber,
								$pCcType,
								$pExpMonth,
								$pExpYear,								
								$pVerification,
								$pAddress1,
								$pAddress2,
								$pCity,
								$pStateProv,
								$pCountry,
								$pZipcode,
								$pTelephone,
								$pEmail,
								$pNotes,
								$pCardTypes = 'MasterCard,Visa,Amex')
{
	// Get errors from forms
	global $form;
		
	// Display the title descriptions
	$mDescription	= (providePhrase($pServiceMode, 1550)); // Company
	$mDescName		= (providePhrase($pServiceMode, 1551)); // Your company name
	
	
	// Set up the Credit Card Type radio button
	$mCheck1 = '';
	$mCheck2 = '';
	$mCheck3 = '';
	if ($pCcType == 'Visa')
	{
		$mCheck1 = 'checked="true"';
	}
	if ($pCcType == 'MasterCard')
	{
		$mCheck2 = 'checked="true"';
	}
	if ($pCcType == 'Amex')
	{
		$mCheck3 = 'checked="true"';
	}
	
	// Show the card types allowed:
	$mCardRadios = '';
	if (strpos('!'.strtoupper($pCardTypes),'VISA') > 0)
	{
		$mCardRadios .=
		'<label>
			<input type="radio" name="ccType" id="ccType" value="Visa" 			'.$mCheck1.' />
			Visa
		</label>';
	}
	
	if (strpos('!'.strtoupper($pCardTypes),'MASTERCARD') > 0)
	{
		$mCardRadios .=
		'<label>&nbsp;&nbsp;
			<input type="radio" name="ccType" id="ccType" value="MasterCard"	'.$mCheck2.'  />
			M/C
		</label>';
	}
	
	if (strpos('!'.strtoupper($pCardTypes),'AMEX') > 0)
	{		
		$mCardRadios .=
		'<label>&nbsp;&nbsp;
			<input type="radio" name="ccType" id="ccType" value="Amex" 			'.$mCheck3.' />
			AMEX
		</label>';
	}
		
	// Create the Months drop down
	$mMonthOptions = '';
	$mMonths = 'January,February,March,April,May,June,July,August,September,October,November,December';
	$mParts = explode(',',$mMonths);
	$mLoop = 0;
	foreach ($mParts as $mEachOne)
	{
		$mLoop++;
		$mStrNumber = rightstr('0'.$mLoop,2);
		$mText = trim($mEachOne).' ('.$mStrNumber.')';	

		// Add if we are selected
		if ($mStrNumber == $pExpMonth)
		{
			$mMonthOptions .= '<option value="'.$mStrNumber.'" selected="selected">'.$mText.'</option>';
		}
		else
		{
			$mMonthOptions .= '<option value="'.$mStrNumber.'">'.$mText.'</option>';		
		}
	}
	
	// Create the Years drop down
	$mYearOptions = '';
	$mYear = date("Y");	
	for($mLoop = $mYear; $mLoop<=$mYear+8; $mLoop++)
	{
		// Add if we are selected
		if ($mLoop == $pExpYear)
		{
			$mYearOptions .= '<option value="'.$mLoop.'" selected="selected">'.$mLoop.'</option>';
		}
		else
		{
			$mYearOptions .= '<option value="'.$mLoop.'">'.$mLoop.'</option>';		
		}
	}
	
	// Get the options with a selection for province and state
	$mProvStateOptions	= buildProvStateListDropdown($pStateProv);
	// Countries
	$mCountryOptions	= buildCountryListDropdown($pCountry);
	
?>
<table width="100%" border="0" cellspacing="0" cellpadding="2">
  <tr>
    <td colspan="2">&nbsp;</td>
  </tr>
  <tr>
    <td colspan="2" valign="middle">Name on Card</td>
    <td colspan="2" valign="middle">
	<label>
      <input name="cardname" type="text" id="cardname" size="30" value="<?php echo($pCardname);?>"/>
    </label>
	</td>
  </tr>
  
  <tr>
    <td colspan="2" valign="middle">&nbsp;</td>
    <td colspan="2" valign="middle">&nbsp;</td>
  </tr>
  
  <tr>
    <td colspan="2" valign="middle">Card Number</td>
    <td colspan="2" valign="middle"><input name="ccnumber" type="text" id="ccnumber" size="30" value="<?php echo($pCcnumber);?>"/></td>
  </tr>
  
  <tr>
    <td colspan="2" valign="middle">Card Type</td>
    <td colspan="2" valign="middle">
		<?php echo($mCardRadios); ?>
        <br />
        <br />
	</td>
  </tr>
  
  <tr>
    <td colspan="2" valign="middle">Expiry Date</td>
    <td colspan="1" valign="middle"><label>
      <select name="expMonth" id="expMonth">
		<?php echo($mMonthOptions);?>
      </select>
    </label>
    </td>
    <td colspan="1" valign="middle"><label>
      <select name="expYear" id="expYear"> 
		<?php echo($mYearOptions);?>
      </select>
    </label>
    </td>
  </tr>
  
  <tr>
    <td width="36%" valign="middle">Verification Code (3 digits) </td>
    <td width="16%" valign="middle"><img src="../images/cvv.gif" width="51" height="31" /></td>
    <td colspan="2" valign="middle"><input name="verification" type="text" id="verification" size="10" value="<?php echo($pVerification);?>"/></td>
  </tr>
  
  <tr>
    <td colspan="2" valign="middle">&nbsp;</td>
    <td colspan="2" valign="middle">&nbsp;</td>
  </tr>
  
  <tr>
    <td colspan="2" valign="middle">Billing Address</td>
    <td colspan="2" valign="middle"><input name="address1" type="text" id="address1" size="30" value="<?php echo($pAddress1);?>"/></td>
  </tr>
  
  <tr>
    <td colspan="2" valign="middle">Billing Address 2</td>
    <td colspan="2" valign="middle"><input name="address2" type="text" id="address2" size="30" value="<?php echo($pAddress2);?>"/></td>
  </tr>
  
  <tr>
    <td colspan="2" valign="middle">City</td>
    <td colspan="2" valign="middle"><input name="city" type="text" id="city" size="30" value="<?php echo($pCity);?>"/></td>
  </tr>
  
  <tr>
    <td colspan="2" valign="middle">State / Province</td>
    <td colspan="2" valign="middle">
	<label>
      <select name="state" id="state">
		<?php echo($mProvStateOptions);?>
      </select>
    </label>
	</td>
  </tr>
  
  <tr>
    <td colspan="2" valign="middle">Country</td>
    <td colspan="2" valign="middle">
	<label>
    <select name="country" id="country">
		<?php echo($mCountryOptions);?>
    </select>
    </label>
	</td>
  </tr>
  
  <tr>
    <td colspan="2" valign="middle">Zip / Postal Code</td>
    <td colspan="2" valign="middle"><input name="zipcode" type="text" id="zipcode" size="30" value="<?php echo($pZipcode);?>"/></td>
  </tr>
  
  <tr>
    <td colspan="4">&nbsp;</td>
  </tr>

  <tr>
    <td colspan="2" valign="middle">Telephone number</td>
    <td colspan="2" valign="middle"><input name="telephone" type="text" id="telephone" size="30" value="<?php echo($pTelephone);?>"/></td>
  </tr>
  
  <tr>
    <td colspan="2" valign="middle">Email address</td>
    <td colspan="2" valign="middle"><input name="email" type="text" id="email" size="30" value="<?php echo($pEmail);?>"/></td>
  </tr>
  
  <tr>
    <td colspan="1" valign="middle">&nbsp;</td>
    <td colspan="3" valign="middle" align="center"><span class="largerfont" id="emailreview"></span></td>
  </tr>
  
  <tr>
    <td colspan="2" valign="middle">Notes to yourself about the purchase (optional)</td>
    <td colspan="2" valign="middle"><input name="freenotes" type="text" id="freenotes" size="30" value="<?php echo($pNotes);?>"/></td>
  </tr>

  <tr>
    <td colspan="4">&nbsp;</td>
  </tr>
  
  <tr>
	<td colspan="4">
	<input name="termAccepted" id="termAccepted" type="checkbox" value="terms_accepted" />
	&nbsp;I have read the <a href="<?php echo($pWebTermsService);?>" target="_blank">"<?php echo($pWebTermsServiceDescription);?>"</a>, and agree to it.&nbsp;
	</td>
  </tr>
  
  <tr>
    <td align="right" id="ErrorText" colspan="3" class="bodytxtblu">
	</td>
	<td align="right" id="SubmitText" width="31%">
	<label>
		<input name="hiddenField" type="hidden" value="<?php echo($pClientId);?>" />
		<input name="Submit" type="submit" id="Submit" value="<?php echo($pButtonLabel);?>" />
		<input type="hidden" name="MM_update" value="form1">
    </label>
	</td>
  </tr>
  
  <tr>
    <td colspan="4" class="bodytxtblu"></td>
  </tr>
  
	<tr>
	  <td colspan="3">&nbsp;
	  </td>
	  <td align="right">
		<div id="ajax-loader" class="ajax-loaderdiv" style="display:none">
			<img height="32" width="32" border="0" alt="Working..." src="../images/ajax-loader.gif"/>
			Processing...
		</div>
	  </td>
	</tr>
  
</table>

	
<?php
}


// Affiliate signup
/*
Credit card details need to be saved by a process in the main program.  This method simply manages details for the singup
*/
function UniveralSignUp_Affiliate( $pServiceMode,
								$pClientId,
								$pButtonLabel,
								$pMarketingName,
								$pWebPrivacyPolicy,
								$pWebTermsService,
								$pWebTermsServiceDescription,
								$pContactName,
								$pTelephone,
								$pEmail,
								$pFldpasslen,
								$pFldpassword,
								$pFldpassword2)
{
	// Get errors from forms
	global $form;
	
?>
<table width="100%" border="0" cellspacing="0" cellpadding="2">
  <tr>
    <td colspan="2">&nbsp;</td>
  </tr>
  <tr>
    <td colspan="2" valign="middle">Contact Name</td>
    <td colspan="2" valign="middle">
	<label>
      <input name="contactname" type="text" id="contactname" size="30" value="<?php echo($pContactName);?>"/>
    </label>
	</td>
  </tr>
  
  <tr>
    <td colspan="2" valign="middle">&nbsp;</td>
    <td colspan="2" valign="middle">&nbsp;</td>
  </tr>
  
  <tr>
    <td colspan="2" valign="middle">Telephone number</td>
    <td colspan="2" valign="middle"><input name="telephone" type="text" id="telephone" size="30" value="<?php echo($pTelephone);?>"/></td>
  </tr>
  
  <tr>
    <td colspan="2" valign="middle">Email address</td>
    <td colspan="2" valign="middle"><input name="email" type="text" id="email" size="30" value="<?php echo($pEmail);?>"/></td>
  </tr>
  
  <tr>
    <td colspan="4" valign="middle" align="center"><span class="largerfont" id="emailreview"></span></td>
  </tr>
  
  <tr>
    <td colspan="4">&nbsp;</td>
  </tr>
  
  <tr>
    <td colspan="2">Create Password (At least <?php echo($pFldpasslen);?> characters) </td>
    <td colspan="2">
		<input name="pass" type="password" id="pass" size="15" value="<?php echo $pFldpassword; ?>"/>
		<span id="password_strength"></span>
	</td>
  </tr>
  
  <tr>
    <td colspan="2">Retype Password </td>
    <td colspan="2">
		<input name="pass2" type="password" id="pass2" size="15" value="<?php echo $pFldpassword2; ?>"/>
		<span id="password_match"></span>
	</td>
  </tr>

  <tr>
    <td colspan="4">&nbsp;</td>
  </tr>
  
  <tr>
	<td colspan="4">
	<input name="termAccepted" id="termAccepted" type="checkbox" value="terms_accepted" />
	&nbsp;I have read the <a href="<?php echo($pWebTermsService);?>" target="_blank">"<?php echo($pWebTermsServiceDescription);?>"</a>, and agree to it.&nbsp;
	</td>
  </tr>
  
  <tr>
    <td align="right" id="ErrorText" colspan="3" class="bodytxtblu">
	</td>
	<td align="right" id="SubmitText" width="31%">
	<label>
		<input name="hiddenField" type="hidden" value="<?php echo($pClientId);?>" />
		<input name="Submit" type="submit" id="Submit" value="<?php echo($pButtonLabel);?>" />
		<input type="hidden" name="MM_join" value="form1">
    </label>
	</td>
  </tr>
  
  <tr>
    <td colspan="4" class="bodytxtblu"></td>
  </tr>
  
	<tr>
	  <td colspan="3">&nbsp;
	  </td>
	  <td align="right">
		<div id="ajax-loader" class="ajax-loaderdiv" style="display:none">
			<img height="32" width="32" border="0" alt="Working..." src="../images/ajax-loader.gif"/>
			Processing...
		</div>
	  </td>
	</tr>
  
</table>
<?php
}
?>