--
-- Table structure for table `campaign_dialer_app`
--
CREATE TABLE `campaign_dialer_app` (
  `campaign_id` int(10) NOT NULL auto_increment,
  `send_callerid` varchar(20) default NULL,
  `audio_file_web` varchar(128) default NULL,
  `audio_file1` varchar(128) NOT NULL,
  `play_count` int(2) unsigned NOT NULL default '1',
  `transfer_yn` char(1) NOT NULL default 'N',
  `transfer_phone_number` varchar(12) default NULL,
  `transfer_extension` varchar(10) default NULL,
  `create_dtm_utc` datetime,
  `update_dtm_utc` datetime,
  `create_dtm_host` datetime,
  `update_dtm_host` datetime,
  `create_dtm_client` datetime,
  `update_dtm_client` datetime,
  PRIMARY KEY  (`campaign_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `campaign_dialer_call_list`
--
CREATE TABLE `campaign_dialer_call_list` (
  `campaign_call_list_id` int(10) unsigned NOT NULL auto_increment,
  `campaign_id` int(10) NOT NULL,
  `phone_number` varchar(10) default NULL,
  `callout_status` varchar(8) NOT NULL default 'NEW',
  `play1_start_time` double(16,4) default NULL,
  `play1_end_time` double(16,4) default NULL,
  `play2_start_time` double(16,4) default NULL,
  `play2_end_time` double(16,4) default NULL,
  `play_iterations` int(2) unsigned NOT NULL default '1',
  `transfer_opt_avail` char(1) default NULL,
  `transfer_opt_play_time` double(16,4) default NULL,
  `transfer_opt_chosen` char(1) default NULL,
  `transfer_time` double(16,4) default NULL,
  `transfer_duration` int(6) unsigned default NULL,
  `create_dtm_utc` datetime,
  `update_dtm_utc` datetime,
  `create_dtm_host` datetime,
  `update_dtm_host` datetime,
  `create_dtm_client` datetime,
  `update_dtm_client` datetime,
  PRIMARY KEY  (`campaign_call_list_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
CREATE TRIGGER
    campaign_dialer_app_insert_datetime
BEFORE INSERT ON
    campaign_dialer_app
FOR EACH ROW SET
    NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
    NEW.create_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND),
    NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
   campaign_dialer_app_update_datetime
BEFORE UPDATE ON
   campaign_dialer_app
FOR EACH ROW SET
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
   campaign_dialer_list_insert_datetime
BEFORE INSERT ON
   campaign_dialer_call_list
FOR EACH ROW SET
   NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.create_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
   campaign_dialer_list_update_datetime
BEFORE UPDATE ON
   campaign_dialer_call_list
FOR EACH ROW SET
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
