#
# Table structure for table 'application_subscription_billing'
#
CREATE TABLE /*!32312 IF NOT EXISTS*/ `app_subscription_billing` (
  `appsub_billing_id` int(10) unsigned NOT NULL auto_increment,
  `app_type_name` varchar(30) default NULL,
  `u_id` int(10) unsigned default NULL,
  `appsub_billing_package` varchar(30) default NULL,
  `appsub_billing_min_charge` decimal(10,2) unsigned default NULL,
  `appsub_billing_max_charge` decimal(10,2) unsigned default NULL,
  `appsub_transaction_charge` decimal(10,2) unsigned default NULL,
  `appsub_transaction_unit` varchar(10) default NULL,
  `create_dtm_utc` datetime,
  `update_dtm_utc` datetime,
  `create_dtm_host` datetime,
  `update_dtm_host` datetime,
  `create_dtm_client` datetime,
  `update_dtm_client` datetime,
  PRIMARY KEY  (`appsub_billing_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
#
# Table structure for table 'call_log'
#
CREATE TABLE /*!32312 IF NOT EXISTS*/ `call_log` (
  `call_log_id` int(10) unsigned NOT NULL auto_increment,
  `call_direction` varchar(3) default NULL,
  `app_type_name` varchar(30) default NULL,
  `call_start_dtm_utc` datetime default NULL,
  `call_end_dtm_utc` datetime default NULL,
  `call_start_dtm_client` datetime default NULL,
  `call_end_dtm_client` datetime default NULL,
  `call_duration` int(6) default NULL,
  `call_attempt_duration` int(6) default NULL,
  `ivr_computer_name` varchar(50) default NULL,
  `ivr_port` int(3) default NULL,
  `called_number` varchar(20) default NULL,
  `calling_number` varchar(20) default NULL,
  `callout_schedule_id` int(10) unsigned default NULL,
  `callout_app_id` int(10) unsigned default NULL,
  `initial_voice_length` int(10) default NULL,
  `callout_result_code` varchar(20) default NULL,
  PRIMARY KEY  (`call_log_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
#
# Table structure for table 'callout_schedule'
#
CREATE TABLE /*!32312 IF NOT EXISTS*/ `callout_schedule` (
  `callout_schedule_id` int(10) unsigned NOT NULL auto_increment,
  `app_type_name` varchar(30) default NULL,
  `callout_app_id` int(10) unsigned default NULL,
  `callout_phone` varchar(20) default NULL,
  `send_ani` varchar(20) default NULL,
  `callout_start_dt_client` date default NULL,
  `callout_end_dt_client` date default NULL,
  `last_call_dtm_client` datetime default NULL,
  `last_call_dtm_utc` datetime default NULL,
  `callout_status` varchar(20) default NULL,
  `task_fail_count` int(2) default '0',
  `task_noanswer_count` int(2) default '0',
  `task_error_count` int(2) default '0',
  `task_max_fail` int(2) default NULL,
  `task_max_noanswer` int(2) default NULL,
  `callout_task_priority` int(10) default '1',
  `callout_retry_seconds` int(6) default '1800',
  `create_dtm_utc` datetime,
  `update_dtm_utc` datetime,
  `create_dtm_host` datetime,
  `update_dtm_host` datetime,
  `create_dtm_client` datetime,
  `update_dtm_client` datetime,
  PRIMARY KEY `callout_schedule_id` (`callout_schedule_id`),
  KEY `app_type_name` (`app_type_name`),
  KEY `callout_status` (`callout_status`),
  KEY `call_date_range` (`callout_start_dt_client`, `callout_end_dt_client`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
#
# Table structure for table 'callout_settings'
#
CREATE TABLE /*!32312 IF NOT EXISTS*/ `callout_settings` (
  `callout_settings_id` int(10) unsigned NOT NULL auto_increment,
  `app_type_name` varchar(30) default NULL,
  `send_caller_id` varchar(20) default NULL,
  `call_transfer_status` varchar(10) default NULL,
  `call_transfer_phone` varchar(20) default NULL,
  `call_transfer_ext` varchar(10) default NULL,
  `call_transfer_ext_pause` int(10) default NULL,
  `callout_max_fail` int(3) default NULL,
  `callout_max_no_answer` int(3) default NULL,
  `early_hangup_check_yn` char(1) default NULL,
  `early_hangup_max_seconds` int(5) default NULL,
  `early_hangup_retry_call` char(1) default NULL,
  `machine_check_yn` char(1) default NULL,
  `machine_min_length` int(5) default NULL,
  `machine_run_app_yn` char(1) default NULL,
  `callout_start_tm_weekdays` time default NULL,
  `callout_end_tm_weekdays` time default NULL,
  `callout_start_tm_sat` time default NULL,
  `callout_end_tm_sat` time default NULL,
  `callout_start_tm_sun` time default NULL,
  `callout_end_tm_sun` time default NULL,
  `callout_start_num_days_ahead` int(3) default NULL,
  `callout_end_num_days_ahead` int(3) default '1',
  `callout_retry_seconds` int(6) default '1800',
  `create_dtm_utc` datetime,
  `update_dtm_utc` datetime,
  `create_dtm_host` datetime,
  `update_dtm_host` datetime,
  `create_dtm_client` datetime,
  `update_dtm_client` datetime,
  PRIMARY KEY  (`callout_settings_id`),
  KEY `app_type_name` (`app_type_name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
#
# Table structure for table 'client_details'
#
CREATE TABLE `client_details` (
  `client_id` int(10) unsigned NOT NULL default '0',
  `client_name` varchar(50) default NULL,
  `primary_contact_u_id` int(10) unsigned default NULL,
  `client_utc_offset` float(4,1) default NULL,
  `client_timezone` varchar(4) default NULL,
  `client_observes_dst_yn` char(1) default NULL,
  `client_send_callerid` varchar(20) default NULL,
  `client_transfer_status` varchar(10) default NULL,
  `client_transfer_phone` varchar(20) default NULL,
  `client_transfer_ext` varchar(10) default NULL,
  `client_transfer_ext_pause` int(10) default NULL,
  `client_phone` varchar(20) default NULL,
  `client_fax` varchar(20) default NULL,
  `client_email_address` varchar(50) default NULL,
  `client_website` varchar(255) default NULL,
  `client_address` varchar(40) default NULL,
  `client_city` varchar(20) default NULL,
  `client_state` varchar(20) default NULL,
  `client_zip` varchar(15) default NULL,
  `client_country` varchar(15) default NULL,
  `client_type` varchar(30) default NULL,
  `client_package` varchar(15) default NULL,
  `client_promo_code` varchar(20) default NULL,
  `client_cc_name` varchar(40) default NULL,
  `client_bill_address1` varchar(255) default NULL,
  `client_bill_address2` varchar(255) default NULL,
  `client_bill_city` varchar(30) default NULL,
  `client_bill_state` varchar(30) default NULL,
  `client_bill_country` varchar(30) default NULL,
  `client_bill_zip` varchar(10) default NULL,
  `client_bill_phone` varchar(20) default NULL,
  `client_cc_type` varchar(20) default NULL,
  `client_cc_verify_code` int(10) default NULL,
  `client_cc_num` bigint(40) unsigned default NULL,
  `client_cc_expiry_month` int(10) unsigned default NULL,
  `client_cc_expiry_year` int(10) unsigned default NULL,
  `client_last_billing` varchar(20) default NULL,
  `client_referrer` varchar(30) default NULL,
  `client_enews` varchar(10) default NULL,
  `client_startdate` varchar(10) default NULL,
  `triallength` varchar(10) default NULL,
  `create_dtm_utc` datetime,
  `update_dtm_utc` datetime,
  `create_dtm_host` datetime,
  `update_dtm_host` datetime,
  `create_dtm_client` datetime,
  `update_dtm_client` datetime,
  PRIMARY KEY  (`client_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `custom_message`
--
CREATE TABLE `custom_message` (
  `custom_msg_id` int(10) unsigned NOT NULL auto_increment,
  `app_type_name` varchar(30) default NULL,
  `custom_msg_status` varchar(10) default NULL,
  `app_custom_type` varchar(100) default NULL,
  `cust_type_short_display` varchar(30) default NULL,
  `cust_type_description` varchar(100) default NULL,
  `custom_msg_app_num` int(10) default NULL,
  `custom_msg_menu_order` int(10) default NULL,
  `custom_msg_order_num` int(10) default NULL,
  `custom_msg_code` varchar(50) default NULL,
  `custom_msg_data` varchar(50) default NULL,
  `custom_msg_script` varchar(255) default NULL,
  `multi_play_yn` char(1) default 'Y',
  `multi_play_alternate_id` int(10) unsigned default '0',
  `play_once_only` char(1) default 'N',
  `create_dtm_utc` datetime,
  `update_dtm_utc` datetime,
  `create_dtm_host` datetime,
  `update_dtm_host` datetime,
  `create_dtm_client` datetime,
  `update_dtm_client` datetime,
  PRIMARY KEY  (`custom_msg_id`),
  KEY `app_type` (`app_type_name`,`app_custom_type`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
#
# Table structure for table 'event_log'
#
CREATE TABLE /*!32312 IF NOT EXISTS*/ `event_log` (
  `event_log_id` int(10) unsigned NOT NULL auto_increment,
  `evt_date` varchar(10) NOT NULL default '',
  `evt_time` varchar(8) NOT NULL default '',
  `evt_computer_name` varchar(50) NOT NULL default '',
  `evt_port` char(3) NOT NULL default '',
  `log_format_version` char(3) NOT NULL default '',
  `evt_code` varchar(30) NOT NULL default '',
  `evt_start` int(10) NOT NULL default '0',
  `call_duration` int(10) NOT NULL default '0',
  `logging_app` varchar(30) NOT NULL default '',
  `site_code` varchar(30) NOT NULL default '',
  `region_code` varchar(30) NOT NULL default '',
  `evt_type` varchar(30) NOT NULL default '',
  `evt_data1` varchar(30) NOT NULL default '',
  `evt_data2` varchar(30) NOT NULL default '',
  `evt_data3` varchar(30) NOT NULL default '',
  `evt_timestamp` int(10) default NULL,
  PRIMARY KEY  (`event_log_id`),
  KEY `evt_date` (`evt_date`),
  KEY `evt_time` (`evt_time`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table 'file_application_transfer'
--
CREATE TABLE `file_application_transfer` (
  `fat_id` int(10) unsigned NOT NULL auto_increment,
  `fat_app_type_name` varchar(50) default NULL,
  `fat_status` varchar(10) default NULL,
  `fat_wav_type` varchar(5) default NULL,
  `fat_gsm_type` varchar(5) default NULL,
  `fat_mp3_type` varchar(5) default NULL,
  `fat_dest_type` varchar(30) default NULL,
  `fat_dest_host_name` varchar(100) default NULL,
  `fat_dest_ssl_type` varchar(5) default NULL,
  `fat_dest_user_name` varchar(30) default NULL,
  `fat_dest_user_pass` varchar(20) default NULL,
  `fat_dest_folder` varchar(250) default NULL,
  `create_dtm_utc` DATETIME,
  `update_dtm_utc` DATETIME,
  `create_dtm_client` DATETIME,
  `update_dtm_client` DATETIME,
  PRIMARY KEY  (`fat_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `guest_active`
--
CREATE TABLE `guest_active` (
  `g_id` varchar(15) NOT NULL,
  `g_timestamp` int(11) unsigned NOT NULL,
  PRIMARY KEY  (`g_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `media_file`
--
CREATE TABLE `media_file` (
  `media_file_id` INT(10) unsigned NOT NULL auto_increment,
  `media_file_directory` VARCHAR(255) default NULL,
  `media_file_name` VARCHAR(255) default NULL,
  `media_owner_u_id` INT(10) UNSIGNED DEFAULT NULL,
  `file_reference_id` INT UNSIGNED,
  `app_type_name` VARCHAR(30) default NULL,
  `media_file_type` VARCHAR(30) default NULL,
  `ivr_computer_name` VARCHAR(50) default NULL,
  `ivr_port` TINYINT UNSIGNED,
  `file_create_start_dtm_utc` DATETIME,
  `file_create_end_dtm_utc` DATETIME,
  `file_create_start_dtm_client` DATETIME,
  `file_create_end_dtm_client` DATETIME,
  `file_duration` INT(5) UNSIGNED,
  `file_size` INT UNSIGNED,
  `file_app_status` VARCHAR(15),
  `app_status_update_dtm_utc` DATETIME,
  `app_status_update_dtm_client` DATETIME,
  `file_transfer_status` VARCHAR(15),
  `file_note` VARCHAR(255) default NULL,
  `call_direction` VARCHAR(10) default NULL,
  `called_number` VARCHAR(20) default NULL,
  `calling_number` VARCHAR(20) default NULL,
  `recording_start_trigger` VARCHAR(40) default NULL,
  `recording_stop_trigger` VARCHAR(40) default NULL,
  `recording_protocol` VARCHAR(10) default NULL,
  `cc_agent_id` INT(10) UNSIGNED,
  `cc_extension` VARCHAR(10) default NULL,
  `error_text` VARCHAR(150) default NULL,
  `create_dtm_utc` DATETIME,
  `update_dtm_utc` DATETIME,
  `create_dtm_client` DATETIME,
  `update_dtm_client` DATETIME,
  PRIMARY KEY(`media_file_id`),
  KEY `file_transfer_status` (`file_transfer_status`),
  KEY `file_app_status` (`file_app_status`),
  KEY `media_file_name` (`media_file_name`)
  ) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `media_file_transfer`
--
CREATE TABLE `media_file_transfer` (
  `mft_id` INT(10) UNSIGNED NOT NULL auto_increment,
  `fat_id` INT(10),
  `media_file_id` INT(10),
  `mft_status` VARCHAR(15),
  `create_dtm_utc` DATETIME,
  `update_dtm_utc` DATETIME,
  `create_dtm_client` DATETIME,
  `update_dtm_client` DATETIME,
  PRIMARY KEY(`mft_id`),
  KEY `mft_status` (`mft_status`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `user_active`
--
CREATE TABLE `user_active` (
  `u_username` varchar(30) NOT NULL,
  `u_timestamp` int(11) unsigned NOT NULL,
  PRIMARY KEY  (`u_username`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `user_banned`
--
CREATE TABLE `user_banned` (
  `u_username` varchar(30) NOT NULL,
  `u_timestamp` int(11) unsigned NOT NULL,
  `client_id` int(11) default NULL,
  PRIMARY KEY  (`u_username`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
#
# Table structure for table 'user_details'
#
CREATE TABLE /*!32312 IF NOT EXISTS*/ `user_details` (
  `u_id` int(10) unsigned  NOT NULL auto_increment,
  `admin_user_master_id` int(10) unsigned NOT NULL default '0',
  `client_id` int(10) unsigned NOT NULL default '0',
  `user_login_name` varchar(100) default NULL,
  `u_userid` varchar(32) default NULL,
  `u_password` varchar(32) default NULL,
  `user_phone_login` VARCHAR(20) NOT NULL default '0',
  `user_phone_text` VARCHAR(30) default NULL,
  `user_phone_pass` int(10) NOT NULL default '0',
  `u_oauth_access_key` VARCHAR(100) default NULL,
  `u_oauth_secret_access_key` VARCHAR(100) default NULL,
  `u_first` varchar(20) default NULL,
  `u_last` varchar(20) default NULL,
  `u_full_name` varchar(42) default NULL,
  `u_email` varchar(50) default NULL,
  `u_telephone` varchar(20) default NULL,
  `u_telephone_type` VARCHAR(10) default NULL,
  `tt_first` varchar(20) default NULL,
  `tt_last` varchar(20) default NULL,
  `email_broadcast_groups` varchar(255) default NULL,
  `email_broadcast_setting` varchar(10) default NULL,
  `u_status` varchar(20) NOT NULL default 'ACTIVE',
  `u_permissions_level` int(10) unsigned default NULL,
  `u_timestamp` int(10) unsigned default NULL,
  `create_dtm_utc` datetime,
  `update_dtm_utc` datetime,
  `create_dtm_host` datetime,
  `update_dtm_host` datetime,
  `create_dtm_client` datetime,
  `update_dtm_client` datetime,
  PRIMARY KEY  (`u_id`),
  KEY `user_login_name` (`user_login_name`),
  KEY `user_phone_login` (`user_phone_login`),
  KEY `u_status` (`u_status`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
#
# Table structure for table 'vendor_details'
#
CREATE TABLE `vendor_details` (
  `vendor_id` int(10) unsigned NOT NULL auto_increment,
  `vendor_name` varchar(50) default NULL,
  `primary_u_id` int(10) unsigned default NULL,
  `vendor_send_callerid` varchar(20) default NULL,
  `vendor_phone` varchar(20) default NULL,
  `vendor_fax` varchar(20) default NULL,
  `vendor_email_address` varchar(50) default NULL,
  `vendor_website` varchar(255) default NULL,
  `vendor_address` varchar(40) default NULL,
  `vendor_city` varchar(20) default NULL,
  `vendor_state` varchar(20) default NULL,
  `vendor_zip` varchar(15) default NULL,
  `vendor_country` varchar(15) default NULL,
  `vendor_type` varchar(30) default NULL,
  `vendor_package` varchar(15) default NULL,
  `vendor_promo_code` varchar(20) default NULL,
  `vendor_cc_name` varchar(40) default NULL,
  `vendor_bill_address1` varchar(255) default NULL,
  `vendor_bill_address2` varchar(255) default NULL,
  `vendor_bill_city` varchar(30) default NULL,
  `vendor_bill_state` varchar(30) default NULL,
  `vendor_bill_country` varchar(30) default NULL,
  `vendor_bill_zip` varchar(10) default NULL,
  `vendor_bill_phone` varchar(20) default NULL,
  `vendor_cc_type` varchar(20) default NULL,
  `vendor_cc_verify_code` int(10) default NULL,
  `vendor_cc_num` bigint(40) unsigned default NULL,
  `vendor_cc_expiry_month` int(10) unsigned default NULL,
  `vendor_cc_expiry_year` int(10) unsigned default NULL,
  `vendor_last_billing` varchar(20) default NULL,
  `vendor_referrer` varchar(30) default NULL,
  `vendor_affiliate_u_id` int(10) default NULL,
  `vendor_enews` varchar(10) default NULL,
  `vendor_startdate` varchar(10) default NULL,
  `triallength` varchar(10) default NULL,
  `create_dtm_utc` datetime,
  `update_dtm_utc` datetime,
  `create_dtm_host` datetime,
  `update_dtm_host` datetime,
  `create_dtm_client` datetime,
  `update_dtm_client` datetime,
  PRIMARY KEY  (`vendor_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
-- Create app_subscription_billing triggers
CREATE TRIGGER
    app_subscription_billing_insert_datetime
BEFORE INSERT ON
    app_subscription_billing
FOR EACH ROW SET
    NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
    NEW.create_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND),
    NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
    app_subscription_billing_update_datetime
BEFORE UPDATE ON
    app_subscription_billing
FOR EACH ROW SET
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
-- Create callout_schedule triggers
CREATE TRIGGER
    callout_schedule_insert_datetime
BEFORE INSERT ON
    callout_schedule
FOR EACH ROW SET
    NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
    NEW.create_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND),
    NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
    callout_schedule_update_datetime
BEFORE UPDATE ON
    callout_schedule
FOR EACH ROW SET
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
-- Create callout_settings triggers
CREATE TRIGGER
    callout_settings_insert_datetime
BEFORE INSERT ON
    callout_settings
FOR EACH ROW SET
    NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
    NEW.create_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND),
    NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
    callout_settings_update_datetime
BEFORE UPDATE ON
    callout_settings
FOR EACH ROW SET
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
-- Create client_details triggers
CREATE TRIGGER
    client_details_insert_datetime
BEFORE INSERT ON
    client_details
FOR EACH ROW SET
    NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
    NEW.create_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND),
    NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
    client_details_update_datetime
BEFORE UPDATE ON
    client_details
FOR EACH ROW SET
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
-- Create custom_message triggers
CREATE TRIGGER
    custom_message_insert_datetime
BEFORE INSERT ON
    custom_message
FOR EACH ROW SET
    NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
    NEW.create_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND),
    NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
    custom_message_update_datetime
BEFORE UPDATE ON
    custom_message
FOR EACH ROW SET
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
-- Create file_application_transfer triggers
CREATE TRIGGER
    fat_insert_datetime
BEFORE INSERT ON
    file_application_transfer
FOR EACH ROW SET
    NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.create_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND),
    NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
    fat_update_datetime
BEFORE UPDATE ON
    file_application_transfer
FOR EACH ROW SET
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
-- Create media_file triggers
CREATE TRIGGER
    media_file_insert_datetime
BEFORE INSERT ON
    media_file
FOR EACH ROW SET
    NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.create_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND),
    NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
    media_file_update_datetime
BEFORE UPDATE ON
    media_file
FOR EACH ROW SET
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
-- Create media_file_transfer triggers
CREATE TRIGGER
    mft_insert_datetime
BEFORE INSERT ON
    media_file_transfer
FOR EACH ROW SET
    NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.create_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND),
    NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
    mft_update_datetime
BEFORE UPDATE ON
    media_file_transfer
FOR EACH ROW SET
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
-- Create user_details triggers
CREATE TRIGGER
    user_details_insert_datetime
BEFORE INSERT ON
    user_details
FOR EACH ROW SET
    NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
    NEW.create_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND),
    NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
    user_details_update_datetime
BEFORE UPDATE ON
    user_details
FOR EACH ROW SET
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
-- Create vendor_details triggers
CREATE TRIGGER
    vendor_details_insert_datetime
BEFORE INSERT ON
    vendor_details
FOR EACH ROW SET
    NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
    NEW.create_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND),
    NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
    vendor_details_update_datetime
BEFORE UPDATE ON
    vendor_details
FOR EACH ROW SET
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
