--
-- Table structure for table `appointment`
--
CREATE TABLE `appointment` (
  `appointment_id` int(10) unsigned NOT NULL auto_increment,
  `app_custom_type` varchar(50) default NULL,
  `app_type_desc` varchar(50) default NULL,
  `home_ref_id` varchar(100) default NULL,
  `home_patient_id` varchar(25) default NULL,
  `appt_first_name` varchar(25) default NULL,
  `appt_last_name` varchar(25) default NULL,
  `appt_with_home_ref_id` varchar(100) default NULL,
  `appt_with_first_name` varchar(25) default NULL,
  `appt_with_last_name` varchar(25) default NULL,
  `appt_with_title` varchar(20) default NULL,
  `appt_phone` varchar(20) default NULL,
  `appt_dtm_client` datetime default NULL,
  `appt_dtm_utc` datetime default NULL,
  `appt_length` int(4) default NULL,
  `reminder_call_status` varchar(8) default 'NEW',
  `reminder_call_response` varchar(15) default 'PENDING',
  `reminder_call_start_dt_client` datetime default NULL,
  `reminder_type` int(10) default '1',
  `create_dtm_utc` datetime,
  `update_dtm_utc` datetime,
  `create_dtm_host` datetime,
  `update_dtm_host` datetime,
  `create_dtm_client` datetime,
  `update_dtm_client` datetime,
  PRIMARY KEY  (`appointment_id`),
  KEY `appt_date` (`appt_dtm_client`),
  KEY `appt_time` (`appt_dtm_utc`),
  KEY `reminder_status` (`reminder_call_status`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `appt_settings`
--
CREATE TABLE `appt_settings` (
  `menuloop` int(2) default NULL,
  `play_volume` tinyint(4) default NULL,
  `record_volume` tinyint(4) default NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `mr_lab_result`
--
CREATE TABLE `mr_lab_result` (
  `mr_lab_result_id` int(10) unsigned NOT NULL auto_increment,
  `patient_id` varchar(20) default NULL,
  `patient_first_name` varchar(30) default NULL,
  `patient_last_name` varchar(30) default NULL,
  `patient_phone` varchar(20) default NULL,
  `physician_first_name` varchar(30) default NULL,
  `physician_last_name` varchar(30) default NULL,
  `lab_result` varchar(30) default NULL,
  `lab_result_call_status` varchar(8) default NULL,
  `lab_result_call_response` varchar(20) default NULL,
  `create_dtm_utc` datetime,
  `update_dtm_utc` datetime,
  `create_dtm_host` datetime,
  `update_dtm_host` datetime,
  `create_dtm_client` datetime,
  `update_dtm_client` datetime,
  PRIMARY KEY  (`mr_lab_result_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
CREATE TRIGGER
   appointment_insert_datetime
BEFORE INSERT ON
   appointment
FOR EACH ROW SET
   NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.create_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
   appointment_update_datetime
BEFORE UPDATE ON
   appointment
FOR EACH ROW SET
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
   mr_lab_result_insert_datetime
BEFORE INSERT ON
   mr_lab_result
FOR EACH ROW SET
   NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.create_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
   mr_lab_result_update_datetime
BEFORE UPDATE ON
   mr_lab_result
FOR EACH ROW SET
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
INSERT INTO appt_settings (menuloop,play_volume,record_volume) VALUES (4,0,0);
