--
-- Table structure for table `filepath`
--
CREATE TABLE `filepath` (
  `filepath_id` int(10) unsigned NOT NULL auto_increment,
  `dir_loc` varchar(60) NOT NULL default '',
  `volume_num` int(10) unsigned NOT NULL default '0',
  `status` varchar(20) NOT NULL default '',
  `max_volume_filecount` int(10) unsigned NOT NULL default '0',
  `create_date` varchar(10) default NULL,
  `create_time` varchar(8) default NULL,
  `close_date` varchar(10) default NULL,
  `close_time` varchar(8) default NULL,
  `create_dtm_utc` datetime,
  `update_dtm_utc` datetime,
  `create_dtm_host` datetime,
  `update_dtm_host` datetime,
  `create_dtm_client` datetime,
  `update_dtm_client` datetime,
  PRIMARY KEY  (`filepath_id`),
  KEY `status` (`status`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `grammar_rule`
--
CREATE TABLE `grammar_rule` (
  `grammar_rule_id` int(10) unsigned NOT NULL auto_increment,
  `grammar_rule_for_uid` int(10) unsigned default NULL,
  `grammar_rule_name` varchar(100) default NULL,
  `grammar_rule_result_string` varchar(100) default NULL,
  `grammar_rule_expansion` varchar(255) default NULL,
  `grammar_rule_description` varchar(255) default NULL,
  `grammar_rule_private_yn` char(1) NOT NULL default 'N',
  `grammar_rule_global_allowed_yn` char(1) default 'Y',
  `grammar_rule_global_expected_yn` char(1) default 'N',
  `grammar_rule_active_yn` char(1) default 'Y',
  `grammar_rule_global_required_yn` char(1) default 'N',
  `grammar_rule_build_result_string` char(1) default NULL,
  `grammar_rule_update_notes` varchar(255) default NULL,
  `create_dtm_utc` datetime,
  `update_dtm_utc` datetime,
  `create_dtm_host` datetime,
  `update_dtm_host` datetime,
  `create_dtm_client` datetime,
  `update_dtm_client` datetime,
  PRIMARY KEY  (`grammar_rule_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `grammar_rule_group`
--
CREATE TABLE `grammar_rule_group` (
  `grammar_rule_group_id` int(10) unsigned NOT NULL auto_increment,
  `grammar_rule_group_name` varchar(100) default NULL,
  `grammar_rule_group_desc` varchar(255) default NULL,
  `create_dtm_utc` datetime,
  `update_dtm_utc` datetime,
  `create_dtm_host` datetime,
  `update_dtm_host` datetime,
  `create_dtm_client` datetime,
  `update_dtm_client` datetime,
  PRIMARY KEY  (`grammar_rule_group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `group_detail`
--
CREATE TABLE `group_detail` (
  `group_id` int(10) unsigned NOT NULL auto_increment,
  `group_name` varchar(20) NOT NULL default '',
  `group_description` varchar(40) default NULL,
  `mbx_id` int(10) unsigned NOT NULL default '0',
  `create_dtm_utc` datetime,
  `update_dtm_utc` datetime,
  `create_dtm_host` datetime,
  `update_dtm_host` datetime,
  `create_dtm_client` datetime,
  `update_dtm_client` datetime,
  PRIMARY KEY  (`group_id`),
  KEY `group_name` (`group_name`),
  KEY `mbx_id` (`mbx_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `mailbox`
--
CREATE TABLE `mailbox` (
  `mbx_id` int(10) unsigned NOT NULL auto_increment,
  `mbx_num` int(10) unsigned NOT NULL default '0',
  `u_id` int(10) unsigned NOT NULL default '0',
  `filepath_id` int(10) unsigned NOT NULL default '0',
  `personal_greeting` char(1) NOT NULL default 'N',
  `extend_abs` char(1) default NULL,
  `mbx_ani` varchar(20) default NULL,
  `mbx_dnis` varchar(20) default NULL,
  `max_msg_count` int(10) unsigned NOT NULL default '0',
  `forward_msgto_mbx_id` int(10) unsigned NOT NULL default '0',
  `create_dtm_utc` datetime,
  `update_dtm_utc` datetime,
  `create_dtm_host` datetime,
  `update_dtm_host` datetime,
  `create_dtm_client` datetime,
  `update_dtm_client` datetime,
  PRIMARY KEY  (`mbx_id`),
  KEY `mbx_num` (`mbx_num`),
  KEY `u_id` (`u_id`),
  KEY `filepath_id` (`filepath_id`),
  KEY `mbx_ani` (`mbx_ani`),
  KEY `mbx_dnis` (`mbx_dnis`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `mailbox_message`
--
CREATE TABLE `mailbox_message` (
  `mbx_msg_id` int(10) unsigned NOT NULL auto_increment,
  `msg_id` int(10) unsigned NOT NULL default '0',
  `mbx_id` int(10) unsigned NOT NULL default '0',
  `sender_mbx_id` int(10) unsigned NOT NULL default '0',
  `mbx_msg_status` varchar(10) NOT NULL default '',
  `sender_ani` varchar(30) NOT NULL default '',
  `sender_dnis` varchar(30) NOT NULL default '',
  `sent_date` varchar(10) NOT NULL default '',
  `sent_time` varchar(8) NOT NULL default '',
  `saved_last` varchar(10) NOT NULL default '',
  `original_mbx_msg_id` int(10) unsigned NOT NULL default '0',
  `heard_once_yn` char(1) NOT NULL default '',
  `recipient_mbx_id` int(10) unsigned NOT NULL default '0',
  `message_note` varchar(255) default NULL,
  `create_dtm_utc` datetime,
  `update_dtm_utc` datetime,
  `create_dtm_host` datetime,
  `update_dtm_host` datetime,
  `create_dtm_client` datetime,
  `update_dtm_client` datetime,
  PRIMARY KEY  (`mbx_msg_id`),
  KEY `msg_id` (`msg_id`),
  KEY `mbx_id` (`mbx_id`),
  KEY `mbx_msg_status` (`mbx_msg_status`),
  KEY `sender_ani` (`sender_ani`),
  KEY `sender_dnis` (`sender_dnis`),
  KEY `sent_date` (`sent_date`),
  KEY `sent_time` (`sent_time`),
  KEY `saved_last` (`saved_last`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `message`
--
CREATE TABLE `message` (
  `msg_id` int(10) unsigned NOT NULL auto_increment,
  `msg_name` varchar(35) NOT NULL default '0',
  `filepath_id` int(10) unsigned NOT NULL default '0',
  `msg_status` varchar(10) NOT NULL default '0',
  `msg_type` varchar(15) NOT NULL default '',
  `creat_date` varchar(10) NOT NULL default '0',
  `creat_time` varchar(8) NOT NULL default '0',
  `start_date` varchar(10) NOT NULL default '',
  `temp_msg_loc` varchar(200) NOT NULL default '0',
  `del_date` varchar(10) default NULL,
  `create_dtm_utc` datetime,
  `update_dtm_utc` datetime,
  `create_dtm_host` datetime,
  `update_dtm_host` datetime,
  `create_dtm_client` datetime,
  `update_dtm_client` datetime,
  PRIMARY KEY  (`msg_id`),
  KEY `filepath_id` (`filepath_id`),
  KEY `msg_status` (`msg_status`),
  KEY `msg_type` (`msg_type`),
  KEY `start_date` (`start_date`),
  KEY `del_date` (`del_date`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `schedule`
--
CREATE TABLE `schedule` (
  `schedule_id` int(10) unsigned NOT NULL auto_increment,
  `schedule_desc` varchar(50) NOT NULL default '',
  `create_dtm_utc` datetime,
  `update_dtm_utc` datetime,
  `create_dtm_host` datetime,
  `update_dtm_host` datetime,
  `create_dtm_client` datetime,
  `update_dtm_client` datetime,
  PRIMARY KEY  (`schedule_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `schedule_detail`
--
CREATE TABLE `schedule_detail` (
  `schedule_detail_id` int(10) unsigned NOT NULL auto_increment,
  `schedule_id` int(10) unsigned NOT NULL default '0',
  `start_time` varchar(8) NOT NULL default '00:00:00',
  `end_time` varchar(8) NOT NULL default '24:00:00',
  `days_of_week` varchar(30) NOT NULL default '',
  `create_dtm_utc` datetime,
  `update_dtm_utc` datetime,
  `create_dtm_host` datetime,
  `update_dtm_host` datetime,
  `create_dtm_client` datetime,
  `update_dtm_client` datetime,
  PRIMARY KEY  (`schedule_detail_id`),
  KEY `schedule_id` (`schedule_id`),
  KEY `start_time` (`start_time`),
  KEY `end_time` (`end_time`),
  KEY `days_of_week` (`days_of_week`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `vo_settings`
--
CREATE TABLE `vo_settings` (
  `tfvo_settings_id` int(10) unsigned NOT NULL auto_increment,
  `menuloop` int(2) NOT NULL default '0',
  `play_volume` int(2) NOT NULL default '0',
  `record_volume` int(2) NOT NULL default '0',
  `max_vmail_msg_len` int(10) NOT NULL default '0',
  `max_vmail_silence_timeout` int(10) NOT NULL default '0',
  `del_days` int(2) NOT NULL default '0',
  `msg_days` int(4) NOT NULL default '0',
  `vmail_path_root` varchar(50) NOT NULL default '',
  `multikey_menu_timeout` int(5) NOT NULL default '1000',
  `max_ext_digits` int(10) NOT NULL default '3',
  `max_mbx_digits` int(10) NOT NULL default '3',
  `max_directory_digits` int(10) NOT NULL default '3',
  `system_transfer_type` varchar(15) NOT NULL default 'PBX_SUPER',
  `ringcount` int(2) NOT NULL default '4',
  `rec_ext` char(3) NOT NULL default 'WAV',
  `tts_on_yn` char(1) NOT NULL default '',
  `office_hours_play` varchar(9) NOT NULL default '',
  `time_pregreeting_yn` char(1) NOT NULL default '',
  `holiday_pregreeting_yn` char(1) NOT NULL default '',
  `min_pass_digits` int(2) NOT NULL default '500',
  `default_max_mbxmsg_count` int(10) unsigned NOT NULL default '0',
  `sysadmin_password` varchar(50) NOT NULL default '',
  `default_msg_count_longplay_yn` char(1) NOT NULL default 'N',
  `qa_warning_yn` char(1) NOT NULL default '',
  `advanced_support_yn` char(1) default NULL,
  `simple_call_router` char(1) default 'N',
  `vmail_enabled` char(1) default 'Y',
  `sracquire_allow_fail` char(1) default NULL,
  `aa_mm_fail_xfer_ext` varchar(10) default NULL,
  `simple_tt_admin` char(1) default NULL,
  `create_dtm_utc` datetime,
  `update_dtm_utc` datetime,
  `create_dtm_host` datetime,
  `update_dtm_host` datetime,
  `create_dtm_client` datetime,
  `update_dtm_client` datetime,
  PRIMARY KEY  (`tfvo_settings_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `vo_user`
--
CREATE TABLE `vo_user` (
  `vo_user_id` int(10) NOT NULL auto_increment,
  `u_id` int(10) NOT NULL,
  `vo_user_status` varchar(20) NOT NULL default 'ACTIVE',
  `play_msg_sender_yn` char(1) NOT NULL default '',
  `play_date_yn` char(1) NOT NULL default '',
  `msg_count_longplay_yn` char(1) NOT NULL default '',
  `bcast_permission` char(1) NOT NULL default 'Y',
  `global_user_list_yn` char(1) NOT NULL default 'Y',
  `create_dtm_utc` datetime,
  `update_dtm_utc` datetime,
  `create_dtm_host` datetime,
  `update_dtm_host` datetime,
  `create_dtm_client` datetime,
  `update_dtm_client` datetime,
  PRIMARY KEY  (`vo_user_id`),
  KEY `u_id` (`u_id`),
  KEY `vo_user_status` (`vo_user_status`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `vo_user_extension`
--
CREATE TABLE `vo_user_extension` (
  `user_ext_id` int(10) unsigned NOT NULL auto_increment,
  `u_id` int(10) unsigned NOT NULL default '0',
  `physical_ext` varchar(20) default NULL,
  `virtual_ext` varchar(20) default NULL,
  `phone_number` varchar(50) default NULL,
  `transfer_type` varchar(15) default NULL,
  `primary_line_yn` char(1) NOT NULL default '',
  `available_yn` char(1) NOT NULL default 'Y',
  `virt_ext_followme_yn` char(1) NOT NULL default 'N',
  `user_ext_followme_yn` char(1) NOT NULL default 'N',
  `followme_ringcount` int(2) NOT NULL default '4',
  `ringcount` int(2) NOT NULL default '4',
  `avail_start_time` varchar(8) default NULL,
  `avail_end_time` varchar(8) default NULL,
  `avail_days_of_week` varchar(30) default NULL,
  `create_dtm_utc` datetime,
  `update_dtm_utc` datetime,
  `create_dtm_host` datetime,
  `update_dtm_host` datetime,
  `create_dtm_client` datetime,
  `update_dtm_client` datetime,
  PRIMARY KEY  (`user_ext_id`),
  KEY `u_id` (`u_id`),
  KEY `virtual_ext` (`virtual_ext`),
  KEY `primary_line_yn` (`primary_line_yn`),
  KEY `available_yn` (`available_yn`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;--
-- Table structure for table `vo_user_group`
--
CREATE TABLE `vo_user_group` (
  `user_group_id` int(10) unsigned NOT NULL auto_increment,
  `u_id` int(10) unsigned NOT NULL default '0',
  `group_id` int(10) unsigned NOT NULL default '0',
  `priority` int(10) unsigned NOT NULL default '1',
  `create_dtm_utc` datetime,
  `update_dtm_utc` datetime,
  `create_dtm_host` datetime,
  `update_dtm_host` datetime,
  `create_dtm_client` datetime,
  `update_dtm_client` datetime,
  PRIMARY KEY  (`user_group_id`),
  KEY `u_id` (`u_id`),
  KEY `group_id` (`group_id`),
  KEY `priority` (`priority`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
CREATE TRIGGER
   filepath_insert_datetime
BEFORE INSERT ON
   filepath
FOR EACH ROW SET
   NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.create_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
   filepath_update_datetime
BEFORE UPDATE ON
   filepath
FOR EACH ROW SET
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
   grammar_rule_insert_datetime
BEFORE INSERT ON
   grammar_rule
FOR EACH ROW SET
   NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.create_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
   grammar_rule_update_datetime
BEFORE UPDATE ON
   grammar_rule
FOR EACH ROW SET
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
   grammar_rule_group_insert_datetime
BEFORE INSERT ON
   grammar_rule_group
FOR EACH ROW SET
   NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.create_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
   grammar_rule_group_update_datetime
BEFORE UPDATE ON
   grammar_rule_group
FOR EACH ROW SET
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
   group_detail_insert_datetime
BEFORE INSERT ON
   group_detail
FOR EACH ROW SET
   NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.create_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
   group_detail_update_datetime
BEFORE UPDATE ON
   group_detail
FOR EACH ROW SET
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
   mailbox_insert_datetime
BEFORE INSERT ON
   mailbox
FOR EACH ROW SET
   NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.create_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
   mailbox_update_datetime
BEFORE UPDATE ON
   mailbox
FOR EACH ROW SET
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
   mailbox_message_insert_datetime
BEFORE INSERT ON
   mailbox_message
FOR EACH ROW SET
   NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.create_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
   mailbox_message_update_datetime
BEFORE UPDATE ON
   mailbox_message
FOR EACH ROW SET
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
   message_insert_datetime
BEFORE INSERT ON
   message
FOR EACH ROW SET
   NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.create_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
   message_update_datetime
BEFORE UPDATE ON
   message
FOR EACH ROW SET
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
   schedule_insert_datetime
BEFORE INSERT ON
   schedule
FOR EACH ROW SET
   NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.create_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
   schedule_update_datetime
BEFORE UPDATE ON
   schedule
FOR EACH ROW SET
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
   schedule_detail_insert_datetime
BEFORE INSERT ON
   schedule_detail
FOR EACH ROW SET
   NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.create_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
   schedule_detail_update_datetime
BEFORE UPDATE ON
   schedule_detail
FOR EACH ROW SET
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
   vo_settings_insert_datetime
BEFORE INSERT ON
   vo_settings
FOR EACH ROW SET
   NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.create_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
   vo_settings_update_datetime
BEFORE UPDATE ON
   vo_settings
FOR EACH ROW SET
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
   vo_user_insert_datetime
BEFORE INSERT ON
   vo_user
FOR EACH ROW SET
   NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.create_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
   vo_user_update_datetime
BEFORE UPDATE ON
   vo_user
FOR EACH ROW SET
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
   vo_user_ext_insert_datetime
BEFORE INSERT ON
   vo_user_extension
FOR EACH ROW SET
   NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.create_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
   vo_user_ext_update_datetime
BEFORE UPDATE ON
   vo_user_extension
FOR EACH ROW SET
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
   vo_user_group_insert_datetime
BEFORE INSERT ON
   vo_user_group
FOR EACH ROW SET
   NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.create_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
CREATE TRIGGER
   vo_user_group_update_datetime
BEFORE UPDATE ON
   vo_user_group
FOR EACH ROW SET
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_client = DATE_ADD(UTC_Timestamp(), INTERVAL (SELECT client_utc_offset FROM client_details)*60*60 SECOND);
