-- MySQL dump 10.10
--
-- Host: localhost    Database: teleflow_relay
-- ------------------------------------------------------
-- Server version	5.0.22-community-nt
/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

#
# Database structure for database 'teleflow_relay'
#
CREATE DATABASE /*!32312 IF NOT EXISTS*/ `teleflow_relay` /*!40100 DEFAULT CHARACTER SET latin1 */;
USE `teleflow_relay`;

--
-- Table structure for table `app_sub_billing_defaults`
--
CREATE TABLE /*!32312 IF NOT EXISTS*/ `app_sub_billing_defaults` (
  `appsub_billing_defaults_id` int(10) unsigned NOT NULL auto_increment,
  `app_type_name` varchar(30) default NULL,
  `appsub_billing_package` varchar(30) default NULL,
  `appsub_billing_min_charge` decimal(10,2) unsigned default NULL,
  `appsub_billing_max_charge` decimal(10,2) unsigned default NULL,
  `appsub_transaction_charge` decimal(10,2) unsigned default NULL,
  `appsub_transaction_unit` varchar(10) default NULL,
  `create_dtm_utc` datetime,
  `update_dtm_utc` datetime,
  `create_dtm_host` datetime,
  `update_dtm_host` datetime,
  PRIMARY KEY  (`appsub_billing_defaults_id`),
  KEY (`app_type_name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `app_type_task_fail_settings`
--
DROP TABLE IF EXISTS `app_type_task_fail_settings`;
CREATE TABLE `app_type_task_fail_settings` (
  `app_task_fail_settings_id` int(10) unsigned NOT NULL auto_increment,
  `app_type_name` varchar(30) default NULL,
  `fail_update_state_table` varchar(30) default NULL,
  `fail_update_app_id_field` varchar(30) default NULL,
  `fail_update_state_field_1` varchar(30) default NULL,
  `fail_update_state_update_1` varchar(30) default NULL,
  `fail_update_state_field_2` varchar(30) default NULL,
  `fail_update_state_update_2` varchar(30) default NULL,
  `create_dtm_utc` datetime default NULL,
  `update_dtm_utc` datetime default NULL,
  `create_dtm_host` datetime default NULL,
  `update_dtm_host` datetime default NULL,
  PRIMARY KEY  (`app_task_fail_settings_id`),
  KEY `app_type_name` (`app_type_name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `application_type`
--
DROP TABLE IF EXISTS `application_type`;
CREATE TABLE `application_type` (
  `application_type_id` int(10) unsigned NOT NULL auto_increment,
  `app_type_name` varchar(30) default NULL,
  `app_type_status` varchar(10) default NULL,
  `app_type_group_codes` varchar(100) default NULL,
  `app_type_group_menu_order` INT(10) unsigned default NULL,
  `app_type_billing_code` varchar(10) default NULL,
  `app_type_display` varchar(30) default NULL,
  `app_type_desc` varchar(100) default NULL,
  `app_type_tf_app` varchar(200) default NULL,
  `app_type_web_app` varchar(200) default NULL,
  `app_type_callout_fail_tf_app` varchar(200) default NULL,
  `app_tel_connect_delay` INT(4) default NULL,
  `create_dtm_utc` datetime default NULL,
  `update_dtm_utc` datetime default NULL,
  `create_dtm_host` datetime default NULL,
  `update_dtm_host` datetime default NULL,
  PRIMARY KEY  (`application_type_id`),
  KEY `app_type_name` (`app_type_name`),
  KEY `app_type_status` (`app_type_status`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `area_exchange`
--
DROP TABLE IF EXISTS `area_exchange`;
CREATE TABLE `area_exchange` (
  `area_exchange_id` int(10) unsigned NOT NULL auto_increment,
  `server_area_code` int(3) default NULL,
  `server_exchange` int(3) default NULL,
  `remote_area_code` int(3) default NULL,
  `remote_exchange` int(3) default NULL,
  `local_yn` char(1) default NULL,
  `area_exchange_status` varchar(10) default NULL,
  `create_dtm_utc` datetime default NULL,
  `update_dtm_utc` datetime default NULL,
  `create_dtm_host` datetime default NULL,
  `update_dtm_host` datetime default NULL,
  PRIMARY KEY  (`area_exchange_id`),
  KEY `area_exchange` (`server_area_code`,`server_exchange`,`remote_area_code`,`remote_exchange`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `call_log_master`
--
DROP TABLE IF EXISTS `call_log_master`;
CREATE TABLE `call_log_master` (
  `call_log_id` int(10) unsigned NOT NULL auto_increment,
  `call_direction` varchar(3) default NULL,
  `app_type_name` varchar(30) default NULL,
  `client_id` int(10) unsigned default NULL,
  `call_start_dtm_utc` datetime default NULL,
  `call_end_dtm_utc` datetime default NULL,
  `call_start_dtm_ivr` datetime default NULL,
  `call_end_dtm_ivr` datetime default NULL,
  `call_duration` int(6) default NULL,
  `call_attempt_duration` int(6) default NULL,
  `ivr_computer_name` varchar(50) default NULL,
  `ivr_port` int(3) default NULL,
  `called_number` varchar(20) default NULL,
  `calling_number` varchar(20) default NULL,
  `callout_task_id` int(10) unsigned default NULL,
  `callout_app_id` int(10) unsigned default NULL,
  `initial_voice_length` int(10) default NULL,
  `callout_result_code` varchar(20) default NULL,
  PRIMARY KEY  (`call_log_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `callout_application_defaults`
--
DROP TABLE IF EXISTS `callout_application_defaults`;
CREATE TABLE `callout_application_defaults` (
  `application_default_id` int(10) unsigned NOT NULL auto_increment,
  `app_type_name` varchar(30) default NULL,
  `callout_max_fail` int(3) default NULL,
  `callout_max_no_answer` int(3) default NULL,
  `early_hangup_check_yn` char(1) default NULL,
  `early_hangup_max_seconds` int(5) default NULL,
  `early_hangup_retry_call` char(1) default NULL,
  `machine_check_yn` char(1) default NULL,
  `machine_min_length` int(5) default NULL,
  `machine_run_app_yn` char(1) default NULL,
  `callout_start_tm_weekdays` time default NULL,
  `callout_end_tm_weekdays` time default NULL,
  `callout_start_tm_sat` time default NULL,
  `callout_end_tm_sat` time default NULL,
  `callout_start_tm_sun` time default NULL,
  `callout_end_tm_sun` time default NULL,
  `callout_start_num_days_ahead` int(3) default NULL,
  `callout_end_num_days_ahead` int(3) default NULL,
  `callout_retry_seconds` int(6) default NULL,
  `create_dtm_utc` datetime default NULL,
  `update_dtm_utc` datetime default NULL,
  `create_dtm_host` datetime default NULL,
  `update_dtm_host` datetime default NULL,
  PRIMARY KEY  (`application_default_id`),
  KEY `app_type_name` (`app_type_name`),
  KEY `callout_max_no_answer` (`callout_max_no_answer`),
  KEY `callout_max_fail` (`callout_max_fail`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `callout_task`
--
DROP TABLE IF EXISTS `callout_task`;
CREATE TABLE `callout_task` (
  `callout_task_id` int(10) unsigned NOT NULL auto_increment,
  `app_type_name` varchar(30) default NULL,
  `client_id` int(10) unsigned default NULL,
  `callout_schedule_id` int(10) unsigned default NULL,
  `callout_app_id` int(10) unsigned default NULL,
  `send_ani` varchar(20) default NULL,
  `callout_phone` varchar(20) default NULL,
  `callout_start_dtm_utc` datetime default NULL,
  `callout_end_dtm_utc` datetime default NULL,
  `last_call_dtm_utc` datetime default NULL,
  `last_call_dtm_ivr` datetime default NULL,
  `last_call_ivr_computer_name` varchar(50) default NULL,
  `task_status` varchar(20) default NULL,
  `task_fail_count` int(2) default NULL,
  `task_noanswer_count` int(2) default NULL,
  `task_error_count` int(2) default NULL,
  `task_max_fail` int(2) default NULL,
  `task_max_noanswer` int(2) default NULL,
  `early_hangup_check_yn` char(1) default NULL,
  `early_hangup_max_seconds` int(5) default NULL,
  `early_hangup_retry_call` char(1) default NULL,
  `machine_check_yn` char(1) default NULL,
  `machine_min_length` int(5) default NULL,
  `machine_run_app_yn` char(1) default NULL,
  `callout_task_priority` int(10) default NULL,
  `callout_retry_seconds` int(6) default NULL,
  PRIMARY KEY  (`callout_task_id`),
  KEY `app_type_name` (`app_type_name`),
  KEY `task_status` (`task_status`),
  KEY `date_range_status` (`callout_start_dtm_utc`, `callout_end_dtm_utc`, `task_status`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `client`
--
DROP TABLE IF EXISTS `client`;
CREATE TABLE `client` (
  `client_id` int(10) unsigned NOT NULL auto_increment,
  `client_name` varchar(50) default NULL,
  `client_status` varchar(10) default NULL,
  `client_permissions_level` int(10) unsigned default NULL,
  `client_db_driver` varchar(50) default NULL,
  `client_db_type` varchar(20) default NULL,
  `client_db_host` varchar(50) default NULL,
  `client_db_host_remote` varchar(50) default NULL,
  `client_db_name` varchar(50) default NULL,
  `client_db_user` varchar(20) default NULL,
  `client_db_password` varchar(20) default NULL,
  `client_db_connect_options` varchar(50) default NULL,
  `next_dst_scan_dtm_utc` datetime default NULL,
  `create_dtm_utc` datetime default NULL,
  `update_dtm_utc` datetime default NULL,
  `create_dtm_host` datetime default NULL,
  `update_dtm_host` datetime default NULL,
  PRIMARY KEY  (`client_id`),
  KEY `client_status` (`client_status`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `client_application_subscription`
--
DROP TABLE IF EXISTS `client_application_subscription`;
CREATE TABLE `client_application_subscription` (
  `client_application_subscription_id` int(10) unsigned NOT NULL auto_increment,
  `client_id` int(10) unsigned default NULL,
  `app_type_name` varchar(30) default NULL,
  `app_type_group_menu_order` INT(10) unsigned default NULL,
  `subscription_management_file` varchar(100) default NULL,
  `subscription_status` varchar(20) default NULL,
  `last_data_change_dtm_utc` datetime default NULL,
  `next_data_scan_dtm_utc` datetime default NULL,
  `last_data_scan_dtm_utc` datetime default NULL,
  `create_dtm_utc` datetime default NULL,
  `update_dtm_utc` datetime default NULL,
  `create_dtm_host` datetime default NULL,
  `update_dtm_host` datetime default NULL,
  PRIMARY KEY  (`client_application_subscription_id`),
  KEY (`client_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `client_ip_access`
--
DROP TABLE IF EXISTS `client_ip_access`;
CREATE TABLE `client_ip_access` (
  `cia_id` int(10) unsigned NOT NULL auto_increment,
  `client_id` int(10) unsigned default NULL,
  `cia_status` varchar(10) default NULL,
  `cia_ip_address_range_start` varchar(20) default NULL,
  `cia_ip_address_range_end` varchar(20) default NULL,
  `cia_ip_address_description` varchar(200) default NULL,
  `create_dtm_utc` datetime default NULL,
  `update_dtm_utc` datetime default NULL,
  `create_dtm_host` datetime default NULL,
  `update_dtm_host` datetime default NULL,
  PRIMARY KEY  (`cia_id`),
  KEY `cia_ip_range` (`cia_ip_address_range_start`, `cia_ip_address_range_end`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `dnis_service`
--
DROP TABLE IF EXISTS `dnis_service`;
CREATE TABLE `dnis_service` (
  `dnis_service_id` int(10) unsigned NOT NULL auto_increment,
  `app_type_name` varchar(30) default NULL,
  `client_id` int(10) unsigned default NULL,
  `service_dnis` varchar(30) default NULL,
  `internal_service_dnis` VARCHAR(30) default NULL,
  `service_phone_number` varchar(30) default NULL,
  `service_notes` varchar(200) default NULL,
  `home_ivr_computer_name` varchar(50) default NULL,
  `circuit_id` varchar(30) default NULL,
  `dnis_status` varchar(10) default NULL,
  `tel_connect_delay` SMALLINT(4),
  `db_pre_connect_yn` varchar(1) default 'N',
  `db_pre_connect_handle` varchar(50) default NULL,
  `max_service_instances` int(10) default '-1',
  `srtt_type` varchar(5) default NULL,
  `srtt_engine` varchar(30) default NULL,
  `create_dtm_utc` datetime default NULL,
  `update_dtm_utc` datetime default NULL,
  `create_dtm_host` datetime default NULL,
  `update_dtm_host` datetime default NULL,
  PRIMARY KEY  (`dnis_service_id`),
  KEY `service_dnis` (`service_dnis`),
  KEY `client_id` (`client_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `event_log_master`
--
DROP TABLE IF EXISTS `event_log_master`;
CREATE TABLE `event_log_master` (
  `event_log_id` int(10) unsigned NOT NULL auto_increment,
  `client_id` int(10) unsigned default NULL,
  `evt_dtm_utc` datetime default NULL,
  `evt_dtm_host` datetime default NULL,
  `evt_computer_name` varchar(50) default NULL,
  `evt_port` char(3) NOT NULL default '',
  `log_format_version` char(3) NOT NULL default '',
  `evt_code` varchar(30) NOT NULL default '',
  `evt_start` int(10) NOT NULL default '0',
  `call_duration` int(10) NOT NULL default '0',
  `logging_app` varchar(30) NOT NULL default '',
  `site_code` varchar(30) NOT NULL default '',
  `region_code` varchar(30) NOT NULL default '',
  `evt_type` varchar(30) NOT NULL default '',
  `evt_data1` varchar(30) NOT NULL default '',
  `evt_data2` varchar(30) NOT NULL default '',
  `evt_data3` varchar(30) NOT NULL default '',
  `evt_timestamp` int(10) default NULL,
  PRIMARY KEY  (`event_log_id`),
  KEY `evt_dtm_host` (`evt_dtm_host`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `ivrconfig`
--
DROP TABLE IF EXISTS `ivrconfig`;
CREATE TABLE `ivrconfig` (
  `ivrconfig_id` int(10) unsigned NOT NULL auto_increment,
  `ivr_computer_name` varchar(50) default NULL,
  `callout_mgr_computer_name` varchar(50) default NULL,
  `cpu_wait` int(6) default NULL,
  `local_utc_offset` int(3) default NULL,
  `local_timezone` varchar(4) default NULL,
  `location_observes_dst_yn` char(1) default NULL,
  `tts_server_ip_primary` varchar(100) default NULL,
  `tts_ip_port_primary` varchar(10) default NULL,
  `tts_server_ip_secondary` varchar(100) default NULL,
  `tts_ip_port_secondary` varchar(10) default NULL,
  `voip_media_ip_address` varchar(100) default NULL,
  `voip_media_ip_min_port` varchar(10) default NULL,
  `email_alert_list` varchar(100) default NULL,
  `email_warn_list` varchar(100) default NULL,
  `default_transfer_type` varchar(15) default NULL,
  `local_area_codes` varchar(20) default NULL,
  `local_caller_id` varchar(20) default NULL,
  `pre_local` varchar(5) default NULL,
  `pre_long` varchar(5) default NULL,
  `ring_count` int(2) default NULL,
  `isdn_calling_number_plan` varchar(20) default NULL,
  `isdn_calling_number_type` varchar(20) default NULL,
  `isdn_called_number_plan` varchar(20) default NULL,
  `isdn_called_number_type` varchar(20) default NULL,
  `callout_silence_timeout` int(4) default NULL,
  `max_callout_errors` int(2) default NULL,
  `call_wait` int(3) default NULL,
  `create_dtm_utc` datetime default NULL,
  `update_dtm_utc` datetime default NULL,
  `create_dtm_host` datetime default NULL,
  `update_dtm_host` datetime default NULL,
  PRIMARY KEY  (`ivrconfig_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `port_task`
--
DROP TABLE IF EXISTS `port_task`;
CREATE TABLE `port_task` (
  `port_task_id` int(10) unsigned NOT NULL auto_increment,
  `callout_task_id` int(10) unsigned default NULL,
  `ivr_computer_name` varchar(50) default NULL,
  `port_number` int(5) default NULL,
  `port_phone_number` VARCHAR(20) default NULL,
  `port_extension_number` VARCHAR(10) default NULL,
  `port_direction` varchar(5) default NULL,
  `task_status` char(15) default NULL,
  `cc_recording_protocol` VARCHAR(10) default NULL,
  `cc_recording_custom_tam` VARCHAR(100) default NULL,
  `cc_recording_rule_code` VARCHAR(8) default NULL,
  `cc_schedule_id` INT(10) unsigned default NULL,
  `create_dtm_utc` datetime default NULL,
  `update_dtm_utc` datetime default NULL,
  `create_dtm_host` datetime default NULL,
  `update_dtm_host` datetime default NULL,
  PRIMARY KEY  (`port_task_id`),
  KEY `callout_task_id` (`callout_task_id`),
  KEY `port_number` (`port_number`),
  KEY `task_status` (`task_status`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `registered_sip_uri`
--
DROP TABLE IF EXISTS `registered_sip_uri`;
CREATE TABLE `registered_sip_uri` (
  `registered_sip_uri_id` int(10) unsigned NOT NULL auto_increment,
  `sip_registrar` varchar(50) default NULL,
  `uri_register_to` varchar(50) default NULL,
  `uri_register_from` varchar(50) default NULL,
  `contact_uri` varchar(50) default NULL,
  `uri_expiry_seconds` int(10) default NULL,
  PRIMARY KEY  (`registered_sip_uri_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `sales_affiliate`
--
DROP TABLE IF EXISTS `sales_affiliate`;
CREATE TABLE `sales_affiliate` (
  `sales_id` int(10) NOT NULL auto_increment,
  `Sales_login` varchar(30) default NULL,
  `sales_password` varchar(10) default NULL,
  `sales_name` varchar(50) default NULL,
  `sales_contact` varchar(30) default NULL,
  `sales_address` varchar(30) default NULL,
  `sales_city` varchar(30) default NULL,
  `sales_state` varchar(30) default NULL,
  `sales_zip` varchar(10) default NULL,
  `sales_country` varchar(15) default NULL,
  `sales_phone` varchar(20) default NULL,
  `sales_email` varchar(30) default NULL,
  `sales_company_email` varchar(30) default NULL,
  `sales_discounttype` varchar(10) default NULL,
  `sales_code` varchar(20) default NULL,
  `create_dtm_utc` datetime default NULL,
  `update_dtm_utc` datetime default NULL,
  `create_dtm_host` datetime default NULL,
  `update_dtm_host` datetime default NULL,
  PRIMARY KEY  (`sales_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `swipool`
--
DROP TABLE IF EXISTS `swipool`;
CREATE TABLE `swipool` (
  `swipool_id` int(10) unsigned NOT NULL auto_increment,
  `port` int(5) default NULL,
  `ivr_computer_name` varchar(50) default NULL,
  `status` varchar(10) default NULL,
  `reqport` int(5) default NULL,
  `req_dtm_utc` datetime default NULL,
  `req_dtm_ivr` datetime default NULL,
  `reqcallref` varchar(20) default NULL,
  `req_client_id` int(10) default NULL,
  `req_app_type_name` varchar(30) default NULL,
  `phone` varchar(30) default NULL,
  `extension` varchar(10) default NULL,
  `extension_xfer_pause` int(10) default NULL,
  `xfer_type` varchar(20) default NULL,
  `xfer_network_type` varchar(10) default NULL,
  `ringcount` int(2) default NULL,
  `send_ani` varchar(20) default NULL,
  PRIMARY KEY  (`swipool_id`),
  KEY `port` (`port`),
  KEY `port_status` (`port`,`status`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `tfr_server`
--
DROP TABLE IF EXISTS `tfr_server`;
CREATE TABLE `tfr_server` (
  `tfr_server_id` int(10) unsigned NOT NULL auto_increment,
  `server_name` varchar(50) default NULL,
  `server_status` varchar(10) default NULL,
  `server_ip_address` varchar(20) default NULL,
  `web_server_yn` char(1) default NULL,
  `db_server_yn` char(1) default NULL,
  `tf_server_yn` char(1) default NULL,
  `tf_monitor_ip_port` int(10) default NULL,
  `create_dtm_utc` datetime default NULL,
  `update_dtm_utc` datetime default NULL,
  `create_dtm_host` datetime default NULL,
  `update_dtm_host` datetime default NULL,
  PRIMARY KEY  (`tfr_server_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `timezone`
--
DROP TABLE IF EXISTS `timezone`;
CREATE TABLE `timezone` (
  `timezone_id` int(10) unsigned NOT NULL auto_increment,
  `timezone_abbreviation` varchar(4) default NULL,
  `timezone_description` varchar(50) default NULL,
  `timezone_standard_utc_offset` float(4,1) default NULL,
  `timezone_dst_start_dtm_utc` datetime default NULL,
  `timezone_dst_end_dtm_utc` datetime default NULL,
  `timezone_dst_adjust_minutes` int(10) default NULL,
  `create_dtm_utc` datetime default NULL,
  `update_dtm_utc` datetime default NULL,
  `create_dtm_host` datetime default NULL,
  `update_dtm_host` datetime default NULL,
  PRIMARY KEY  (`timezone_id`),
  KEY (`timezone_abbreviation`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `user_access_log`
--
DROP TABLE IF EXISTS `user_access_log`;
CREATE TABLE `user_access_log` (
  `user_access_log_id` int(10) unsigned NOT NULL auto_increment,
  `ip_from` varchar(23) default NULL,
  `session_id` VARCHAR(60) default NULL,
  `access_type` varchar(20) default NULL,
  `user_id` int(10) unsigned default NULL,
  `client_id` int(10) unsigned default NULL,
  `page_access` varchar(50) default NULL,
  `optional_command` varchar(50) default NULL,
  `optional_detail` varchar(50) default NULL,
  `create_dtm_utc` datetime default NULL,
  `update_dtm_utc` datetime default NULL,
  `create_dtm_host` datetime default NULL,
  `update_dtm_host` datetime default NULL,
  PRIMARY KEY  (`user_access_log_id`),
  KEY `user_id` (`user_id`),
  KEY `client_id` (`client_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
--
-- Table structure for table `user_master`
--
DROP TABLE IF EXISTS `user_master`;
CREATE TABLE `user_master` (
  `user_master_id` int(10) unsigned NOT NULL auto_increment,
  `user_login_name` varchar(50) default NULL,
  `client_id` int(10) unsigned default NULL,
  `create_dtm_utc` datetime default NULL,
  `update_dtm_utc` datetime default NULL,
  `create_dtm_host` datetime default NULL,
  `update_dtm_host` datetime default NULL,
  PRIMARY KEY  (`user_master_id`),
  KEY `user_login_name` (`user_login_name`),
  KEY `client_id` (`client_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
-- Create app_subscription_billing triggers
CREATE TRIGGER
    app_sub_billing_defaults_insert_datetime
BEFORE INSERT ON
    app_sub_billing_defaults
FOR EACH ROW SET
    NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s');
CREATE TRIGGER
    app_sub_billing_defaults_update_datetime
BEFORE UPDATE ON
    app_sub_billing_defaults
FOR EACH ROW SET
   NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
   NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s');
-- Create application_type triggers
CREATE TRIGGER
	app_type_insert_datetime
BEFORE INSERT ON
	application_type
FOR EACH ROW SET
    NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s');
CREATE TRIGGER
    app_type_update_datetime
BEFORE UPDATE ON
	application_type
FOR EACH ROW SET
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s');
-- Create app_type_task_fail_settings triggers
CREATE TRIGGER
    app_taskfail_insert_datetime
BEFORE INSERT ON
    app_type_task_fail_settings
FOR EACH ROW SET
    NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s');
CREATE TRIGGER
    app_taskfail_update_datetime
BEFORE UPDATE ON
    app_type_task_fail_settings
FOR EACH ROW SET
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s');
-- Auto-populate rows for known/existing application types
-- Appointment reminder
INSERT INTO app_type_task_fail_settings (app_type_name,fail_update_state_table,fail_update_app_id_field,fail_update_state_field_1,fail_update_state_update_1,fail_update_state_field_2,fail_update_state_update_2)
VALUES ('APPOINTMENT_REMINDER','appointment','appointment_id','reminder_call_status','DONE','reminder_call_response','UNDELIVERABLE');
-- Lab Results
INSERT INTO app_type_task_fail_settings (app_type_name,fail_update_state_table,fail_update_app_id_field,fail_update_state_field_1,fail_update_state_update_1,fail_update_state_field_2,fail_update_state_update_2)
VALUES ('LAB_RESULTS','mr_lab_result','mr_lab_result_id','lab_result_call_status','DONE','lab_result_call_response','UNDELIVERABLE');
-- Wellness Messaging
INSERT INTO app_type_task_fail_settings (app_type_name,fail_update_state_table,fail_update_app_id_field,fail_update_state_field_1,fail_update_state_update_1,fail_update_state_field_2,fail_update_state_update_2)
VALUES ('WELLNESS_MESSAGING','mr_wellness_message','mr_wellness_message_id','wellness_msg_call_status','DONE','wellness_msg_call_response','UNDELIVERABLE');
-- Create area_exchange triggers
CREATE TRIGGER
    area_exchange_insert_datetime
BEFORE INSERT ON
    area_exchange
FOR EACH ROW SET
    NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s');
CREATE TRIGGER
    area_exchange_update_datetime
BEFORE UPDATE ON
    area_exchange
FOR EACH ROW SET
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s');
-- Create callout_application_defaults triggers
CREATE TRIGGER
    callout_app_defaults_insert_datetime
BEFORE INSERT ON
    callout_application_defaults
FOR EACH ROW SET
    NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s');
CREATE TRIGGER
    callout_app_defaults_update_datetime
BEFORE UPDATE ON
    callout_application_defaults
FOR EACH ROW SET
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s');
-- Create client triggers
CREATE TRIGGER
    client_insert_datetime
BEFORE INSERT ON
    client
FOR EACH ROW SET
    NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s');
CREATE TRIGGER
    client_update_datetime
BEFORE UPDATE ON
    client
FOR EACH ROW SET
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s');
-- Create client_application_subscription triggers
CREATE TRIGGER
    client_app_subs_insert_datetime
BEFORE INSERT ON
    client_application_subscription
FOR EACH ROW SET
    NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s');
CREATE TRIGGER
    client_app_subs_update_datetime
BEFORE UPDATE ON
    client_application_subscription
FOR EACH ROW SET
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s');
-- Create client_ip_access triggers
CREATE TRIGGER
    cia_insert_datetime
BEFORE INSERT ON
    client_ip_access
FOR EACH ROW SET
    NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s');
CREATE TRIGGER
    cia_update_datetime
BEFORE UPDATE ON
    client_ip_access
FOR EACH ROW SET
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s');
-- Create dnis_service triggers
CREATE TRIGGER
    dnis_server_insert_datetime
BEFORE INSERT ON
    dnis_service
FOR EACH ROW SET
    NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s');
CREATE TRIGGER
    dnis_server_update_datetime
BEFORE UPDATE ON
    dnis_service
FOR EACH ROW SET
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s');
-- Create ivrconfig triggers
CREATE TRIGGER
    ivrconfig_insert_datetime
BEFORE INSERT ON
    ivrconfig
FOR EACH ROW SET
    NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s');
CREATE TRIGGER
    ivrconfig_update_datetime
BEFORE UPDATE ON
    ivrconfig
FOR EACH ROW SET
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s');
-- Create port_task triggers
CREATE TRIGGER
    port_task_insert_datetime
BEFORE INSERT ON
    port_task
FOR EACH ROW SET
    NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s');
CREATE TRIGGER
    port_task_update_datetime
BEFORE UPDATE ON
    port_task
FOR EACH ROW SET
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s');
-- Create tfr_server triggers
CREATE TRIGGER
    tfr_server_insert_datetime
BEFORE INSERT ON
    tfr_server
FOR EACH ROW SET
    NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s');
CREATE TRIGGER
    tfr_server_update_datetime
BEFORE UPDATE ON
    tfr_server
FOR EACH ROW SET
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s');
-- Create timezone triggers
CREATE TRIGGER
    timezone_insert_datetime
BEFORE INSERT ON
    timezone
FOR EACH ROW SET
    NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s');
CREATE TRIGGER
    timezone_update_datetime
BEFORE UPDATE ON
    timezone
FOR EACH ROW SET
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s');
-- Create user_access_log triggers
CREATE TRIGGER
    user_access_log_insert_datetime
BEFORE INSERT ON
    user_access_log
FOR EACH ROW SET
    NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s');
CREATE TRIGGER
    user_access_log_update_datetime
BEFORE UPDATE ON
    user_access_log
FOR EACH ROW SET
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s');
-- Create user_master triggers
CREATE TRIGGER
    user_master_insert_datetime
BEFORE INSERT ON
    user_master
FOR EACH ROW SET
    NEW.create_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.create_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s');
CREATE TRIGGER
    user_master_update_datetime
BEFORE UPDATE ON
    user_master
FOR EACH ROW SET
    NEW.update_dtm_utc = DATE_FORMAT(UTC_Timestamp(),'%Y-%m-%d %H:%i:%s'),
    NEW.update_dtm_host = DATE_FORMAT(Now(),'%Y-%m-%d %H:%i:%s');

/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;
/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;
