<?php
/*  cr_media_file_hostpush.php

Check with host for new media, convert and push media files ( recordings) back.
* Used for website media play back
* MediaFiles
* Convert to MP3

*/

// Determine relative location for paths
require_once("cr_reference.php");
require_once($incPath.'LocalSettings.php'); 
require($incPath.$sessionphp);

require_once($websiteLibrary.'calcWorkUnit.php'); 
// Media
require_once($websiteLibrary.'mediaWorkUnit.php'); 
// Post using stream
require_once($websiteLibrary.'httpWorkUnit.php');     

/////////////////////////////////////////
// Settings for Media Management
require_once($incPath.'../LocalSettings_MediaManager.php'); 
/////////////////////////////////////////


//////////////////
// Settings
//////////////////

// Note: These values should eventually come from a database or algorithm that determines what to do

// Transfer types
define("TELEFLOWRELAY",	'TELEFLOWRELAY');	// HTTP Post to a TeleFlowRelay host


// === Constants ===
// -- See operationconstants for details


// How many files are we allowed to process in a cycle
// -- Only do 20 at a time so that we are not overwhelming the server
$cProcessMAX 			= 20;  
$mProcessLimit 			= $cProcessMAX;  
$cWaitLoop				= 5;	// Time for next SQL check
		
// Simple functions
function output($pLine)
{
	global $incPath;
	
	fwrite(STDOUT, $pLine."\n"); // echo
	//LogTextToFile('cr_transfer_log.log', $pLine."\n");	
	LogTextToDateNamedFileSystem($incPath, 'cr-recording-transfer', $pLine."\n");	
}


output ("-------------------------------");
output ("Starting Transfr Host Push process");
output ("-------------------------------");

// Get the computer name - eg:  JUPITER
$mCompName = strtoupper(getHostComputerName()); //php_uname('n'); 
//$mCompName = 'EUROPA';
 
$mMediaType = 'TWITYAX';
$mRemoteClientId = 11;
output ("Search for files created by ".$mCompName);

$mHostName 			= 'http://www.callwhip.com/cr_transfer_system/xml_media_publish.php';
$mHostName 			= 'http://www.twityax.com/cr_transfer_system/xml_media_publish.php';
$mTwitterPublisher	= 'http://www.twityax.com/cr_transfer_system/xml_recordingpublish.php';

$mProcessLimit	= 20;

$mOauthKey1 = '';
$mOauthKey2 = '';

$mLoop = 0;
// Loop the entire file
do // forever
{
$mLoop++;

// Catch any problems: Namely:  "MySQL server has gone away"
try
{


//////////////////////////////////////
// Find all clients that have files that may need to have media file transfers done
//////////////////////////////////////

// - Get the uri, and call it with data
$data = '<REQUEST 
action="MediaFilesAsNew" 
client_id="'.$mRemoteClientId.'" 
media_file_type="'.$mMediaType.'"
ivr_computer_name="'.$mCompName.'">
</REQUEST>';

//output ($data);


// Times out after 5 seconds max
$result   = ffl_XMLPostStream($mHostName, $data);
//output ( $result['body']); die;

$doc = new DOMDocument();
$doc->loadXML($result['body']);
// -- Find out what the command is (Must be a REQUEST)
$theFile = $doc->getElementsByTagName('RESPONSE')->item(0);

output ($theFile->getAttribute('action'));

// Loop through each file and process
foreach($theFile->getElementsBytagName('MEDIARESULT') as $mediaFile)
{
	
	output ('Media '.$mediaFile->getAttribute('count'));
	
	$mmedia_file_id 				= $mediaFile->getAttribute('media_file_id');				
	$mmedia_file_directory 			= $mediaFile->getAttribute('media_file_directory');	
	$mmedia_file_name 				= $mediaFile->getAttribute('media_file_name'); 				
	$mmedia_owner_u_id 				= $mediaFile->getAttribute('media_owner_u_id'); 				
	$mfile_reference_id 			= $mediaFile->getAttribute('file_reference_id'); 				
	$mapp_type_name 				= $mediaFile->getAttribute('app_type_name'); 				
	$mmedia_file_type 				= $mediaFile->getAttribute('media_file_type'); 				
	$mivr_computer_name 			= $mediaFile->getAttribute('ivr_computer_name'); 				
	$mivr_port 				    	= $mediaFile->getAttribute('ivr_port'); 				
	$mfile_create_start_dtm_utc 	= $mediaFile->getAttribute('file_create_start_dtm_utc');			
	$mfile_create_end_dtm_utc 		= $mediaFile->getAttribute('file_create_end_dtm_utc'); 				
	$mfile_create_start_dtm_client	= $mediaFile->getAttribute('file_create_start_dtm_client');	
	$mfile_create_end_dtm_client 	= $mediaFile->getAttribute('file_create_end_dtm_client'); 
	$mfile_duration 				= $mediaFile->getAttribute('file_duration'); 
	$mfile_size 				    = $mediaFile->getAttribute('file_size');
	$mfile_app_status 				= $mediaFile->getAttribute('file_app_status');
	$mapp_status_update_dtm_utc 	= $mediaFile->getAttribute('app_status_update_dtm_utc');
	$mapp_status_update_dtm_client	= $mediaFile->getAttribute('app_status_update_dtm_client');
	$mfile_transfer_status 			= $mediaFile->getAttribute('file_transfer_status');
	
	// Find the file location (This is the web folder)
	$mMediaFullPath = filePathForOS(clientMediaFolderLocate(false, $incPath, $mRemoteClientId).'/'.$mmedia_file_directory.'/'.$mmedia_file_name);
	// OVERRIDE - Find the file location (This is the teleflwo folder)
	$mMediaFullPath = filePathForOS(mediaFileFolderLocate(false, $mRemoteClientId, '').'/'.$mmedia_file_directory.'/'.$mmedia_file_name);
	
	
	// If we have the file, then transfer, otherwise indicate as not found
	if (file_exists($mMediaFullPath))
	{
		output (('Found: '.$mMediaFullPath));
		// We are attempting to mark the file as completed.
		clearstatcache();
		$mFileSize = (filesize($mMediaFullPath));
		$mFileLocal = 'TRUE';
		
		
		// Convert the files as needed
		output("Converting to MP3: ". $mMediaFullPath);
	
		// We are processing this, so reduce the count
		$mProcessLimit = $mProcessLimit -1;
	
		// Set up the names we expect
		$fileWAV	= $mMediaFullPath;
		// Determine filenames for compressed versions
		$fileMP3   = getMediaFileNameMP3($fileWAV); 
		$fileGSM   = getMediaFileNameGSM($fileWAV); 
		output("-- MP3: ". $fileMP3);
		
		// Test conversions to ensure they worked 
		$SuccessConversion = false;

		// CONVERT: Wav to MP3
		if (!stristr(PHP_OS, 'WIN'))
		{
			// Linux.  Install withL
			//sudo apt-get install sox	
			$cmd = ('sox '.$mMediaFullPath.' -s '.$fileWAV);
			//$result = shell_exec($cmd);  // GSM ONLY
			
			// sudo apt-get install lame	
			$cmd = ('lame -h -V 4 '.$fileWAV.' '.$fileMP3); // Now, finalize the move
			$result = shell_exec($cmd);
		}
		else
		{
			// Windows
			$cmd = ('sox\sox '.$mMediaFullPath.' -s '.$fileWAV);
			//$result = shell_exec($cmd);  // GSM ONLY
			
			$cmd = ('lame\lame -h -V 4 '.$fileWAV.' '.$fileMP3);
			$result = shell_exec($cmd);
		}

		// Did we get it?
		$SuccessConversion = (file_exists($fileMP3));		
		if ($SuccessConversion)
		{
			output('-- SUCCESS: ');

			if (file_exists($fileMP3))
			{
				$mMP3FileSize = (filesize($fileMP3));
			
				// Load the contents of the file to Mime encode
				// -WARNING: This file could be any size.  Should we put a limit on it somehow?
				$handle = fopen($fileMP3, "rb");  // windows MUST have a 'b' for binary
				$contents = fread($handle, $mMP3FileSize);
				fclose($handle);
				
				// Send as an mp3 file name
				$mSendFileNameMP3   = getMediaFileNameMP3($mmedia_file_name); 
			
				$data1 = '<REQUEST 
action="MediaFileUploadAndComplete" 
media_file_id="'.$mmedia_file_id.'"
media_file_directory="'.$mmedia_file_directory.'"
media_file_name="'.$mSendFileNameMP3.'"
client_id="'.$mRemoteClientId.'" 
media_file_type="'.$mMediaType.'"
file_duration="'.$mfile_duration.'"
file_size="'.$mMP3FileSize.'"
ivr_computer_name="'.$mCompName.'">';
			
				$data2 = '<FileContents>'.base64_encode($contents).'</FileContents>';
				$data3 = '</REQUEST>';

				output("Posting MP3 (".$mMP3FileSize." bytes) to: ".$mHostName);
				//echo $mHostName.$data1.$data2.$data3; die;
				$result = ffl_XMLPostStream($mHostName, $data1.$data2.$data3);
				//print_r($result); die;
			
				$doc->loadXML($result['body']);
				// -- Find out what the command is (Must be a REQUEST)
				$theFile = $doc->getElementsByTagName('RESPONSE')->item(0);
				$theResponse = $theFile->getElementsByTagName('SUCCESS')->item(0);
				if ($theResponse)
				{
					output("-- SUCCESS: remote host received ".$theResponse->getAttribute('filesize')." bytes");

					if ($mMediaType == 'TWITYAX')
					{
						output("-- ATTEMPTING to post to Twitter");
						
						$data1 = '<REQUEST action="PostMediaToTwitter" 
media_file_id="'.$mmedia_file_id.'"
media_file_directory="'.$mmedia_file_directory.'"
media_file_name="'.$mSendFileNameMP3.'"
media_owner_u_id="'.$mmedia_owner_u_id.'"
client_id="'.$mRemoteClientId.'" 
media_file_type="'.$mMediaType.'">';
						$data3 = '</REQUEST>';

						output("Posting MP3 (".$mMP3FileSize." bytes) to: ".$mTwitterPublisher);
						
						//echo $data1.$data3; die;
						$result = ffl_XMLPostStream($mTwitterPublisher, $data1.$data3);
						//print_r($result); die;
					}
				}
				else
				{
					output("-- ERROR with upload");
				}
			}
			else
			{
				$mSuccessSend = false;
			}								
		}
	}
	else
	{
		output (('Missing: '.$mMediaFullPath));
	
	}	
}


output (('Done: '));
die;
/*
	// Do a check to make sure all the mft entries are COMPLETED (new, completed, retry)
	// - If successful transfers = the number to transfer... we are done
	// - Update media_file from PROCESSING to COMPLETED		
	if ($mTotal == 0)
	{
		// Update the details in Database
		$result = $database->mediaEntryUpdate($mClientId, 
					$mMedia_file_id,
					'', // no need to update file_app_status
					FT_COMPLETED,
					$mFile_duration,
					$mFile_size);
					
		output ("-- Recording completed for Media File: ".$mMedia_file_id);
	}
	else
	{
		output ("-- Warning: Could not complete Media File: ".$mMedia_file_id);
	}							
*/


//output ("DEBUG - Shutdown");
//die;
//catch exception
}
catch(Exception $e)
{
	output (" "); // A blank space
	output ("ERROR Encountered");
	output ("* Message: ".$e->getMessage());
	output ("* Waiting to continue loop...");
	sleep($cWaitLoop);
	output (" "); // A blank space
}


} while (TRUE);
  
output ("Done! \n");
?>