<?php
// Push emails out.... in case of slow, or system which cannot be reached for times

//XML post in a Stream, so that the program will timeout, and continue without holding the user forever
// *** RECOMMENDED *** - Go with this approach for XML post and responses
/*
	$result   = ffl_XMLPostStream($mHostName, $data);
	echo $result['body'];
*/
function ffl_XMLPostStream( $url, $postdata) 
{
	$url_parsed = parse_url($url);
	if ( empty($url_parsed['scheme']) ) 
	{
		$url_parsed = parse_url('http://'.$url);
	}
	$rtn['url'] = $url_parsed;

	$port = 80;
	if (isset($url_parsed["port"]))
	{
		$port = $url_parsed["port"];
	}
	$rtn['url']['port'] = $port;
    
	$path='';
	if (isset($url_parsed["path"]))
	{
		$path = $url_parsed["path"];
	}
	if ( empty($path) ) 
	{
		$path="/";
	}		
	
	if ( !empty($url_parsed["query"]) ) 
	{
		$path .= "?".$url_parsed["query"];
	}
	$rtn['url']['path'] = $path;
	$host = $url_parsed["host"];
	$foundBody = false;

	$out =  "POST $path HTTP/1.0\r\n";
	$out .= "Host: $host\r\n";
	$out .= "Content-Length: ".strlen($postdata)."\r\n";
	$out .= "Connection: keep-alive: 3\r\n\r\n";
	
	// Read socket - timeout 10 seconds
	if ( !$fp = @fsockopen($host, $port, $errno, $errstr, 5) ) 
	{
		$rtn['body']		= "Error: Read 'errornumber' and 'errorstring' for details";
		$rtn['errornumber'] = $errno;
		$rtn['errorstring'] = $errstr;
		return $rtn;
	}
	stream_set_timeout($fp, 5);
	fwrite($fp, $out);
	fwrite($fp, $postdata);


	// The \r\n\r\n breaks up the body from the head
	$res = split("\r\n\r\n",fread($fp, 20000));
	$header = $res[0];
	// Possible not to get a body
	$body	= '';
	if (isset($res[1]))
	{
		$body 	= $res[1];
	}
	
	/*
	fwrite($fp, $out);
	
	$responseData = '';
	while (!feof($fp))
	{
		$responseData .= fgets($fp, 128);
	}

	// The \r\n\r\n breaks up the body from the head
	$res = split("\r\n\r\n", $responseData);
	$header = $res[0];
	// Possible not to get a body
	$body	= '';
	if (isset($res[1]))
	{
		$body 	= $res[1];
	}
	*/
	
	$info = stream_get_meta_data($fp);
	fclose($fp);

	// How did we get here?
	if ($info['timed_out']) 
	{
		// Connection timed out!
		$body = '<?xml version="1.0" encoding="ISO-8859-1"?><RESPONSE><FAILURE result="TIMEOUT">Timeout</FAILURE></RESPONSE>';
	}
	
	$rtn['body'] = trim($body);
	return $rtn;
} // ffl_XMLPostStream


// HTTP Post
// Post, but if no response happens, move on
// -- Use this function to post a command or XML that cannot be waited for.  
// -- A realtime environment may use this when a result is not critical (eg - command to send email)
function ffl_Post( $path, $port, $postdata, $followRedirects=true) 
{
	$rtn['url']['path'] = $path;
	$rtn['url']['port'] = $port;
	$host = $path;
	$foundBody = false;

	$out =  "POST $path HTTP/1.0\r\n";
	$out .= "Host: $host\r\n";
	$out .= "Content-Length: ".strlen($postdata)."\r\n";
	$out .= "Connection: keep-alive: 3\r\n\r\n";
	//echo $out;    
	if ( !$fp = @fsockopen($host, $port, $errno, $errstr, 30) ) 
	{
		$rtn['errornumber'] = $errno;
		$rtn['errorstring'] = $errstr;
		return $rtn;
	}
	fwrite($fp, $out);
	fwrite($fp, $postdata);

	while (!feof($fp)) 
	{
		$s = fgets($fp, 128);
		if ( $s == "\r\n" ) 
		{
			$foundBody = true;
			continue;
		}
		
		if ( $foundBody ) 
		{
			$body .= $s;
		} 
		else 
		{
			if ( ($followRedirects) && (stristr($s, "location:") != false) ) 
			{
				$redirect = preg_replace("/location:/i", "", $s);
				return ffl_HttpGet( trim($redirect) );
			}
			$header .= $s;
		}
	}
	fclose($fp);

	$rtn['header'] = trim($header);
	$rtn['body'] = trim($body);

	//echo "".$rtn['header']."<BR><BR>";
	//echo "".$rtn['body']."<BR><BR>";

	return $rtn;
} // ffl_Post

function email_client($pClientId)
{
	$data = '<REQUEST action="EmailDistribution" client_id="'.$pClientId.'" seconds="2"></REQUEST>';
	// Post Back to ourselves for an email-now request
	//$host     = $_SERVER['SERVER_NAME'];
	//$uri      = rtrim($_SERVER['PHP_SELF'], "/\\");					
	//$thisprog = currentURLPath("http://".$host.$uri).'/sr_ajax_email.php';	
	$thisprog = 'http://europa/eng_staffrelay_xml/xml_staffcmd.php';
	
	$stringData = $thisprog.' with '.$data."\n"."-- System attempted XML for: ".Date('G:i:s')."\n\n";
	
	//LogTextToFile($incPath.SYSTEM_LOGFILES."StaffRelay-".Date('Y-m-d').".log", $stringData);
	// Times out after 5 seconds max
	//$result   = XMLPostStream($thisprog, $data );
	//$result   = ffl_XMLPostStream($thisprog, $data);
	// Use ffl_post to post the Email, but not wait for the response
	echo ("Posting emails for ".$data."\n");
	$result   = ffl_XMLPostStream($thisprog, $data);
}


////////////////
// MAIN
////////////////

email_client(6);
email_client(7);
email_client(13);
email_client(14);
echo ("Done! \n");
sleep(30);

	
	
?>