<?php
// Responses provided by the PHP program
$responsecode = "";


// Date and Time defaults
$teleflowDate = Date("Y/m/d");
$teleflowTime = Date("H:i:s");
     // yyyy/mm/dd ==> mm/dd/yyyy
$webDate      = Date("m/d/Y");

$mMode = '';
//echo("<BR><BR>".$data."<BR><BR>");
//decho($mMode, "STARTED at ".teleflowNowDate()." ".teleflowNowTime()." (".$webDate.")<BR>");

// Set up file names
$stmp        = date("Y-m-d_H-i-s");
$reqf  = $incPath.SYSTEM_LOGFILES.$mSystemCode."_".$stmp."_request.xml";
$resf  = $incPath.SYSTEM_LOGFILES.$mSystemCode."_".$stmp."_response.xml";


// Assume an XML document, and process...
$doc = new DOMDocument();

$request_Command = '';
// Did the user actually send a request?
if ($data <> '')
{
   $doc->loadXML($data);
   // save it for later review
   //$doc->save($reqf);

   // XML Command request
   // -- Find out what the command is (Must be a REQUEST)
   $theFile = $doc->getElementsByTagName('REQUEST')->item(0);

   if ($theFile->hasAttribute('action'))
   {
      $request_Command = GetSQLSafeValues($theFile->getAttribute('action'));
   }
}

// Create the Result XML document
$domobject = new DOMDocument('1.0', 'utf-8');

// Wrap the request
$elementHolder  = $domobject->createElement("RESPONSE", "");
// Default 

$error   = 'ERROR';
$success = 'SUCCESS';
// Types --
$db		= 'DB';
$cmd 	= 'CMD';
$read	= 'READ';

// Review the requested Command
if ($request_Command <> "") 
{
	{

	  /////////////////////////////////////////////////////////
	  if ($request_Command == "Hello")
	  /////////////////////////////////////////////////////////
	  {
		$responsecode = "Hi back: We are here to serve";
				
		$elementSuccess  = $domobject->createElement("SUCCESS");
		$elementSuccess->setAttribute("action", $request_Command); 
		$elementSuccess->setAttribute("result", $success); 
		$elementSuccess->setAttribute("type",   $read); 
		// Add verbose TEST 
		$elementSuccess->appendChild($domobject->createTextNode($responsecode));
		// Add to the complete list
		$elementHolder->appendChild($elementSuccess);		
		
	  }

	  /////////////////////////////////////////////////////////
	  else if ($request_Command == "Sleep")
	  /////////////////////////////////////////////////////////
	  {
		$seconds      = GetSQLSafeValues(GetNonEmptyValue($theFile->getAttribute('seconds'), -1));
		$responsecode = "Sleeping for ".$seconds." seconds.";
		//sleep for x seconds
		sleep($seconds);

		$elementSuccess  = $domobject->createElement("SUCCESS");
		$elementSuccess->setAttribute("action", $request_Command); 
		$elementSuccess->setAttribute("result", $success); 
		$elementSuccess->setAttribute("type",   $read); 
		// Add verbose TEST 
		$elementSuccess->appendChild($domobject->createTextNode($responsecode));
		// Add to the complete list
		$elementHolder->appendChild($elementSuccess);
	  }

	  /////////////////////////////////////////////////////////
	  else if ($request_Command == "ConvertMP3")
	  /////////////////////////////////////////////////////////
	  {
		if(($theFile->hasAttribute('mediafile')))
		{
			$responsecode = "Converting media to MP3";			
			
			// Get the attributes to find the song
			$mMediaComputer		= GetSQLSafeValues($theFile->getAttribute('mediacomputer'));
			$mMediaDirectory	= GetSQLSafeValues($theFile->getAttribute('mediadirectory'));
			$mMediaFile			= GetSQLSafeValues(GetNonEmptyValue($theFile->getAttribute('mediafile'), -1));

			// Get the original location of the file
			$mMediaFullPath = $mRemoteMappedDrive.$mMediaComputer.'/'.$mMediaDirectory.'/'.$mMediaFile;

			///////////// Generate Media or Data //////////////
			// Compressed version (wav)
			// Mp3 version 
			$fileMP3   = str_replace('.wav', '.mp3', $mMediaFile);  // Lower case (wav)
			$fileMP3   = str_replace('.WAV', '.mp3', $fileMP3);  	// Lower case (wav)
			$fileMP3   = str_replace('.gsm', '.mp3', $fileMP3);   	// Lower case (or gsm)
			$fileMP3   = str_replace('.GSM', '.mp3', $fileMP3);   	// Lower case (or gsm)
			$mMediaFileReturn = $fileMP3;
			$fileMP3   = ($incPath.CLIENT_MEDIA_AREA.'/'.$fileMP3);  // Should have backslash to slash

			$fileWAV   = str_replace('.mp3', '.wav', $fileMP3);   	// Convert the MP3 to wav (for gsm conversions)

			$mMediaPlayName = str_replace('.wav', '.mp3', CLIENT_MEDIA_AREA.'/'.$mMediaFileReturn);

			// CONVERT: Convert the WAV FAT file to WAV GSM  (also see SOX:  http://sox.sourceforge.net/)
			//$cmd = ('libsndfile\sndfile-convert.exe -gsm610 '.$fileWAV.' '.$fileGSM);
			//$result = shell_exec($cmd);

			// CONVERT: Wav to MP3
			if (!stristr(PHP_OS, 'WIN'))
			{
				// Linux.  Install withL
				//sudo apt-get install sox	
				$cmd = ('sox '.$mMediaFullPath.' -s '.$fileWAV);
				$result = shell_exec($cmd);
				
				// sudo apt-get install lame	
				$cmd = ('lame -h -V 4 '.$fileWAV.' '.$fileMP3); // Now, finalize the move
				$result = shell_exec($cmd);
			}
			else
			{
				// Windows
				$cmd = ('sox\sox '.$mMediaFullPath.' -s '.$fileWAV);
				$result = shell_exec($cmd);
				
				$cmd = ('lame\lame -h -V 4 '.$fileWAV.' '.$fileMP3);
				$result = shell_exec($cmd);
			}

			//echo 'result'.$_SERVER['HTTP_USER_AGENT'].$result; die;
			
			// Determine success by testing to see if the file exists
			if (file_exists($fileMP3))
			{
				$elementHolder->setAttribute("result", $success); 
				
				$elementSuccess  = $domobject->createElement("MEDIA");
				$elementSuccess->setAttribute("action", 	$request_Command); 
				$elementSuccess->setAttribute("result", 	$success); 
				$elementSuccess->setAttribute("type",   	$read); 
				$elementSuccess->setAttribute("orig",   	$mMediaFullPath); //$mMediaFullPath); 
				$elementSuccess->setAttribute("mediaplay",	$mMediaPlayName); 
				
				$elementSuccess->appendChild($domobject->createTextNode($responsecode));
				// Add to the complete list
				$elementHolder->appendChild($elementSuccess);	
			}
			else
			{
				$elementHolder->setAttribute("result", $error); 
				
				$elementError  = $domobject->createElement("MEDIA");
				$elementError->setAttribute("action", 	$request_Command); 
				$elementError->setAttribute("result", 	$error); 
				$elementError->setAttribute("type",   	$read); 
				
				$responsecode = 'Unable to locate MP3 file';
				
				$elementError->appendChild($domobject->createTextNode($responsecode));
				// Add to the complete list
				$elementHolder->appendChild($elementError);	
			}

		}
	  }
		  

	  /////////////////////////////////////////////////////////
	  else if ($request_Command == "DiskSpace")
	  /////////////////////////////////////////////////////////
	  {
		$di      = GetNonEmptyValue($theFile->getAttribute('drive'), -1);

		if(($theFile->hasAttribute('drive'))
		)
		{
			$request_drive		= GetSQLSafeValues($theFile->getAttribute('drive'));	

			$free = 0;
			$total = 0;
			if (getDiskSpaceImage($request_drive.":",0,'',$free,$total))
			{
				$elementSuccess  = $domobject->createElement("SUCCESS");
				// Add verbose TEST 
				
				$elementSuccess->setAttribute("units",	'GB'); 
				$elementSuccess->setAttribute("disksize", $total); 
				$elementSuccess->setAttribute("diskfree", $free); 
				
				$elementSuccess->appendChild($domobject->createTextNode($responsecode));
				// Add to the complete list
				$elementHolder->setAttribute("action", $request_Command); 
				$elementHolder->setAttribute("result", $success); 
				$elementHolder->setAttribute("type",   $read); 
				$elementHolder->appendChild($elementSuccess);					
			}
			else
			{
				$responsecode = "Failed to determine diskspace";
				$elementHolder->setAttribute("action", $request_Command); 
				$elementHolder->setAttribute("result", $error); 
				$elementHolder->setAttribute("type",   $read); 
				// Add verbose TEST 
				$elementHolder->appendChild($domobject->createTextNode($responsecode));
			}
		}
		else
		{
			// Missing parameters
			$responsecode = "Mandetory parameters are missing";
			$elementHolder->setAttribute("action", $request_Command); 
			$elementHolder->setAttribute("result", $error); 
			$elementHolder->setAttribute("type",   $read); 
			// Add verbose TEST 
			$elementHolder->appendChild($domobject->createTextNode($responsecode));		
		}		
		
	  }
	  /////////////////////////////////////////////////////////
	  else
	  /////////////////////////////////////////////////////////
 	  {
			//decho($mMode,"BAD COMMAND<BR>");
			$elementHolder->setAttribute("action", $request_Command);
			// Final results
			$responsecode = "Unknown Command";
			$elementResult  = $domobject->createElement("ERROR", $responsecode);
			$elementHolder->appendChild($elementResult);			
	  }
	}
}
else
{
	//decho($mMode,"NO COMMAND Provided<BR>");
	$elementHolder->setAttribute("action", "NotDefined");
	// Final results
	$responsecode = "ERROR: No Command Provided";
	$elementResult  = $domobject->createElement("RESULT", $responsecode);
}

// Put it all together
//$elementHolder->appendChild($elementResult);
$domobject->appendChild($elementHolder);
// Save to Log dir .. if there was a request
if ($request_Command <> "") 
{
    // No saving for this app.  Its not creating new info really
    //$domobject->save($resf);
}
?>