<?php
/*  cr_media_file_manager.php

This process performs the following functions:
* Review all clients for *.new.xml files
* Review all clients for files to remove
** Dictations
** Voice Messages 
** Call Recordings 
** Log files


*/

// Determine relative location for paths
require_once("cr_reference.php");
require_once($incPath.'LocalSettings.php'); 
require($incPath."include/session.php");
require_once($websiteLibrary.'calcWorkUnit.php'); 
// Media
require_once($websiteLibrary.'mediaWorkUnit.php'); 
// Post using stream
//require_once($websiteLibrary.'httpWorkUnit.php');     

/////////////////////////////////////////
// Settings for Media Management
require_once($incPath.'../LocalSettings_MediaManager.php'); 
/////////////////////////////////////////

function decho($pText)
{ 
}

/////////////////////////// XML_MEDIA_PUBLISH BODY ///////////////////////////////
// NOTE: This is a little trick to create a function, whic  then works with the value in $data
function xml_media_publish($data)
{
	global $database;
	// All the contents become the function
	// - Note: requires a decho function
	include('xml_media_publish_body.php');
	$doc->loadXML($domobject->saveHTML());
	if($doc->getElementsByTagName('SUCCESS')->item(0))
	{
		// Element was found, so we are good
		return true;
	}
	return false;
} // xml_media_publish
/////////////////////////// XML_MEDIA_PUBLISH BODY ///////////////////////////////
		
// Simple functions
function output($pLine)
{
	global $incPath;
	
	fwrite(STDOUT, $pLine."\n"); // echo
	//LogTextToFile('cr_transfer_log.log', $pLine."\n");	
	LogTextToDateNamedFileSystem($incPath, 'cr-recording-transfer', $pLine."\n");	
}


output ("-------------------------------");
output ("Starting File Management Process");
output ("-------------------------------");

// Get the computer name - eg:  JUPITER
$mCompName = getHostComputerName(); //php_uname('n');  
output ("Search for files created by ".$mCompName);

$mLoop = 0;
// Loop the entire file
do // forever
{
// Sleep every loop
if ($mLoop <> 0)
{
	sleep($cWaitLoop);
}
// Count up
$mLoop++;


// Catch any problems: Namely:  "MySQL server has gone away"
try
{

	//////////////////////////////////////
	// Find all clients that are active, and 
	//////////////////////////////////////
	$q =
"SELECT 
	a.client_id client_id,
	client_name,
	app_type_name,
	subscription_status
FROM 
	".DATABASE_MASTER.".client a,
	".DATABASE_MASTER.".client_application_subscription b
WHERE
	a.client_id = b.client_id
AND a.client_status = 'ACTIVE'
AND b.subscription_status = 'ACTIVE'
AND app_type_name like '".PROCESSTYPE."'
ORDER BY client_id
";		
//echo $q; die;

	// Do we have any clients needing processsing
	$clientResult = $database->sqlConvert_sql_query($q, $database->connectionSystem);
	if (!$clientResult || ($database->sqlConvert_sql_numrows($clientResult) < 1))
	{
		output("* ".teleflowNowTimeStamp()."(".$mLoop."): No clients are current set with ".PROCESSTYPE." to ACTIVE. Sleeping ".$cWaitLoop." seconds...");
		sleep($cWaitLoop);
	}
	else
	{
		output("* ".$mLoop.": Found ".$database->sqlConvert_sql_numrows($clientResult)." clients with ".PROCESSTYPE." as ACTIVE.");
		output(" "); // A blank space
		
		//////////////////////////////////////
		//  MEDIA - For Each Client
		//////////////////////////////////////
		while (($row_rsClientResult = $database->sqlConvert_sql_fetch_array($clientResult)))
		{		
			// Set the Files Array to keep track what to delete at the end
			$mFilesTempArray 		= array();
			$mFilesTempCount 		= 0;
			// Array for files used when send via SSLNR
			$mFilesTransferArray	= array();	
			$mFilesTransferCount 	= 0;
			
			// Remember the client
			$mClientId = $row_rsClientResult['client_id'];
			
			// Leave a break for readability
			output(' '); 
		
		
			//////////////////////////////////////
			//  SELECT CLIENT DATABASE
			//////////////////////////////////////		
			output('Client: '.$mClientId.' - '.$row_rsClientResult['client_name']);		
			if ($database->selectClientDatabaseByMasterClientId($mClientId))
			{
				output('- Selected database & testing for files');
			
				// See if there are files to load
				if ($mClientMediaNewXmlYN)
				{
					// Determine the folder in which the file should be found (do not create, and in the client_id, root)
					$mMediaFolder = mediaFileFolderLocate(false, $mClientId, '');
					
					output('- XML Reading: '.$mMediaFolder);
					
					// Define where the *.NEW.XML files are to be found (if any)
					$dir = opendir($mMediaFolder);

					$mFileFound = false;
					while (($file = readdir($dir)) !== false)
					{
						// Only files, no dirs
						if (!is_dir($file))
						{
							$mFileFound = true;
							$fs=filesize($mMediaFolder."/". $file);
							$moddate=date('F j, Y',filemtime($mMediaFolder."/". $file));
							
							// Do we have a new file?
							if (rightstr($file,8) == '.NEW.XML')
							{
								output('- Processing XML Media: '.$file);
								
								// Load the file into a file, and then post it
								$dataLoad  = file_get_contents($mMediaFolder."/". $file);
								if ($dataLoad)
								{
									// Create a media entry
									//output('-- Create: '.$dataLoad);
								
									// Build on the action
									$dataCmd = '<REQUEST action="MediaFileInsertMediaEntry" client_id="'.$mClientId.'">'.
											xml_sanitize($dataLoad).
											'</REQUEST>';
									//echo $dataCmd; die;
									
									// If we successfully created a media entry, then move the file
									if (xml_media_publish($dataCmd))
									{
										// Prepare the file, and then move it to a backup (see MediaWorkUnit)
										$mMediaFolderDated = mediaFileFolderLocate(true, $mClientId, teleflowNowDate());
										
										// If file exists, rename 
										if (file_exists($mMediaFolderDated."/".$file))
										{
											unlink($mMediaFolderDated."/".$file);
										}										
										// Move the file to a new place
										rename( $mMediaFolder."/".$file, $mMediaFolderDated."/".$file);	
										output('-- Successfully processed and moved to: '.$mMediaFolderDated);
									}
									else
									{
										output('- ERROR: Could not create Media entry for: '.$file);
									}
								}
							}
							
							//<td align="left" class="tabletxt"><a href="'.$mMediaFolder."/". $file.'">'.$file.'</a></td>
							//<td align="left" class="tabletxt">'.formatReadableSize($fs).'</td>
						}
					}
					closedir($dir);					
				}
				
				// Test to see if we want to delete
				if ($mClientMediaDeleteYN)
				{
					
					//////////////////////////////////////
					//  Find all Media to test for removal
					//////////////////////////////////////
					// Rules 
					// - The media file is set to NEW for the file_app_status once the use has indicated the file is ready for processing
					// - Once file_app_status is NEW, then the file_xfer status becomes the trigger for the rest of the processing
					$query_statement = (sprintf(
"SELECT 
	media_file_id,
	media_owner_u_id,
	media_file_directory,
	media_file_name, 
	file_reference_id, 
	app_type_name,
	file_duration,
	file_size
FROM
	media_file
WHERE
	(file_app_status 		<> '%s') 
AND (file_transfer_status 	= '%s') 
AND (ivr_computer_name  	= '%s')
AND (%s	< %s)",
	FA_SAVED, 
	FT_COMPLETED, 
	$mCompName,
	$database->sqlConvert_DateAdd_Days('update_dtm_client',TELEFLOW_CLIENT_MEDIA_MAXDAYS),
	$database->sqlConvert_DateFormat_FullTimeStamp_Now() ));

					//output($query_statement);	die; // Read them 
					
					$rsSearchResult = $database->sqlConvert_sql_query($query_statement, $database->connectionClient); // or die(mysql_error());
					$totalRows_rsSearchResult = $database->sqlConvert_sql_numrows($rsSearchResult);  
					output ("- Total media recordings for processing on ".$mCompName." = ".$totalRows_rsSearchResult);
					
					// Only process if we have something to do
					if ($totalRows_rsSearchResult > 0)
					{
						// Mark that we only do so much work per client per cycle
						$mProcessLimit 			= $cProcessMAX;  
						
						// For each media file to be processed...				
						while (($row_rsSearchResult = $database->sqlConvert_sql_fetch_array($rsSearchResult)) && ($mProcessLimit > 0))
						{   
							// Get the fields from media_file
							$mMedia_file_id				= $row_rsSearchResult['media_file_id'];
							$mMedia_owner_u_id			= $row_rsSearchResult['media_owner_u_id'];
							$mMedia_file_directory		= $row_rsSearchResult['media_file_directory'];
							$mMedia_file_name			= $row_rsSearchResult['media_file_name'];
							$mFile_reference_id			= $row_rsSearchResult['file_reference_id'];
							$mApp_type_name				= $row_rsSearchResult['app_type_name'];
							$mFile_duration				= $row_rsSearchResult['file_duration'];
							$mFile_size					= $row_rsSearchResult['file_size'];

							
							// Determine the folder in which the file should be found
							$mMediaFolder = mediaFileFolderLocate(false, $mClientId, $mMedia_file_directory);
							// The original dictation recording from TeleFlow
							$fileWAV   = $mMediaFolder.'/'.$mMedia_file_name;
							
							// Remove if exists
							if (file_exists($fileWAV))
							{
								output("-- Deleting for ".$fileWAV);
								if ($mAllowDeleteYN)
								{
									unlink($fileWAV);
								}
								
								// We are processing this, so reduce the count
								$mProcessLimit = $mProcessLimit -1;
							
								// Determine filenames for compressed versions
								$fileMP3   = getMediaFileNameMP3($fileWAV); 
								if (file_exists($fileMP3))
								{
									output("-- Deleting for ".$fileMP3);
									if ($mAllowDeleteYN)
									{
										unlink($fileMP3);
									}
								}
								
								$fileGSM   = getMediaFileNameGSM($fileWAV); 
								if (file_exists($fileGSM))
								{
									output("-- Deleting for ".$fileGSM);
									if ($mAllowDeleteYN)
									{
										unlink($fileGSM);
									}
								}
							}
							else 
							{
								output("-- File does not exist ".$fileWAV);
							}
							

							// If we have set the file to  allow delete
							if ($mAllowDeleteYN)
							{
								// Mark that the file was updated
								$result = $database->mediaEntryUpdate($mClientId, 
											$mMedia_file_id,
											'', // no need to update file_app_status
											FT_PURGED,
											$mFile_duration,
											$mFile_size);
							}
						} // while each media
					} // if $totalRows_rsSearchResult
				} // if ($mClientMediaDeleteYN)
			}  // if ($database->sele
		
		} //  while

		output (" "); // A blank space

	} // while clients with media transfer applications


	//output ("DEBUG - Shutdown");
	//die;
	//catch exception
}
catch(Exception $e)
{
	output (" "); // A blank space
	output ("ERROR Encountered");
	output ("* Message: ".$e->getMessage());
	output ("* Waiting to continue loop...");
	sleep($cWaitLoop);
	output (" "); // A blank space
}


} while (TRUE);
  
output ("Done! \n");
?>