<?php
// Responses provided by the PHP program
$responsecode = "";

// Date and Time defaults
$teleflowDate = Date("Y/m/d");
$teleflowTime = Date("H:i:s");
     // yyyy/mm/dd ==> mm/dd/yyyy
$webDate      = Date("m/d/Y");


//echo("<BR><BR>".$data."<BR><BR>");
decho("STARTED at ".teleflowNowDate()." ".teleflowNowTime()." (".$webDate.")</br>");

// Set up file names
/*
$stmp        = date("Y-m-d_H-i-s");
$fold        = "log/";
// Create the log folder
if (!is_dir($fold))
{
    mkdir($fold);
}
$reqf  = $fold.$cSysName."_".$stmp."_request.xml";
$resf  = $fold.$cSysName."_".$stmp."_response.xml";
*/



// Assume an XML document, and process...
$doc = new DOMDocument();

// Get the session user name.  Note: will be "Guest" (GUEST_NAME) if no one has signed on
$request_UserName = $_SESSION['username'];

$request_Command = '';
// Did the user actually send a request?
if ($data <> '')
{
	$doc->loadXML($data);
	// save it for later review
	//$doc->save($reqf);

	// XML Command request
	// -- Find out what the command is (Must be a REQUEST)
	$theFile = $doc->getElementsByTagName('REQUEST')->item(0);

	if ($theFile->hasAttribute('action'))
	{
		$request_Command  = GetSQLSafeValues($theFile->getAttribute('action'));
		// "username" only needs to be send if testing is being done... other wise its a session variable
		if ($theFile->hasAttribute('username'))
		{
			if ($theFile->getAttribute('username') <> "")
			{
				$request_UserName =  GetSQLSafeValues($theFile->getAttribute('username'));
			}
		}
		
		///////////////////////
		// Get the client_id
		///////////////////////
		$mClient_id = GetSQLSafeValues($theFile->getAttribute('client_id'));
	}
}

//echo 'Here'.$mClient_id;

// Create the Result XML document
$domobject = new DOMDocument('1.0', 'utf-8');

// Wrap the request
$elementHolder  = $domobject->createElement("RESPONSE", "");
$elementHolder->setAttribute("action", "invalid"); //$request_Command); 
// Default 

$error   = 'ERROR';
$success = 'SUCCESS';
// Types --
$db      = 'DB';
$cmd     = 'CMD';

// Review the requested Command
if ($request_Command <> "") 
{
  if (!allowAccessForIPListOrLocalIPs($cLocationAccess ))
  {
	// We cannot allow this request to go through
	$mIP = getClientIpAddress();
	$responsecode = "Failed request due to access control blocking ".$mIP;
	$elementHolder->removeAttribute("action");
	$elementHolder->setAttribute("action", $request_Command); 
	$elementHolder->setAttribute("result", $error); 
	$elementHolder->setAttribute("type",   $db); 
	$elementHolder->setAttribute("ipaddress",    $mIP);
	// Add verbose TEST 
	$elementHolder->appendChild($domobject->createTextNode($responsecode));
	
  }
  else
  {
	// We are good to go
	$elementHolder->setAttribute("action", $request_Command); 

	// See if we can select the database 
	// - Try first with the client ID, and then go to the username for in session usages
	if ($mClient_id <> '')
	{
		$db_selected2  = $database->selectClientDatabaseByMasterClientId($mClient_id);
	}
	else
	{
		$db_selected2  = $database->selectClientDatabaseByUsername($request_UserName);
	}

	
	// Fail to connect to database
	if (!$db_selected2)
	{
		$responsecode = "Failed to Connect to Database for ".$request_UserName;
		$elementHolder->setAttribute("action", $request_Command); 
		$elementHolder->setAttribute("result", $error); 
		$elementHolder->setAttribute("type",   $db); 
		// Add verbose TEST 
		$elementHolder->appendChild($domobject->createTextNode($responsecode));
	}
	else
	{

   
	/////////////////////////////////////////////////////////
	if ($request_Command == "Hello")
	/////////////////////////////////////////////////////////
	{
		$responsecode = "Greetings: Database is up, and we are here to serve";
				
		$elementSuccess  = $domobject->createElement("SUCCESS");
		$elementSuccess->setAttribute("action", $request_Command); 
		$elementSuccess->setAttribute("result", $success); 
		$elementSuccess->setAttribute("type",   $db); 
		// Add verbose TEST 
		$elementSuccess->appendChild($domobject->createTextNode($responsecode));
		// Add to the complete list
		$elementHolder->appendChild($elementSuccess);		
		
	}

	/////////////////////////////////////////////////////////
	if ($request_Command == "Sleep")
	/////////////////////////////////////////////////////////
	{
		$seconds      =  GetSQLSafeValues(GetNonEmptyValue($theFile->getAttribute('seconds'), -1));
		$responsecode = "Sleeping for ".$seconds." seconds.";
		//sleep for x seconds
		sleep($seconds);

				
		$elementSuccess  = $domobject->createElement("SUCCESS");
		$elementSuccess->setAttribute("action", $request_Command); 
		$elementSuccess->setAttribute("result", $success); 
		$elementSuccess->setAttribute("type",   $db); 
		// Add verbose TEST 
		$elementSuccess->appendChild($domobject->createTextNode($responsecode));
		// Add to the complete list
		$elementHolder->appendChild($elementSuccess);		
	}

	/////////////////////////////////////////////////////////
	if($request_Command == "Authorize")
	/////////////////////////////////////////////////////////
	{
		//Authorize code added by daniel. 
		//Code added to authorize a user, from a Request xml post. 
		//<REQUEST action="Authorize" client_id="21" app_type_name="TWITYAX" caller_id="6049804457" caller_pass="123456"></REQUEST>
		
		$authClientID = "";
		if($theFile->hasAttribute('client_id'))
		{
			$authClientID =  GetSQLSafeValues($theFile->getAttribute('client_id'));
		}
		
		$authTypeName = "";
		if($theFile->hasAttribute('app_type_name'))
		{
			$authTypeName =  GetSQLSafeValues($theFile->getAttribute('app_type_name')); 
		}
		
		$authCallingNumber = "";
		if($theFile->hasAttribute('caller_id'))
		{
			$authCallingNumber =  GetSQLSafeValues($theFile->getAttribute('caller_id'));
		}
		
		$authCallingPassword = "";
		if($theFile->hasAttribute('caller_pass'))
		{
			$authCallingPassword =  GetSQLSafeValues($theFile->getAttribute('caller_pass')); 
		}

		// Check to see if the caller is authorized, and return back the user id for future lookups etc
		$vUserID = 0;
		$result = $database->ConfirmCaller($authCallingNumber,$authClientID, $authCallingPassword, $vUserID); //checks if the callerid match password in the twityax database. 
		
		if($result == 0)
		{
			$responsecode = "User is Authorized";
			$elementSuccess  = $domobject->createElement("SUCCESS");
			$elementSuccess->setAttribute("action", $request_Command); 
			$elementSuccess->setAttribute("user_id", $vUserID); 
			$elementSuccess->setAttribute("result", $result); 		//pass back the result code (0). 						
			$elementSuccess->appendChild($domobject->createTextNode($responsecode));			
			$elementHolder->appendChild($elementSuccess);
		}
		else
		{
			if($result == -1)//couldnt connect to the database
			{
				$responsecode = "Database Error";
			}
			else if($result == 2)//database indicates that user has not confirmed their account. 
			{
				$responsecode = "Account has not yet been activated";
			}			
			else if($result == 1)
			{
				$responsecode = "Username could not be found";
			}
			else//no other errors, so password did not match. 
			{
				$responsecode = "Invalid Password";
			}
			
			$elementFailure  = $domobject->createElement("FAILURE");
			$elementFailure->setAttribute("action", $request_Command); 
			$elementFailure->setAttribute("result", $result); 
			$elementFailure->setAttribute("callerID",   $authCallingNumber); 
			$elementFailure->setAttribute("callerPassword",   $authCallingPassword);			
			$elementFailure->appendChild($domobject->createTextNode($responsecode));			
			$elementHolder->appendChild($elementFailure);			
		}
    }
	  	  
		  
	// Record a total, and completed a NEW recording which has already occured from another program
	/////////////////////////////////////////////////////////
	if (($request_Command == "MediaFileInsertMediaEntry"))	
	/////////////////////////////////////////////////////////
	{
		// Defaults
		$mUserId		= '';
		$mFileSize		= 0;
		
		// Optional user id
		if ($theFile->hasAttribute('user_id'))
		{
			$mUserId			=  GetSQLSafeValues($theFile->getAttribute('user_id'));
		}	
		
		// Location where the file is located
		$mmedia_folder_name = '';
		if ($theFile->hasAttribute('media_folder_name'))
		{
			$mmedia_folder_name      =  GetSQLSafeValues($theFile->getAttribute('media_folder_name'));
		}	
		
		// Because these XML files can be located just as a file entry, they will have full RECORDING tags
		// - Break them out to continue
		$theRecording = $doc->getElementsByTagName('RECORDING')->item(0);
		
		/////////////////////////////
		// Standard recording components
		/////////////////////////////
		//app_type_name="CALLCAPTURE" 
		//media_file_type="CALL" 
		//ivr_computer_name="URANUS" 
		//ivr_port="5" 
		//call_direction="" 
		//called_number="" 
		//calling_number="" 
		// Is the file name being passed
		$mmedia_file_name = '';
		if ($theRecording->hasAttribute('media_file_name'))
		{
			$mmedia_file_name      =  GetSQLSafeValues($theRecording->getAttribute('media_file_name'));
		}
		// Get optional fields
		$mapp_type_name = '';
		if ($theRecording->hasAttribute('app_type_name'))
		{
			$mapp_type_name =  GetSQLSafeValues($theRecording->getAttribute('app_type_name'));
		}
		// Type of media (FAX, DICTATION, VOICEMESSAGE, TWITYAX)
		$mmedia_file_type = '';
		if ($theRecording->hasAttribute('media_file_type'))
		{
			$mmedia_file_type =  GetSQLSafeValues($theRecording->getAttribute('media_file_type'));
		}
		// Default the host computer name
		// Get this computer name (assuming that this is a local call from a related teleflow app)
		$mivr_computer_name = getHostComputerName();
		if ($theRecording->hasAttribute('ivr_computer_name'))
		{
			$mivr_computer_name =  GetSQLSafeValues($theRecording->getAttribute('ivr_computer_name'));
		}		
		// IVR Port
		$mivr_port = -1;
		if ($theRecording->hasAttribute('ivr_port'))
		{
			$mivr_port =  GetSQLSafeValues($theRecording->getAttribute('ivr_port'));
		}		
		// Call Direction Code
		$mcall_direction = 'UNKNOWN';
		if ($theRecording->hasAttribute('call_direction'))
		{
			$mcall_direction =  GetSQLSafeValues($theRecording->getAttribute('call_direction'));
		}		
		// Called number (number dialed generally by the person calling)
		$mcalled_number = '';
		if ($theRecording->hasAttribute('called_number'))
		{
			$mcalled_number =  GetSQLSafeValues($theRecording->getAttribute('called_number'));
		}
		// Calling number (telephone number of the initiating party)
		$mcalling_number = '';
		if ($theRecording->hasAttribute('calling_number'))
		{
			$mcalling_number =  GetSQLSafeValues($theRecording->getAttribute('calling_number'));
		}
		
		/////////////////////////////
		// Recording duration
		/////////////////////////////
		// file_duration="296" 
		$mfile_duration = '0';
		if ($theRecording->hasAttribute('file_duration'))
		{
			$mfile_duration =  GetSQLSafeValues($theRecording->getAttribute('file_duration'));

			// Test for file size
			// Determine the folder in which the file should be found
			$mMediaFolder = mediaFileFolderLocate(false, $mClient_id, $mmedia_folder_name);
			if (file_exists($mMediaFolder.'/'.$mmedia_file_name)) 
			{
				// We are attempting to mark the file as completed.
				clearstatcache();
				$mFileSize = (filesize($mMediaFolder.'/'.$mmedia_file_name));
			}	
		}		
			
		/////////////////////////////
		// CallCapture specific components
		/////////////////////////////
		// recording_start_trigger="unknown" 
		// recording_stop_trigger="Turned_Off" 
		// recording_protocol="Continuous" 
		// cc_agent_id="0" 
		// cc_extension=""
		$mrecording_start_trigger = '';
		if ($theRecording->hasAttribute('recording_start_trigger'))
		{
			$mrecording_start_trigger =  GetSQLSafeValues($theRecording->getAttribute('recording_start_trigger'));
		}		
		$mrecording_stop_trigger = '';
		if ($theRecording->hasAttribute('recording_stop_trigger'))
		{
			$mrecording_stop_trigger =  GetSQLSafeValues($theRecording->getAttribute('recording_stop_trigger'));
		}		
		$mrecording_protocol = '';
		if ($theRecording->hasAttribute('recording_protocol'))
		{
			$mrecording_protocol =  GetSQLSafeValues($theRecording->getAttribute('recording_protocol'));
		}		
		$mcc_agent_id = '';
		if ($theRecording->hasAttribute('cc_agent_id'))
		{
			$mcc_agent_id =  GetSQLSafeValues($theRecording->getAttribute('cc_agent_id'));
		}		
		$mcc_extension = '';
		if ($theRecording->hasAttribute('cc_extension'))
		{
			$mcc_extension =  GetSQLSafeValues($theRecording->getAttribute('cc_extension'));
		}		

		/////////////////////////////
		// CallCapture specific components
		/////////////////////////////
		//file_create_start_dtm_utc="2009/09/21 22:25:30" 
		//file_create_end_dtm_utc="2009/09/21 22:30:26" 
		//file_create_start_dtm_client="2009/09/21 15:25:30" 
		//file_create_end_dtm_client="2009/09/21 15:30:26" 
		$mfile_create_start_dtm_utc = '';
		if ($theRecording->hasAttribute('file_create_start_dtm_utc'))
		{
			$mfile_create_start_dtm_utc =  GetSQLSafeValues($theRecording->getAttribute('file_create_start_dtm_utc'));
		}		
		$mfile_create_end_dtm_utc = '';
		if ($theRecording->hasAttribute('file_create_end_dtm_utc'))
		{
			$mfile_create_end_dtm_utc =  GetSQLSafeValues($theRecording->getAttribute('file_create_end_dtm_utc'));
		}		
		$mfile_create_start_dtm_client = '';
		if ($theRecording->hasAttribute('file_create_start_dtm_client'))
		{
			$mfile_create_start_dtm_client =  GetSQLSafeValues($theRecording->getAttribute('file_create_start_dtm_client'));
		}		
		$mfile_create_end_dtm_client = '';
		if ($theRecording->hasAttribute('file_create_end_dtm_client'))
		{
			$mfile_create_end_dtm_client =  GetSQLSafeValues($theRecording->getAttribute('file_create_end_dtm_client'));
		}			
	
		// Return the ID and File name  ( (MediaFileInsertMediaEntry ))
		$mMediaFileId = $database->mediaEntryInsert(
				$mClient_id						, 
				$mUserId						,
				'NEW'							,
				// Sub folder from client media (could be a date for example)
				$mmedia_folder_name				,				
				// Standard media information
				$mmedia_file_name      			,
				$mapp_type_name 				, 
				$mmedia_file_type 				, 
				$mivr_computer_name 			, 
				$mivr_port 						, 
				$mcall_direction 				, 
				$mcalled_number 				, 
				$mcalling_number 				, 
				// Optional duration
				$mfile_duration 				, 
				$mFileSize						,
				// Standard CallCapture
				$mrecording_start_trigger 		, 
				$mrecording_stop_trigger 		, 
				$mrecording_protocol 			, 
				$mcc_agent_id 					, 
				$mcc_extension 					, 
				// File create information from other create methods 
				$mfile_create_start_dtm_utc 	, 
				$mfile_create_end_dtm_utc 		, 
				$mfile_create_start_dtm_client 	,
				$mfile_create_end_dtm_client 
				);

		// Was the insert successful?
		if ($mMediaFileId > -1)
		{
			// Respond with the details
			$responsecode = "Inserting ".$mmedia_file_name;
			$elementSuccess  = $domobject->createElement("SUCCESS");
			$elementSuccess->setAttribute("action", $request_Command); 
			$elementSuccess->setAttribute("result", $success); 
			$elementSuccess->setAttribute("type",   $db); 
			$elementSuccess->setAttribute("media_file_id",   	$mMediaFileId); 
			//$elementSuccess->setAttribute("media_file_fullpath",$varMediaFullPath);
			$elementSuccess->setAttribute("media_file_name",	$mmedia_file_name); 
				
			// Add verbose TEST 
			$elementSuccess->appendChild($domobject->createTextNode($responsecode));
			// Add to the complete list
			$elementHolder->appendChild($elementSuccess);
		}
		else
		{
			$elementFailure  = $domobject->createElement("FAILURE");
			$elementFailure->setAttribute("action", $request_Command); 
			$elementFailure->setAttribute("result", $error); 
			$elementFailure->setAttribute("type",   $db); 
			$elementFailure->setAttribute("media_file_name",   strlen($mmedia_file_name));
								
			// Add verbose TEST 
			$elementFailure->appendChild($domobject->createTextNode($responsecode));
			// Add to the complete list
			$elementHolder->appendChild($elementFailure);
		}	
	}  // $request_Command == "MediaFileInsertMediaEntry"
	
	
	
	// Create entries in a database, and prepare for a following command to complete, or abandon the entry
	/////////////////////////////////////////////////////////
	if (($request_Command == "MediaFileCreateNew") ||		// Just create the file location, and return file name
		($request_Command == "MediaFileCreateFileName"))	// Provide the filename that we want to create 
	/////////////////////////////////////////////////////////
	{
		// Defauls
		$mmedia_folder_name = '';
	
		// Optional user id
		$mUserId			= -1;
		if ($theFile->hasAttribute('user_id'))
		{
			$mUserId			=  GetSQLSafeValues($theFile->getAttribute('user_id'));
		}	
		
		// Handle each command slightly differently
		$mmedia_file_name	= '';
		if ($request_Command == "MediaFileCreateFileName")
		{
			// Is the file name being passed
			if ($theFile->hasAttribute('media_file_name'))
			{
				$mmedia_file_name      =  GetSQLSafeValues($theFile->getAttribute('media_file_name'));
			}
		}
		
		
		/////////////////////////////
		// Standard recording components
		/////////////////////////////
		//app_type_name="CALLCAPTURE" 
		//media_file_type="CALL" 
		//ivr_computer_name="URANUS" 
		//ivr_port="5" 
		//call_direction="" 
		//called_number="" 
		//calling_number="" 
		// Is the file name being passed
		$mmedia_file_name = '';
		if ($theFile->hasAttribute('media_file_name'))
		{
			$mmedia_file_name      =  GetSQLSafeValues($theFile->getAttribute('media_file_name'));
		}
		// Get optional fields
		$mapp_type_name = '';
		if ($theFile->hasAttribute('app_type_name'))
		{
			$mapp_type_name =  GetSQLSafeValues($theFile->getAttribute('app_type_name'));
		}
		// Type of media (FAX, DICTATION, VOICEMESSAGE, TWITYAX)
		$mmedia_file_type = '';
		if ($theFile->hasAttribute('media_file_type'))
		{
			$mmedia_file_type =  GetSQLSafeValues($theFile->getAttribute('media_file_type'));
		}
		// Default the host computer name
		// Get this computer name (assuming that this is a local call from a related teleflow app)
		$mivr_computer_name = getHostComputerName();
		if ($theFile->hasAttribute('ivr_computer_name'))
		{
			$mivr_computer_name =  GetSQLSafeValues($theFile->getAttribute('ivr_computer_name'));
		}		
		// IVR Port
		$mivr_port = -1;
		if ($theFile->hasAttribute('ivr_port'))
		{
			$mivr_port =  GetSQLSafeValues($theFile->getAttribute('ivr_port'));
		}		
		// Call Direction Code
		$mcall_direction = 'UNKNOWN';
		if ($theFile->hasAttribute('call_direction'))
		{
			$mcall_direction =  GetSQLSafeValues($theFile->getAttribute('call_direction'));
		}		
		// Called number (number dialed generally by the person calling)
		$mcalled_number = '';
		if ($theFile->hasAttribute('called_number'))
		{
			$mcalled_number =  GetSQLSafeValues($theFile->getAttribute('called_number'));
		}
		// Calling number (telephone number of the initiating party)
		$mcalling_number = '';
		if ($theFile->hasAttribute('calling_number'))
		{
			$mcalling_number =  GetSQLSafeValues($theFile->getAttribute('calling_number'));
		}
		
		

		
		// Check to see if we made the entry 
		$mSuccess = false;
		
		// Create the media path (mediaWorkUnit)
		if ($mmedia_file_name == '')
		{
			// Generate a file name for the application to use
			$mmedia_file_name = mediaFileNameGenerate($mClient_id, 
										$mUserId,
										$mapp_type_name, 
										$mmedia_file_type, 
										teleflowNowTimeStamp(),
										$mivr_port, 
										$mcalled_number, 
										$mcalling_number);
			// What is the folder going to be named
			$mmedia_folder_name = teleflowNowDate(); // Create a subfolder named: yyyy-mm-dd
			
			// Create the directory and file structure to record the file to
			$varMediaFullPath = '';
			if (mediaFileNameCreate($incPath, $mClient_id, $mmedia_folder_name, $mmedia_file_name, $varMediaFullPath))
			{
				// Create the entry in the database
				// Return the ID and File name
				$mMediaFileId = $database->mediaEntryInsert(
						$mClient_id						, 
						$mUserId						,
						'CREATED'						,
						// Sub folder from client media (could be a date for example)
						$mmedia_folder_name				,				
						// Standard media information
						$mmedia_file_name      			,
						$mapp_type_name 				, 
						$mmedia_file_type 				, 
						$mivr_computer_name 			, 
						$mivr_port 						, 
						$mcall_direction 				, 
						$mcalled_number 				, 
						$mcalling_number 				, 
						// Optional duration etc
						'0', // Duration
						0, // File size
						// Standard CallCapture
						'', 
						'', 
						'', 
						'0', // Agent id
						'', 
						// File create information from other create methods 
						'', 
						'', 
						'', 
						''
						);
				
				// Remove if exists
				// Determine the folder in which the file should be found
				$mMediaFolder = mediaFileFolderLocate(false, $mClient_id, $mmedia_folder_name);
				if (file_exists($mMediaFolder.'/'.$mmedia_file_name))
				{
					unlink($mMediaFolder.'/'.$mmedia_file_name);
				}	
				
				$mSuccess = true;
			}
		}
		else
		{
			// File name is passed by the calling program
			// -- The file may, or may not exist
			
			// Lets find the file on disk
			// Determine the folder in which the file should be found
			$mMediaFolder = mediaFileFolderLocate(false, $mClient_id, $mmedia_folder_name);
			if (file_exists($mMediaFolder)) // Must be a complete path with folders / date named sub folders / relative location etc
			{
				// Create the entry in the database
				// Return the ID and File name
				$mMediaFileId = $database->mediaEntryInsert(
						$mClient_id						, 
						$mUserId						,
						'CREATED'						,
						// Sub folder from client media (could be a date for example)
						$mmedia_folder_name				,				
						// Standard media information
						$mmedia_file_name      			,
						$mapp_type_name 				, 
						$mmedia_file_type 				, 
						$mivr_computer_name 			, 
						$mivr_port 						, 
						$mcall_direction 				, 
						$mcalled_number 				, 
						$mcalling_number 				, 
						// Optional duration
						'0', // Duration
						0, // File size
						// Standard CallCapture
						'', 
						'', 
						'', 
						'0', // Agent id
						'', 
						// File create information from other create methods 
						'', 
						'', 
						'', 
						''
						);
						
				$mSuccess = true;
			}		
		} // if $mmedia_file_name == ''
	
		if ($mSuccess)
		{
			// Used by teleflow
			$mMediaRecordingFolder = mediaFileFolderLocate(false, $mClient_id, $mmedia_folder_name);
		
			// Respond with the details
			$responsecode = "Creating ".$mmedia_file_name;
			$elementSuccess  = $domobject->createElement("SUCCESS");
			$elementSuccess->setAttribute("action", $request_Command); 
			$elementSuccess->setAttribute("result", $success); 
			$elementSuccess->setAttribute("type",   $db); 
			$elementSuccess->setAttribute("media_file_id",   	$mMediaFileId); 
			$elementSuccess->setAttribute("media_file_folder",	$mMediaRecordingFolder);
			$elementSuccess->setAttribute("media_file_fullpath",$varMediaFullPath);
			$elementSuccess->setAttribute("media_file_name",	$mmedia_file_name); 
				
			// Add verbose TEST 
			$elementSuccess->appendChild($domobject->createTextNode($responsecode));
			// Add to the complete list
			$elementHolder->appendChild($elementSuccess);
		}
		else
		{
			$elementFailure  = $domobject->createElement("FAILURE");
			$elementFailure->setAttribute("action", $request_Command); 
			$elementFailure->setAttribute("result", $error); 
			$elementFailure->setAttribute("type",   $db); 
			$elementFailure->setAttribute("media_file_name",   strlen($mmedia_file_name));
								
			// Add verbose TEST 
			$elementFailure->appendChild($domobject->createTextNode($responsecode));
			// Add to the complete list
			$elementHolder->appendChild($elementFailure);
		}
	}  // $request_Command == "MediaFileCreateNew"

	
	/////////////////////////////////////////////////////////
	if (($request_Command == "MediaFileComplete") ||
		($request_Command == "MediaFileAbandon"))
	// -- Update an existing media file entry
	/////////////////////////////////////////////////////////
	{
		// Defaults
		$responsecode	= '';
		$mUserId		= -1;
		
		// Optional user id
		if ($theFile->hasAttribute('user_id'))
		{
			$mUserId			=  GetSQLSafeValues($theFile->getAttribute('user_id'));
		}
		
		// Get the media ide
		if ($theFile->hasAttribute('media_file_id'))
		{
			// Mandetory
			$mMediaFileId      =  GetSQLSafeValues($theFile->getAttribute('media_file_id'));
			
			// Get optional fields
			$mDuration = 0;
			if ($theFile->hasAttribute('duration'))
			{
				$mDuration =  GetSQLSafeValues($theFile->getAttribute('duration'));
			}

			// How many hours
			$q = 'SELECT client_utc_offset FROM client_details';
			$result = $database->sqlConvert_sql_query($q, $database->connectionClient);
			$row = $database->sqlConvert_sql_fetch_array($result);
			$mHoursOffset = 0;
			if ($row == TRUE)
			{
				$mHoursOffset = $row['client_utc_offset'];
			}

			// Get the entry
			// - NOTE: Also get the times that need to be updated back into the table
			$q = 
"SELECT
	media_file_directory,
	media_file_name,
	app_type_name,
	media_file_type,
	ivr_computer_name,
	ivr_port,
	file_create_start_dtm_utc,
	file_duration,
	file_size,
	file_app_status,
	file_transfer_status,
	call_direction,
	called_number,
	calling_number,
	".$database->sqlConvert_DateAdd_Seconds($database->sqlConvert_DateFormat_FullTimeStamp_Now(), $mHoursOffset*3600)." file_create_end_dtm_client,
	".$database->sqlConvert_DateFormat_FullTimeStamp_Now()." file_create_end_dtm_utc
FROM  
	media_file
WHERE
	media_file_id = ".$mMediaFileId;
			//echo($q); die;

			$result = $database->sqlConvert_sql_query($q, $database->connectionClient);
			$row = $database->sqlConvert_sql_fetch_array($result);
			if ($row == TRUE)
			{
				// Assemble the file path based on the codes in the media file record
				$mMediaFilename = $row['media_file_name'];

				// Determine the folder in which the file should be found
				$mMediaFolder = mediaFileFolderLocate(false, $mClient_id, $row['media_file_directory']);
				
				// Find the file size, and check for abandoned
				$mFileSize = -1;
				if ($request_Command == "MediaFileAbandon")
				{
					// We are just dropping the file.  It doesnt matter if it exists or not
					$mUpdateCode = 'ABANDONED';
					$mDuration = 0;
					
					// Update the details in Database
					$result = $database->mediaEntryUpdate($mClient_id, 
								$mMediaFileId,
								$mUpdateCode,
								$mUpdateCode,
								$mDuration,
								$mFileSize);
					
					// Remove if exists
					if (file_exists($mMediaFolder.'/'.$mMediaFilename))
					{
						unlink($mMediaFolder.'/'.$mMediaFilename);
					}	
				
					// Respond with the details
					$responsecode = "Updating ".$mMediaFileId." to ".$mUpdateCode;
					$elementSuccess  = $domobject->createElement("SUCCESS");
					$elementSuccess->setAttribute("action", $request_Command); 
					$elementSuccess->setAttribute("duration", $mDuration); 
					$elementSuccess->setAttribute("result", $success); 
					$elementSuccess->setAttribute("type",   $db); 
					$elementSuccess->setAttribute("media_file_id",   	$mMediaFileId); 
						
					// Add verbose TEST 
					$elementSuccess->appendChild($domobject->createTextNode($responsecode));
					// Add to the complete list
					$elementHolder->appendChild($elementSuccess);				
				}
				else // MediaFileComplete
				{
					// Get the current time data
					$mTimeStampEndUTC 		= $row['file_create_end_dtm_utc'];
					$mTimeStampEndClient	= $row['file_create_end_dtm_client'];

					// Does our file exist
					$mFileSize = 0;
					$mFileLocal = 'FALSE';
					if (file_exists($mMediaFolder.'/'.$mMediaFilename)) 
					{
						// We are attempting to mark the file as completed.
						clearstatcache();
						$mFileSize = (filesize($mMediaFolder.'/'.$mMediaFilename));
						$mFileLocal = 'TRUE';
					}
					
					// If we do not have a passed duration, then lets determine it based on the times
					if ($mDuration == 0)
					{
						$mDuration = strtotime($mTimeStampEndUTC) - strtotime($row['file_create_start_dtm_utc']); 
					}
					
					//echo $mDuration;
					$mUpdateCode = 'NEW';
					
					// Update the details in Database
					$result = $database->mediaEntryUpdate($mClient_id, 
								$mMediaFileId,
								$mUpdateCode,
								$mUpdateCode,
								$mDuration,
								$mFileSize);
					
					// Respond with the details
					$responsecode = "Updating ".$mMediaFileId." to ".$mUpdateCode;
					$elementSuccess  = $domobject->createElement("SUCCESS");
					$elementSuccess->setAttribute("action", $request_Command); 
					$elementSuccess->setAttribute("duration", $mDuration); 
					$elementSuccess->setAttribute("file_is_local", $mFileLocal); 
					$elementSuccess->setAttribute("media_file_fullpath",filePathForOS($mMediaFolder.'/'.$mMediaFilename));
					$elementSuccess->setAttribute("media_file_name",	$mMediaFilename); 
					$elementSuccess->setAttribute("result", 			$success); 
					$elementSuccess->setAttribute("type",   			$db); 
					$elementSuccess->setAttribute("media_file_id",   	$mMediaFileId); 
					
					// Add verbose TEST 
					$elementSuccess->appendChild($domobject->createTextNode($responsecode));
					// Add to the complete list
					$elementHolder->appendChild($elementSuccess);
				}
			}
			else
			{
					echo ' -DIE- ';
					die;
			}
		}
		else
		{
			$responsecode = 'Missing Parameters: '.'media_file_id';
		
			// Missing parameters
			$elementFailure  = $domobject->createElement("FAILURE");
			$elementFailure->setAttribute("action", $request_Command); 
			$elementFailure->setAttribute("result", $error); 
			$elementFailure->setAttribute("type",   $db); 
								
			// Add verbose TEST 
			$elementFailure->appendChild($domobject->createTextNode($responsecode));
			// Add to the complete list
			$elementHolder->appendChild($elementFailure);		
		}
	}
	
	
	/////////////////////////////////////////////////////////
	if (($request_Command == "MediaFilesAsNew"))
	// -- List entries that need to be sent up
	/////////////////////////////////////////////////////////
	{
		// Defaults
		$responsecode	= '';
		
		// Type of media (FAX, DICTATION, VOICEMESSAGE, TWITYAX)
		$mmedia_file_type = '';
		if ($theFile->hasAttribute('media_file_type'))
		{
			$mmedia_file_type =  GetSQLSafeValues($theFile->getAttribute('media_file_type'));
		}
		// Default the host computer name
		// Get this computer name (assuming that this is a local call from a related teleflow app)
		$mivr_computer_name = getHostComputerName();
		if ($theFile->hasAttribute('ivr_computer_name'))
		{
			$mivr_computer_name =  GetSQLSafeValues($theFile->getAttribute('ivr_computer_name'));
		}	
		
		// Show 
		//echo $mmedia_file_type ." - ". $mivr_computer_name;
		
		// Get the media list if we have have asked for the file type and computer 
		if (($mmedia_file_type <> '') && ($mivr_computer_name <> ''))
		{
			// Mandetory
			$mMediaFileId      =  GetSQLSafeValues($theFile->getAttribute('media_file_id'));
			
			// How many hours
			$q = 'SELECT client_utc_offset FROM client_details';
			$result = $database->sqlConvert_sql_query($q, $database->connectionClient);
			$row = $database->sqlConvert_sql_fetch_array($result);
			$mHoursOffset = 0;
			if ($row == TRUE)
			{
				$mHoursOffset = $row['client_utc_offset'];
			}

			// Get the entry
			// - NOTE: Also get the times that need to be updated back into the table
			$q = 
"SELECT
	media_file_id,
	media_file_directory,
	media_file_name,
	media_owner_u_id,
	file_reference_id,
	app_type_name,
	media_file_type,
	ivr_computer_name,
	ivr_port,
	file_create_start_dtm_utc,
	file_create_end_dtm_utc,
	file_create_start_dtm_client,
	file_create_end_dtm_client,
	file_duration,
	file_size,
	file_app_status,
	app_status_update_dtm_utc,
	app_status_update_dtm_client,
	file_transfer_status,
	call_direction,
	called_number,
	calling_number,
	".$database->sqlConvert_DateAdd_Seconds($database->sqlConvert_DateFormat_FullTimeStamp_Now(), $mHoursOffset*3600)." file_create_end_dtm_client,
	".$database->sqlConvert_DateFormat_FullTimeStamp_Now()." file_create_end_dtm_utc
FROM  
	media_file
WHERE
	app_type_name		= '".$mmedia_file_type."'
AND ivr_computer_name	= '".$mivr_computer_name."'
AND file_app_status 	= 'NEW'
AND file_transfer_status= 'NEW'";
			//echo($q); die;

			$totalResults = 0;
			$rsMediaList = $database->sqlConvert_sql_query($q, $database->connectionClient);
		
			// Now add each job as an element
			while ($row_rsMenuItems = $database->sqlConvert_sql_fetch_array($rsMediaList))
			{
				$totalResults++;
				
				$single = $row_rsMenuItems;
				$elementResult  = $domobject->createElement("MEDIARESULT", $single['media_file_id']);
				
				// Add the fields from the database
				$elementResult->setAttribute("count",        $totalResults);
			
				$elementResult->setAttribute('media_file_id' 				, $single['media_file_id']);				
				$elementResult->setAttribute('media_file_directory' 		, $single['media_file_directory']);				
				$elementResult->setAttribute('media_file_name' 				, $single['media_file_name']); 				
				$elementResult->setAttribute('media_owner_u_id' 			, $single['media_owner_u_id']); 				
				$elementResult->setAttribute('file_reference_id' 			, $single['file_reference_id']); 				
				$elementResult->setAttribute('app_type_name' 				, $single['app_type_name']); 				
				$elementResult->setAttribute('media_file_type' 				, $single['media_file_type']); 				
				$elementResult->setAttribute('ivr_computer_name' 			, $single['ivr_computer_name']); 				
				$elementResult->setAttribute('ivr_port' 				    , $single['ivr_port']); 				
				$elementResult->setAttribute('file_create_start_dtm_utc' 	, $single['file_create_start_dtm_utc']); 				
				$elementResult->setAttribute('file_create_end_dtm_utc' 		, $single['file_create_end_dtm_utc']); 				
				$elementResult->setAttribute('file_create_start_dtm_client' , $single['file_create_start_dtm_client']); 				
				$elementResult->setAttribute('file_create_end_dtm_client' 	, $single['file_create_end_dtm_client']); 				
				$elementResult->setAttribute('file_duration' 				, $single['file_duration']); 				
				$elementResult->setAttribute('file_size' 				    , $single['file_size']); 				
				$elementResult->setAttribute('file_app_status' 				, $single['file_app_status']); 				
				//$elementResult->setAttribute('file_note' 					, $single['file_note']); 				
				$elementResult->setAttribute('app_status_update_dtm_utc' 	, $single['app_status_update_dtm_utc']); 				
				$elementResult->setAttribute('app_status_update_dtm_client' , $single['app_status_update_dtm_client']);				
				$elementResult->setAttribute('file_transfer_status' 		, $single['file_transfer_status']); 				
				// These two fields were killed off
				//$elementResult->setAttribute('xfer_status_update_dtm_utc' 	, $single['xfer_status_update_dtm_utc']); 				
				//$elementResult->setAttribute('xfer_status_update_dtm_client', $single['xfer_status_update_dtm_client']); 				
				$elementResult->setAttribute('call_direction' 				, $single['call_direction']); 				
				$elementResult->setAttribute('called_number' 				, $single['called_number']); 				
				$elementResult->setAttribute('calling_number' 				, $single['calling_number']); 				
			
				// CallCapture systems only
				//$elementResult->setAttribute('recording_start_trigger' 		, $single['recording_start_trigger']); 				
				//$elementResult->setAttribute('recording_stop_trigger' 		, $single['recording_stop_trigger']); 				
				//$elementResult->setAttribute('recording_protocol' 			, $single['recording_protocol']); 				
				//$elementResult->setAttribute('cc_agent_id' 				    , $single['cc_agent_id']); 				
				//$elementResult->setAttribute('cc_extension' 				, $single['cc_extension']); 				
				//$elementResult->setAttribute('create_dtm_utc' 				, $single['create_dtm_utc']);				
				//$elementResult->setAttribute('update_dtm_utc' 				, $single['update_dtm_utc']); 				
				//$elementResult->setAttribute('create_dtm_client' 			, $single['create_dtm_client']); 				
				//$elementResult->setAttribute('update_dtm_client'			, $single['update_dtm_client']);				
			
				$elementHolder->appendChild($elementResult);					
			}
			
			// Put in the totals
			$elementHolder->setAttribute("total",   $totalResults); 
		}
		else
		{
			$responsecode = 'Missing Parameters: '.'media_file_id';
		
			// Missing parameters
			$elementFailure  = $domobject->createElement("FAILURE");
			$elementFailure->setAttribute("action", $request_Command); 
			$elementFailure->setAttribute("result", $error); 
			$elementFailure->setAttribute("type",   $db); 
								
			// Add verbose TEST 
			$elementFailure->appendChild($domobject->createTextNode($responsecode));
			// Add to the complete list
			$elementHolder->appendChild($elementFailure);		
		}
	}
	
	
	/////////////////////////////////////////////////////////
	if ($request_Command == "MediaFileReceive")  // Media file is recieved by the application
	/////////////////////////////////////////////////////////
	// -- Called from cr_media_file_hostpush.php for example
	{
			//$element = $theFile->documentElement;
			$mContent = '';
			foreach ($theFile->childNodes as $value)
			{
				if ($value->nodeName == 'FileContents')
				{
					//echo $value->nodeName . "  is the name of the node ......whose content value is ...... " .  
					$mContents = $value->nodeValue;
				}
			}

			// Did anything come along?
			if (strlen($mContents) > 0)
			{
				// Save the file to the appropriate place.  Check the client information
				if ($handle = fopen($mLocalFilename, "wb")) // windows MUST have a 'b' for binary
				{
					fwrite($handle, base64_decode($mContents));
					fclose($handle);
				}

				$responsecode = "Saving ".$mName;
				$elementSuccess  = $domobject->createElement("SUCCESS");
				$elementSuccess->setAttribute("action", $request_Command); 
				$elementSuccess->setAttribute("result", $success); 
				$elementSuccess->setAttribute("type",   $db); 
				$elementSuccess->setAttribute("contentsize",	strlen($mContents));
				$elementSuccess->setAttribute("filesize",   	filesize($mLocalFilename));
					
			}
			else
			{
				$responsecode = "Error: File empty";			
				
				$elementFailure  = $domobject->createElement("FAILURE");
				$elementFailure->setAttribute("action", $request_Command); 
				$elementFailure->setAttribute("result", $error); 
				$elementFailure->setAttribute("type",   $db); 
				$elementFailure->setAttribute("contentsize",   strlen($mContents));
			}

	}

	/////////////////////////////////////////////////////////
	if ($request_Command == "MediaFileUploadAndComplete")  // Media file is recieved by the application
	/////////////////////////////////////////////////////////
	// -- Called from cr_media_file_hostpush.php for example
	{
		if (($theFile->hasAttribute('media_file_id')) &&
			($theFile->hasAttribute('media_file_directory')) &&
			($theFile->hasAttribute('media_file_name')) &&
			($theFile->hasAttribute('client_id')) &&
			($theFile->hasAttribute('file_duration')) &&
			($theFile->hasAttribute('file_size')))
		{
			
			$mclient_id 			=  GetSQLSafeValues($theFile->getAttribute('client_id'));
			$mmedia_file_id			=  GetSQLSafeValues($theFile->getAttribute('media_file_id'));
			$mmedia_file_directory	=  GetSQLSafeValues($theFile->getAttribute('media_file_directory'));
			$mmedia_file_name		=  GetSQLSafeValues($theFile->getAttribute('media_file_name'));
			$mfile_duration			=  GetSQLSafeValues($theFile->getAttribute('file_duration'));
			$mfile_size				=  GetSQLSafeValues($theFile->getAttribute('file_size'));
			
			//$element = $theFile->documentElement;
			$mContents = '';
			foreach ($theFile->childNodes as $value)
			{
				if ($value->nodeName == 'FileContents')
				{
					//echo $value->nodeName . "  is the name of the node ......whose content value is ...... " .  
					$mContents = $value->nodeValue;
				}
			}

			// Did anything come along?
			if (strlen($mContents) > 0)
			{
				// Determine the names of the files
				$uploadroot = $incPath.CLIENT_MEDIA_AREA;
				// Does it exist?
				if (!is_dir($uploadroot))
				{
					// Does now
					mkdir($uploadroot);
				}				

				// Location of the client
				$uploadpath = $uploadroot.'/client_'.zeroFill($mclient_id,5); //.'/recordings';
				// Does it exist?
				if (!is_dir($uploadpath))
				{
					// Does now
					mkdir($uploadpath);
				}				
				// Location of the client recordings
				$uploadpath .= '/'.$mmedia_file_directory;
				// Does it exist?
				if (!is_dir($uploadpath))
				{
					// Does now
					mkdir($uploadpath);
				}				

				$mLocalFilename = $uploadpath.'/'.$mmedia_file_name;
				// Remove if exists
				if (file_exists($mLocalFilename))
				{
					unlink($mLocalFilename);
				}
				
				
				// Save the file to the appropriate place.  Check the client information
				$mReceivedFileSize = -1;
				if ($handle = fopen($mLocalFilename, "wb")) // windows MUST have a 'b' for binary
				{
					fwrite($handle, base64_decode($mContents));
					fclose($handle);
					
					// Get the file size
					clearstatcache();
					$mReceivedFileSize = (filesize($mLocalFilename));
				}


				// If we are success fule 
				if ($mfile_size == $mReceivedFileSize)
				{
					// Successful receive, so update the details in Database 
					$result = $database->mediaEntryUpdate($mclient_id, 
								$mmedia_file_id,
								FT_COMPLETED,
								FT_COMPLETED,
								$mfile_duration,
								$mfile_size);

					$responsecode = "Saving ".$mName;
					$elementSuccess  = $domobject->createElement("SUCCESS");
					$elementSuccess->setAttribute("action", 	$request_Command); 
					$elementSuccess->setAttribute("result", 	$success); 
					$elementSuccess->setAttribute("type",   	$db); 
					$elementSuccess->setAttribute("contentsize",strlen($mContents));
					$elementSuccess->setAttribute("filesize",   $mReceivedFileSize);
					// Add to the complete list
					$elementHolder->appendChild($elementSuccess);		
				}
				else
				{
					$responsecode = "Error: File wrong size";			
					
					$elementFailure  = $domobject->createElement("FAILURE");
					$elementFailure->setAttribute("action",		$request_Command); 
					$elementFailure->setAttribute("result",		$error); 
					$elementFailure->setAttribute("type",  		$db); 
					$elementFailure->setAttribute("contentsize",strlen($mContents));
					// Add to the complete list
					$elementHolder->appendChild($elementFailure);		
				}
					
			}
			else
			{
				$responsecode = "Error: File empty";			
				
				$elementFailure  = $domobject->createElement("FAILURE");
				$elementFailure->setAttribute("action", $request_Command); 
				$elementFailure->setAttribute("result", $error); 
				$elementFailure->setAttribute("type",   $db); 
				$elementFailure->setAttribute("contentsize",   strlen($mContents));
				// Add to the complete list
				$elementHolder->appendChild($elementFailure);		
			}
		}
		else
		{
			$responsecode = 'Missing Parameters: '.'media_file_id';
		
			// Missing parameters
			$elementFailure  = $domobject->createElement("FAILURE");
			$elementFailure->setAttribute("action", $request_Command); 
			$elementFailure->setAttribute("result", $error); 
			$elementFailure->setAttribute("type",   $db); 
								
			// Add verbose TEST 
			$elementFailure->appendChild($domobject->createTextNode($responsecode));
			// Add to the complete list
			$elementHolder->appendChild($elementFailure);		
		}

	}

	  
	/////////////////////////////////////////////////////////
	else if ($request_Command == "LogEvent")
	/////////////////////////////////////////////////////////
    {
		$responsecode = "Response";
		$elementHolder->setAttribute("action", $request_Command); 
		
		// If there is missing info, set it up
		$log_date		= GetNonEmptyValue( GetSQLSafeValues($theFile->getAttribute('log_date')), teleflowNowDate());
		$log_time		= GetNonEmptyValue( GetSQLSafeValues($theFile->getAttribute('log_time')), teleflowNowTime());
		$evt_port		= GetNonEmptyValue( GetSQLSafeValues($theFile->getAttribute('evt_port')),		-1);
		$evt_code		= GetNonEmptyValue( GetSQLSafeValues($theFile->getAttribute('evt_code')),		'');
		$call_start 	= GetNonEmptyValue( GetSQLSafeValues($theFile->getAttribute('call_start')),		-1);
		$call_elapse	= GetNonEmptyValue( GetSQLSafeValues($theFile->getAttribute('call_elapse')),	-1);
		$tf_app 		= GetNonEmptyValue( GetSQLSafeValues($theFile->getAttribute('tf_app')),		'');
		$site_code 		= GetNonEmptyValue( GetSQLSafeValues($theFile->getAttribute('site_code')),		'');
		$region_code 	= GetNonEmptyValue( GetSQLSafeValues($theFile->getAttribute('region_code')),	'');
		$evt_type 		= GetNonEmptyValue( GetSQLSafeValues($theFile->getAttribute('evt_type')),		'');
		$evt_data1 		= GetNonEmptyValue( GetSQLSafeValues($theFile->getAttribute('evt_data1')),		'');
		$evt_data2 		= GetNonEmptyValue( GetSQLSafeValues($theFile->getAttribute('evt_data2')),		'');
		$evt_data3 		= GetNonEmptyValue( GetSQLSafeValues($theFile->getAttribute('evt_data3')),		'');
					
		// Log the entry
		$result = $database->logCallEvent(
									$log_date	,
									$log_time	,
									$evt_port	,
									$evt_code	,
									$call_start ,
									$call_elapse,
									$tf_app 	,
									$site_code 	,
									$region_code,
									$evt_type 	,
									$evt_data1 	,
									$evt_data2 	,
									$evt_data3 
								);
		// What happened?
		if ($result == FALSE) 
		{
			$responsecode = "Failed to Insert Record";
			$elementHolder->setAttribute("action", $request_Command); 
			$elementHolder->setAttribute("result", $error); 
			$elementHolder->setAttribute("type",   $db); 
			// Add verbose TEST 
			$elementHolder->appendChild($domobject->createTextNode($responsecode));
			// If debug
			if ($OutPutMode)
			{
				$elementHolder->appendChild($domobject->createElement("DEBUG", $qInsert));			
			}				
		} 
		else
		{
			//  SUCCESSFULLY Inserted log data
			$elementHolder->setAttribute("action", $request_Command); 
			$elementHolder->setAttribute("result", $success); 
			$elementHolder->setAttribute("type",   $db); 
		}
		
    }
	
	} // if database connect
  }
}
else
{
	decho("NO COMMAND Provided<BR>");
	$elementHolder->setAttribute("action", "NotDefined");
	// Final results
	$responsecode = "ERROR: No Command Provided";
	$elementResult  = $domobject->createElement("RESULT", $responsecode);
}

// Put it all together
//$elementHolder->appendChild($elementResult);
$domobject->appendChild($elementHolder);
// Save to Log dir .. if there was a request
if ($request_Command <> "") 
{
    // No saving for this app.  Its not creating new info really
    //$domobject->save($resf);
}
?>