<?php
// Form the data in an email
function BoldWrapIndent($pRow)
{
	return '<br />&nbsp;&nbsp;&nbsp;<b>'.$pRow.'</b><br /><br />';
}

function Telephone_Exchange_Lookup(
				$pRemoteNumber,   // Phone number to perform lookup for (the number being called)
				$pLocalAreaList,  // Comma-delimited list of area codes local to the equipment making the phone call.
				$pFromNumber)     // Caller ID of the system making the phone call                                
{
	global $database;  //The database connection
	
	// Assume we are dialing a local number. Only update this if we determine otherwise.
	$DialingArea = "UNDETERMINED";

	if ($pRemoteNumber[0] == 1)
	{
		$pRemoteNumber = substr($pRemoteNumber,1,20);
	};

	// Ensure the phone number string we are working with has numeric characters ONLY.
	$RemoteNumber_NoFormatting = ereg_replace("[^0-9]", "", $pRemoteNumber);
	
	$FromAreaCode = substr($pFromNumber,0,3);
	$FromExchange = substr($pFromNumber,3,3);  
	$ToAreaCode   = substr($RemoteNumber_NoFormatting,0,3);
	$ToExchange   = substr($RemoteNumber_NoFormatting,3,3);

	$pos = strpos($pLocalAreaList,$ToAreaCode);
	if ($pos === false)
	{	
		// The number is long distance
		$DialingArea = "LD";
	}
	else //  The number could still be local.
	{    
		// Attempt to get the information from the local lookup table
		$LocalLookupQuery = 
"SELECT
	area_exchange_id,
	local_yn AS CURRENT_LOCAL_SETTING,
	area_exchange_status
FROM
	area_exchange
WHERE
	server_area_code = " . $FromAreaCode . " 
AND server_exchange  = " . $FromExchange . " 
AND remote_area_code = " . $ToAreaCode . " 
AND remote_exchange  = " . $ToExchange . ";";

		// NOTE: This TABLE is in the SYSTEM level
		$LocalLookupQueryResult = mysql_query($LocalLookupQuery, $database->connectionSystem);
		$LocalLookupQueryRow = mysql_fetch_array($LocalLookupQueryResult);
   
		$AreaExchangeID = $LocalLookupQueryRow['area_exchange_id'];
		$LocalYN = $LocalLookupQueryRow['CURRENT_LOCAL_SETTING'];
		$AreaExchangeStatus = $LocalLookupQueryRow['area_exchange_status'];
   
		if (($AreaExchangeStatus == "GOOD" || $AreaExchangeStatus == "MANUAL"))
		{
			if ($LocalYN == "Y") 
			{
				$DialingArea = "LOCAL";
			}
			else
			{
				$DialingArea = "LD";         
			};
		}
		else    
		{
			// Get an XML package from localcalling guide.com. 
			// Provided the remote area code & exchange and the calling number's area code & exchange, the site returns an XML package with a variety of calling info, including a local dialing flag.
			$LocalDialingWebLookup = "http://www.localcallingguide.com/xmlrcdist.php?npa1=" . 
										$FromAreaCode . "&nxx1=" . $FromExchange . "&npa2=" .
										$ToAreaCode . "&nxx2=" . $ToExchange;
             
			// fopen is much easier to use to simply grab a web page, but you can't set socket timeouts with it with safe mode enabled.
			// You CAN change the default socket timeout to ensure a any socket operations have a more limited time.       
			// I have verified this works, by toggling the time to 0 or 1 seconds. 0 we get no handle, 1+ we get a handle. 
			// The subsequent code works fine regardless of whether we get a handle or not.
			$HoldSocketTimeout = ini_get("default_socket_timeout");
			ini_set("default_socket_timeout",3);
			$handle = @fopen($LocalDialingWebLookup, "rb");
			$contents = '';
			if ($handle <> "")
			{
				while (!feof($handle)) 
				{  
					$contents .= fread($handle, 8192);
				}
				fclose($handle);
			};
			ini_set("default_socket_timeout", $HoldSocketTimeout);
    
			// Load XML packet into local arrays for processing. 
			$XMLParser = xml_parser_create();
			xml_parse_into_struct($XMLParser, $contents, $vals, $index);
			xml_parser_free($XMLParser);
/*   
   echo "<pre>";
   echo "Index array\n";
   print_r($index);
   echo "\nVals array\n";
   print_r($vals);
   echo $vals[45]["tag"];
   root->rcdist->islocal
   echo "</pre>";    
*/      
			// Find the correct index for the ISLOCAL node of the XML packet, then use his to determine the node's value.
			$IsLocalIndex = $index["ISLOCAL"][0];
			if ($vals[$IsLocalIndex]["value"] == "Y")
			{
				$DialingArea = "LOCAL";
			}   
			elseif ($vals[$IsLocalIndex]["value"] == "N")
			{
				$DialingArea = "LD";         
			}
			else
			{
				// Check our last resort: The number can't be determined LD just by area code; the number isn't in the database as GOOD or MANUAL
				// The local calling guide is either unavailable or didn't return a proper result for the lookup we need. 
				// It's time to check if we have a number in the table that will do...
				if ($AreaExchangeStatus == "UNKNOWN")
				{
					if ($LocalYN == "Y")
					{
					$DialingArea = "LOCAL";
					}
					else
					{
						$DialingArea = "LD";
					}
				}
				else
				{
					// None of the ways we normally use to get the LOCAL/LD setting have worked. Since the area code COULD be local, assume it is.
					$DialingArea = "LOCAL";
				};
			};
		};
    
		// INSERT/UPDATE the area code info we have collected in the database.
		if ($DialingArea == "LOCAL")
		{
			$Local_DialingYN = "Y";
		}
		else
		{     
			$Local_DialingYN = "N";      
		};
      
		$StoreAreaExchangeQuery = "";
		if ($AreaExchangeID == "") 
		{
			$StoreAreaExchangeQuery = 
"INSERT INTO area_exchange
(
	server_area_code,
	server_exchange,
	remote_area_code,
	remote_exchange,
	local_yn,
	area_exchange_status
)
VALUES
(
	".$FromAreaCode.",
	".$FromExchange.",
	".$ToAreaCode.",
	".$ToExchange.",
	'".$Local_DialingYN."',
	'UNKNOWN'
)";                
		}
		else
		{
			// Update only if the local dialing flag in the DB differs from what was determined this time.     
			if ($Local_DialingYN != $LocalYN)
			{
				// We update only the local_yn flag, and only if the status is UNKNOWN already.          
				$StoreAreaExchangeQuery = 
"UPDATE 
	area_exchange
SET
	local_yn = '".$Local_DialingYN."'
WHERE
	area_exchange_id = ".$AreaExchangeID." 
AND area_exchange_status = 'UNKNOWN'";      
			};
		};
		// Remember: 
		// GOOD status always updates
		// UNKNOWN status can be overwritten by GOOD or MANUAL
		if ($StoreAreaExchangeQuery != "")
		{
			$result = mysql_query($StoreAreaExchangeQuery);
		};
	}
   
	// @@@ Temporary: These should come from the database...
	$pre_long = "1";
	$pre_local = "";
   
	if ($DialingArea == "LOCAL")
	{
		$pRemoteNumber = $pre_local . $pRemoteNumber;
	}
	else
	{
		$pRemoteNumber = $pre_long . $pRemoteNumber;
	}
	return $pRemoteNumber;   
}; // Telephone_Exchange_Lookup


// Constants
$cSysName   = 'xml_recordingpublish';


// Determine how much output we should see
$OutPutMode   = FALSE;
if(isset($_GET['DEBUG']))
{
	$OutPutMode   = TRUE;
}


////////////////// FUNCTIONS //////////////////
function decho($pText)
{ 
   //if (!IsSet($OutPutMode))
   //{
   //  echo "CANT SEE YOU!!<BR>";
   //}
   //if ($OutPutMode == TRUE)
   { 
      //echo ($pText);
   }
}  
?>