<?php
/**
 * cr_useredit.php
 *
 * This page is for users to edit their account information
 * such as their password, email address, etc. Their
 * usernames can not be edited. When changing their
 * password, they must first confirm their current password.
 *
 * Written by: Jpmaster77 a.k.a. The Grandmaster of C++ (GMC)
 * Extended by: vbaker@engenic.com
 * Last Updated: Jan 19, 2009
 */

// Determine relative location for paths
require("cr_reference.php");
require_once($incPath.'LocalSettings.php'); 
require($incPath."include/session.php");
require_once($websiteLibrary.'calcWorkUnit.php'); 

/**
 * User not logged in, redirect to main page
 * automatically.
 */
if(!$session->checkLogin())
{
	header("Location: cr_main.php");
}
else
{

/* Requested Username error checking */
if (isset($_GET['user']))
{
	$req_user = trim($_GET['user']);
}
else
{
	// Current user
	$req_user = $session->username; 
}

if(!$req_user || strlen($req_user) == 0 ||
   !eregi("^([0-9a-z@._])+$", $req_user) ||
   !$database->usernameTaken($req_user))
{
   die("Username not registered");
}

// Include all the standard JavaScript files
include($_SESSION['IncPath']."include/header.php"); 
// JavaScript goes here + + +
?>
<script type="text/javascript"> 
function testOkayToSubmit()
{
	$mOkay=true;
	
	// See if anything exists
	if ( $('#newpass').length ) 
	{
	
	// Show the details, and make sure the password is at least 5 chars long
	if (PassWordStrength($("#newpass").val(), 5) == 0)
	{
		$mOkay=false;	
	}
	
	if (!PassMatchTest($("#newpass").val(), $("#newpass2").val()))
	{
		$mOkay=false;
	}
	
	//////////////////////////////////////
	// Override
	// - This system will ignor password changes if the fields are blank
	if (($("#newpass").val() == '') && ($("#newpass2").val() == ''))
	{
		$mOkay=true;
	}
	
	// Add further tests here!!!  (( Following the blank test ))
	
	if (!$mOkay)
	{
		// We are good to go
		$("#updatebutton").removeAttr("disabled", "false").attr("disabled", "true");
	}
	else
	{
		$("#updatebutton").removeAttr("disabled", "false");
	}
	
	}
}

//  Set up jQuery - Now is a good timeto see if it will fly / load up the libraries
$(document).ready(function()
{
	////////////////////////////////////////////////////////
	// Set up the environment - runs once
	////////////////////////////////////////////////////////
	$(function()
	{
		if ( $('#telephone').length ) 
		{
			$("#telephone").mask("(999) 999-9999");
			$("#pass").mask("9?9999999");

			// Make sure there is something to test
			if ($("#newpass").val() !== "")
			{
				PassWordStrength($("#newpass").val(), 1);
				PassMatchTest($("#newpass").val(), $("#newpass2").val());
			}	   
		}
	});

	// Cancel buttons
	$("#cancel").click(function()
	{	
		window.location = "cr_main.php"
	});

	// Do password checking
	$("#newpass").keyup(function()
	{
		testOkayToSubmit();
	});
	
	$("#newpass2").keyup(function()
	{
		testOkayToSubmit();
	});
	
	
	// JavaScript standard components
	<?php include('cr_javascript_graphics.php'); ?>
})
</script>
<?php
include($_SESSION['IncPath']."include/header_divs.php"); 
?>
<?php
/* Display requested user information */
$req_user_info   = $database->getUserInfo($req_user);
$req_client_info = $database->getClientInfo($_SESSION['userclientid']);

$mSameUser = false;
/* Logged in user viewing own account */
if ((isset($session->username)) &&
	(isset($req_user)) &&
	(strcmp($session->username,$req_user) != 0))  // If not the same
{
   $mTitle = "Account Management";
}
/* Visitor not viewing own account */
else
{
   $mTitle  = "Edit User Account";
   $mSameUser = true;

}

?>
<div id="topbar">
  <a class="active">
  <span>
    <div id="bartitle"><?php echo($mTitle);?>    
    </div>
  </span>
  </a>
</div>

<div id="frontpage" >
<div id="maintext">

<TABLE cellPadding=5 border=0>
<TBODY>
<?php
/**
 * User has submitted form without errors and user's
 * account has been edited successfully.
 */
if ((isset($_SESSION['useredit'])) ||
	(isset($_SESSION['usereditadmin'])))
{
	unset($_SESSION['useredit']);   
?> 
<table cellpadding="5" border="0">
<tbody>
<tr>
  <td>
<?php	
	// Indicate success
	echo(displayContainerOutline('<h1>User Account Edit Success!</h1>'));
?>  
  </td>
</tr> 

<?php


// Have we just done an admin update
if (isset($_SESSION['usereditadmin']))
{
	unset($_SESSION['usereditadmin']);
?>
<tr>
  <td>
	<p><b>User account has been successfully updated.</p>
  </td>
</tr> 
<?php
}
else
{
?>
<tr>
  <td>
	<p><?php echo($req_user_info['u_first']);?>, your user account <b><?php echo($session->username); ?></b> has been successfully updated.</p>
  </td>
</tr> 
<?php
}
?>
<tr>
  <td>
	<p>Return to the <a href="cr_main.php"><u>Client Access</u></a> page.</p>
   </td>
</tr> 

</tbody>
</table>

<?php
}
else
{
/**
 * If user is not logged in, then do not display anything.
 * If user is logged in, then display the form to edit
 * account information, with the current email address
 * already in the field.
 */
if($session->logged_in)
{
?>
<TR>
  <TD>
<?php 
	if ($mSameUser)
	{
		echo(displayContainerOutline('<h1>'.$session->username.'</h1>'));
	}
	else
	{
		echo(displayContainerOutline('<h1>User Administration</h1>'));
	}
?>
  </TD>
</TR>   


<?php
/* Display requested user information */
$req_user_info = $database->getUserInfo($req_user);
echo "<TR><TD>";
// Put the information about the user in a box
echo(displayContainerHeader(1, 'User Details'));
echo "<TR><TD>";

echo "<TABLE align=center cellSpacing=0 cellPadding=1 width=540 border=0>";
/* Name */
echo "<TR><TD width=110><span class=\"style5\">Name</TD>";
echo "<TD><span class=\"style5\"><b>".$req_user_info['u_full_name']."</b></TD></TR>";
/* Company */
echo "<TR><TD><span class=\"style5\">Company</TD>";
echo "<TD><span class=\"style5\">".displayCompanyNameTitle(1,$_SESSION['userclientname'])."</TD></TR>";
echo "<TR><TD><span class=\"style5\">&nbsp;</TD>";
// Put one more row in to make it look nice
echo "<TR><TD><TD><TD width=20></TD>";
// End
echo "</TABLE>";

echo "</TD></TR>";
echo(displayContainerFooter());

echo "<br />";
echo "</TD></TR>";




if($form->num_errors > 0)
{
   echo "<font size=\"2\" color=\"#ff0000\">".$form->num_errors." error(s) found</font></td>";
}
?>
<TR><TD>
<form action="cr_process.php" method="POST">
<table align="left" border="0" cellspacing="0" cellpadding="3">


<?php
// Only display the Current password if we are not administering another user
if ((!$mSameUser) &&
	($session->userlevel == ADMIN_LEVEL))
{
	// Do not show the current password field for a user
}
else
// Administrator for the current user?
{
?>
<tr>
	<td><span class="style5">Current Password</span></td>
	<td><input type="password" name="curpass" id="curpass" maxlength="30" value="
	<?php echo $form->value("curpass"); ?>">	
	</td>
	<td><?php echo $form->error("curpass"); ?></td>
</tr>
<?php
}
?>

<tr>
	<td><span class="style5">New Password</span></td>
	<td><input type="password" name="newpass" id="newpass" maxlength="30" value="
	<?php echo $form->value("newpass"); ?>">
	<span id="password_strength"></span>
	</td>
	<td><?php echo $form->error("newpass"); ?></td>
</tr>

<tr>
	<td><span class="style5">New Again</span></td>
	<td><input type="password" name="newpass2" id="newpass2" maxlength="30" value="
	<?php echo $form->value("newpass"); ?>">
	<span id="password_match"></span>
	</td>
	<td><?php echo $form->error("newpass"); ?></td>
</tr>

<?php
// Only display the Current password if we are not administering another user
if ((!$mSameUser) &&
	($session->userlevel == ADMIN_LEVEL))
{
// Admin edit
?>
<tr>
<td><span class="style5">&nbsp;</td>
<td colspan="2"><span class="important">Note:</span> Leave this blank if you do not want to change the user's password</td>
</tr>
<?php
}
else
// Regular edit
{
?>
<tr>
<td><span class="style5">&nbsp;</td>
<td colspan="2"><span class="important">Note:</span> Leave these blank if you do not want to change your password</td>
</tr>
<?php
}
?>

<tr>
<td colspan="3">&nbsp;</td>
</tr>

<tr>
<td colspan="3"><hr /></td>
</tr>

<tr>
<td colspan="3">&nbsp;</td>
</tr>

<tr>
<td><span class="style5">Email Address</td>
<td><span class="style5"><input type="text" name="email" maxlength="50" size="30" value="
<?php
if($form->value("email") == "")
{
   //echo $session->userinfo['u_email'];
   echo ($req_user_info['u_email']);
}
else
{
   echo $form->value("email");
}
?>">
</td>
<td><span class="style5"><?php echo $form->error("email"); ?></td>
</tr>




<tr>
<td><span class="style5">&nbsp;</td>
<td colspan="2">
<?php
if ($mSameUser)
{
?>
<span class="important">Note:</span> This will only change where we email you, and not your username</td>
<?php
}
else
{
?>
<span class="important">Note:</span> This will only change where we email the user, and not their username</td>
<?php
}
?>
</tr>


<tr>
<td colspan="3">&nbsp;</td>
</tr>

<tr>
<td><span class="style5">Telephone Number</td>
<td><span class="style5"><input type="text" name="telephone" id="telephone" maxlength="14" size="20" value="
<?php
if($form->value("telephone") == "")
{
	//echo telephoneFormatClassic($session->userinfo['u_telephone']);
	echo telephoneFormatClassic($req_user_info['u_telephone']);
}
else
{
	echo telephoneFormatClassic($form->value("telephone"));
}
?>">
</td>
<td><span class="style5"><?php echo $form->error("telephone"); ?></td>
</tr>




<tr>
<td><span class="style5">Pass Number</td>
<td><span class="style5"><input type="text" name="pass" id="pass" maxlength="8" value="
<?php
if($form->value("pass") == "")
{
	//echo $session->userinfo['user_phone_pass'];
	echo ($req_user_info['user_phone_pass']);
}
else
{
	echo $form->value("pass");
}
?>">
</td>
<td><span class="style5"><?php echo $form->error("pass"); ?></td>
</tr>

<tr>
<td></td>
<td><p>Optional: This is your touch tone password for use with your <?php echo(VEXT_CODE);?>.</p></td>
</tr>

<tr>
<td colspan="2" align="right"><span class="style5">
<?php
// See if we are editing another user?
if ((!$mSameUser) &&
	($session->userlevel == ADMIN_LEVEL))
{
	// Admin for another user
?>
	<input type="hidden" name="subeditadminuser" value="1">
	<input type="hidden" type="text" name="user" id="user" value="<?php echo($req_user);?>">
<?php
}
else
{
	// Admin self
?>
	<input type="hidden" name="subedit" value="1">
<?php
}
?>
<input type="submit" name="updatebutton" id="updatebutton" value="Update" >&nbsp;&nbsp;
<input type="button" name="cancel" id="cancel" value="Cancel">
</td>
</tr>

<tr><td colspan="2" align="left"></td></tr>
<tr><td></td></tr>

</table>
</form>
</TD></TR>

<?php
}
}
}
?>
</TBODY>
</TABLE>


<!-- Footer standard -->
</div> <!-- maintext -->
</div> <!-- frontpage -->
<?php 
include($_SESSION['IncPath']."include/footer.php");
?>