<?php
/**
 * cr_userinfo.php
 *
 * This page is for users to view their account information
 * with a link added for them to edit the information.
 *
 * Vern Baker
 * Last Updated: March 6, 2007
*/

// Determine relative location for paths
require("cr_reference.php");
require_once($incPath.'LocalSettings.php'); 
require($incPath."include/session.php");
$_SESSION['IncPath'] = $incPath;
require_once($websiteLibrary.'calcWorkUnit.php'); 

/**
 * User not logged in, redirect to main page
 * automatically.
 */
if(!$session->checkLogin())
{
   header("Location: cr_main.php");
}
else
{

/* Requested Username error checking */
$req_user = trim($_GET['user']);
if(!$req_user || strlen($req_user) == 0 ||
   !eregi("^([0-9a-z@._])+$", $req_user) ||
   !$database->usernameTaken($req_user))
{
   die("Username not registered");
}


include($_SESSION['IncPath']."include/header.php"); 
// JavaScript goes here + + +
?>
<script type="text/javascript"> 
//  Set up jQuery - Now is a good timeto see if it will fly / load up the libraries
$(document).ready(function()
{
	<?php include('cr_javascript_graphics.php'); ?>

	// Cancel buttons
	$("#cancel").click(function()
	{	
		window.location = "cr_main.php"
	}); 

	// Cancel buttons
	$("#edit").click(function()
	{	
		window.location = "cr_useredit.php?user=<?php echo($req_user);?>"
	});
})
</script>
<?php
include($_SESSION['IncPath']."include/header_divs.php"); 
?>
<?php
/* Display requested user information */
$req_user_info   = $database->getUserInfo($req_user);
$req_client_info = $database->getClientInfo($_SESSION['userclientid']);

$mSameUser = false;
/* Logged in user viewing own account */
if ((isset($session->username)) &&
	(isset($req_user)) &&
	(strcmp($session->username,$req_user) != 0))  // If not the same
{
   $mTitle = "Account Information";
}
/* Visitor not viewing own account */
else
{
   $mTitle  = "User Information";
   $mSameUser = true;

}

?>
<div id="topbar">
  <a class="active">
  <span>
    <div id="bartitle"><?php echo($mTitle);?>    
    </div>
  </span>
  </a>
</div>

<?php 
}
?>
<div id="frontpage" >
<div id="maintext">

<table cellpadding="5" border="0">
<tbody>
<tr>
  <td>
<?php 
	if ($mSameUser)
	{
		echo(displayContainerOutline('<h1>'.$session->username.'</h1>'));
	}
	else
	{
		echo(displayContainerOutline('<h1>Administration View</h1>'));	
	}
?>
  </td>
</tr> 

<tr>
  <td>
<?php
	echo(displayContainerHeader(1, 'User Details'));
?>
<tr>
  <td>

<TABLE align=center cellSpacing=0 cellPadding=1 width=500 border=0>
<?php /* Username */ ?>
<TR>
	<TD width=120><span class=\"style5\">Username</span></TD>
	<TD><span class=\"style5\"><b><?php echo($req_user_info['user_login_name']); ?></b></span></TD>
</TR>
<?php /* Name */ ?>
<TR>
	<TD><span class=\"style5\">Name</span></TD>
	<TD><span class=\"style5\"><b><?php echo($req_user_info['u_full_name']); ?></b></span></TD>
</TR>
<?php /* Company */ ?>
<TR>
	<TD><span class=\"style5\">Company</span></TD>
	<TD><span class=\"style5\"><?php echo(displayCompanyNameTitle(1,$_SESSION['userclientname'])); ?></span></TD>
</TR>
<TR>
	<TD><span class=\"style5\">&nbsp;</span></TD>
</TR>
<?php /* Email */ ?>
<TR>
	<TD><span class=\"style5\">Email</span></TD>
	<TD><span class=\"style5\"><b><?php echo($req_user_info['u_email']); ?></b></span></TD>
</TR>
<TR>
	<TD><span class=\"style5\">&nbsp;</span></TD><TD></TD>
</TR>
<?php /* Telephone */ ?>
<TR>
	<TD><span class=\"style5\">Telephone</span></TD>
	<TD><span class=\"style5\"><b><?php echo(telephoneFormatClassic($req_user_info['u_telephone'])); ?></b></span></TD>
</TR>
<?php /* Passnum */ ?>
<TR>
	<TD><span class=\"style5\">Pass Number</span></TD>
	<TD><span class=\"style5\"><b><?php echo($req_user_info['user_phone_pass']); ?></b></span></TD>
</TR>
<?php // Put one more row in to make it look nice ?>
<TR>
	<TD></TD>
	<TD></TD>
</TR>

<?php
/* If logged in user viewing own account, give link to edit */
if(strcmp($session->username,$req_user) == 0)
{

}
// End
?>
</TABLE>
  </td>
</tr> 

<?php

	echo(displayContainerFooter());
?>
  </td>
</tr> 


<tr>
	<td>
		<input class="myButton" type="submit" value="Edit"   name="edit" id="edit">&nbsp;&nbsp;		
		<input class="myButton" type="button" value="Cancel" name="cancel" id="cancel">
	</td>
</tr>

<tr>
	<td>&nbsp;
	</td>
</tr>

</tbody>
</table>
<?php

/**
 * Note: when you add your own fields to the users table
 * to hold more information, like homepage, location, etc.
 * they can be easily accessed by the user info array.
 *
 * $session->user_info['location']; (for logged in users)
 *
 * ..and for this page,
 *
 * $req_user_info['location']; (for any user)
*/

?>
<!-- Footer standard -->
</div> <!-- maintext -->
</div> <!-- frontpage -->
<?php 
include($_SESSION['IncPath']."include/footer.php");
?>