<?php
function validate($xml)
{
    libxml_use_internal_errors(true);

    $doc = new DOMDocument('1.0', 'utf-8');
    $doc->loadXML($xml);

    $errors = libxml_get_errors();
    if (empty($errors))
    {
        return true;
    }

    $error = $errors[0];
    if ($error->level < 3)
    {
        return true;
    }

    return true;
} // validate



// Assume an XML document, and process...
$doc = new DOMDocument();

/*
<twityax action=GetuserVoiceMessages most_recent=10 user="userid" target_user="other_user" password="pass">
</twityax
*/

// Create the Result XML document
$domobject = new DOMDocument('1.0', 'utf-8');
// Wrap the request
$elementHolder  = $domobject->createElement("Response", "");
 //$request_Command); 
// Default 

$error   = 'ERROR';
$success = 'SUCCESS';
// Types --
$db      = 'DB';
$cmd     = 'CMD';

$request_Command = '';
// Did the user actually send a request?
$fatalFailure = 0; 

if ($data <> '')
{

	if(!validate($data))
	{		
		$responsecode = "Invalid XML";	
		$elementFailure  = $domobject->createElement("FAILURE");	
		$elementFailure->appendChild($domobject->createTextNode($responsecode));			
		$elementHolder->appendChild($elementFailure);	
		
		$request_Command = "";
		$fatalFailure = 1; 
	}	
	else
	{	
		$doc->loadXML($data);
		// XML Command request
		// -- Find out what the command is (Must be a REQUEST)
		$theFile = $doc->getElementsByTagName('twityax')->item(0);

		if ($theFile->hasAttribute('action'))
		{
			$request_Command  = $theFile->getAttribute('action');
			$db_selected  = $database->selectClientDatabaseByMasterClientId("21");
			// "username" only needs to be send if testing is being done... other wise its a session variable
		}
	}
}

// Review the requested Command
if ($request_Command <> "") 
{  
	/////////////////////////////////////////////////////////
	if ($request_Command == "Hello")
	/////////////////////////////////////////////////////////
	{
		$responsecode = "Greetings: Database is up, and we are here to serve";
		$elementHolder->setAttribute("action", "$request_Command");		
		$elementSuccess  = $domobject->createElement("SUCCESS");
		$elementSuccess->setAttribute("action", $request_Command); 
		$elementSuccess->setAttribute("result", $success); 
		$elementSuccess->setAttribute("type",   $db); 
		// Add verbose TEST 
		$elementSuccess->appendChild($domobject->createTextNode($responsecode));
		// Add to the complete list
		$elementHolder->appendChild($elementSuccess);
	}
	
	
	/*
	<twityax 
		action="StarStarAvailable" 
		starstar="846">
	</twityax>
	*/
	/////////////////////////////////////////////////////////
	if ($request_Command == "StarStarAvailable")
	/////////////////////////////////////////////////////////
	{
		// Return the action
		$elementHolder->setAttribute("action", "$request_Command");		
				
		if ($theFile->hasAttribute('starstar'))
		{
			$starStarCode = mysql_real_escape_string($theFile->getAttribute('starstar'));

			// Check to see if is in user
			if ($database->extlocalInUse($starStarCode))
			{
				$responsecode = "StarStar Code ".$starStarCode." is NOT available";								
				$elementHolder->setAttribute("result", "FAILURE");		
				$elementFailure  = $domobject->createElement("FAILURE");			
				$elementFailure->setAttribute("action", $request_Command); 					
				$elementFailure->appendChild($domobject->createTextNode($responsecode));			
				$elementHolder->appendChild($elementFailure);					
			}
			else
			{
				$responsecode = "StarStar Code ".$starStarCode." is available";					
				$elementHolder->setAttribute("result", "SUCCESS");		
				$elementSuccess  = $domobject->createElement("SUCCESS");
				$elementSuccess->setAttribute("action", $request_Command); 
				$elementSuccess->setAttribute("result", $success); 
				$elementSuccess->setAttribute("type",   $db); 
				// Add verbose TEST 
				$elementSuccess->appendChild($domobject->createTextNode($responsecode));
				// Add to the complete list
				$elementHolder->appendChild($elementSuccess);
			}
		}
	}
		
	
	
	
	
	/*
	-Notes
	+sample Request:
	<twityax 
		action="GetUserVoiceMessages" 
		most_recent="1" 
		page="1"
		username="dhaimanot@engenic.com" 		
		password="mysamplepassword" 
		target_user="dhaimanot@engenic.com">
	</twityax>
	
	- action: specifies the api call to be made (required). 
	- most_recent: specifies the number of most recent voice messages to retrieve from the server. Default and max value is 5000, to retrieve more voiceMessages use the page attribute to specifiy a page. (optional)
	- page: specifies the page of entries to be retrieved from the server. The number of entries per page is determined by the most_recent attribute.By default each page holds 5000 voiceMessages and page=1.(optional)
		for example when most_recent=10 and page = 1, the 10 most recent entries are returned. 
		If page=2 the next 10 voice messages would be returned. 
	-username: specifies your twityax username (required)
	-password: specifies your twityax password (required)
	-target_user specifies the user you would like to retrieve the voice messages from. Must be an existing twityax member (required)
	
	+sample Response:
	<Response action="GetUserVoiceMessages">
		<SUCCESS action="GetUserVoiceMessages" result="SUCCESS">		
			<VOICEMESSAGE date="2009-08-26 13:01:35" id="0">
				http://twityax.com/player.php?file=cr_client_media%2Fclient_00021%2F2009-08-26%2FTWITYAX_21_RECORDING_39_20090826130126_001_NA_6046396391.mp3
			</VOICEMESSAGE>
			...etc
		</SUCCESS>
	</Response>
	*/
	/////////////////////////////////////////////////////////
	if ($request_Command == "GetUserVoiceMessages")
	/////////////////////////////////////////////////////////
	{
		$elementHolder->setAttribute("action", "$request_Command");	
		
		if ($theFile->getAttribute('username') <> "")
		{
			$twityaxUsername = $theFile->getAttribute('username');
			$twityaxUsername = mysql_real_escape_string($twityaxUsername); 
			
			if($theFile->getAttribute('password') <> "")
			{	
				$twityaxPassword = $theFile->getAttribute('password'); 
				//@@@check database for user Details. 
				$userDetailsQuery = "
SELECT
	user_login_name,
	u_password
FROM
	user_details
WHERE
	user_login_name = '$twityaxUsername'";
										
				$result = mysql_query($userDetailsQuery) or die(mysql_error());
				$row = mysql_fetch_array($result);
			
				$authorize = 0; 
				
				if ($row == TRUE)
				{
					$userPassword = $row['u_password'];
										
					if($userPassword != md5($twityaxPassword))
					{
						$responsecode = "Could not authorize user";								
						$elementFailure  = $domobject->createElement("FAILURE");			
						$elementFailure->setAttribute("action", $request_Command); 					
						$elementFailure->appendChild($domobject->createTextNode($responsecode));			
						$elementHolder->appendChild($elementFailure);		
						$authorize = 0; 
					}
					else
					{
						$authorize = 1;
					}
				}	
				else
				{
					$responsecode = "Could not authorize user";								
					$elementFailure  = $domobject->createElement("FAILURE");			
					$elementFailure->setAttribute("action", $request_Command); 					
					$elementFailure->appendChild($domobject->createTextNode($responsecode));			
					$elementHolder->appendChild($elementFailure);		
					$authorize = 0; 
				}
																
			}
		}
		
		if($theFile->hasAttribute('target_user') && $authorize == 1)
		{ 	
			$failure = 0;
			
			$targetUser = $theFile->getAttribute('target_user');				
			
			$targetUser = mysql_real_escape_string($targetUser); 
			
			$userDetailsQuery = "
SELECT
	u_id									
FROM
	user_details
WHERE
	user_login_name='$targetUser'";
			
			$result = mysql_query($userDetailsQuery) or die(mysql_error());
			$row = mysql_fetch_array($result);
			
			if ($row == TRUE)
			{
				$targetUserID = $row['u_id'];
			}
			else
			{
				$failure = 1; 
			}			
					
			if($theFile->hasAttribute('most_recent'))
			{
				$mostRecent = (int) $theFile->getAttribute('most_recent');
				$mostRecent < 1 || $mostRecent > 5000 ? $mostRecent = 5000 : null;
			}		
			else
			{
				$mostRecent = 5000; //@@@ create a paging option. 
			}	
			
			$page = 0;
			if($theFile->hasAttribute('page'))
			{
				$page = (int) $theFile->getAttribute('page');
			}
			
			$page <= 1 ? $page = 0 : $page = ($mostRecent*$page) - $mostRecent; 
						
			//for date SELECT some_id FROM datatable WHERE concat(date,' ',time) >= '2007-01-01 05:00:00';
			if(!$db_selected || $failure == 1)
			{
				$responsecode = "Could not find target user.";			
		
				$elementSuccess  = $domobject->createElement("FAILURE");
				$elementSuccess->setAttribute("action", $request_Command); 
				$elementSuccess->setAttribute("result", $error); 			
				// Add verbose TEST 
				$elementSuccess->appendChild($domobject->createTextNode($responsecode));
				// Add to the complete list
				$elementHolder->appendChild($elementSuccess);
			}
			else
			{
				$mostRecent = mysql_real_escape_string($mostRecent); 
				$page = mysql_real_escape_string($page); 
				
				$voiceMessagesQuery = "
SELECT
	media_file_name,
	app_status_update_dtm_client,	
	media_file_directory
FROM
	media_file
WHERE
	media_owner_u_id='$targetUserID' 
AND
	file_transfer_status='COMPLETED'
ORDER BY 
	app_status_update_dtm_client DESC
LIMIT 	
	$page, $mostRecent";				

				$Info = mysql_query($voiceMessagesQuery, $database->connectionClient) or die(mysql_error());
						
				$elementSuccess  = $domobject->createElement("SUCCESS");
				$elementSuccess->setAttribute("action", $request_Command); 
				$elementSuccess->setAttribute("result", $success); 
				
				$voiceNumber = 0; 
				
				while ($rowResult = mysql_fetch_assoc($Info))
				{						
					$filepath = CLIENT_MEDIA_AREA."/client_".zeroFill(21,5)."/" . $rowResult['media_file_directory'] . "/" 
					. str_replace('.wav','.mp3',$rowResult['media_file_name']);
					$filepath = rawurlencode($filepath); 
					
					$element = $domobject->createElement('VOICEMESSAGE', "http://twityax.com/player.php?file=$filepath");
					$element->setAttribute("date","". $rowResult['app_status_update_dtm_client']); 
					$element->setAttribute("id","".$voiceNumber); 
		
					$elementSuccess->appendChild($element); 	
					$voiceNumber++;
				}
				
				$elementHolder->appendChild($elementSuccess);	
			}			
		}		
		else if($authorize != 0)
		{
			$responsecode = " Missing target_user=";			
		
			$elementSuccess  = $domobject->createElement("FAILURE");
			$elementSuccess->setAttribute("action", $request_Command); 
			$elementSuccess->setAttribute("result", $error); 			
			// Add verbose TEST 
			$elementSuccess->appendChild($domobject->createTextNode($responsecode));
			// Add to the complete list
			$elementHolder->appendChild($elementSuccess);
		}		
				
		/*
		<success action="GetVoiceMessages" result="SUCCESS">
			<voicemessage id="1"  date="09/11/02">htttp://twityax.com/1dasf321</voicemessage>
			<voicemessage id="2" date="09/11/02">htttp://twityax.com/1dasf321</voicemessage>
			<voicemessage id="3"  date="09/11/02">htttp://twityax.com/1dasf321</voicemessage>
		</success>
		*/	
	}//GetUserVoiceMessages..
	
	
	
	
	
	
	
/* Example:
<twityax 
action="GetVoiceMessages"
date="2009-08-29 01:22:58">
</twityax>
*/
	//Note have to pass in date as the following format "2009-08-28 23:03:47";
	if ($request_Command == "GetVoiceMessages")
	/////////////////////////////////////////////////////////
	{
		$elementHolder->setAttribute("action", "$request_Command");	
		$error = 0;
		//$date = "2009-08-28 23:03:47";
		
		if($theFile->hasAttribute('date'))
		{ 							
			$date = $theFile->getAttribute('date');				
						
			$voiceMessagesQuery = "
SELECT
	media_file_name,
	app_status_update_dtm_utc,	
	media_file_directory
FROM
	media_file
WHERE
	app_status_update_dtm_utc >= '$date' 
AND
	file_transfer_status='COMPLETED'
ORDER BY 
	app_status_update_dtm_client DESC
";
				
			$Info = mysql_query($voiceMessagesQuery, $database->connectionClient) or $error = 1;
						
			$elementSuccess  = $domobject->createElement("SUCCESS");
			$elementSuccess->setAttribute("action", $request_Command); 
			$elementSuccess->setAttribute("result", $success); 
			
			$voiceNumber = 0; 
			
			while ($rowResult = mysql_fetch_assoc($Info))
			{						
				$filepath = CLIENT_MEDIA_AREA."/client_".zeroFill(21,5)."/" . $rowResult['media_file_directory'] . "/" 
				. str_replace('.wav','.mp3',$rowResult['media_file_name']); //@@@Get Rid of the str_replace. 
				$filepath = rawurlencode($filepath); 
				
				$element = $domobject->createElement('VOICEMESSAGE', "http://twityax.com/player.php?file=$filepath");
				//$element->setAttribute("date","". $rowResult['app_status_update_dtm_client']); 
				$element->setAttribute("id","".$voiceNumber); 
	
				$elementSuccess->appendChild($element); 	
				$voiceNumber++;
			}
			
			$elementHolder->appendChild($elementSuccess);				
				
		}	
		else 
		{
			$responsecode = "date parameter";			
		
			$elementSuccess  = $domobject->createElement("FAILURE");
			$elementSuccess->setAttribute("action", $request_Command); 
			$elementSuccess->setAttribute("result", $error); 			
			// Add verbose TEST 
			$elementSuccess->appendChild($domobject->createTextNode($responsecode));
			// Add to the complete list
			$elementHolder->appendChild($elementSuccess);
		}
	} //GetVoiceMessages..	
	/*
	<success action="GetVoiceMessages" result="SUCCESS">
		<voicemessage id="1"  date="09/11/02">htttp://twityax.com/1dasf321</voicemessage>
		<voicemessage id="2" date="09/11/02">htttp://twityax.com/1dasf321</voicemessage>
		<voicemessage id="3"  date="09/11/02">htttp://twityax.com/1dasf321</voicemessage>
	</success>
	*/	
		
}
else
{
	if($fatalFailure != 1)
	{
		$responsecode = "ERROR: No Command Provided";
		
		$elementFailure  = $domobject->createElement("FAILURE");
		$elementFailure->setAttribute("action", "NotDefined");
		$elementFailure->setAttribute("result", $error);
		// Final results
		$elementFailure->appendChild($domobject->createTextNode($responsecode));
		$elementHolder->appendChild($elementFailure);
	}
}

// Put it all together
//$elementHolder->appendChild($elementResult);
$domobject->appendChild($elementHolder);
// Save to Log dir .. if there was a request
if ($request_Command <> "") 
{
    // No saving for this app.  Its not creating new info really
    //$domobject->save($resf);
}

?>
