<?php
// Responses provided by the PHP program
$responsecode = "";


// Date and Time defaults
$teleflowDate = Date("Y/m/d");
$teleflowTime = Date("H:i:s");
     // yyyy/mm/dd ==> mm/dd/yyyy
$webDate      = Date("m/d/Y");


//echo("<BR><BR>".$data."<BR><BR>"); die;
decho("STARTED at ".teleflowNowDate()." ".teleflowNowTime()." (".$webDate.")<BR>");

// Set up file names
$stmp        = date("Y-m-d_H-i-s");
$fold        = "log/";
// Create the log folder
if (!is_dir($fold))
{
    mkdir($fold);
}
$reqf  = $fold.$cSysName."_".$stmp."_request.xml";
$resf  = $fold.$cSysName."_".$stmp."_response.xml";


// Assume an XML document, and process...
$doc = new DOMDocument();

// Get the session user name.  Note: will be "Guest" (GUEST_NAME) if no one has signed on
$request_UserName = $_SESSION['username'];


$request_Command = '';
// Did the user actually send a request?
if ($data <> '')
{
	$doc->loadXML($data);
	// save it for later review
	//$doc->save($reqf);

	// XML Command request
	// -- Find out what the command is (Must be a REQUEST)
	$theFile = $doc->getElementsByTagName('REQUEST')->item(0);

	if ($theFile->hasAttribute('action'))
	{
		$request_Command = GetSQLSafeValues($theFile->getAttribute('action'));
		// "username" only needs to be send if testing is being done... other wise its a session variable
		if (GetSQLSafeValues($theFile->getAttribute('username') <> ""))
		{
			$request_UserName = GetSQLSafeValues($theFile->getAttribute('username'));
		}

		// Get the client_id
		$mClient_id = GetSQLSafeValues($theFile->getAttribute('client_id'));
	}
}

// Create the Result XML document
$domobject = new DOMDocument('1.0', 'utf-8');

// Wrap the request
$elementHolder  = $domobject->createElement("RESPONSE", "");
$elementHolder->setAttribute("action", "Invalid"); 
// Default 

$error   = 'ERROR';
$success = 'SUCCESS';
// Types --
$db		= 'DB';
$cmd 	= 'CMD';
$read	= 'READ';

// Review the requested Command
if ($request_Command <> "") 
{
	// See if we can select the database 
	// - Try first with the client ID, and then go to the username for in session usages
	if ($mClient_id <> '')
	{
		$db_selected2  = $database->selectClientDatabaseByMasterClientId($mClient_id);
	}
	else
	{
		// Try by a user name
		$db_selected2  = $database->selectClientDatabaseByUsername($request_UserName);
	}
	
	// Success
	if (!$db_selected2)
	{
		$responsecode = "Failed to Connect to Database for ".$request_UserName;
		$elementHolder->setAttribute("action", $request_Command); 
		$elementHolder->setAttribute("result", $error); 
		$elementHolder->setAttribute("type",   $db); 
		// Add verbose TEST 
		$elementHolder->appendChild($domobject->createTextNode($responsecode));
	}
	else
	{
	   
		/////////////////////////////////////////////////////////
		if ($request_Command == "Hello")
		/////////////////////////////////////////////////////////
		{
			$responsecode = "Hi back: Database is up. We are here to serve";
					
			$elementSuccess  = $domobject->createElement("SUCCESS");
			$elementSuccess->setAttribute("action", $request_Command); 
			$elementSuccess->setAttribute("result", $success); 
			$elementSuccess->setAttribute("type",   $read); 
			// Add verbose TEST 
			$elementSuccess->appendChild($domobject->createTextNode($responsecode));
			// Add to the complete list
			$elementHolder->appendChild($elementSuccess);		
		
		}

		/////////////////////////////////////////////////////////
		else if ($request_Command == "Sleep")
		/////////////////////////////////////////////////////////
		{
			$seconds      = GetSQLSafeValues(GetNonEmptyValue($theFile->getAttribute('seconds'), -1));
			$responsecode = "Sleeping for ".$seconds." seconds.";
			//sleep for x seconds
			sleep($seconds);

					
			$elementSuccess  = $domobject->createElement("SUCCESS");
			$elementSuccess->setAttribute("action", $request_Command); 
			$elementSuccess->setAttribute("result", $success); 
			$elementSuccess->setAttribute("type",   $read); 
			// Add verbose TEST 
			$elementSuccess->appendChild($domobject->createTextNode($responsecode));
			// Add to the complete list
			$elementHolder->appendChild($elementSuccess);		

		}
		  

		/////////////////////////////////////////////////////////
		else if ($request_Command == "DiskSpace")
		/////////////////////////////////////////////////////////
		{
			$di      = GetSQLSafeValues(GetNonEmptyValue($theFile->getAttribute('drive'), -1));

			if(($theFile->hasAttribute('drive'))
			)
			{
				$request_drive		= GetSQLSafeValues($theFile->getAttribute('drive'));	

				$free = 0;
				$total = 0;
				if (getDiskSpaceImage($request_drive.":",0,'',$free,$total))
				{
					$elementSuccess  = $domobject->createElement("SUCCESS");
					// Add verbose TEST 
					
					$elementSuccess->setAttribute("units",	'GB'); 
					$elementSuccess->setAttribute("disksize", $total); 
					$elementSuccess->setAttribute("diskfree", $free); 
					
					$elementSuccess->appendChild($domobject->createTextNode($responsecode));
					// Add to the complete list
					$elementHolder->setAttribute("action", $request_Command); 
					$elementHolder->setAttribute("result", $success); 
					$elementHolder->setAttribute("type",   $read); 
					$elementHolder->appendChild($elementSuccess);					
				}
				else
				{
					$responsecode = "Failed to determine diskspace";
					$elementHolder->setAttribute("action", $request_Command); 
					$elementHolder->setAttribute("result", $error); 
					$elementHolder->setAttribute("type",   $read); 
					// Add verbose TEST 
					$elementHolder->appendChild($domobject->createTextNode($responsecode));
				}
			}
			else
			{
				// Missing parameters
				$responsecode = "Mandetory parameters are missing";
				$elementHolder->setAttribute("action", $request_Command); 
				$elementHolder->setAttribute("result", $error); 
				$elementHolder->setAttribute("type",   $read); 
				// Add verbose TEST 
				$elementHolder->appendChild($domobject->createTextNode($responsecode));		
			}		
			
		}

				  
		/////////////////////////////////////////////////////////
		else if ($request_Command == "LogEvent")
		/////////////////////////////////////////////////////////
		{
			$responsecode = "Response";
			$elementHolder->setAttribute("action", $request_Command); 

			// If there is missing info, set it up
			$log_date      = GetSQLSafeValues(GetNonEmptyValue($theFile->getAttribute('log_date'), teleflowNowDate()));
			$log_time      = GetSQLSafeValues(GetNonEmptyValue($theFile->getAttribute('log_time'), teleflowNowTime()));
			$evt_port      = GetSQLSafeValues(GetNonEmptyValue($theFile->getAttribute('evt_port'), -1));
			$log_version   = '400';
			// evt_code here
			$call_start    = GetSQLSafeValues(GetNonEmptyValue($theFile->getAttribute('call_start'),  -1));
			$call_elapse   = GetSQLSafeValues(GetNonEmptyValue($theFile->getAttribute('call_elapse'), -1));
			
			// Log the entry
			$qInsert = "			
INSERT INTO ".TABLE_EVENTLOG."
	(evt_date,
	evt_time,
	evt_port,
	log_format_version,
	evt_code,
	evt_start,
	call_duration,
	logging_app,
	site_code,
	region_code,
	evt_type,
	evt_data1,
	evt_data2,
	evt_data3,
	evt_timestamp
	)
VALUES
	('".$log_date."',
	 '".$log_time."',
	  ".$evt_port.",
	 '".$log_version."',
	 '".GetSQLSafeValues($theFile->getAttribute('evt_code'))."',
	  ".$call_start .",
	  ".$call_elapse.",
	 '".GetSQLSafeValues($theFile->getAttribute('tf_app'))."',
	 '".GetSQLSafeValues($theFile->getAttribute('site_code'))."',
	 '".GetSQLSafeValues($theFile->getAttribute('region_code'))."',
	 '".GetSQLSafeValues($theFile->getAttribute('evt_type'))."',
	 '".GetSQLSafeValues($theFile->getAttribute('evt_data1'))."',
	 '".GetSQLSafeValues($theFile->getAttribute('evt_data2'))."',
	 '".GetSQLSafeValues($theFile->getAttribute('evt_data3'))."',
	 ".time()."	 
	)";

			$result = mysql_query($qInsert);
			//echo($qInsert);
			
			// What happened?
			if ($result == FALSE) 
			{
				$responsecode = "Failed to Insert Record";
				$elementHolder->setAttribute("action", $request_Command); 
				$elementHolder->setAttribute("result", $error); 
				$elementHolder->setAttribute("type",   $db); 
				// Add verbose TEST 
				$elementHolder->appendChild($domobject->createTextNode($responsecode));
				// If debug
				if ($OutPutMode)
				{
					$elementHolder->appendChild($domobject->createElement("DEBUG", $qInsert));			
				}				
			} 
			else
			{
				//  SUCCESSFULLY Inserted log data
				$elementHolder->setAttribute("action", $request_Command); 
				$elementHolder->setAttribute("result", $success); 
				$elementHolder->setAttribute("type",   $db); 
			}
		}

		/////////////////////////////////////////////////////////
		else if ($request_Command == "GetTestLoginEvent")
		/////////////////////////////////////////////////////////
		// NOTE: Returns a SINGLE entry
		{	
			$responsecode = "Response";
			$elementHolder->setAttribute("action", $request_Command); 

			// Get the most recent event timestamp
			$q = "
SELECT 
	*  
FROM
	".TABLE_EVENTLOG." 
WHERE 
	evt_code = 'LOGIN' 
and evt_timestamp > (UNIX_TIMESTAMP() - 15*60)
ORDER BY evt_timestamp DESC";
			//echo($q);

			$result = mysql_query($q);
			$row=mysql_fetch_array($result);
			if ($row == TRUE)
			{
				$single = $row;

				// Have the data, now respond
				$elementHolder->setAttribute("action", $request_Command); 
				$elementHolder->setAttribute("result", $success); 
				$elementHolder->setAttribute("type",   $db); 
				
				// Add the fields from the database 
				// Singular information only
				
				
				$elementEmployee  = $domobject->createElement("OCCURANCE");
				$elementEmployee->setAttribute("timestamp",    $single['evt_timestamp']);
				$elementEmployee->setAttribute("occurred",     Date("F j, Y, g:i a", $single['evt_timestamp']));
				// Add verbose TEST 
				$elementEmployee->appendChild($domobject->createTextNode($responsecode));
				// Add to the complete list
				$elementHolder->appendChild($elementEmployee);		
				
			}
			else
			{
				$responsecode = "ERROR - No occurance within last 15 minutes";
				$elementHolder->setAttribute("action", $request_Command); 
				$elementHolder->setAttribute("result", $error); 
				$elementHolder->setAttribute("type",   $db); 
				// Add verbose TEST 
				$elementHolder->appendChild($domobject->createTextNode($responsecode));
			}
		}


		/////////////////////////////////////////////////////////
		else if ($request_Command == "GetLocationCodes")
		/////////////////////////////////////////////////////////
		// NOTE: Returns a SINGLE entry
		{	
			$responsecode = "Response";
			$elementHolder->setAttribute("action", $request_Command); 

			// Get the most recent event timestamp
			$query_rsMediaList = "
SELECT 
	cc_server_name, 
	cc_server_desc  
FROM
	cc_server_config";
			//echo($q);

			$rsMediaList = $database->sqlConvert_sql_query($query_rsMediaList, $database->connectionSystem); // or die(mysql_error());
			$totalSetSize = $database->sqlConvert_sql_numrows($rsMediaList);
			$totalResults = 0;
			
			if ($totalSetSize > 0)
			{
				// Have the data, now respond
				$elementHolder->setAttribute("action", $request_Command); 
				$elementHolder->setAttribute("result", $success); 
				$elementHolder->setAttribute("type",   $db); 

				// Now add each code as an element
				while ($row_rsMenuItems = $database->sqlConvert_sql_fetch_array($rsMediaList))
				{
					$single = $row_rsMenuItems;
					$elementResult  = $domobject->createElement("LOCATIONRESULT", $single['cc_server_name']);
									
					// Add the fields from the database
					$totalResults++;
					$elementResult->setAttribute("count",        $totalResults);
				
					$elementResult->setAttribute('cc_server_name' 		, $single['cc_server_name']);				
					$elementResult->setAttribute('cc_server_desc' 		, $single['cc_server_desc']);	

					// Add it to the result
					$elementHolder->appendChild($elementResult);					
					
				}
			}
			else
			{
				$responsecode = "Media File results not Found";
				$elementHolder->setAttribute("action",		$request_Command); 
				$elementHolder->setAttribute("result",		$error); 
				$elementHolder->setAttribute("type",		$db); 
				$elementHolder->setAttribute("page_last",	0); 
				$elementHolder->setAttribute("maxrows",		$totalLimit); 
				// Add verbose TEST 
				$elementHolder->appendChild($domobject->createTextNode($responsecode));
			}
		}


		/////////////////////////////////////////////////////////
		else if ($request_Command == "CountMediaFilesOlderThanDate")
		/////////////////////////////////////////////////////////
		// NOTE: Returns a SINGLE entry
		{	
			$responsecode = "Response";
			$elementHolder->setAttribute("action", $request_Command); 

			// Ensure we have the minimum requirements
			if($theFile->hasAttribute('client_id')) 
			{
				if ($theFile->hasAttribute('date_min'	)) 	{$rep_date_min	= GetSQLSafeValues($theFile->getAttribute('date_min'));}
				if ($theFile->hasAttribute('server'		)) 	{$rep_server	= GetSQLSafeValues($theFile->getAttribute('server'));}

				$mLimit = "AND ".$database->sqlConvert_DateFormat_Date('file_create_start_dtm_client')." <= '".$rep_date_min."'\n\r";

				// Get the most recent event timestamp
				$query_rsMediaList = "
SELECT 
	count(*) total
FROM
	media_file
WHERE
	file_app_status <> 'PURGED'
AND	ivr_computer_name = '".$rep_server."'".
$mLimit;
			//echo($q);

				$rsMediaList = $database->sqlConvert_sql_query($query_rsMediaList, $database->connectionClient); // or die(mysql_error());

				// Have the data, now respond
				$elementHolder->setAttribute("action", $request_Command); 
				$elementHolder->setAttribute("result", $success); 
				$elementHolder->setAttribute("type",   $db); 

				// Now add each code as an element
				if ($row_rsSelectItems = $database->sqlConvert_sql_fetch_array($rsMediaList))
				{
					$single = $row_rsSelectItems;
					$elementResult  = $domobject->createElement("TOTALRESULT", $single['total']);

					// Add the fields from the database
					$elementResult->setAttribute("total",        $single['total']);
				
					// Add it to the result
					$elementHolder->appendChild($elementResult);
				}
			}
			else
			{
				$responsecode = "Media File results not Found";
				$elementHolder->setAttribute("action",		$request_Command); 
				$elementHolder->setAttribute("result",		$error); 
				$elementHolder->setAttribute("type",		$db); 
				$elementHolder->setAttribute("total",		'0'); 
				// Add verbose TEST 
				$elementHolder->appendChild($domobject->createTextNode($responsecode));
			}
		}


		/////////////////////////////////////////////////////////
		else if ($request_Command == "PurgeMediaFilesOlderThanDate")
		/////////////////////////////////////////////////////////
		// NOTE: Returns a SINGLE entry
		{	
			$responsecode = "Response";
			$elementHolder->setAttribute("action", $request_Command); 

			// Ensure we have the minimum requirements
			if($theFile->hasAttribute('client_id')) 
			{
				if ($theFile->hasAttribute('date_min'	)) 	{$rep_date_min	= GetSQLSafeValues($theFile->getAttribute('date_min'));}
				if ($theFile->hasAttribute('server'		)) 	{$rep_server	= GetSQLSafeValues($theFile->getAttribute('server'));}

				$mLimit = "AND ".$database->sqlConvert_DateFormat_Date('file_create_start_dtm_client')." <= '".$rep_date_min."'\n\r";

				// Get the most recent event timestamp
				$query_rsMediaList = "
SELECT 
	media_file_id, 
	media_file_directory, 
	media_file_name, 
	media_owner_u_id, 
	app_type_name,
	media_file_type,
	ivr_computer_name,
	ivr_port,
	file_create_start_dtm_utc,
	file_duration,
	file_size,
	file_app_status,
	file_transfer_status,
	call_direction,
	called_number,
	calling_number
FROM
	media_file
WHERE
	file_app_status <> 'PURGED'
AND	ivr_computer_name = '".$rep_server."'".
$mLimit;
			//echo($query_rsMediaList);

				$rsMediaList = $database->sqlConvert_sql_query($query_rsMediaList, $database->connectionClient); // or die(mysql_error());

				// Have the data, now respond
				$elementHolder->setAttribute("action", $request_Command); 
				$elementHolder->setAttribute("result", $success); 
				$elementHolder->setAttribute("type",   $db); 

				// Now burn through each media entry and purge it
				$mPurgeTotal = 0;
				while ($row_rsSelectItems = $database->sqlConvert_sql_fetch_array($rsMediaList))
				{
					$single = $row_rsSelectItems;
					$mPurgeTotal++;
					
					// We are just dropping the file.  It doesnt matter if it exists or not
					$mUpdateCode	= 'PURGED';
					$mMediaFileId	= $single['media_file_id'];
					$mDuration		= $single['file_duration'];
					$mFileSize		= $single['file_size'];

					// Find the file name on the remote computer
					$file =  		$single['media_file_name']; 		
					$mCompName =	$rep_server; 				
					
					// Get the create date from the name
					$mParts = explode('_',trim($file));
					
					// Get the count
					$mCount = 0;
					foreach ($mParts as $mEachOne)
					{
						$mCount++;		
					}
					
					// Do we have a file with the number of parts in it?
					//      0        1               2                        3            4
					// eg: MSG_2009-12-01_1259698004.310_URANUS_3.GSM.NEW.XML
					if ($mCount > 1)
					{
						// Get date folder for file
						$mDateFolder = $mParts[1];
						// Get the recording
						// eg: MSG_2009-12-01_1259698004.310_URANUS_3.GSM
						// Get the extentions
						$mExtensionParts = explode('.',$mParts[4]);
						$mExtAdd = $mExtensionParts[0].'.'.$mExtensionParts[1];
						$mWavRecording = $mParts[0].'_'.$mParts[1].'_'.$mParts[2].'_'.$mParts[3].'_'.
										$mExtAdd;
					
						//////////////////////////////
						// REMOTE
						//////////////////////////////
						// NOTE: $mRemoteMappedDrive comes from LocalSettings_MediaManager.php
						$mRemotePath = $mRemoteMappedDrive.$mCompName."\\".$mDateFolder."\\";
						//$mRemotePath = "\\\\ANTARES\\3rdParty\\".$mCompName."\\".$mDateFolder."\\";
						
						if (file_exists($mRemotePath."\\".$mWavRecording))
						{
							// Delete the file here;
							unlink($mRemotePath."\\".$mWavRecording);
						}
						
					}

					// Update the media file details in Database
					$result = $database->mediaEntryUpdate($mClient_id, 
								$mMediaFileId,
								$mUpdateCode,
								$mUpdateCode,
								$mDuration,
								$mFileSize);
				}
				
				// Put in the total purge
				$elementHolder->setAttribute("total",		$mPurgeTotal); 
				
			}
			else
			{
				$responsecode = "Media File results not Found";
				$elementHolder->setAttribute("action",		$request_Command); 
				$elementHolder->setAttribute("result",		$error); 
				$elementHolder->setAttribute("type",		$db); 
				$elementHolder->setAttribute("total",		'0'); 
				// Add verbose TEST 
				$elementHolder->appendChild($domobject->createTextNode($responsecode));
			}
		}



		/////////////////////////////////////////////////////////
		else if ($request_Command == "ListMediaFilesForSearch")
		/////////////////////////////////////////////////////////
		{
			$responsecode = "Response";
			$elementHolder->setAttribute("action", $request_Command); 

			// See if mandetory data exists
			// - Name (both first and last) or telephone
			if($theFile->hasAttribute('client_id')) 
			{
				$request_Client_Id  	= GetSQLSafeValues($theFile->getAttribute('client_id'));

				// Reporting parameters
				$mClassHeader			= '';
				$rep_page_lines			= 30;
				$rep_page_number		= 1;
				$rep_include_table		= 'NO'; // Return a table for quick report generation - HTML ROWS only 
												// NO, CALLCAPTURE, 
				// Load up values from request
				if ($theFile->hasAttribute('page_lines'	)) 	{$rep_page_lines	= GetSQLSafeValues($theFile->getAttribute('page_lines'));}
				if ($theFile->hasAttribute('page_number')) 	{$rep_page_number	= GetSQLSafeValues($theFile->getAttribute('page_number'));}
				if ($theFile->hasAttribute('include_table')){$rep_include_table	= GetSQLSafeValues($theFile->getAttribute('include_table'));}
				

				// Search parameters
				$req_Date_Min			= '0000-00-00';
				$req_Date_Max			= '9999-99-99';
				$req_Time_Min			= '00:00:00';
				$req_Time_Max			= '23:59:59';
				$req_Caller_Id			= '';
				$req_Called_Id			= '';
				$req_Extension			= '';
				$req_Port_Range			= '';
				$req_In_Notes			= '';
				$req_Duration_Compare	= '';
				$req_Duration_Amount	= '';
				$req_Duration_Units		= '';
				$req_Server				= '';
				$req_Direction			= '';
				$req_Days_All			= '';
				$req_Day_Mon			= '';
				$req_Day_Tue			= '';
				$req_Day_Wed 			= '';
				$req_Day_Thu 			= '';
				$req_Day_Fri 			= '';
				$req_Day_Sat 			= '';
				$req_Day_Sun 			= '';
				// Load up values from request
				if ($theFile->hasAttribute('date_min'			)) {$req_Date_Min			= GetSQLSafeValues($theFile->getAttribute('date_min'));	}
				if ($theFile->hasAttribute('date_max'			)) {$req_Date_Max			= GetSQLSafeValues($theFile->getAttribute('date_max'));	}
				if ($theFile->hasAttribute('time_min'			)) {$req_Time_Min			= GetSQLSafeValues($theFile->getAttribute('time_min'));	}
				if ($theFile->hasAttribute('time_max'			)) {$req_Time_Max			= GetSQLSafeValues($theFile->getAttribute('time_max'));	}
				if ($theFile->hasAttribute('caller_id'			)) {$req_Caller_Id			= GetSQLSafeValues($theFile->getAttribute('caller_id'));	}
				if ($theFile->hasAttribute('called_id'			)) {$req_Called_Id			= GetSQLSafeValues($theFile->getAttribute('called_id'));	}
				if ($theFile->hasAttribute('extension'			)) {$req_Extension			= GetSQLSafeValues($theFile->getAttribute('extension'));	}
				if ($theFile->hasAttribute('port_range'			)) {$req_Port_Range			= GetSQLSafeValues($theFile->getAttribute('port_range'));	}
				if ($theFile->hasAttribute('in_notes'			)) {$req_In_Notes			= GetSQLSafeValues($theFile->getAttribute('in_notes'));		}
				if ($theFile->hasAttribute('duration_compare'	)) {$req_Duration_Compare	= GetSQLSafeValues($theFile->getAttribute('duration_compare'));	}
				if ($theFile->hasAttribute('duration_amount'	)) {$req_Duration_Amount	= GetSQLSafeValues($theFile->getAttribute('duration_amount'));	}
				if ($theFile->hasAttribute('duration_units'		)) {$req_Duration_Units		= GetSQLSafeValues($theFile->getAttribute('duration_units'));	}
				if ($theFile->hasAttribute('server'				)) {$req_Server				= GetSQLSafeValues($theFile->getAttribute('server'));	}
				if ($theFile->hasAttribute('direction'			)) {$req_Direction			= GetSQLSafeValues($theFile->getAttribute('direction'));		}
				if ($theFile->hasAttribute('days_all'			)) {$req_Days_All			= GetSQLSafeValues($theFile->getAttribute('days_all'));	}
				if ($theFile->hasAttribute('day_mon'			)) {$req_Day_Mon			= GetSQLSafeValues($theFile->getAttribute('day_mon'));	}
				if ($theFile->hasAttribute('day_tue'			)) {$req_Day_Tue			= GetSQLSafeValues($theFile->getAttribute('day_tue'));	}
				if ($theFile->hasAttribute('day_wed' 			)) {$req_Day_Wed 			= GetSQLSafeValues($theFile->getAttribute('day_wed'));	}
				if ($theFile->hasAttribute('day_thu' 			)) {$req_Day_Thu 			= GetSQLSafeValues($theFile->getAttribute('day_thu'));	}
				if ($theFile->hasAttribute('day_fri' 			)) {$req_Day_Fri 			= GetSQLSafeValues($theFile->getAttribute('day_fri'));	}
				if ($theFile->hasAttribute('day_sat' 			)) {$req_Day_Sat 			= GetSQLSafeValues($theFile->getAttribute('day_sat'));	}
				if ($theFile->hasAttribute('day_sun' 			)) {$req_Day_Sun 			= GetSQLSafeValues($theFile->getAttribute('day_sun'));	}
				                                          
/*				
				if ($theFile->hasAttribute('filter_ext'			))
{				
				echo "yep"; die;
};				
				echo "extension " . $req_Extension; die;
*/

				// Set the limit variable, and add as needed
				// Date ranges will need to be intact
				$mLimit  = "    ".$database->sqlConvert_DateFormat_Date('file_create_start_dtm_client')." >= '".$req_Date_Min."'\n\r";
				$mLimit .= "AND ".$database->sqlConvert_DateFormat_Date('file_create_start_dtm_client')." <= '".$req_Date_Max."'\n\r";
				$mLimit .= "AND ".$database->sqlConvert_DateFormat_Time('file_create_start_dtm_client')." >= '".$req_Time_Min."'\n\r";
				$mLimit .= "AND ".$database->sqlConvert_DateFormat_Time('file_create_start_dtm_client')." <= '".$req_Time_Max."'\n\r";
				
				// See if we are looking for a certain day
				$mDaysOnly = '';
				if (!TrueOrYes($req_Days_All))
				{
					// No separators needs for Name specific search
					$mDaysOnly .= TrueOrYes($req_Day_Mon) ? 'Monday' : '';
					$mDaysOnly .= TrueOrYes($req_Day_Tue) ? 'Tuesday' : '';
					$mDaysOnly .= TrueOrYes($req_Day_Wed) ? 'Wednesday' : '';
					$mDaysOnly .= TrueOrYes($req_Day_Thu) ? 'Thursday' : '';
					$mDaysOnly .= TrueOrYes($req_Day_Fri) ? 'Friday' : '';
					$mDaysOnly .= TrueOrYes($req_Day_Sat) ? 'Saturday' : '';
					$mDaysOnly .= TrueOrYes($req_Day_Sun) ? 'Sunday' : '';
				}   
				// Narrow the search if any days were found
				if ($mDaysOnly <> '')
				{
					$mLimit .= "AND ".$database->sqlConvert_Locate($database->sqlConvert_DayName('file_create_start_dtm_client'), $mDaysOnly).">=1\n\r";   
				}
				
				// Check to see if we have notes to compare
				if ($req_In_Notes	<> '')
				{
					$mLimit .= "AND file_note like '%".$req_In_Notes."%'\n\r";   
				}
				// Check to see if we have telephone
				if ($req_Caller_Id	<> '')
				{
					$mLimit .= "AND (calling_number like '%".$req_Caller_Id."%'\n\r";  // ANI
					$mLimit .= "OR called_number like '%".$req_Caller_Id."%')\n\r";  // DNIS 	// @@@ CG - Wasn't testing both called/caller id as intended.
				}
				// Extension?
				if ($req_Extension	<> '')
				{
					$mLimit .= "AND cc_extension like '%".$req_Extension."%'\n\r";  
				}

				// Call direction
				if ($req_Direction	<> '')
				{
					if ($req_Direction == 'IN')
					{
						$mLimit .= "AND call_direction = 'IN'\n\r";  
					}
					if ($req_Direction == 'OUT')
					{
						$mLimit .= "AND call_direction = 'OUT'\n\r";  
					}
				}
				
				// Server
				if ($req_Server <> '')
				{
					$mLimit .= "AND ivr_computer_name = '".$req_Server."'\n\r";  
				}
				
				// Port 
				if ($req_Port_Range	<> '')
				{
					// We can extend the range where a dash is included
					// $mInList = ','.RangeSetStringCreate($req_Port_Range).',';
					// $mLimit .= "AND ".$database->sqlConvert_Locate($database->sqlConvert_Concat(',','ivr_port',','), $mInList)."\n\r";   					
					// $mLimit .= "AND ".$database->sqlConvert_Locate("ivr_port",$mInList). " >=1 \n\r";   					
					// @@@ CG - Replaced faulty locate search with IN() set function; this should work regardless of DB, and is a better
					// version of essentially the same search.
					$mInList = RangeSetStringCreate($req_Port_Range);
					$mLimit .= "AND ivr_port IN(".$mInList.") \n\r";   					
				}
//				echo $mInList; 
//				echo " " . $mLimit; die;

				// Check durations
				if (($req_Duration_Compare <> '') && ($req_Duration_Units <> '') && (is_numeric($req_Duration_Amount)))
				{
					$mOp = '';
					if (strtoupper($req_Duration_Compare) == 'GTE')
					{
						$mOp = '>=';
					}
					else if (strtoupper($req_Duration_Compare) == 'LTE')
					{
						$mOp = '<=';
					}
		
					// Get the units
					$mSeconds = 0;
					if (strtoupper($req_Duration_Units) == 'SECONDS')
					{
						$mSeconds = $req_Duration_Amount;
					}
					else if (strtoupper($req_Duration_Units) == 'MINUTES')
					{
						$mSeconds = $req_Duration_Amount*60;
					}
					else if (strtoupper($req_Duration_Units) == 'HOURS')
					{
						$mSeconds = $req_Duration_Amount*60*60;
					}
					
					// If we have something to do
					if (($mOp <> '') && ($req_Duration_Amount > 0))
					{
						$mLimit .= "AND file_duration ".$mOp." ".$mSeconds."\n\r";  
					}
				}
				
				// Add the report range
				$mLinesReturn 		= $rep_page_lines;
				$mLinesStartFrom	= $rep_page_lines * $rep_page_number;
				                
				               
				// See if the table exists
				$query_rsMediaList = "
SELECT
	media_file_id, 
	media_file_directory, 
	media_file_name, 
	media_owner_u_id, 
	file_reference_id, 
	app_type_name, 
	media_file_type, 
	ivr_computer_name, 
	ivr_port, 
	file_create_start_dtm_utc, 
	file_create_end_dtm_utc, 
	file_create_start_dtm_client, 
	file_create_end_dtm_client, 
	file_duration, 
	file_size, 
	file_app_status, 
	file_note,
	app_status_update_dtm_utc, 
	app_status_update_dtm_client, 
	file_transfer_status, 
	call_direction, 
	called_number, 
	calling_number, 
	recording_start_trigger, 
	recording_stop_trigger, 
	recording_protocol, 
	cc_agent_id, 
	cc_extension, 
	create_dtm_utc, 
	update_dtm_utc, 
	create_dtm_client, 
	update_dtm_client
FROM
	media_file                                
WHERE
	".$mLimit."
ORDER BY
	file_create_start_dtm_client		
".$database->sqlConvert_Limit_MySQL($rep_page_lines, $rep_page_number);
// @@@ CG - Add order by to be certain the query would always properly sort results. SQL Server isn't always respectful of natural order.
				//  echo $query_rsMediaList; die;

				$totalResults		= 0;
				$totalSetSize		= 0;
				$totalLimit			= 500; // Limit to records 
				
				// Make the report look good if asked for
				$mBuildHTMLTable	= '';	// HTML rows if requested
				$mBuildHTMLCols 	= 0;
				$mClassHeader 		= '';
				
				if (strtoupper($rep_include_table) == 'CALLCAPTURE')
				{
					$mClassHeader = strtolower($rep_include_table).'_';
					$mBuildHTMLTable = '<table class="'.$mClassHeader.'table">';
					
					// Add the column names and classes
					$mBuildHTMLTable .= '<tr class="'.$mClassHeader.'titles">'.
										'<td class="'.$mClassHeader.'col_'.++$mBuildHTMLCols.'">#</td>'.
										'<td class="'.$mClassHeader.'col_'.++$mBuildHTMLCols.'">Recording Start</td>'.
										'<td class="'.$mClassHeader.'col_'.++$mBuildHTMLCols.'">Duration</td>'.
										'<td class="'.$mClassHeader.'col_'.++$mBuildHTMLCols.'">Direction</td>'.
										'<td class="'.$mClassHeader.'col_'.++$mBuildHTMLCols.'">Caller ID</td>'.
										'<td class="'.$mClassHeader.'col_'.++$mBuildHTMLCols.'">Called ID</td>'.
										'<td class="'.$mClassHeader.'col_'.++$mBuildHTMLCols.'">Ext.</td>'.
										'<td class="'.$mClassHeader.'col_'.++$mBuildHTMLCols.'">Port</td>'.
										// '<td class="'.$mClassHeader.'col_'.++$mBuildHTMLCols.'">Notes</td>'.
										'<td class="'.$mClassHeader.'col_'.++$mBuildHTMLCols.'"></td>'.
									'</tr>';
				}
				
				$rsMediaList = $database->sqlConvert_sql_query($query_rsMediaList, $database->connectionSystem); // or die(mysql_error());
				$totalSetSize = $database->sqlConvert_sql_numrows($rsMediaList);
				$pageLast = floor($totalSetSize / $rep_page_lines); // @@@ what about mySQL?
				
//				echo $query_rsMediaList . " " . $totalSetSize . " " . $pageLast; die;
				
				if ($totalSetSize > 0)
				{
					// Have the data, now respond
					$elementHolder->setAttribute("action", $request_Command); 
					$elementHolder->setAttribute("result", $success); 
					$elementHolder->setAttribute("type",   $db); 

					// For MS SQL Server only
					$mCountStartTop = $rep_page_lines * $rep_page_number;					
					$mCountRepLine 	= $rep_page_lines;
								
					// Now add each job as an element
					while ($row_rsMenuItems = $database->sqlConvert_sql_fetch_array($rsMediaList))
					{
						// For MS SQL Server only -  MySQL is taken care of by LIMIT,
						if (((SYS_DATABASE_SYSTEM == "SQLServer") ||
							 (SYS_DATABASE_SYSTEM == "MS_PHP_SQLSvr"))
							&& 
							($mCountStartTop > 0)
							&&
							($rep_page_number <> 1))	// @@@ CG - Without this, 1st page results were always missing.
						{
							// Get to the top
							$mCountStartTop--;
							continue;
						}
						
						$totalResults = $totalResults + 1;
						// Make sure we don't return too much 
						if ($totalResults > $totalLimit)
						{
							break;
						}
						
						$single = $row_rsMenuItems;
						$elementResult  = $domobject->createElement("MEDIARESULT", $single['media_file_id']);
										
						// Add the fields from the database
						$elementResult->setAttribute("count",        $totalResults);
					
						$elementResult->setAttribute('media_file_id' 				, $single['media_file_id']);				
						$elementResult->setAttribute('media_file_directory' 		, $single['media_file_directory']);				
						$elementResult->setAttribute('media_file_name' 				, $single['media_file_name']); 				
						$elementResult->setAttribute('media_owner_u_id' 			, $single['media_owner_u_id']); 				
						$elementResult->setAttribute('file_reference_id' 			, $single['file_reference_id']); 				
						$elementResult->setAttribute('app_type_name' 				, $single['app_type_name']); 				
						$elementResult->setAttribute('media_file_type' 				, $single['media_file_type']); 				
						$elementResult->setAttribute('ivr_computer_name' 			, $single['ivr_computer_name']); 				
						$elementResult->setAttribute('ivr_port' 				    , $single['ivr_port']); 				
						$elementResult->setAttribute('file_create_start_dtm_utc' 	, DATE_FORMAT( $single['file_create_start_dtm_utc']		,"Y-m-d H:i:s")); 				
						$elementResult->setAttribute('file_create_end_dtm_utc' 		, DATE_FORMAT( $single['file_create_end_dtm_utc']		,"Y-m-d H:i:s")); 				
						$elementResult->setAttribute('file_create_start_dtm_client' , DATE_FORMAT( $single['file_create_start_dtm_client']	,"Y-m-d H:i:s"));	
						$elementResult->setAttribute('file_create_end_dtm_client' 	, DATE_FORMAT( $single['file_create_end_dtm_client']	,"Y-m-d H:i:s")); 	
						$elementResult->setAttribute('file_duration' 				, $single['file_duration']); 				
						$elementResult->setAttribute('file_size' 				    , $single['file_size']); 				
						$elementResult->setAttribute('file_app_status' 				, $single['file_app_status']); 				
						$elementResult->setAttribute('file_note' 					, $single['file_note']); 				
						$elementResult->setAttribute('app_status_update_dtm_utc' 	, $single['app_status_update_dtm_utc']); 				
						$elementResult->setAttribute('app_status_update_dtm_client' , $single['app_status_update_dtm_client']);				
						$elementResult->setAttribute('file_transfer_status' 		, $single['file_transfer_status']); 				
						// These two fields were killed off
						//$elementResult->setAttribute('xfer_status_update_dtm_utc' 	, $single['xfer_status_update_dtm_utc']); 				
						//$elementResult->setAttribute('xfer_status_update_dtm_client', $single['xfer_status_update_dtm_client']); 				
						$elementResult->setAttribute('call_direction' 				, $single['call_direction']); 				
						$elementResult->setAttribute('called_number' 				, $single['called_number']); 				
						$elementResult->setAttribute('calling_number' 				, $single['calling_number']); 				
						$elementResult->setAttribute('recording_start_trigger' 		, $single['recording_start_trigger']); 				
						$elementResult->setAttribute('recording_stop_trigger' 		, $single['recording_stop_trigger']); 				
						$elementResult->setAttribute('recording_protocol' 			, $single['recording_protocol']); 				
						$elementResult->setAttribute('cc_agent_id' 				    , $single['cc_agent_id']); 				
						$elementResult->setAttribute('cc_extension' 				, $single['cc_extension']); 				
						$elementResult->setAttribute('create_dtm_utc' 				, DATE_FORMAT( $single['create_dtm_utc']		,"Y-m-d H:i:s"));				
						$elementResult->setAttribute('update_dtm_utc' 				, DATE_FORMAT( $single['update_dtm_utc']		,"Y-m-d H:i:s")); 				
						$elementResult->setAttribute('create_dtm_client' 			, DATE_FORMAT( $single['create_dtm_client']		,"Y-m-d H:i:s")); 				
						$elementResult->setAttribute('update_dtm_client'			, DATE_FORMAT( $single['update_dtm_client']		,"Y-m-d H:i:s"));				
					
						$elementHolder->appendChild($elementResult);					
					
						// HTML Table: See if the user gets a table full of HTML rows
						// - Get the class to show
						if (strtoupper($rep_include_table) == 'CALLCAPTURE')
						{
							$mPlayLink = '<div id="media_play'.$single['media_file_id'].'"></div>';
						
							$mClassHeader = strtolower($rep_include_table).'_';
							$mRowClasses = array($mClassHeader."report_row_odd", $mClassHeader."report_row_even");
							$mRowClass = $mRowClasses[$totalResults % count($mRowClasses)];
							
							$mBuildHTMLTable .= '<tr id="ccrow'.$single['media_file_id'].'" class="'.$mRowClass.'">'.
										'<td>'.($rep_page_lines * ($rep_page_number -1) + $totalResults).'</td>'.
										'<td>'.DATE_FORMAT( $single['file_create_start_dtm_client'],"Y-m-d H:i:s").' '.
											(date('D',strtotime(DATE_FORMAT($single['file_create_start_dtm_client'],"Y-m-d H:i:s")))).
										'</td>'.
										'<td>'.convertSecondsToTime($single['file_duration']).'</td>'.
										'<td>'.sentence_case($single['call_direction']).'</td>'.
										'<td>'.telephoneFormatClassic($single['calling_number']).'</td>'.
										'<td>'.telephoneFormatClassic($single['called_number']).'</td>'.
										'<td>'.$single['cc_extension'].'</td>'.
										'<td>'.$single['ivr_port'].'</td>'.
										// '<td>'.$single['file_note'].'</td>'.
										'<td>'.$mPlayLink.'</td>'.
									'</tr>';
						}


						// For MS SQL Server only -  MySQL is taken care of by LIMIT,
						if (((SYS_DATABASE_SYSTEM == "SQLServer") ||
							 (SYS_DATABASE_SYSTEM == "MS_PHP_SQLSvr"))						
						&& ($mCountRepLine > 0))
						{
							// Get to the top
							$mCountRepLine--;
							if ($mCountRepLine == 0)
							{
								break;
							}
						}					
					}
					
					// Put in the totals
					$elementHolder->setAttribute("total",   $totalResults); 
					
					$elementHolder->setAttribute("page_last", $pageLast); 
					$elementHolder->setAttribute("maxrows",	$totalLimit); 
					
					// Add table if needed
					if ($rep_include_table <> 'NO')
					{
						$mBuildHTMLTable .= '</table>';
						$elementHolder->setAttribute("htmltable",	$mBuildHTMLTable); 
					}
					
				}
				else
				{
					// Add table if needed
					if ($rep_include_table <> 'NO')
					{
						$mBuildHTMLTable .= '<tr class="'.$mClassHeader.'report_row_odd">'.
						'<td colspan="'.$mBuildHTMLCols.'">No entries found</td></tr>'.
						'</table>';
						$elementHolder->setAttribute("htmltable",	$mBuildHTMLTable); 
					}
				
					$responsecode = "Media File results not Found";
					$elementHolder->setAttribute("action",		$request_Command); 
					$elementHolder->setAttribute("result",		$error); 
					$elementHolder->setAttribute("type",		$db); 
					$elementHolder->setAttribute("page_last",	0); 
					$elementHolder->setAttribute("maxrows",		$totalLimit); 
					// Add verbose TEST 
					$elementHolder->appendChild($domobject->createTextNode($responsecode));
				}
			}
			else
			{
				// Missing parameters
				$responsecode = "Mandetory parameters are missing or too short";
				$elementHolder->setAttribute("action", $request_Command); 
				$elementHolder->setAttribute("result", $error); 
				$elementHolder->setAttribute("type",   $cmd); 
				// Add verbose TEST 
				$elementHolder->appendChild($domobject->createTextNode($responsecode));		
			}

		} // ListMediaFilesForSearch
		  
		
		
		/////////////////////////////////////////////////////////
		else if ($request_Command == "AquireMediaFile")
		/////////////////////////////////////////////////////////
		{
			$responsecode = "Response";
			$elementHolder->setAttribute("action", $request_Command); 

			// See if mandetory data exists
			// - Name (both first and last) or telephone
			if(($theFile->hasAttribute('client_id'))
			  &($theFile->hasAttribute('media_file_id')))
			{
				$request_Client_Id  	= GetSQLSafeValues($theFile->getAttribute('client_id'));
				$request_media_file_id	= GetSQLSafeValues($theFile->getAttribute('media_file_id'));

				// See if the table exists
				$query_rsMediaItem = "
SELECT
	media_file_id, 
	media_file_directory, 
	media_file_name, 
	media_owner_u_id, 
	file_reference_id, 
	app_type_name, 
	media_file_type, 
	ivr_computer_name, 
	ivr_port, 
	file_create_start_dtm_utc, 
	file_create_end_dtm_utc, 
	file_create_start_dtm_client, 
	file_create_end_dtm_client, 
	file_duration, 
	file_size, 
	file_app_status, 
	file_note,
	app_status_update_dtm_utc, 
	app_status_update_dtm_client, 
	file_transfer_status, 
	call_direction, 
	called_number, 
	calling_number, 
	recording_start_trigger, 
	recording_stop_trigger, 
	recording_protocol, 
	cc_agent_id, 
	cc_extension, 
	create_dtm_utc, 
	update_dtm_utc, 
	create_dtm_client, 
	update_dtm_client
FROM
	media_file                                
WHERE
	media_file_id = ".$request_media_file_id;
				//echo $query_rsMediaItem; die;
				
				$mWavFullPath = '';
				$elementResult  = $domobject->createElement("MEDIAACQUIRE", $request_media_file_id);
				
				$rsMediaList = $database->sqlConvert_sql_query($query_rsMediaItem, $database->connectionSystem); // or die(mysql_error());
				if ($database->sqlConvert_sql_numrows($rsMediaList) > 0)
				{
					if ($row_rsMediaItem = $database->sqlConvert_sql_fetch_array($rsMediaList))
					{
						// $row_rsMediaItem['media_file_id']);				
						// $row_rsMediaItem['media_file_directory']);				
						$file =  		$row_rsMediaItem['media_file_name']; 		
						$mCompName =	$row_rsMediaItem['ivr_computer_name']; 				
						
						//  $row_rsMediaItem['media_owner_u_id']); 				
					
						// Get the create date from the name
						$mParts = explode('_',trim($file));
						
						// Get the count
						$mCount = 0;
						foreach ($mParts as $mEachOne)
						{
							$mCount++;		
						}
						
						// Do we have a file with the number of parts in it?
						//      0        1               2                        3            4
						// eg: MSG_2009-12-01_1259698004.310_URANUS_3.GSM.NEW.XML
						if ($mCount > 1)
						{
							// Get date folder for file
							$mDateFolder = $mParts[1];
							// Get the recording
							// eg: MSG_2009-12-01_1259698004.310_URANUS_3.GSM
							// Get the extentions
							$mExtensionParts = explode('.',$mParts[4]);
							$mExtAdd = $mExtensionParts[0].'.'.$mExtensionParts[1];
							$mWavRecording = $mParts[0].'_'.$mParts[1].'_'.$mParts[2].'_'.$mParts[3].'_'.
											$mExtAdd;
						
							//////////////////////////////
							// REMOTE
							//////////////////////////////
							$mRemotePath = $mRemoteMappedDrive.$mCompName."\\".$mDateFolder."\\";
							//$mRemotePath = "\\\\ANTARES\\3rdParty\\".$mCompName."\\".$mDateFolder."\\";

							$mLocalPath = clientMediaFolderLocate(true, $incPath, $request_Client_Id);
							echo ('From: '.$mRemotePath."\\".$mWavRecording);
							if (file_exists($mRemotePath."\\".$mWavRecording))
							{
								echo ("FOUND!!!!  ");
							}
							echo ('To: '.$mLocalPath."\\".$mWavRecording); die;
							
							
							// Grab it, and place it local
							// WARNING: Apache MUST run as a network account to copy in a file.
							if (copy(SlashToBackslash($mRemotePath."/".$mWavRecording), $mWavRecording))
							{
								// Did we find it?
								// NOTE: The file_exists function returns FALSE for files inaccessible due to safe mode restrictions. 
								// However these files still can be included if they are located in safe_mode_include_dir. 
								if (file_exists($mWavRecording))
								{
									echo ('Found: '.$mRemotePath."/".$mWavRecording) ; die;

									$mWavFullPath = $mRemotePath."/".$mWavRecording;
									
									$elementResult->setAttribute('media_file', $mWavFullPath);				
									
									// Have the data, now respond
									$elementHolder->setAttribute("action", $request_Command); 
									$elementHolder->setAttribute("result", $success); 
									$elementHolder->setAttribute("type",   $cmd); 
								}
								else 
								{
									echo ('Missing: '.SlashToBackslash($mRemotePath."/".$mWavRecording)) ; die;
								
								}
							}
						}
					}
				}
				
				// If nothing happened, report false
				if ($mWavFullPath == '')
				{
					// Found nothing
					$elementHolder->setAttribute("action", $request_Command); 
					$elementHolder->setAttribute("result", $error); 
					$elementHolder->setAttribute("type",   $cmd); 
				}
			}
			else
			{
				// Missing parameters
				$responsecode = "Mandetory parameters are missing or too short";
				$elementHolder->setAttribute("action", $request_Command); 
				$elementHolder->setAttribute("result", $error); 
				$elementHolder->setAttribute("type",   $cmd); 
				// Add verbose TEST 
				$elementHolder->appendChild($domobject->createTextNode($responsecode));		
			}
			
		} // AquireMediaFile

		/////////////////////////////////////////////////////////
		else
		/////////////////////////////////////////////////////////
		{
			decho("BAD COMMAND<BR>");
			$elementHolder->setAttribute("action", $request_Command);
			// Final results
			$responsecode = "Unknown Command";
			$elementResult  = $domobject->createElement("ERROR", $responsecode);
			$elementHolder->appendChild($elementResult);			
		}
	} // if $dbsuccess
}
else
{
	decho("NO COMMAND Provided<BR>");
	$elementHolder->setAttribute("action", "NotDefined");
	// Final results
	$responsecode = "ERROR: No Command Provided";
	$elementResult  = $domobject->createElement("RESULT", $responsecode);
}

// Put it all together
//$elementHolder->appendChild($elementResult);
$domobject->appendChild($elementHolder);
// Save to Log dir .. if there was a request
if ($request_Command <> "") 
{
    // No saving for this app.  Its not creating new info really
    //$domobject->save($resf);
}
?>