<?php
/*
* TeleFlow
*
* Copyright (C) 2008 engenic (engenic.com)
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with this program; if not, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
* http://www.gnu.org/copyleft/gpl.html
*/

// Function to display the reference to main page
function displayClientAccessLink($pOptionalUser)
{
	global $sys_static_text;
	
	// If the user is populated, then add that as a parameter
	if ($pOptionalUser <> '')
	{
		$mLinkToClient 	= '<a href="cr_main.php?user='.$pOptionalUser.'"><u>'.$sys_static_text['cr'][162].'</u></a>';	
	}
	else
	{
		$mLinkToClient	= '<a href="cr_main.php"><u>'.$sys_static_text['cr'][162].'</u></a>';
	}
	return $mLinkToClient;
} // displayClientAccessLink

// Function to display title with admin option
function displaySectionNameTitle($pSize,$pTitle)
{
	$mText = 
	'<div class="container_title">'.
		'<div class="cont_header">'.
			$pTitle.
		'</div>'.
	'</div>';
	return $mText;
}

// Company title
function displayCompanyNameTitle($pSize,$pTitle)
{
	if (isset($_SESSION['adminmode']))
	{
		$mText = 
		'<div class="container">'.
			'<div class="cont_header_admin">'.
				$pTitle.
			'</div>'.
		'</div>';
	}
	else
	{
		$mText = 
		'<div class="container">'.
			'<div class="cont_header">'.
				$pTitle.
			'</div>'.
		'</div>';
	}
	return $mText;
}

// Functions for displaying title
function displayContainerTitle($pSize,$pTitle)
{
	$mText = 
	'<div class="container">'.
		'<div class="cont_header">'.
			$pTitle.
		'</div>'.
	'</div>';
	return $mText;
} // displayContainerTitle

function displayContainerAdminLink($pTitle)
{
	$mText = 
	'<div class="container">'.
		'<div class="cont_header_admin">'.
			'<a href="cr_admin.php">'.$pTitle.'</a>'.
		'</div>'.
	'</div>';
	return $mText;
} // displayContainerAdminLink

// Functions for displaying a light outlined box
function displayContainerOutline($pHTMLDetails)
{
	$mText = displayContainerOutlineHeader().
			$pHTMLDetails.
			displayContainerOutlineFooter();
	return $mText;
} // displayContainerOutline
function displayContainerOutlineHeader()
{
	$mText = 
	'<div class="container_block">'.
		'<div class="cont_outline">';
	return $mText;
}
function displayContainerOutlineFooter()
{
	$mText = 
		'</div>'.
	'</div>';
	return $mText;
}


// Functions for displaying a light outlined box
function displayContainerShaded($pHTMLDetails)
{
	$mText = displayContainerShadedHeader(false).
			$pHTMLDetails.
			displayContainerShadedFooter();
	return $mText;
} // displayContainerShaded
function displayContainerShadedHeader($pFullWidth = false)
{
	// Select a class that does full width
	if ($pFullWidth)
	{
		$mText = 
		'<div class="container_block_full">'.
			'<div class="cont_shaded">';
	}
	else
	{
		$mText = 
		'<div class="container_block">'.
			'<div class="cont_shaded">';
	}
	return $mText;
}
function displayContainerShadedFooter()
{
	$mText = 
		'</div>'.
	'</div>';
	return $mText;
}


// Functions for displaying boxs and outlints
function displayContainerHeader($pSize,$pTitle,$pClassAdd='')
{
	$mClassAdd = '';
	if ($pClassAdd <> '')
	{
		$mClassAdd =$pClassAdd;
	}
	
	$mText = 
	'<div class="container">'.
		'<div class="cont_outer">'.
		'<div class="cont_inner">'.		
		// Portfolio Contents Section
		'<table width="100%">';
	// If we have included a title
	if ($pTitle <> '')
	{
		$mText .= 
			'<tr class="style5">'.
			   '<td colspan="3"><h3><span class="'.$mClassAdd.'">'.$pTitle.'</span></h3></td>'.
			'</tr>';
	}
		
	return $mText;
} // displayContainerHeader
// Provide a spacer block
function displayContainerEmptyBlock()
{
	return '<div class="container_block">&nbsp;</div>';
}
// Functions for displaying menu item in a standard container
function displayContainerMenuItem($pHTMLDetails)
{
	$mText = 
		'<tr class="style5">'.
		'<td valign="top" width="15">'.displayBullet().'</td>'.
		'<td>'.
		'&nbsp;'.
		$pHTMLDetails.'</td>'.
		'<td width="15">&nbsp;</td>'.
		'</tr>';
	return $mText;
} // displayContainerFooter
// Drop information in from another file
function displayContainerFileContent($pFile)
{
	$mText = 
		'<tr class="style5">'.
		'<td colspan="2">'.
		displayBullet().
		'&nbsp;';
	$handle = fopen($pFile, "r");
	while ($mRow = fread($handle,"1000"))
	{
		$mText .= $mRow;
	}
	$mText .= 
		'</td>'.
		'<td width="15">&nbsp;</td>'.
		'</tr>';
	//echo $mText; die;		
	return $mText;
} // displayContainerFooter
// Display regular content
function displayContainerRowStart()
{
	$mText = 
		'<tr class="style5">'.
		'<td colspan="3">';
	return $mText;
} // displayContainerRowStart
function displayContainerRowContent($pHTMLDetails)
{
	$mText = 
		displayContainerRowStart().
		$pHTMLDetails.
		displayContainerRowEnd();
	return $mText;
} // displayContainerRowContent
function displayContainerRowEnd()
{
	$mText = 
		'</td>'.
		'</tr>';
	return $mText;
} // displayContainerRowEnd
// Functions for displaying boxs and outlints
function displayContainerFooter()
{
	$mText = 
		'</table>'.
		// End of Portfolio Section
		'</div>'.
		'</div>'.
	'</div>';
	return $mText;
} // displayContainerFooter

// Display a nice standard bullet 
function displayBullet()
{
	return '<img height="15" width="15" border="0" src="images/mr-bullet-menu.gif"/>';
}

// Menu - used to display general menu items (used in cr_main_content and cr_access_client etc)
function menuItemBuild($pAppTypeWebApp, $pAppTypeDisplay, $pAppTypeDesc, $pSubManagementFile)
{
	// See if there is a subscription management file parameter included
	$mManagementFile = '';
	if ($pSubManagementFile <> '')		
	{
		$mManagementFile = '?managementfile='.$pSubManagementFile;
	}

	$mMenu = '<a class="contmenu" href="'.$pAppTypeWebApp.$mManagementFile.'">'.
				'<b>'.$pAppTypeDisplay.'</b>'.
				' - '.
				'<span class="contmenudescription">'.$pAppTypeDesc.'</span>'.
				'</a>';
	return $mMenu;
}  // menuItemBuild

// Test  to ensure we are running secure for some items
function headerTestRedirectToHTTPS()
{
  if($_SERVER['HTTPS']!=="on")
  {
     $redirect= "https://".$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
     header("Location:$redirect");
  }
}


// Check for SSL mode
// This is a secure page, so redirect if needed
if ($cGlobalSecure) 
{
	headerTestRedirectToHTTPS();
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">	
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="description" content="<?php echo $webMetaDescription;?>">
<meta name="keywords" content="<?php echo $webMetaKeywords;?>">
<head profile="http://www.w3.org/2005/10/profile">
<?php
// See if the system wants to timeout after disuse
// -- Used to refresh the logon screen if the system is set to not allow users to logon.  Ie:  Screen will eventually show the logon again.
if ($cGlobalMode == MODE_OFFLINE)
{
	// Off line refresh every 2 minutes to return the user to the login screen
?>
	<meta http-equiv="refresh" content="120;url=<?php echo ($logoutPage);?>"/>
<?php
}
// Put an autologout if we are not dealing with an automatically allowed IP address
// -- See: (database->selectByIPAddressClientDatabase)
else if ((LOGINSESSIONHTTPTIMEOUT > 0) && (!isset($_SESSION['CLIENTID_BY_IP_ADDR'])) && isset($logoutPage))
{
?>
	<meta http-equiv="refresh" content="<?php echo (LOGINSESSIONHTTPTIMEOUT);?>;url=<?php echo($logoutPage);?>"/>
<?php
}
?>
<link rel="icon" 
      type="image/png" 
      href="/favicon.png" />
<title><?php echo $webTitleOverride;?></title>
<link href="<?php echo ($incPath);?>include/default.css" rel="stylesheet" media="screen,,projection" title="default" type="text/css"  />
<link href="<?php echo ($incPath);?>include/datepicker.css" rel="stylesheet" media="screen,,projection" title="default" type="text/css"  />
<link href="<?php echo ($incPath.$webCSS);?>" rel="stylesheet" media="screen,,projection" title="default" type="text/css"  />
<script language="JavaScript" src="/library_js/jslibrary.js"></script>
<?php
// Include all the standard JavaScript files
include($incPath."include/javascript.includes.php"); 
?>