<?php
/**
 * Constants.php
 *
 * This file is intended to group all constants to
 * make it easier for the site administrator to tweak
 * the login script.
 *
 * Written by: Jpmaster77 a.k.a. The Grandmaster of C++ (GMC)
 * Last Updated: August 19, 2004
 *
 * Many updates by Vern Baker - javakinetic@gmail.com
 * Last Updated: August 2008
 */
 
/**
 * Database Constants - these constants are required
 * in order for there to be a successful connection
 * to the MySQL database. Make sure the information is
 * correct.
 */

/**
 * Database Table Constants - these constants
 * hold the names of all the database tables used
 * in the script.
 */
// Tables for Authorization system
define("TBL_USERS",          "user_details");
define("TBL_USER_EXTENSION", "vo_user_extension");
define("TBL_COMPANY",        "company");
define("TBL_CLIENT",         "client_details");
define("TBL_ACTIVE_USERS",   "user_active");
define("TBL_ACTIVE_GUESTS",  "guest_active");
define("TBL_BANNED_USERS",   "user_banned");
// Tables for MedicalRelay
define("TBL_APPOINTMENT",    "appointment");
define("TBL_REPORT",         "mr_report");
define("TBL_ADMIN",          "user_details");   // formerly mr_admin


/**
 * Special Names and Level Constants - the admin
 * page will only be accessible to the user with
 * the admin name and also to those users at the
 * admin user level. Feel free to change the names
 * and level constants as you see fit, you may
 * also add additional level specifications.
 * Levels must be digits between 0-9.
 */
define("ADMIN_NAME", "admin");
define("GUEST_NAME", "Guest");
define("SUPER_ADMIN_LEVEL", 99);
define("ADMIN_LEVEL", 9);
define("USER_LEVEL",  1);
define("GUEST_LEVEL", 0);

// Registration types
define("REG_BY_SELF",   1);
define("REG_BY_INVITE", 2);


/**
 * This boolean constant controls whether or
 * not the script keeps track of active users
 * and active guests who are visiting the site.
 */
define("TRACK_VISITORS", true);

/**
 * Timeout Constants - these constants refer to
 * the maximum amount of time (in minutes) after
 * their last page fresh that a user and guest
 * are still considered active visitors.
 */
define("USER_TIMEOUT", 10);
define("GUEST_TIMEOUT", 5);

/**
 * Cookie Constants - these are the parameters
 * to the setcookie function call, change them
 * if necessary to fit your website. If you need
 * help, visit www.php.net for more info.
 * <http://www.php.net/manual/en/function.setcookie.php>
 */
define("COOKIE_EXPIRE", 60*60*24*100);  //100 days by default
define("COOKIE_PATH", "/");  //Avaible in whole domain

/**
 * This constant forces all users to have
 * lowercase usernames, capital letters are
 * converted automatically.
 */
define("ALL_LOWERCASE", false);

/**
 File App Status and File Transfer Status
 */
// FILE_APP_STATUS
// - Media starts off as NEW, and then gets set to ABANDONED or SAVED.  Once SAVED, it gets set to PROCESSED
define("FA_CREATED"		,'CREATED');	// A recording entry has been created, and is about to be recorded
define("FA_NEW"			,'NEW');		// User successfully recorded a file and it is set to new
define("FA_DELETED"		,'DELETED');	// User deleted the recording
define("FA_ABANDONED"	,'ABANDONED');	// User abandoned the recording
define("FA_SAVED"		,'SAVED');		// A reviewer has saved the recording
define("FA_PURGED"		,'PURGED');		// System purged the recording after x days and successful transfer
define("FA_REPLACED"	,'REPLACED');	// System has replaced this entry with a new one, most likely due to the user reloading the media file XML

// FILE_TRANSFER_STATUS
define("FT_NEW"			,'NEW');
define("FT_PROCESSING"	,'PROCESSING');
define("FT_COMPLETED"	,'COMPLETED');
define("FT_MISSING"		,'MISSING');
define("FT_ABANDONED"	,'ABANDONED');
define("FT_ERROR"		,'ERROR');
define("FT_RETRY"		,'RETRY');
define("FT_REPLACED"	,'REPLACED');	// System has replaced this entry with a new one, most likely due to the user reloading the media file XML

// PROCESSING CODES
define("PENDING"		,'Pending');
define("PENDINGRETRY"	,'PendingRetry');
define("UPLOADED"  		,'Uploaded');
define("ABANDONED"		,'Abandoned');

?>