<?php
/*
 Session_nodb.php
 
 The Session class is meant to simplify the task of keeping track of user and details.  This version does not include the database, and is limited to 
 basic display and form functions.  Most likely, this would be used for basic display only web pages

 * Written by: Jpmaster77 a.k.a. The Grandmaster of C++ (GMC)
 *  Overhauled and updated by: vbaker@engenic.com
 Last Updated: August 19, 2004
 */
 
// NOTE - SessionStart is found in the LocalSettings.php file

// Make sure we have the variable set
if (!isset($incPath))
{
	$incPath = '';
}

// Email performed by Swift
require_once $incPath."swift_emailer/lib/Swift.php";
require_once $incPath."swift_emailer/lib/Swift/Connection/SMTP.php";
require_once $incPath."swift_emailer/lib/Swift/Authenticator/LOGIN.php";

// Email templates created by system owner
require_once $incPath.'../'.'LocalSettings_EmailTemplates.php';

// Fires Contructors
require("form.php");

	
class Session
{
	// @@@ None of this should populate
	var $username;     //Username given on sign-up
	var $userid;       //Random value generated on current login
	var $userclientid; //The client to which the user belongs
	var $userfirst;    //User first name
	var $userlevel;    //The level to which the user pertains
	var $time;         //Time user was last active (page loaded)
	var $logged_in;    //True if user is logged in, false otherwise
	var $userinfo = array();  //The array holding all user info
	var $url;          //The page url current being viewed
	var $referrer;     //Last recorded site page viewed
	// Not using database in this mode
	var $databasemode = false;	// Are we in database mode
	
	/**
	* Note: referrer should really only be considered the actual
	* page referrer in process.php, any other time it may be
	* inaccurate.
	*/

	/* Class constructor */
	function Session()
	{
		$this->time = time();
		$this->startSession(); //Tell PHP to start the session
	}

	/**
	* startSession - Performs all the actions necessary to 
	* initialize this session object. Tries to determine if the
	* the user has logged in already, and sets the variables 
	* accordingly. Also takes advantage of this page load to
	* update the active visitors tables.
	*/
	function startSession()
	{
		// See Local_Settings for session_start()
	
		/* Set referrer page */
		if(isset($_SESSION['url']))
		{
			$this->referrer = $_SESSION['url'];
		}
		else
		{
			$this->referrer = "/";
		}
	
		/* Set current url */
		$this->url = $_SESSION['url'] = $_SERVER['PHP_SELF'];
	}
	
};


/**
 * Initialize session object - This must be initialized before
 * the form object because the form uses session variables,
 * which cannot be accessed unless the session has started.
 */
$session = new Session;

/* Initialize form object */
$form = new Form;
?>
