/*
MySQL Backup
Source Host:           LocalHost
Source Server Version: 5.0.24-community-nt
Source Database:       opendictation
Date:                  2008/03/29 15:51:49
*/

SET FOREIGN_KEY_CHECKS=0;
use opendictation;
#----------------------------
# Table structure for call_log
#----------------------------
CREATE TABLE `call_log` (
  `call_log_id` int(10) unsigned NOT NULL auto_increment,
  `call_start_date` varchar(10) default NULL,
  `call_start_date_web` varchar(10) default NULL,
  `call_start_time` varchar(8) default NULL,
  `call_end_date` varchar(10) default NULL,
  `call_end_date_web` varchar(10) default NULL,
  `call_end_time` varchar(8) default NULL,
  `call_duration` int(6) default NULL,
  `call_port` varchar(4) default NULL,
  `dictate_client_id` int(10) default NULL,
  `dp_id` int(10) default NULL,
  `dictate_physician_id` varchar(4) default NULL,
  `dnis` varchar(20) default NULL,
  `ani` varchar(20) default NULL,
  `call_commands` text,
  `call_end_reason` varchar(50) default NULL,
  PRIMARY KEY  (`call_log_id`),
  KEY `call_start_date` (`call_start_date`),
  KEY `call_end_date` (`call_end_date`)
) ENGINE=MyISAM AUTO_INCREMENT=48058 DEFAULT CHARSET=latin1;
#----------------------------
# Records for table call_log
#----------------------------


insert  into call_log values 
(48051, '2008/03/20', '03/20/2008', '12:01:56', '2008/03/20', '03/20/2008', '12:03:17', 82, '97', 98, 16, '2000', '6046382650', '101', '1, #, 9', 'User pressed end key'), 
(48052, '2008/03/20', '03/20/2008', '12:12:47', '2008/03/20', '03/20/2008', '12:14:52', 126, '97', 98, 16, '2000', '6046382650', '101', '#, 6, 6, 4, 4, 3, #, 8(1), 9', 'User pressed end key'), 
(48053, '2008/03/20', '03/20/2008', '12:34:35', '2008/03/20', '03/20/2008', '12:35:04', 29, '97', null, null, null, '6046382650', '101', null, 'User hang up'), 
(48054, '2008/03/20', '03/20/2008', '12:35:26', '2008/03/20', '03/20/2008', '12:35:27', 2, '97', null, null, null, '6046382650', '101', null, 'User hang up'), 
(48055, '2008/03/24', '03/24/2008', '05:59:01', '2008/03/24', '03/24/2008', '05:59:47', 47, '97', 98, 16, '2000', '6046382650', '115', '0, 1', 'User hang up'), 
(48056, '2008/03/24', '03/24/2008', '06:01:49', '2008/03/24', '03/24/2008', '06:02:34', 47, '97', 98, 16, '2000', '6046382650', '115', '*1, 2, 1, 9', 'User pressed end key'), 
(48057, '2008/03/24', '03/24/2008', '06:03:07', '2008/03/24', '03/24/2008', '06:03:39', 33, '97', 98, 16, '2000', '6046382650', '115', '8(1)', 'User hang up');
#----------------------------
# Table structure for confirm
#----------------------------
CREATE TABLE `confirm` (
  `confirmNum` int(10) NOT NULL auto_increment,
  `port` int(3) default NULL,
  `callStart` char(8) default NULL,
  `callDate` char(10) default NULL,
  PRIMARY KEY  (`confirmNum`)
) ENGINE=MyISAM AUTO_INCREMENT=1000065424 DEFAULT CHARSET=latin1;
#----------------------------
# Records for table confirm
#----------------------------


insert  into confirm values 
(1000065416, 97, '15:00:36', '2008/03/20'), 
(1000065417, 97, '15:02:03', '2008/03/20'), 
(1000065418, 97, '15:12:58', '2008/03/20'), 
(1000065419, 97, '15:14:35', '2008/03/20'), 
(1000065420, 97, '08:59:10', '2008/03/24'), 
(1000065421, 97, '09:01:57', '2008/03/24'), 
(1000065422, 97, '09:03:14', '2008/03/24'), 
(1000065423, 97, '09:03:29', '2008/03/24');
#----------------------------
# Table structure for dicate_phone_map
#----------------------------
CREATE TABLE `dicate_phone_map` (
  `dictate_phone_map_id` int(10) NOT NULL auto_increment,
  `dpm_dialed_phone` varchar(20) default NULL,
  `dpm_dnis` varchar(20) default NULL,
  PRIMARY KEY  (`dictate_phone_map_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
#----------------------------
# No records for table dicate_phone_map
#----------------------------

#----------------------------
# Table structure for dictate_client
#----------------------------
CREATE TABLE `dictate_client` (
  `superuser_id` int(5) NOT NULL default '1',
  `dictate_client_id` int(10) NOT NULL auto_increment,
  `client_name` varchar(30) default NULL,
  `client_dnis` varchar(20) default NULL,
  `client_create_date` varchar(10) default NULL,
  `client_create_date_web` varchar(10) default NULL,
  `client_create_time` varchar(8) default NULL,
  `client_needs_record` char(1) default 'Y',
  `client_name_file` varchar(50) default NULL,
  `file_transfer_status` varchar(15) default NULL,
  `client_requires_mrn` char(1) default NULL,
  `client_report_digits` int(1) default NULL,
  `client_no_action_timeout` int(10) default '120',
  `client_status` varchar(10) default 'Enabled',
  PRIMARY KEY  (`dictate_client_id`),
  KEY `client_name` (`client_name`),
  KEY `client_dnis` (`client_dnis`),
  KEY `client_status` (`client_status`)
) ENGINE=MyISAM AUTO_INCREMENT=99 DEFAULT CHARSET=latin1;
#----------------------------
# Records for table dictate_client
#----------------------------


insert  into dictate_client values 
(1, 97, 'XXXX', '6045555555', '2008/03/11', '03/11/2008', '19:20:25', 'N', 'CLIENT-2008031169915731-42.wav', 'Uploaded', 'N', 1, 120, 'Enabled'), 
(1, 98, 'ZZZZ', '6046396391', '2008/02/25', '02/25/2008', '14:19:19', 'N', 'CLIENT-2008031961031700-95.wav', 'Pending', null, 1, 120, 'Enabled');
#----------------------------
# Table structure for dictate_client_load
#----------------------------
CREATE TABLE `dictate_client_load` (
  `client_name` varchar(30) default NULL,
  `client_dnis` varchar(20) default NULL,
  `client_create_date` varchar(10) default NULL,
  `client_create_date_web` varchar(10) default NULL,
  `client_create_time` varchar(10) default NULL,
  `client_requires_mrn` char(1) default NULL,
  `client_report_digits` int(1) default NULL,
  `load_status` varchar(20) default 'NEW'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
#----------------------------
# No records for table dictate_client_load
#----------------------------

#----------------------------
# Table structure for dictate_file
#----------------------------
CREATE TABLE `dictate_file` (
  `file_id` int(10) NOT NULL auto_increment,
  `file_conf_num` varchar(6) default NULL,
  `dictate_client_id` int(10) default NULL,
  `dp_id` int(10) default NULL,
  `dictate_physician_id` varchar(4) default NULL,
  `physician_number` varchar(10) default NULL,
  `file_name` varchar(255) default NULL,
  `file_date` varchar(10) default NULL,
  `file_date_web` varchar(10) default NULL,
  `file_time` varchar(8) default NULL,
  `file_port` int(5) default NULL,
  `file_sent` int(1) NOT NULL default '0',
  `file_status_transcription` varchar(12) default NULL,
  `file_status_web` varchar(12) default NULL,
  `filepath_id` int(10) default NULL,
  `call_dnis` varchar(20) default NULL,
  `call_ani` varchar(20) default NULL,
  `call_log_id` int(10) default NULL,
  `file_dir` varchar(100) default NULL,
  `mrn` int(10) default NULL,
  `report_type` varchar(4) default NULL,
  PRIMARY KEY  (`file_id`),
  KEY `file_conf_num` (`file_conf_num`),
  KEY `physician_number` (`physician_number`),
  KEY `file_date` (`file_date`),
  KEY `call_dnis` (`call_dnis`),
  KEY `call_log_id` (`call_log_id`),
  KEY `dictate_physician_id` (`dictate_physician_id`)
) ENGINE=MyISAM AUTO_INCREMENT=64914 DEFAULT CHARSET=latin1;
#----------------------------
# Records for table dictate_file
#----------------------------


insert  into dictate_file values 
(64907, '065417', 98, 16, '2000', '2000', '1_ZZZZ_6046382650_2000_Spears_032008_120203_0_065417_orig.wav', '2008/03/20', '03/20/2008', '12:03:17', 97, 0, 'Pending', 'Pending', 1, '6046396391', '6046396391', 48051, null, 0, '1'), 
(64908, '065418', 98, 16, '2000', '2000', '1_ZZZZ_6046382650_2000_Spears_032008_121258_0_065418_orig.wav', '2008/03/20', '03/20/2008', '12:14:33', 97, 0, 'Deleted', 'Deleted', 1, '6046396391', '6046396391', 48052, null, 0, '1'), 
(64909, '065419', 98, 16, '2000', '2000', '1_ZZZZ_6046382650_2000_Spears_032008_121435_0_065419_orig.wav', '2008/03/20', '03/20/2008', '12:14:52', 97, 0, 'Pending', 'Pending', 1, '6046396391', '6046396391', 48052, null, 0, '1'), 
(64910, '065420', 98, 16, '2000', '2000', '2_ZZZZ_6046382650_2000_Spears_032408_055910_0_065420_orig.wav', '2008/03/24', '03/24/2008', '05:59:47', 97, 0, 'Pending', 'Pending', 1, '6046396391', '6046396391', 48055, null, 0, '2'), 
(64911, '065421', 98, 16, '2000', '2000', '3_ZZZZ_6046382650_2000_Spears_032408_060157_0_065421_orig.wav', '2008/03/24', '03/24/2008', '06:02:34', 97, 0, 'Pending', 'Pending', 1, '6046396391', '6046396391', 48056, null, 0, '3'), 
(64912, '065422', 98, 16, '2000', '2000', '5_ZZZZ_6046382650_2000_Spears_032408_060314_0_065422_orig.wav', '2008/03/24', '03/24/2008', '06:03:26', 97, 0, 'Deleted', 'Deleted', 1, '6046396391', '6046396391', 48057, null, 0, '5'), 
(64913, '065423', 98, 16, '2000', '2000', '4_ZZZZ_6046382650_2000_Spears_032408_060329_0_065423_orig.wav', '2008/03/24', '03/24/2008', '06:03:39', 97, 0, 'Pending', 'Pending', 1, '6046396391', '6046396391', 48057, null, 0, '4');
#----------------------------
# Table structure for dictate_physician
#----------------------------
CREATE TABLE `dictate_physician` (
  `dp_id` int(10) NOT NULL auto_increment,
  `dictate_physician_id` varchar(4) default '0',
  `dictate_client_id` int(10) default NULL,
  `physician_last_name` varchar(30) default NULL,
  `physician_first_name` varchar(30) default NULL,
  `physician_number` int(10) default NULL,
  `physician_status` varchar(10) default 'Enabled',
  `physician_needs_record` char(1) default 'N',
  `physician_name_file` varchar(150) default NULL,
  `file_transfer_status` varchar(15) default NULL,
  PRIMARY KEY  (`dp_id`),
  KEY `dictate_physician_id` (`dictate_physician_id`),
  KEY `dictate_client_id` (`dictate_client_id`),
  KEY `physician_status` (`physician_status`),
  KEY `physician_last_name` (`physician_last_name`)
) ENGINE=MyISAM AUTO_INCREMENT=3409 DEFAULT CHARSET=latin1;
#----------------------------
# Records for table dictate_physician
#----------------------------


insert  into dictate_physician values 
(16, '2000', 98, 'Spears', 'Kate', 2000, 'Enabled', 'N', 'NAME-2008032049851683-97.wav', 'Pending'), 
(3407, '3703', 97, 'Moss', 'Britney', 3703, 'Enabled', 'N', null, 'NA'), 
(3408, '2232', 97, 'Issac', 'Jason', 2232, 'Enabled', 'N', null, 'NA');
#----------------------------
# Table structure for dictate_physician_load
#----------------------------
CREATE TABLE `dictate_physician_load` (
  `dictate_physician_id` varchar(4) default '0',
  `dictate_client_name` varchar(30) default NULL,
  `physician_last_name` varchar(30) default NULL,
  `physician_first_name` varchar(30) default NULL,
  `physician_number` varchar(10) default NULL,
  `load_status` varchar(30) default 'NEW',
  `dictate_client_id` int(10) default NULL,
  KEY `dictate_physician_id` (`dictate_physician_id`),
  KEY `dictate_client_id` (`dictate_client_id`),
  KEY `physician_last_name` (`physician_last_name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
#----------------------------
# No records for table dictate_physician_load
#----------------------------

#----------------------------
# Table structure for filepath
#----------------------------
CREATE TABLE `filepath` (
  `filepath_id` int(10) unsigned NOT NULL auto_increment,
  `dir_loc` varchar(100) NOT NULL default '',
  `web_dir_loc` varchar(100) default NULL,
  `web_local_dirloc` varchar(100) default NULL,
  `volume_num` int(11) unsigned NOT NULL default '0',
  `status` varchar(20) NOT NULL default '',
  `max_volume_filecount` int(10) unsigned NOT NULL default '0',
  `create_date` varchar(10) default NULL,
  `create_time` varchar(8) default NULL,
  `close_date` varchar(10) default NULL,
  `close_time` varchar(8) default NULL,
  PRIMARY KEY  (`filepath_id`),
  KEY `status` (`status`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=latin1;
#----------------------------
# Records for table filepath
#----------------------------


insert  into filepath values 
(1, 'C:\\HostCompany\\TFApps\\OpenDictation\\Vmail\\Volume0000000001', 'http://209.192.192.151:5048/Vmail/', null, 1, 'ACTIVE', 5000, '2006/10/30', '12:54:00', null, null);
#----------------------------
# Table structure for ivrconfig
#----------------------------
CREATE TABLE `ivrconfig` (
  `ivrconfig_id` int(10) NOT NULL auto_increment,
  `menuloop` int(2) default NULL,
  `dbloop` int(2) default NULL,
  `play_volume` int(2) default NULL,
  `rec_volume` int(2) default NULL,
  `password` int(6) default NULL,
  `rec_ext` char(3) NOT NULL default '',
  `adminpw` int(6) NOT NULL default '0',
  `start_time` time NOT NULL default '00:00:00',
  `end_time` time NOT NULL default '00:00:00',
  `dictate_dir` varchar(100) default NULL,
  `email_pause` int(6) default NULL,
  `email_address` varchar(100) default NULL,
  `name_dir_loc` varchar(100) default NULL,
  `name_web_dir_loc` varchar(100) default NULL,
  `local_gmt_offset` int(3) default NULL,
  `remote_gmt_offset` int(3) default NULL,
  PRIMARY KEY  (`ivrconfig_id`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=latin1;
#----------------------------
# Records for table ivrconfig
#----------------------------


insert  into ivrconfig values 
(1, 3, 3, 1, 3, 1234, 'wav', 2222, '08:00:00', '16:00:00', 'C:\\Dictate_Demo\\', 600000, 'admin@hostcompany.com', 'C:\\HostCompany\\TFApps\\OpenDictation\\Vmail', 'http://209.192.192.151:5048/Vmail/', -5, -8);
#----------------------------
# Table structure for superuser
#----------------------------
CREATE TABLE `superuser` (
  `superuser_id` int(5) NOT NULL default '1',
  `superuser_login_id` varchar(10) default NULL,
  `superuser_password` varchar(10) NOT NULL default '0',
  PRIMARY KEY  (`superuser_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
#----------------------------
# Records for table superuser
#----------------------------


insert  into superuser values 
(1, 'admin', '1234');

