<?php
/*
* TeleFlow Open Dictation
*
* Copyright (C) 2008 engenic (engenic.com)
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with this program; if not, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
* http://www.gnu.org/copyleft/gpl.html
*/
// Includes Section
// Includes Section
require_once("cr_reference.php");
require_once($incPath.'LocalSettings.php'); 
include($incPath."include/session.php");

require_once($websiteLibrary.'calcWorkUnit.php');   
// Dictation specific
require_once($websiteLibrary.'dictationWorkUnit.php'); 


/**
 * User not logged in, redirect to main page
 * automatically.
 */
if(!$session->checkLogin())
{
   header("Location: ".$incPath."cr_main.php");
}



function tfm_cleanOrderBy($theValue, $defaultSort) 
{
	if (preg_match("/^[\w,]{1,50}\s+(asc|desc)\s*$/i",$theValue, $matches)) 
	{
		return $matches[0];
	}
	return $defaultSort;
}
 

$tfm_orderby =(!isset($_GET["tfm_orderby"]))?"file_date DESC, file_time DESC":$_GET["tfm_orderby"];
$tfm_order =(!isset($_GET["tfm_order"]))?"ASC":$_GET["tfm_order"];
$sql_orderby = $tfm_orderby." ".$tfm_order;

//echo "<br>".$sql_orderby."<br><br>";
if ($sql_orderby == "file_date ASC")
{
	$sql_orderby = tfm_cleanOrderBy($sql_orderby, "file_date ASC, file_time ASC");
	$sql_orderby = $sql_orderby.", file_time ASC";
} 
else 
{
	$sql_orderby = tfm_cleanOrderBy($sql_orderby, "file_date DESC, file_time DESC");
	$sql_orderby = $sql_orderby.", file_date DESC, file_time DESC";
}
//echo "<br>".$sql_orderby."<br><br>";


// -------- Pagination for Reports ------------
// Note: Don't forget at the start of this program:  session_start(); 
// Was a page parameter passed
if (isset($_GET['page'])) 
{
	$pageLines  = (isset($_SESSION["pageLines"])) ? $_SESSION["pageLines"] : 0;
	$pageCurr   = (isset($_SESSION["pageCurr"]))  ? $_SESSION["pageCurr"]  : 0;
	$pageMax    = (isset($_SESSION["pageMax"]))   ? $_SESSION["pageMax"]   : 0;
	// Determine the new page to hit
	$pageCurr   = engRepPageSettings($_GET['page'], $pageCurr, $pageMax);
}
else
{
	// Go with new page
	$pageLines  = 100;
	$pageCurr   = 0;
	$pageMax    = -1; // set with count   
}  
// -------- Pagination for Reports ------------


$SSAdv_colors1 = array("#FFFFFF", "#EAF2F4");
$SSAdv_k1 = 0;
$SSAdv_m1 = 0;
$SSAdv_change_every1 = 1;

$varstartdate = "";
if (isset($_GET['startdate'])) 
{
	$varstartdate = (get_magic_quotes_gpc()) ? $_GET['startdate'] : addslashes($_GET['startdate']);
}

$varenddate = "";
if (isset($_GET['enddate'])) 
{
	$varenddate = (get_magic_quotes_gpc()) ? $_GET['enddate'] : addslashes($_GET['enddate']);
}

$varloaded = "";
if (isset($_GET['loaded'])) 
{
	$varloaded = (get_magic_quotes_gpc()) ? $_GET['loaded'] : addslashes($_GET['loaded']);
}

$varSearch_rsSearchResultDate = "-1";
if (isset($_COOKIE['tfdict_login'])) 
{
	$varSearch_rsSearchResultDate = (get_magic_quotes_gpc()) ? $_COOKIE['tfdict_login'] : addslashes($_COOKIE['tfdict_login']);
}

// Start Date

$varstartdate  = str_replace("%2F","/",$varstartdate);
$searchstartdate = $varstartdate;
if ($searchstartdate == "")  
{
	$searchstartdate  = trim(date("m/d/Y"));
}

// End Date
$searchenddate = $varenddate;
if ($searchenddate == "")  
{
	$searchenddate = ("99/99/9999"); 
}


if ($varloaded == "")  
{
	$varloaded = ("loaded"); 
	$query_rsSearchResultDate = "";
}  
else
{
	$query_fields = (    
"SELECT 
* ");
	$query_from = (sprintf(
"FROM 
	dictate_file d, 
	dictate_physician p, 
	filepath f, 
	dictate_client c
WHERE 
    d.file_date  >= CONCAT(SUBSTRING('%s',  7,4), '/', SUBSTRING('%s',  1,2),'/',SUBSTRING('%s',  4,2))
AND d.file_date  <= CONCAT(SUBSTRING('%s',  7,4), '/', SUBSTRING('%s',  1,2),'/',SUBSTRING('%s',  4,2))
AND d.dp_id = p.dp_id 
AND d.dictate_client_id = c.dictate_client_id
AND d.filepath_id = f.filepath_id
ORDER BY d.file_conf_num DESC", $searchstartdate, $searchstartdate, $searchstartdate, $searchenddate, $searchenddate, $searchenddate));

	// Retrieve for pagination style 
	$query_rsSearchResultDate = $query_fields." ".$query_from.engRepLimit($pageCurr,$pageLines);

	//echo ($query_rsSearchResultDate);

	$rsSearchResultDate = mysql_query($query_rsSearchResultDate) or die(mysql_error());
	$row_rsSearchResultDate = mysql_fetch_assoc($rsSearchResultDate);
	$totalRows_rsSearchResultDate = mysql_num_rows($rsSearchResultDate);  

	// -------- Pagination for Reports ------------
	// Get the count if there is no page defined
	$pageMax = engRepPageMax($pageMax, $pageLines, $query_from, '');
}


// Save Session variables
$_SESSION["pageLines"] = $pageLines;
$_SESSION["pageCurr"]  = $pageCurr;
$_SESSION["pageMax"]   = $pageMax;
// From here for line number use: ($counter++)+engRepCounter()
//  engRepOptions();  for the |< < page of x > >| options
// -------- Pagination for Reports ------------

//End Special List Recordset


//sort column headers for rsSearchResultDate 
$tfm_saveParams = explode(",","startdate,enddate,loaded");
$tfm_keepParams = "";
if($tfm_order == "ASC") 
{
	$tfm_order = "DESC";
}
else
{
	$tfm_order = "ASC";
};
while (list($key,$val) = each($tfm_saveParams)) {
	if(isset($_GET[$val]))$tfm_keepParams .= ($val)."=".urlencode($_GET[$val])."&";	
	if(isset($_POST[$val]))$tfm_keepParams .= ($val)."=".urlencode($_POST[$val])."&";
}
$tfm_orderbyURL = $_SERVER["PHP_SELF"]."?".$tfm_keepParams."tfm_order=".$tfm_order."&tfm_orderby=";
?>
<?php
include($incPath."include/header.php"); 
// JavaScript goes here + + +
?>
<script type="text/javascript"> 
//  Set up jQuery - Now is a good timeto see if it will fly / load up the libraries
$(document).ready(function()
{
	<?php include($incPath.'cr_javascript_graphics.php'); ?>

})
</script>  
<link href="dictation.css" rel="stylesheet" media="screen,,projection" title="default" type="text/css"  /> 
<?php
include($incPath."include/header_divs.php"); 
?>
<div id="topbar">
    <a class="active"><span><div id="bartitle">Dictation</div></span></a>
</div>

<div id="frontpage">
<div id="maintext">

<!--------------------------->
<!-- Liquid Start -->
<!--------------------------->
<div class="colmask rightmenu">
<div class="colleft-wide">
<!--------------------------->
<!-- Column 1 start -->
<!--------------------------->
<div class="col1-wide">

<table cellpadding="5" border="0">
<tbody>
<tr>
  <td>
	<?php echo(displayContainerOutline('<h2>File Transfer Status</h2>'));?>
  </td>
</tr> 
</tbody>
</table>


<TABLE width="99%" border=0 cellPadding=0>
<TBODY>
<TR>
	<TD colSpan=2>
    Choose to search by date range, confirmation number or by <a href="searchaudiobyphys.php"><strong>physician ID &amp; DNIS</strong></a>. 
	</TD>
</TR>

<tr>
  <td>

<form name="form1" method="GET">
<table width="99%" border="0" cellspacing="0" cellpadding="2">

<tr class="body">
	<td width="20%">Select date range:</td>
	<td width="6%">start:</td>
	<td width="22%">
		<span class="bodytextBOLD">
		<input name="startdate" type="text" id="startdate" value="<?php echo $varstartdate; ?>" size="8" />
		<img src='../images/calendar.gif' border='0' align='top' onclick="displayDatePicker('startdate','','mdy');">
		</span>
	</td>
	<td width="24%">- Choose start date range </td>
	<td><a target="_blank"></a></td>
</tr>

<tr>
   <td>&nbsp;</td>
   <td>end:</td>
   <td>
   <span class="bodytextBOLD">
     <input name="enddate" type="text" id="enddate" value="<?php echo $varenddate; ?>" size="8" />
     <img src='../images/calendar.gif' border='0' align='top' onclick="displayDatePicker('enddate','','mdy');">
   </span></td>
   <td>- Choose end date range</td>
   <td>&nbsp;</td>
</tr>

<tr>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
</tr>

<tr>
	<td>&nbsp;</td>
	<td colspan="2">&nbsp;</td>
	<td><input type="submit" name="Submit" value="Get Report" /></td>
	<td>&nbsp;</td>
</tr>

<tr>
	<td colspan="5">Start date searched: <b><?php echo $varstartdate ?></b></td>
</tr>

<tr>
	<td colspan="5">End date searched:&nbsp; <b><?php echo $varenddate ?></b>
	<input name="loaded" type="hidden" id="loaded" value="<?php echo $varloaded; ?>" /></td>
</tr>

<tr>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
	<td>&nbsp;</td>
</tr>

</table>   
</form>   

	
<?php engRepOptions(); ?>
<table width="660" border="0" cellpadding="0" cellspacing="0">
	<tr>
		<td bgcolor="#29386B"><span class="style11"><strong>#</strong></span></td>
		<td bgcolor="#29386B"><span class="style11"><strong>Client ID </strong></span></td>
		<td bgcolor="#29386B"><div align="left">
							  <span class="style11">Last Name </span></div></td>
		<td bgcolor="#29386B"><span class="style11">First Name </span></td>
		<td bgcolor="#29386B"><span class="style11">Conf. #</span></td>
		<td bgcolor="#29386B"><span class="style11">Date</span></td>
		<td bgcolor="#29386B"><span class="style11">Time</span></td>
		<td bgcolor="#29386B"><span class="style11">Web Sts</span></td>
		<td bgcolor="#29386B"><span class="style11">XFer sts</span></td>
	</tr>

<?php 
$counter = 1;
if ($query_rsSearchResultDate != "") 
{
  do 
  { 
	// Alternate colours
	if($SSAdv_m1%$SSAdv_change_every1==0 && $SSAdv_m1>0)
	{
		$SSAdv_k1++;
	}
	$bgcolor = $SSAdv_colors1[$SSAdv_k1%count($SSAdv_colors1)];
	$SSAdv_m1++;
	
	if ($totalRows_rsSearchResultDate == 0) 
	{ // Show if recordset empty 
?>
		<tr class="body">
		  <td colspan="5">No Results Found </td>  
		</tr>
<?php 
	} 
	else 
	{ 
		// Determine if we should create a link depending on the web upload code
		if ($row_rsSearchResultDate['file_status_web'] == "Uploaded") 
		{ 
			// Find the file root for the webside
			// $row_rsSearchResultDate['web_dir_loc']
			// Add the download reference 
			$mWavFile = webDictationFileName($incPath, 
							$_SESSION['userclientid'], 
							$row_rsSearchResultDate['file_name']);
			// Wrap link 
			$mWavLink = webDictationFileLink($mWavFile,
							untack_orig($row_rsSearchResultDate['file_name']),
							'style10');
					
		} 
		else
		{
			// There is not a download link... just display as text
			$mWavLink = $row_rsSearchResultDate['file_status_web'];
						//"<class=\"style10\">".$row_rsSearchResultDate['file_name']."</class>";
			$mWavLink = '<font class="style14">'.
						$row_rsSearchResultDate['file_name']."</font> ".
						// Provide the status of where the file is at
						'<font class="style6">'.
						$row_rsSearchResultDate['file_status_web']."</font>";
		}		

?>  
	<tr class="body">
		<td bgcolor=<?php echo $bgcolor?>><span class="style10"><?php echo ($counter++)+engRepCounter();?></span></td>
		<td div align="center" bgcolor=<?php echo $bgcolor?>>
		  <div align="left"><?php echo $row_rsSearchResultDate['client_name']; ?></div>
		</td>
		<td div align="left" 
			bgcolor=<?php echo $bgcolor?>><span class="style10"><?php echo $row_rsSearchResultDate['physician_last_name']; ?></span></td>
		<td bgcolor=<?php echo $bgcolor?>><span class="style10"><?php echo $row_rsSearchResultDate['physician_first_name']; ?></span></td>
		<td bgcolor=<?php echo $bgcolor?>><span class="style10"><?php echo $row_rsSearchResultDate['file_conf_num']; ?></span></td>
		<td bgcolor=<?php echo $bgcolor?>><span class="style10"><?php echo $row_rsSearchResultDate['file_date_web']; ?></span></td>
		<td bgcolor=<?php echo $bgcolor?>><span class="style10"><?php echo $row_rsSearchResultDate['file_time']; ?></span></td>
		<td bgcolor=<?php echo $bgcolor?>><span class="style10"><?php echo $row_rsSearchResultDate['file_status_web']; ?></span></td>
		<td bgcolor=<?php echo $bgcolor?>><span class="style10"><?php echo $row_rsSearchResultDate['file_status_transcription']; ?></span></td>
	</tr>
	<tr class="body">
		<td bgcolor=<?php echo $bgcolor?> colspan="9" align="right"><?php echo $mWavLink; ?></td>
	</tr>    
	
<?php 
	}

  } while (($rsSearchResultDate != "") and ($row_rsSearchResultDate = mysql_fetch_assoc($rsSearchResultDate))); 
} // if 
?>


</table>

<p>
<?php engRepOptions(); ?>
</p>
<p>&nbsp;</p>
<p>&nbsp;</p>


 <div align="right"></div>
  </td>
</TR>
</TBODY>
</TABLE>


</div>
<!--------------------------->
<!-- Column 1 end -->
<!--------------------------->

<!--------------------------->
<!-- Column 2 start -->
<!--------------------------->
<div class="col2-wide">
<?php include("menusection.php"); ?>
</div>
<!--------------------------->
<!-- Column 2 end -->
<!--------------------------->

</div>
</div>
<!--------------------------->
<!-- Liquid End -->
<!--------------------------->
	
<!-- Footer standard -->
</div>	
</div>
<?php 
include($incPath."include/footer.php");
if ($query_rsSearchResultDate != "") 
{
	mysql_free_result($rsSearchResultDate);
}

?>
