<?php
/*
* TeleFlow Open Dictation
*
* Copyright (C) 2008 engenic (engenic.com)
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with this program; if not, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
* http://www.gnu.org/copyleft/gpl.html
*/
// Includes Section
// Includes Section
require_once("cr_reference.php");
require_once($incPath.'LocalSettings.php'); 
include($incPath."include/session.php");

require_once($websiteLibrary.'calcWorkUnit.php');   
// Dictation specific
require_once($websiteLibrary.'dictationWorkUnit.php'); 


/**
 * User not logged in, redirect to main page
 * automatically.
 */
if(!$session->checkLogin())
{
   header("Location: ".$incPath."cr_main.php");
}



// -------- Pagination for Reports ------------
// Note: Don't forget at the start of this program:  session_start(); 
// Was a page parameter passed
if (isset($_GET['page'])) 
{
  $pageLines  = (isset($_SESSION["pageLines"])) ? $_SESSION["pageLines"] : 0;
  $pageCurr   = (isset($_SESSION["pageCurr"]))  ? $_SESSION["pageCurr"]  : 0;
  $pageMax    = (isset($_SESSION["pageMax"]))   ? $_SESSION["pageMax"]   : 0;
  // Determine the new page to hit
  $pageCurr   = engRepPageSettings($_GET['page'], $pageCurr, $pageMax);
}
else
{
  // Go with new page
  $pageLines  = 100;
  $pageCurr   = 0;
  $pageMax    = -1; // set with count   
}  
// -------- Pagination for Reports ------------


// Standard
$SSAdv_colors1 = array("#EAF2F4","#FFFFFF");
$SSAdv_k1 = 0;
$SSAdv_m1 = 0;
$SSAdv_change_every1 = 1;

$client_id = "";
if (isset($_GET['client_id'])) {
  $client_id = (get_magic_quotes_gpc()) ? $_GET['client_id'] : addslashes($_GET['client_id']);
}

$varloaded = "";
if (isset($_GET['loaded'])) {
  $varloaded = (get_magic_quotes_gpc()) ? $_GET['loaded'] : addslashes($_GET['loaded']);
}

$varSearch_rsPhysicianList = "0";
if (isset($_COOKIE['tfdict_login'])) {
  $varSearch_rsPhysicianList = (get_magic_quotes_gpc()) ? $_COOKIE['tfdict_login'] : addslashes($_COOKIE['tfdict_login']);
}

$searchStr = trim($client_id);

$query_fields = (    
"SELECT 
   * ");
$query_from = (    
"FROM 
   dictate_physician p, 
   dictate_client c, 
   ivrconfig i 
 WHERE 
       p.dictate_client_id = c.dictate_client_id  
   AND p.physician_status  = 'Enabled'  
   AND c.client_name    LIKE '%%$searchStr%%'
   AND c.client_status     = 'Enabled'  
 ORDER BY p.physician_last_name ASC");

// Define two reports 
$query_rsPhysicianList = sprintf($query_fields." ".$query_from.engRepLimit($pageCurr,$pageLines), GetSQLValueString($varSearch_rsPhysicianList, "int"));
 
 
// -------- Pagination for Reports ------------
// Get the count if there is no page defined
$pageMax = engRepPageMax($pageMax, $pageLines, $query_from, '');
// Save Session variables
$_SESSION["pageLines"] = $pageLines;
$_SESSION["pageCurr"]  = $pageCurr;
$_SESSION["pageMax"]   = $pageMax;
// From here for line number use: ($counter++)+engRepCounter()
//  engRepOptions();  for the |< < page of x > >| options
// -------- Pagination for Reports ------------

                     

// Run the query to return lines.                     
$rsPhysicianList     = mysql_query($query_rsPhysicianList) or die(mysql_error());
$row_rsPhysicianList = mysql_fetch_assoc($rsPhysicianList);
$totalRows_rsPhysicianList = mysql_num_rows($rsPhysicianList);

// Debug
//echo "Query: ".$query_rsPhysicianList;
include($incPath."include/header.php"); 
// JavaScript goes here + + +
?>
<script type="text/javascript"> 
//  Set up jQuery - Now is a good timeto see if it will fly / load up the libraries
$(document).ready(function()
{
	<?php include($incPath.'cr_javascript_graphics.php'); ?>

})
</script>  
<link href="dictation.css" rel="stylesheet" media="screen,,projection" title="default" type="text/css"  /> 
<?php
include($incPath."include/header_divs.php"); 
?>
<div id="topbar">
    <a class="active"><span><div id="bartitle">Dictation</div></span></a>
</div>

<div id="frontpage">
<div id="maintext">

<!--------------------------->
<!-- Liquid Start -->
<!--------------------------->
<div class="colmask rightmenu">
<div class="colleft-wide">
<!--------------------------->
<!-- Column 1 start -->
<!--------------------------->
<div class="col1-wide">


<table cellpadding="5" border="0">
<tbody>
<tr>
  <td>
	<?php echo(displayContainerOutline('<h2>Active Physicians</h2>'));?>
  </td>
</tr> 
</tbody>
</table>

<TABLE width="99%" border=0 cellPadding=0>
<TBODY>


<form name="form1" method="GET">
<table width="80%" border="0" cellspacing="0" cellpadding="0">
   <tr>
     <td colSpan=3>&nbsp;</td>
   </tr>

   <tr class="body">
     <td width="30%">Limit to Client:</td>
     <td width="30%"><input name="client_id" type="text" id="client_id" value="<?php echo $client_id ?>" size="10"/></td>
     <td width="40%"><input type="submit" name="Submit" value="Update" /></td>
   </tr>

   <tr>
     <td><input name="loaded" type="hidden" id="loaded" value="<?php echo $varloaded; ?>" /></td>
     <td>&nbsp;</td>
     <td>&nbsp;</td>
   </tr>

   <tr>
     <td colSpan=3>Select a physician to modify the details</td>
   </tr>

   <tr>
     <td colSpan=3>&nbsp;</td>
   </tr>

</table> 
</form>   


<TD align=left vAlign=top><table width="100%" border="0" cellspacing="0" cellpadding="0">
    <tr>
      <td><?php engRepOptions(); ?>&nbsp;</td>
    </tr>
    <td>
    <table width="100%" border="0" cellspacing="0" cellpadding="0">
      <tr>
        <td width="5%" bgcolor="#29386B" class="style4">#</td>
        <td width="20%" bgcolor="#29386B"><span class="style4">Last Name </span></td>
        <td width="15%" bgcolor="#29386B"><span class="style4">First Name </span></td>
        <td width="10%" bgcolor="#29386B"><span class="style4">Phys ID </span></td>
        <td width="30%" bgcolor="#29386B"><span class="style4">Client ID </span></td>
        <td             bgcolor="#29386B"><span class="style4">File Link </span></td>
      </tr>

<?php $counter = 1; ?>
<?php do { ?>
		<tr bgcolor="<?php
if($SSAdv_m1%$SSAdv_change_every1==0 && $SSAdv_m1>0){
$SSAdv_k1++;
}
print $SSAdv_colors1[$SSAdv_k1%count($SSAdv_colors1)];
$SSAdv_m1++;
?>" class="body">

  <?php if ($totalRows_rsPhysicianList == 0) { // Show if recordset empty ?>
          <td colspan="3">No Results Found </td>
          <td>&nbsp;</td>
          <td>&nbsp;</td>
          <td>&nbsp;</td>
          <?php } else { ?>


 	<td><?php echo ($counter++)+engRepCounter(); ?></td>
 	<td><a href="updatephysician.php?dp_id=<?php echo $row_rsPhysicianList['dp_id']; ?>"><?php echo $row_rsPhysicianList['physician_last_name']; ?></a></td>
    <td><?php echo $row_rsPhysicianList['physician_first_name']; ?></td>
    <td><?php echo $row_rsPhysicianList['dictate_physician_id']; ?></td>
    <td><?php echo $row_rsPhysicianList['client_name']; ?></td>
    <td>
	<a href="<?php echo webPhysicianFileName($incPath, $_SESSION['userclientid'], $row_rsPhysicianList['physician_name_file']); ?>">Physician Name WAV </a></td>
    <?php }} while ($row_rsPhysicianList = mysql_fetch_assoc($rsPhysicianList)); ?></tr>

      <tr>
        <td>&nbsp;</td>
        <td>&nbsp;</td>
        <td></td>
        <td>&nbsp;</td>
        <td>&nbsp;</td>
        <td>&nbsp;</td>
      </tr>
    </table>      
      <?php engRepOptions(); ?>
      <p></p>
      <p>&nbsp;</p>
      <p>&nbsp;</p></td>
  </tr>
</table>
  <div align="right"></div></TD>
</TR></TBODY></TABLE>

</div>
<!--------------------------->
<!-- Column 1 end -->
<!--------------------------->

<!--------------------------->
<!-- Column 2 start -->
<!--------------------------->
<div class="col2-wide">
<?php include("menusection.php"); ?>
</div>
<!--------------------------->
<!-- Column 2 end -->
<!--------------------------->

</div>
</div>
<!--------------------------->
<!-- Liquid End -->
<!--------------------------->
	
<!-- Footer standard -->
</div>	
</div>
<?php 
include($incPath."include/footer.php");
mysql_free_result($rsPhysicianList);
?>
