<?php
/*
* TeleFlow Dictation
*
* Copyright (C) 2008 engenic (engenic.com)
*
* This program is NOT FREE software; you may purchase a licence from engenic
*/

/* xml_dictations
-- Enables the client to get a list of all the dictations that have happened.

NOTE:  The is a test program for running these commands easily:  HTTPXMLPost.exe
-- This program also stores the XML statements and results (Quite useful for testing this PHP)
 
XML examples
URL: http://127.0.0.1/host/xml_dictations.php

Body
<?xml version="1.0" encoding="utf-8"?><REQUEST action="DictationLast"></REQUEST>

Refer to documentation at http://teleflow.org for more information
*/

// Samples
// <REQUEST action="ListDateCount" date="2008/04/07"></REQUEST>
// <REQUEST action="ListDateSummary" date="2008/04/07"></REQUEST>
// <REQUEST action="ListDateDetail" date="2008/04/07"></REQUEST>

// <REQUEST action="ListDateDetail" date="2008/04/07" timestart="10:00:00"  timeend="11:00:00"></REQUEST>
// <REQUEST action="ListDateDetail" date="2008/04/09" timeend="04:35:00"></REQUEST>

//  <REQUEST action="ListSingleDictation" confid="123456"></REQUEST>
// Includes Section
require_once("cr_reference.php");
require_once($incPath.'LocalSettings.php'); 
require($incPath."include/session.php");
require_once($websiteLibrary.'calcWorkUnit.php'); 


// Constants
$cSysName   = 'xml_dictations';

$cUnknown   = "Unknown";
$cAdded     = "Added";
$cModified  = "Modified";
$cFailed    = "Failed";
$cDeleted   = "Deleted";
$cDataErr   = "DataError";
$cExists    = "Exists";
$cNotFound  = "NotFound";

// Determine how much output we should see
$OutPutMode   = TRUE;


////////////////// FUNCTIONS //////////////////
function decho($pText)
{ 
   //if (!IsSet($OutPutMode))
   //{
   //  echo "CANT SEE YOU!!<BR>";
   //}
   //if ($OutPutMode == TRUE)
   { 
      //echo ($pText);
   }
}  



/////////////////////////// MAIN ///////////////////////////////

// Get the full request
$data         = file_get_contents("php://input");
//$data         = file_get_contents("test_sendtest.xml");  // Debug

// Resposnes provided by the PHP program
$responsecode = "";
$xmlresult    = "<RESULT>ERROR Database or other failure</RESULT>";

// Record statuses
$dnisstatus   = $cUnknown;
$clientstatus = $cUnknown;
$client_pk    = -1;
$physstatus   = $cUnknown;


// Date and Time defaults
$teleflowDate = Date("Y/m/d");
$teleflowTime = Date("H:i:s");
     // yyyy/mm/dd ==> mm/dd/yyyy
$webDate      = Date("m/d/Y");


//echo("<BR><BR>".$data."<BR><BR>");
decho("STARTED at ".teleflowNowDate()." ".teleflowNowTime()." (".$webDate.")<BR>");

// Set up file names
$stmp        = date("Y-m-d_H-i-s");
$fold        = "log/";
// Create the log folder
if (!is_dir($fold))
{
    mkdir($fold);
}
$reqf        = $fold.$cSysName."_".$stmp."_request.xml";
$resf        = $fold.$cSysName."_".$stmp."_response.xml";
            


// Assume an XML document, and process...
$doc = new DOMDocument();

$request_Command = '';
// Did the user actually send a request?
if ($data <> '')
{
   $doc->loadXML($data);
   // save it for later review
   $doc->save($reqf);

   // XML Command request
   // -- Find out what the command is (Must be a REQUEST)
   $theFile = $doc->getElementsByTagName('REQUEST')->item(0);

   if ($theFile->hasAttribute('action'))
   {
      $request_Command    = $theFile->getAttribute('action');
   }
}

// Create the Result XML document
$docresult = new DOMDocument('1.0', 'utf-8');

// Wrap the request
$elementHolder  = $docresult->createElement("RESPONSE", "");
$elementHolder->setAttribute("action", "Invalid"); 
// Default 
$elementResult      = $docresult->createElement("RESULT", "Nothing");  // Used for all results


// Review the requested Command
if ($request_Command <> "") 
{
	$refClientId = -1;
	// Is this command authorized to work?
	$mIP = getClientIpAddress();
	if (!$database->selectByIPAddressClientDatabase($mIP, $refClientId))
	{
		$responsecode = "ERROR: Failed to Authorize IP address ".$mIP;
		$elementResult  = $docresult->createElement("RESULT", $responsecode);
	}
	else
	{
      
      // Process commands
      /////////////////////////////////////////////////////////
      if ($request_Command == "ListDateCount")
      /////////////////////////////////////////////////////////
      {
         $responsecode = "ListDateCount";
         $elementHolder->setAttribute("action", $request_Command); 

         // Get the Attibutes (Fields)
         $reqListDateCount_date         = $theFile->getAttribute('date');
         
         // Are all the fields populated
         if ($reqListDateCount_date <> "" )
         {
           // Were good to go...
           decho("Date: ".$reqListDateCount_date."<BR>");

           
           // Do we have the Client yet?
           // select count(*) from dictate_file  WHERE file_date = "2008/04/07"
           $q = "SELECT             
                    count(*) exist,
                    max(file_time) filetime
                 FROM 
                    dictate_file  
                 WHERE             
                     file_date = '$reqListDateCount_date'
                 ";

           //echo $q."<br><br>";
           $result = mysql_query($q) or die(mysql_error());
           

           // Provide the result
           if ($result) 
           {
              // Final results
              $row_resultList     = mysql_fetch_assoc($result);
              $totalRows_result   = mysql_num_rows($result);
              //$responsecode = "ERROR: Dictation Last Database Error";
              $elementResult  = $docresult->createElement("Total", $row_resultList['exist']);
              $elementResult ->setAttribute("LastEntryTime",  $row_resultList['filetime']);
           }
           
         }
      }
      /////////////////////////////////////////////////////////
      else if ($request_Command == "ListDateSummary")
      /////////////////////////////////////////////////////////
      {
         $responsecode = "ListDateSummary";
         $elementHolder->setAttribute("action", $request_Command); 

         // Get the Attibutes (Fields)
         $reqListDateSummary_date         = $theFile->getAttribute('date');
         
         // Are all the fields populated
         if ($reqListDateSummary_date <> "" )
         {
           // Were good to go...
           decho("Date: ".$reqListDateSummary_date."<BR>");
           
           // Do we have the Client yet?
           // select count(*) from dictate_file  WHERE file_date = "2008/04/07"
           $q = "SELECT     
                    file_status_transcription sts,
                    count(file_status_transcription) exist 
                 FROM 
                    dictate_file  
                 WHERE             
                     file_date = '$reqListDateSummary_date'
                 GROUP BY file_status_transcription    
                 ";
      
           //echo $q."<br><br>";
           $result = mysql_query($q) or die(mysql_error());
           

           // Provide the result
           if ($result) 
           {
              // Final results
              $totalRows_result   = mysql_num_rows($result);
              
              $elementResult  = $docresult->createElement("DateSummary", "");
              while ($row_resultList = mysql_fetch_assoc($result))
              {
                $elementChild  = $docresult->createElement("Dictations", $row_resultList['exist']);
                $elementChild ->setAttribute("Status",  $row_resultList['sts']);
                $elementResult->appendChild($elementChild);
              } ;
           }
           
         }
      }
      /////////////////////////////////////////////////////////
      else if ($request_Command == "ListDateDetail")
      /////////////////////////////////////////////////////////
      {
         $responsecode = "ListDateDetail";
         $elementHolder->setAttribute("action", $request_Command); 

         // Get the Attibutes (Fields)
         $reqListDateDetail_date         = $theFile->getAttribute('date');
         $reqListDateDetail_timeStart    = $theFile->getAttribute('timestart');
         $reqListDateDetail_timeEnd      = $theFile->getAttribute('timeend');
          
         
         // Are all the fields populated
         if ($reqListDateDetail_date <> "" )
         {
           // Were good to go...
           decho("Date: ".$reqListDateDetail_date."<BR>");
           
           // Make sure we have a valid end date
           if ($reqListDateDetail_timeEnd == '')
           {
              $reqListDateDetail_timeEnd ='99:99:99';
           }
           // <REQUEST action="ListDateSummary" date="2008/04/08"></REQUEST>
           
           
           
           // Do we have the Client yet?
           // select count(*) from dictate_file  WHERE file_date = "2008/04/07"
           $q = "SELECT     
                    file_id,
                    file_conf_num,
                    file_date_web,
                    file_time,
                    dictate_client_id,
                    dictate_physician_id,
                    call_dnis,
                    file_status_transcription,
                    file_name
                 FROM 
                    dictate_file  
                 WHERE             
                     file_date =  '$reqListDateDetail_date'
                 and file_time >= '$reqListDateDetail_timeStart'
                 and file_time <= '$reqListDateDetail_timeEnd'
                 ";
      
           //echo $q."<br><br>";
           $result = mysql_query($q) or die(mysql_error());
           

           // Provide the result
           if ($result) 
           {
              // Final results
              $totalRows_result   = mysql_num_rows($result);
              
              $elementResult  = $docresult->createElement("DateDetail", "");
              while ($row_resultList = mysql_fetch_assoc($result))
              {
                $elementChild  = $docresult->createElement("Dictation", $row_resultList['file_id']);
                $elementChild ->setAttribute("ConfId",    $row_resultList['file_conf_num']);
                $elementChild ->setAttribute("FileDate",  $row_resultList['file_date_web']);
                $elementChild ->setAttribute("FileTime",  $row_resultList['file_time']);
                $elementChild ->setAttribute("ClientId",  $row_resultList['dictate_client_id']);
                $elementChild ->setAttribute("PhysId",    $row_resultList['dictate_physician_id']);
                $elementChild ->setAttribute("DNIS",      $row_resultList['call_dnis']);
                $elementChild ->setAttribute("Status",    $row_resultList['file_status_transcription']);
                $elementChild ->setAttribute("File",      $row_resultList['file_name']);
                $elementResult->appendChild($elementChild);
              } ;
           }
           
         }
      }
      /////////////////////////////////////////////////////////
      else if ($request_Command == "ListSingleDictation")
      /////////////////////////////////////////////////////////
      {
         $responsecode = "ListSingleDictation";
         $elementHolder->setAttribute("action", $request_Command); 

         // Get the Attibutes (Fields)
         $reqListSingleDictation_confid         = $theFile->getAttribute('confid');
          
         
         // Are all the fields populated
         if ($reqListSingleDictation_confid <> "" )
         {
           // Were good to go...
           decho("ConfId: ".$reqListSingleDictation_confid."<BR>");
           
           // select count(*) from dictate_file  WHERE file_date = "2008/04/07"
           $q = "SELECT     
                    file_id,
                    file_date_web,
                    file_time,
                    dictate_client_id,
                    dictate_physician_id,
                    call_dnis,
                    file_status_transcription,
                    file_name
                 FROM 
                    dictate_file  
                 WHERE             
                     file_conf_num =  '$reqListSingleDictation_confid'
                 ";
      
           //echo $q."<br><br>";
           $result = mysql_query($q) or die(mysql_error());
           
           // Provide the result
           if ($result) 
           {
              // Final results
              $row_resultList     = mysql_fetch_assoc($result);
              $totalRows_result   = mysql_num_rows($result);
              
              $elementResult  = $docresult->createElement("Dictation", $row_resultList['file_id']);
              if ($totalRows_result > 0) 
              {
                 //$responsecode = "ERROR: Dictation Last Database Error";
                 $elementResult ->setAttribute("LastEntryTime",   $row_resultList['file_time']);
                 $elementResult ->setAttribute("FileDate",        $row_resultList['file_date_web']);
                 $elementResult ->setAttribute("FileTime",        $row_resultList['file_time']);
                 $elementResult ->setAttribute("ClientId",        $row_resultList['dictate_client_id']);
                 $elementResult ->setAttribute("PhysId",          $row_resultList['dictate_physician_id']);
                 $elementResult ->setAttribute("DNIS",            $row_resultList['call_dnis']);
                 $elementResult ->setAttribute("Status",          $row_resultList['file_status_transcription']);
                 $elementResult ->setAttribute("File",            $row_resultList['file_name']);
              }
              else
              {
                 $elementResult ->setAttribute("Status",          'DoesNotExist');
              }
           }                                             

         }
      }

      /////////////////////////////////////////////////////////
      else
      /////////////////////////////////////////////////////////
      {
        decho("BAD COMMAND<BR>");
        $elementHolder->setAttribute("action", $request_Command);
        // Final results
        $responsecode = "ERROR: Unknown Command";
        $elementResult  = $docresult->createElement("RESULT", $responsecode);
      }
   }
   
   // Put the results on the screen.
   // Add the DNIS info
   if ($request_Command == "Add") 
   {
      decho("RESULT: DNIS=".$dnisstatus."<BR>");
      // Final results
      $responsecode = "SUCCESS";
      if ($dnisstatus != $cUnknown)
      {
         $elementResultDNIS  = $docresult->createElement("RESULT", $dnisstatus);
         $elementResultDNIS->setAttribute("DNIS",  $reqPhysician_clientid);
         // Add the child here
         $elementHolder->appendChild($elementResultDNIS);
      }
   }
   // Add Physician info
   if (($request_Command == "Add") || ($request_Command == "Modify") || ($request_Command == "Delete"))
   {
      decho("RESULT: Client=".$clientstatus."<BR>");
      decho("RESULT: Physician=".$physstatus."<BR>");
      // Final results
      $responsecode = "SUCCESS";
      $elementResult  = $docresult->createElement("RESULT", $physstatus);
      $elementResult->setAttribute("PhysicianID",    $reqPhysician_id);
      $elementResult->setAttribute("ClientID",       $reqPhysician_clientid);
      $elementResult->setAttribute("ClientStatus",   $clientstatus);
   }
}
else
{
   decho("NO COMMAND Provided<BR>");
   $elementHolder->setAttribute("action", "NotDefined");
   // Final results
   $responsecode = "ERROR: No Command Provided";
   $elementResult  = $docresult->createElement("RESULT", $responsecode);
}

// Put it all together
$elementHolder->appendChild($elementResult);
$docresult->appendChild($elementHolder);
// Save to Log dir .. if there was a request
if ($request_Command <> "") 
{
    $docresult->save($resf);
}

// Return results
echo $docresult->saveHTML();   // Displays out to the screen

                                    
?> 

<?php
 // mysql_free_result($result);
?>