<?php
/*
* TeleFlow Open Dictation
*
* Copyright (C) 2008 engenic (engenic.com)
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with this program; if not, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
* http://www.gnu.org/copyleft/gpl.html
*/

/* syscommand
-- Enables the client to create Clients and Physicians

The following commands can be sent:
* add
* modify
* delete
* dictationlast
 
NOTE:  The is a test program for running these commands easily:  HTTPXMLPost.exe
-- This program also stores the XML statements and results (Quite useful for testing this PHP)
 
XML examples
URL: http://127.0.0.1/host/syscommand.php

Body
<?xml version="1.0" encoding="utf-8"?><REQUEST action="DictationLast"></REQUEST>

Refer to documentation at http://teleflow.org for more information
*/
// Includes Section
require_once("cr_reference.php");
require_once($incPath.'LocalSettings.php');
require($incPath."include/session.php"); 
require_once($websiteLibrary.'calcWorkUnit.php'); 


// Constants
$cUnknown   = "Unknown";
$cAdded     = "Added";
$cModified  = "Modified";
$cFailed    = "Failed";
$cDeleted   = "Deleted";
$cDataErr   = "DataError";
$cExists    = "Exists";
$cNotFound  = "NotFound";

// Determine how much output we shoudl see
$OutPutMode   = TRUE;

$cBr		= '<br />';


////////////////// FUNCTIONS //////////////////

function decho($pText)
{ 
   //if (!IsSet($OutPutMode))
   //{
   //  echo "CANT SEE YOU!!<BR>";
   //}
   //if ($OutPutMode == TRUE)
   { 
      echo ($pText);
   }
}  


//
function tfVoiceOfficeProcess($reqPhysician_dnis, $pAppTypeName, $pClientId)
{
    // - - - - - - - - - - - - - - - - NOTE  TFVO  START- - - - - - - - - - - - - - - - - - - - 
    // - - - - - - - - - - - - - - - - NOTE  TFVO  START- - - - - - - - - - - - - - - - - - - - 
    // Check to see that the client is in TFVO 
    // Note: This is done because each client is assigned their own DNIS. 
    global $database;
	
    // Open up the scope of the variables
    global $cUnknown,  
           $cAdded,   
           $cModified, 
           $cFailed,   
           $cDeleted,  
           $cDataErr,  
           $cExists,   
           $cNotFound;
         
	/*
    // Find the application ID (Must exist if we are to add)
    $q =  "select   "
         ."  application_type_id  "
         ."from  "
         ."  application_type  "
         ."where  "
         ."  app_type_name = '$appSysName' "
         ."";
         
    $result = mysql_query($q) or die(mysql_error());
    if (!$result) 
    {
       // Make it put something in there
       $appTypeId = '20';
    }
    else
    {
       $row_resultList  = mysql_fetch_assoc($result);
       $appTypeId       = $row_resultList['application_type_id'];
    }
    mysql_free_result($result);
    */

    // Find the service Name
    $q =  "
SELECT 
   count(*) exist
FROM                      
   ".DATABASE_MASTER.".dnis_service
WHERE
    app_type_name = '$pAppTypeName'
and client_id     = $pClientId
and dnis_status   = 'ACTIVE'
and service_dnis  = '$reqPhysician_dnis' ";
//echo ($q); die;
	$result = mysql_query($q, $database->connectionSystem) or die(mysql_error());

	$row_resultList     = mysql_fetch_assoc($result);
	$totalRows_result   = mysql_num_rows($result);

	// Do we add the Client 
	if ($row_resultList['exist'] == 0) 
	{
		// Add the new DNIS entry
		$qIns = "
INSERT INTO 
  ".DATABASE_MASTER.".dnis_service 
  (   
    app_type_name, 
    client_id,
	dnis_status,
	tel_connect_delay,
	db_pre_connect_yn,
	srtt_type,
	srtt_engine,
    service_dnis,
    service_phone_number, 
    max_service_instances 
  )    
VALUES 
  (    
    '$pAppTypeName',
    $pClientId, 
	'ACTIVE',
	1000,
	'Y',
	'TT',
	'NONE',
    '$reqPhysician_dnis',
    '$reqPhysician_dnis', 
    -1 
  )";
		//echo $qIns; die;
		// Run command ?
		$result = mysql_query($qIns, $database->connectionSystem);
		// What happened?
		if ($result == TRUE)
		{
			decho("Client TFVO Insert Success<BR>");
			$dnisstatus   = $cAdded;
		}
		else
		{
			decho("Client TFVO Insert Failed<BR>");
			$dnisstatus   = $cFailed;
			$clientstatus = $cFailed;
		}
	}
	else
	{
		$dnisstatus = $cExists;
	}

	return $dnisstatus;
	// - - - - - - - - - - - - - - - - NOTE  TFVO  END- - - - - - - - - - - - - - - - - - - - 
	// - - - - - - - - - - - - - - - - NOTE  TFVO  END- - - - - - - - - - - - - - - - - - - - 

}  // tfVoiceOfficeProcess
?>




<?php

/////////////////////////// MAIN ///////////////////////////////


// Get the full request
$data         = file_get_contents("php://input");
//$data         = file_get_contents("test_sendtest.xml");  // Debug

// Resposnes provided by the PHP program
$responsecode = "";
$xmlresult    = "<RESULT>ERROR Database or other failure</RESULT>";

// Record statuses
$dnisstatus   = $cUnknown;
$clientstatus = $cUnknown;
$client_pk    = -1;
$physstatus   = $cUnknown;


// Date and Time defaults
$teleflowDate = Date("Y/m/d");
$teleflowTime = Date("H:i:s");
     // yyyy/mm/dd ==> mm/dd/yyyy
$webDate      = Date("m/d/Y");


//echo("<BR><BR>".$data."<BR><BR>");
decho("STARTED at ".teleflowNowDate()." ".teleflowNowTime()." (".$webDate.")<BR>");

// Set up file names
$stmp        = date("Y-m-d_H-i-s");
$fold        = "log/";
// Create the log folder
if (!is_dir($fold))
{
    mkdir($fold);
}
$reqf        = $fold."xml_syscommand_".$stmp."_request.xml";
$resf        = $fold."xml_syscommand_".$stmp."_response.xml";
            


// Assume an XML document, and process...
$doc = new DOMDocument();

$request_Command = '';
if ($data <> '')
{
   $doc->loadXML($data);
   // save it for later review
   $doc->save($reqf);

   // XML Command request
   // -- Find out what the command is (Must be a REQUEST)
   $theFile = $doc->getElementsByTagName('REQUEST')->item(0);

   if ($theFile->hasAttribute('action'))
   {
      $request_Command    = $theFile->getAttribute('action');
   }
}

// Create the Result XML document
$docresult = new DOMDocument('1.0', 'utf-8');
// Wrap the request
$elementHolder  = $docresult->createElement("RESPONSE", "");
$elementHolder->setAttribute("action", "Invalid"); 
// Default relust nothing
$elementResult      = $docresult->createElement("RESULT", "Nothing");  // Used for all results
$elementResultDNIS  = $docresult->createElement("RESULT", "Nothing");  // Used for ADD


// Review the requested Command
if ($request_Command <> "") 
{
	$refClientId = -1;
	
	// Is this command authorized to work?
	$mIP = getClientIpAddress();
	// Will return the client id for use
	if (!$database->selectByIPAddressClientDatabase($mIP, $refClientId))
	{
		$responsecode = "ERROR: Failed to Authorize IP address ".$mIP;
		$elementResult  = $docresult->createElement("RESULT", $responsecode);
		$elementResult->setAttribute("ipaddress",    $mIP);
	}
	else
	{
      // Process commands
      /////////////////////////////////////////////////////////
      if ($request_Command == "Add")
      /////////////////////////////////////////////////////////
      {
         decho ("ADD Physician<BR>");
         $responsecode = "Add Physician";
         $elementHolder->setAttribute("action", $request_Command); 

         
         // Break out the Physician section
         $request_Physician  = $theFile->getElementsByTagName("PHYSICIAN")->item(0)->nodeValue;

         // Get the Attibutes (Fields)
         $reqPhysician_id         = $theFile->getElementsByTagName("PHYSICIAN")->item(0)->getAttribute('id');  
         $reqPhysician_firstname  = $theFile->getElementsByTagName("PHYSICIAN")->item(0)->getAttribute('firstname');
         $reqPhysician_lastname   = $theFile->getElementsByTagName("PHYSICIAN")->item(0)->getAttribute('lastname');
         $reqPhysician_clientdnis = $theFile->getElementsByTagName("PHYSICIAN")->item(0)->getAttribute('clientid'); 
         $reqPhysician_clientname = $theFile->getElementsByTagName("PHYSICIAN")->item(0)->getAttribute('clientname'); 

         // Are all the fields populated
         if (($reqPhysician_id <> "" ) and 
             ($reqPhysician_firstname <> "" ) and 
             ($reqPhysician_lastname <> "" ) and 
             ($reqPhysician_clientdnis <> "" ) and 
             ($reqPhysician_clientname <> "" ))
         {
           // Were good to go...
           decho("Physician: ".$reqPhysician_id.$cBr);
           decho("Physician: ".$reqPhysician_firstname.$cBr);
           decho("Physician: ".$reqPhysician_lastname.$cBr);
           decho("Physician: ".$reqPhysician_clientdnis.$cBr);
           decho("Physician: ".$reqPhysician_clientname.$cBr);

           
           // Do we have the Client yet?
           $q = "
SELECT    
   count(*) exist
FROM    
   dictate_client 
WHERE   
     client_dnis = '$reqPhysician_clientdnis'
 and client_name = '$reqPhysician_clientname'";

           //echo $q."<br><br>";
           $result = mysql_query($q) or die(mysql_error());
           
           $row_resultList     = mysql_fetch_assoc($result);
           $totalRows_result   = mysql_num_rows($result);
 
           // Do we add the Client 
           if ($row_resultList['exist'] == 0) 
           {
              // Insert Client information into the TFVoiceOffice database (including rollover db)
              $dnisstatus    = tfVoiceOfficeProcess("$reqPhysician_clientdnis", "MEDTEK_DICTATION", $refClientId);

              // If we succeeded
              if (($dnisstatus == $cAdded) || ($dnisstatus == $cExists))
              {
                 // Insert the new Client 
                 //////////////////////
                 $qIns =  "
INSERT INTO 
  dictate_client 
  ( 
    client_dnis,  
    client_name,  
    client_create_date,
    client_create_date_web, 
    client_create_time,     
    client_needs_record,    
    file_transfer_status,   
    client_requires_mrn,    
    client_report_digits,    
    client_no_action_timeout 
  )    
VALUES 
 (     
    '$reqPhysician_clientdnis', 
    '$reqPhysician_clientname', 
    '$teleflowDate', 
    '$webDate',      
    '$teleflowTime', 
    'N',             
    'NA',            
    'N', 
    1,   
    120  
  )";
                 //decho($qIns."<br><br>");
                 
                 // Run command ?
                 $result = mysql_query($qIns);
                 // What happened?
                 if ($result == TRUE)
                 {
                      decho("Client Insert Success<BR>");
                      $clientstatus = $cAdded;
                 }
                 else
                 {
                      decho("Client Insert Failed<BR>");
                      $clientstatus = $cFailed;
                 }
              }
           }
           else
           {
              decho("Client Already Exists<BR>");
              $clientstatus = $cExists;
           }
           
           // Continue with Physician inssert
           //////////////////////////////
           if (($clientstatus == $cExists) || ($clientstatus == $cAdded))
           {
              // Get the PK
              $q =  "
SELECT 
   dictate_client_id  
FROM              
   dictate_client  
WHERE                  
     client_dnis = '$reqPhysician_clientdnis' 
 and client_name = '$reqPhysician_clientname' ";                 
              $result = mysql_query($q);
              
              if (!$result) 
              {
                 // This shouldnt happen
                 decho("Physician Insert Database Error<BR>");
                 $physstatus = $cDataErr;
              }
              else
              {
                 $row_resultList     = mysql_fetch_assoc($result);
                      
                 $client_pk = $row_resultList['dictate_client_id'];

                 decho("Client PK: ".$client_pk.$cBr); 

                 // See if the physician already exists 
                 $q = " 
SELECT 
    count(*) exist 
FROM  
    dictate_physician 
WHERE 
    dictate_client_id    =  $client_pk 
and dictate_physician_id = '$reqPhysician_id' 
and physician_status     = 'Enabled' ";

                 $result = mysql_query($q);
                 $row_resultList     = mysql_fetch_assoc($result);
                 
                 // If Physician does not exist, insert it
                 if ($row_resultList['exist'] == 0) 
                 {
                    // Insert the new Client 
                    $qIns =  "
INSERT INTO 
  dictate_physician  
  ( 
    dictate_client_id, 
    dictate_physician_id,  
    physician_last_name,   
    physician_first_name,  
    physician_number, 
    physician_status,
    physician_needs_record,
    file_transfer_status   
  )          
VALUES       
  (          
    $client_pk, 
    '$reqPhysician_id', 
    '$reqPhysician_lastname', 
    '$reqPhysician_firstname', 
    '$reqPhysician_id', 
    'Enabled',  
    'N', 
    'NA'               
   )";

                    //decho($qIns."<br><br>");
                    
                    // Run command ?
                    $result = mysql_query($qIns);
                    // What happened?
                    if ($result == TRUE) 
                    {
                         decho("Physician Insert Success<BR>");
                         $physstatus = $cAdded;
                    }
                    else
                    {
                         decho("Physician Insert Failed<BR>");
                         $physstatus = $cFailed;
                    }                 
                 }
                 else
                 {
                    decho("Physician Already Exists<BR>");
                    $physstatus = $cExists;              
                    
                    //  Was the Physican deleted before
                    // Note:  This is now redundant... but, I dont want to make too many changes.
                    $q = " 
SELECT            
    physician_status 
FROM   
    dictate_physician             
WHERE 
    dictate_client_id    = $client_pk 
and dictate_physician_id = '$reqPhysician_id' 
and physician_status     = 'Enabled' 
";
                    $result = mysql_query($q);
                         
                    if (!$result) 
                    {
                       // This shouldnt happen
                       decho("Physician Add Database Error<BR>");
                       $physstatus = $cDataErr;
                    }
                    else
                    {
                       $row_resultList   = mysql_fetch_assoc($result);
                       $responsecode     = "Physician Status is ".$row_resultList['physician_status'];
                       decho($responsecode.$cBr);
                    }
                 }
              }   
           }
         }
         else
         {
            $responsecode = "ERROR: Insufficient parameters for Add";
         }

      }
      /////////////////////////////////////////////////////////
      else if ($request_Command == "Modify")
      /////////////////////////////////////////////////////////
      {
         decho("MODIFY Physician<BR>");
         $responsecode = "Modify Physician";
         $elementHolder->setAttribute("action", $request_Command); 
         
         // Break out the Physician section
         $request_Physician  = $theFile->getElementsByTagName("PHYSICIAN")->item(0)->nodeValue;

         // Get the Attibutes (Fields)
         $reqPhysician_id         = $theFile->getElementsByTagName("PHYSICIAN")->item(0)->getAttribute('id');  
         $reqPhysician_firstname  = $theFile->getElementsByTagName("PHYSICIAN")->item(0)->getAttribute('firstname');
         $reqPhysician_lastname   = $theFile->getElementsByTagName("PHYSICIAN")->item(0)->getAttribute('lastname');
         $reqPhysician_clientdnis = $theFile->getElementsByTagName("PHYSICIAN")->item(0)->getAttribute('clientid'); 
         $reqPhysician_clientname = $theFile->getElementsByTagName("PHYSICIAN")->item(0)->getAttribute('clientname'); 

         // Are all the fields populated
         if (($reqPhysician_id <> "" ) and 
             ($reqPhysician_firstname <> "" ) and 
             ($reqPhysician_lastname <> "" ) and 
             ($reqPhysician_clientdnis <> "" ) and 
             ($reqPhysician_clientname <> "" ))
         {
           // Were good to go...
           decho("Phsyician: ".$reqPhysician_id.$cBr);
           decho("Phsyician: ".$reqPhysician_firstname.$cBr);
           decho("Phsyician: ".$reqPhysician_lastname.$cBr);
           decho("Phsyician: ".$reqPhysician_clientdnis.$cBr);
           decho("Phsyician: ".$reqPhysician_clientname.$cBr);

           // Get the PK
           $q =  "
SELECT 
   dictate_client_id 
FROM 
   dictate_client 
WHERE 
     client_dnis = '$reqPhysician_clientdnis'
 and client_name = '$reqPhysician_clientname' ";                 
           $result = mysql_query($q);

           if (!$result) 
           {
              // This shouldnt happen
              decho("Physician Delete Database Error<BR>");
              $physstatus = $cDataErr;
           }
           else
           {
              $row_resultList     = mysql_fetch_assoc($result);
                   
              $client_pk = $row_resultList['dictate_client_id'];
              decho("Client PK: ".$client_pk.$cBr); 
              $clientstatus = $cExists;

              // See if the physician already exists 
              $q =  "
SELECT 
    count(*) exist 
FROM  
    dictate_physician 
WHERE 
    dictate_client_id    = $client_pk 
and dictate_physician_id = '$reqPhysician_id'
and physician_status     = 'Enabled' ";
              $result = mysql_query($q);
              $row_resultList     = mysql_fetch_assoc($result);
              
              // If Physician does not exist, modify
              if ($row_resultList['exist'] > 0) 
              {
                 // Update the Physician
                 $qUpd = "
UPDATE 
  dictate_physician 
SET 
  physician_last_name  =  '$reqPhysician_lastname', 
  physician_first_name =  '$reqPhysician_firstname' 
WHERE 
    dictate_client_id    = $client_pk 
and dictate_physician_id = '$reqPhysician_id' 
and physician_status     = 'Enabled' ";

                        // Run command ?
                 $result = mysql_query($qUpd);
                 // What happened?
                 if ($result == TRUE) 
                 {
                      decho("Physician Modify Success<BR>");
                      $physstatus = $cModified;
                 }
                 else
                 {
                      decho("Physician Modify Failed<BR>");
                      $physstatus = $cFailed;
                 }                 
              }
              else
              {
                 // Does not exist
                 $physstatus = $cNotFound;           
              }
           }
         }
         else
         {
            $responsecode = "ERROR: Insufficient parameters for Modify";
         }
      }
      /////////////////////////////////////////////////////////
      else if ($request_Command == "Delete")
      /////////////////////////////////////////////////////////
      {
         decho("DELETE Physician<BR>");
         $responsecode = "Delete Physician";
         $elementHolder->setAttribute("action", $request_Command); 
         
         // Break out the Physician section
         $request_Physician  = $theFile->getElementsByTagName("PHYSICIAN")->item(0)->nodeValue;

         // Get the Attibutes (Fields)
         $reqPhysician_id         = $theFile->getElementsByTagName("PHYSICIAN")->item(0)->getAttribute('id');  
         $reqPhysician_clientdnis = $theFile->getElementsByTagName("PHYSICIAN")->item(0)->getAttribute('clientid'); 
         $reqPhysician_clientname = $theFile->getElementsByTagName("PHYSICIAN")->item(0)->getAttribute('clientname'); 

         // Are all the fields populated
         if (($reqPhysician_id <> "" ) and 
             ($reqPhysician_clientdnis <> "" ) and 
             ($reqPhysician_clientname <> "" ))
         {
           // Were good to go...
           decho("Phsyician: ".$reqPhysician_id.$cBr);
           decho("Phsyician: ".$reqPhysician_clientdnis.$cBr);
           decho("Phsyician: ".$reqPhysician_clientname.$cBr);

           // Get the PK
           $q =  "
SELECT 
   dictate_client_id 
FROM 
   dictate_client 
WHERE 
    client_dnis          = '$reqPhysician_clientdnis'
and client_name          = '$reqPhysician_clientname'
";                 
           $result = mysql_query($q);

           if (!$result) 
           {
              // This shouldnt happen
              decho("Physician Insert Database Error<BR>");
              $physstatus = $cDataErr;
           }
           else
           {
              $row_resultList     = mysql_fetch_assoc($result);
                   
              $client_pk = $row_resultList['dictate_client_id'];
              decho("Client PK: ".$client_pk.$cBr); 
              $clientstatus = $cExists;
           
              // Update the Physician to Disabled           
              $qUpd = "
UPDATE 
    dictate_physician  
SET 
    physician_status     = 'Disabled' 
WHERE 
    dictate_client_id    = $client_pk 
and dictate_physician_id = '$reqPhysician_id' 
and physician_status     = 'Enabled'  ";                     
              // Run command ?
              $result = mysql_query($qUpd);
              // What happened?
              if ($result == TRUE) 
              {
                   decho("Physician Delete Success<BR>");
                   $physstatus = $cDeleted;
              }
              else
              {
                   decho("Physician Delete Failed<BR>");
                   $physstatus = $cFailed;
              }                 
           }
         }
         else
         {
            $responsecode = "ERROR: Insufficient parameters for Delete";
         }
      }
      /////////////////////////////////////////////////////////
      else if ($request_Command == "DictationLast")
      /////////////////////////////////////////////////////////
      {
         decho("DICTATIONLAST<BR>");
         $responsecode = "DictationLast";
         $elementHolder->setAttribute("action", $request_Command); 
         
         // Get info about the last dictation         
         $q =  "
SELECT 
   dictate_physician_id, 
   file_conf_num, 
   file_status_web, 
   call_dnis, 
   file_date, 
   file_time 
FROM 
   dictate_file 
WHERE 
   file_id = (select max(file_id) from dictate_file) ";

          $result = mysql_query($q) or die(mysql_error());
          
          if (!$result) 
          {
             // This shouldnt happen
             decho("Dictation Last Database Error<BR>");
             $physstatus = $cDataErr;
             // Final results
             $responsecode = "ERROR: Dictation Last Database Error";
             $elementResult  = $docresult->createElement("RESULT", $responsecode);
          }
          else
          {
             $row_resultList   = mysql_fetch_assoc($result);
             decho('Physician ID:'.$row_resultList['dictate_physician_id'].$cBr);
             decho('Confirmation:'.$row_resultList['file_conf_num'].$cBr);
             decho('File Status.:'.$row_resultList['file_status_web'].$cBr);
             decho('Call DNIS...:'.$row_resultList['call_dnis'].$cBr);
             decho('File Date...:'.$row_resultList['file_date'].$cBr);
             decho('File Time...:'.$row_resultList['file_time'].$cBr);
             $responsecode = "SUCCESS";
             $elementResult  = $docresult->createElement("RESULT", $responsecode);
             $elementResult->setAttribute("PhysicianID",  $row_resultList['dictate_physician_id']);
             $elementResult->setAttribute("Confirmation", $row_resultList['file_conf_num']);
             $elementResult->setAttribute("FileStatus",   $row_resultList['file_status_web']);
             $elementResult->setAttribute("CallDNIS",     $row_resultList['call_dnis']);
             $elementResult->setAttribute("FileDate",     $row_resultList['file_date']);
             $elementResult->setAttribute("FileTime",     $row_resultList['file_time']);
          }                                             
      }
      /////////////////////////////////////////////////////////
      else
      /////////////////////////////////////////////////////////
      {
        decho("BAD COMMAND<BR>");
        $elementHolder->setAttribute("action", $request_Command);
        // Final results
        $responsecode = "ERROR: Unknown Command";
        $elementResult  = $docresult->createElement("RESULT", $responsecode);
      }
	  
      /////////////////////////////////////////////////////////
	  // Add final comments and details
      /////////////////////////////////////////////////////////
		// Put the results on the screen.
		// Add the DNIS info
		if ($request_Command == "Add") 
		{
			decho("RESULT: DNIS=".$dnisstatus.$cBr);
			// Final results
			$responsecode = "SUCCESS";
			if ($dnisstatus != $cUnknown)
			{
				$elementResultDNIS  = $docresult->createElement("RESULT", $dnisstatus);
				$elementResultDNIS->setAttribute("DNIS",  $reqPhysician_clientdnis);
				// Add the child here
				$elementHolder->appendChild($elementResultDNIS);
			}
		}

		// Add Physician info
		if (($request_Command == "Add") || 
			($request_Command == "Modify") || 
			($request_Command == "Delete"))
		{
			decho("RESULT: Client=".$clientstatus.$cBr);
			decho("RESULT: Physician=".$physstatus.$cBr);
			// Final results
			$responsecode = "SUCCESS";
			$elementResult  = $docresult->createElement("RESULT", $physstatus);
			$elementResult->setAttribute("PhysicianID",    $reqPhysician_id);
			$elementResult->setAttribute("ClientID",       $reqPhysician_clientdnis);
			$elementResult->setAttribute("ClientDNIS",     $reqPhysician_clientdnis);
			$elementResult->setAttribute("ClientStatus",   $clientstatus);
		}
	  
	} // Legal access to the command system?

}
else
{
	decho("NO COMMAND Provided<BR>");
	$elementHolder->setAttribute("action", "NotDefined");
	// Final results
	$responsecode = "ERROR: No Command Provided";
	$elementResult  = $docresult->createElement("RESULT", $responsecode);
}

// Put it all together
$elementHolder->appendChild($elementResult);
$docresult->appendChild($elementHolder);
// Save to Log dir .. if there was a request
if ($request_Command <> "") 
{
    $docresult->save($resf);
}

// Return results
echo $docresult->saveHTML();   // Displays out to the screen


 // mysql_free_result($result);
?>