<?php
/*
* TeleFlow Open Monitor
*
* Copyright (C) 2008 engenic (engenic.com)
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with this program; if not, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
* http://www.gnu.org/copyleft/gpl.html
*/

/* HOW IT WORKS
1) Load standard TeleFlowRelay PHP application
2) Fire off JavaScript timer to run HTTP post to xml_teleflow_access.php
3) Load results into DIVs

*/


require_once("cr_reference.php");
require_once($incPath.'LocalSettings.php'); 
require($incPath.$sessionphp);

require_once($websiteLibrary.'calcWorkUnit.php');   
require_once($websiteLibrary.'httpWorkUnit.php');
require_once($websiteLibrary.'teleflow-library.php'); 

// Take the logged in client id
$mClient_id = $session->sessionActiveClientSecurity();




// -------- Pagination for Reports ------------
// Note: Don't forget at the start of this program:  session_start(); 
// Was a page parameter passed
if (isset($_GET['page'])) 
{
	$pageLines  = (isset($_SESSION["pageLines"])) ? $_SESSION["pageLines"] : 0;
	$pageCurr   = (isset($_SESSION["pageCurr"]))  ? $_SESSION["pageCurr"]  : 0;
	$pageMax    = (isset($_SESSION["pageMax"]))   ? $_SESSION["pageMax"]   : 0;
	// Determine the new page to hit
	$pageCurr   = engRepPageSettings($_GET['page'], $pageCurr, $pageMax);
}
else
{
	// Go with new page
	$pageLines  = 10;
	$pageCurr   = 0;
	$pageMax    = -1; // set with count     
}  
// -------- Pagination for Reports ------------


$SSAdv_colors1 = array("#EAF2F4","#FFFFFF");
$SSAdv_k1 = 0;
$SSAdv_m1 = 0;
$SSAdv_change_every1 = 1;


// -------- Pagination for Reports ------------
// Get the count if there is no page defined
$pageMax = 0; //engRepPageMax($pageMax, $pageLines, $query_from, $voicemail);

// Save Session variables
$_SESSION["pageLines"] = $pageLines;
$_SESSION["pageCurr"]  = $pageCurr;
$_SESSION["pageMax"]   = $pageMax;
// From here for line number use: ($counter++)+engRepCounter()
//  engRepOptions();  for the |< < page of x > >| options
// -------- Pagination for Reports ------------


//sort column headers for rsSearchResultDate 
$tfm_saveParams = explode(",","startdate,enddate,status,loaded");
$tfm_keepParams = "";
if(isset($tfm_order) && ($tfm_order == "ASC")) 
{
	$tfm_order = "DESC";
}
else
{
	$tfm_order = "ASC";
}


while (list($key,$val) = each($tfm_saveParams)) 
{
	if(isset($_GET[$val]))$tfm_keepParams .= ($val)."=".urlencode($_GET[$val])."&";	
	if(isset($_POST[$val]))$tfm_keepParams .= ($val)."=".urlencode($_POST[$val])."&";
}
$tfm_orderbyURL = $_SERVER["PHP_SELF"]."?".$tfm_keepParams."tfm_order=".$tfm_order."&tfm_orderby=";

include($incPath."include/header.php"); 
// JavaScript goes here + + +
?>
<link rel="stylesheet" href="/library_js/jquery.tooltip.css" />
<script type="text/javascript" src="/library_js/jquery.bgiframe.js"></script>
<script type="text/javascript" src="/library_js/jquery.dimensions.js"></script>
<script type="text/javascript" src="/library_js/jquery.tooltip.js"></script>

<script type="text/javascript" src="/library_js/jquery.timers.js"></script>
<style type="text/css">
@import url(../include/teleflow_monitor.css);
</style>
<script language="javascript"> 
// Runs when the page loads
var secondsCountDown=1;  // Count down from 
var secondsSystemUp=10;  // Loop occasionally
// Keep track of ajax
var xhr = null;

// This will capture all errors
/*
$(document).ajaxError(function(){
    if (window.console && window.console.error) {
        console.error(arguments);
    }
});
*/

//  Interact with PHP system using AJAX
$(document).ready(function()
{
	<?php include($incPath.'cr_javascript_graphics.php'); ?>

	// Put in some defaults
	$('#tab_selected').val('server_LOCALHOST');
	$("#NewMessageTimer").val('5'); 
	$("#MessageSts").val('START'); 
	$("#MessageStsDept").val(''); 
	$("#LastMsgID").val('0'); 
	$("#LastMsgIDDept").val('0'); 
	
	// Initial messages
	$("#monitor-box").html('&nbsp;&nbsp;<img src="../images/licensed.gif" alt="Connecting" width="18" height="18" border="0" />&nbsp;&nbsp;<b>Communicating with TeleFlow Server...</b>');	

	$('#teleflowset a').tooltip({
		bodyHandler: function() {
			alert('ere');
			return $($(this).attr("href")).html();
		},
		delay: 0,
		track: true
	});
	
	// Tabs
	$('#tabs').tabs({
		select: function(event, ui) 
		{ 
			//alert('Here: '+ui.panel.id); //$(this). );
			//alert('Selected: '+$('#tab_selected').val());

			// Mark which tab we are one
			$('#tab_selected').val(ui.panel.id);
			
			// Also set it to run again if the system is breathing
			$("#MessageSts").val('NORMAL');
		}
	});			

	// Set up the system tabs
	var mSystemMenu = '<ul>';
	var mSystemBlock = '';
	$.ajax({ type: "POST", 
		url: "tf_ajax_command.php", 
		data: { action:		'GetTFSystems',
				client_id:	$('#client_id').val(),
				gettype:'XML', 
				nocache_rand:Math.random() }, 
		dataType: "xml", 
		success: function(data)
		{	
			// Populate Employee Information
			$(data).find('RESPONSE').each(function()
			{
				// Did we get something
				if ( $(this).attr('result') == 'ERROR')
				{
					$("#MessageSts").val('NOSERVERS');
					//alert('No Servers Found');
				}
				else
				{
					mCount=0;
					// Put up tabs for all servers
					$(data).find('SYSTEMRESULT').each(function()
					{
						// alert( $(this).attr('cust_type_short_display') );
						mCount=mCount+1;
						
						mSystemServer = 'server_'+$(this).attr("server_name");
						mSystemMenu  = mSystemMenu + '<li><a href="'+mSystemServer +'">'+$(this).attr("server_name")+'</a></li>';
						mSystemBlock = mSystemBlock + '<div id="'+mSystemServer+'">Monitor for '+$(this).attr("server_name")+'</div>';
						
						//$('#tabs').html(mSystemMenu +mSystemBlock);
						$('#tabs').tabs('add' , '#'+mSystemServer, $(this).attr("server_name") );
						
						// Save details
						$('#'+mSystemServer).html('Here for '+mSystemServer);
						$('#'+mSystemServer).attr('ip', $(this).attr("server_ip_address"));
						$('#'+mSystemServer).attr('port', $(this).attr("tf_monitor_ip_port"));
						$('#'+mSystemServer).addClass('teleflow_tabs');
					});					
				}
			});		
		
			// NOTE:  Populate the tables
			mSystemMenu = mSystemMenu + '</ul>';
			
			
		},
		error: function (xhr, desc, exceptionobj) 
		{
			//alert(xhr.responseText);				
			$("#MessageSts").val('TIMEOUT');
		}
	});	
	
	

	$(function() 
	{ 	
		//alert('here');
		var demos = $("div.demos");
		$(".uncontrolled-interval p", demos).html('-- TeleFlow Monitor Defaulting to LocalHost...');	
		// Timer for updating the block
		$(".uncontrolled-interval p", demos).everyTime(5000, function(i)  // 3000 = 3 seconds
		{
			// Only show up every 30 seconds, but start the first one in 3 seconds
			if (i%10 == 1)
			{
				// If the last effort showed as an ERROR, give it a few seconds to breath
				$("#MessageSts").val('NORMAL');
				
				$(".uncontrolled-interval p", demos).html('&nbsp;');
			}

			// In case things were moveing too fast
			if ($("#MessageSts").val() == 'NORMAL')
			{
				$("#MessageSts").val('WORKING');
				
				// Get the information in the current tab
				mName = $('#tab_selected').val() ; 
				//alert('testing'+mName);
				// test port - Make sure there is a default
				mPort = $('#'+mName).attr('port');
				if (mPort == '')
				{
					mPort = '5051';
				}
				
				// Kill the previous entry @@@ Doesnt seem to work
				if (null !== xhr) {
					xhr.abort();
					xhr = null;
				}
				//event.preventDefault();

				
				xhr = $.ajax({ type: "POST", 
						url: "tf_ajax_command.php", 
						timeout: 10000,
						data: { action:		'GetTFMonitor',
								client_id:		$('#client_id').val(),
								tf_ip_address:	$('#'+mName).attr('ip'), //'PHOBOS',
								tf_ip_port:		mPort, //'5051',
								gettype:'XML', 
								nocache_rand:Math.random() }, 
						dataType: "xml", 
						success: function(data)
						{	
							//		$('#tabs').tabs('option', 'selected')+' - '+
							//		$('#tabs').tabs('option', 'selected'));
							mSuccess = false;
							
							// Populate table information
							$(data).find('RESPONSE').each(function()
							{
								// Show what we got
								$('#'+mName).html($(this).attr("htmltable"));
								
								if ($(this).attr("serverlocated"))
								{
									mSuccess = true;
								}
							
							});		
							
							// See  if we got an error 
							if (mSuccess)
							{
								// Let the system know its good to go again
								$("#MessageSts").val('NORMAL');
							}
							else
							{
								// A server was not found
								$("#MessageSts").val('ERROR');
							}
							
							
						},
						error: function (xhr, desc, exceptionobj) 
						{
							xhr.abort();
							//alert('here');
							mError='&nbsp;&nbsp;<img src="../images/warning.gif" alt="Warning" width="18" height="18" border="0" />&nbsp;&nbsp;<b>Warning: TeleFlow Server unavailable</b>';
							$("#monitor-box").html(mError);
							$("#MessageSts").val("ERROR");
				
						}
					}
				);	
			}
		});			
	});
});
</script>


<?php
include($incPath."include/header_divs.php"); 


// Start - TOP MENU 
// Default names that are replaced from the database
$mDefaultDisplay 	= 'TeleFlow Monitor';
$mDefaultDesc 		= 'Review Monitor Activity';
$database->getApplicationNameForWebpage($thisWebPage, $mDefaultDisplay, $mDefaultDesc);
?>
<div id="topbar">
<a class="active"><span><div id="bartitle"><?php echo($mDefaultDisplay);?></div></span></a>	
<?php
echo CheckMenuText($mDefaultDesc );
//echo CheckCurrentMenu($appSysUri, 'cr_register.php', 'Sign Up',  $incPath.'images/tb_span.png');
?>
</div>
<?php
include($incPath."include/contact_links.php");
// END - TOP MENU

?>
<div id="frontpage">
<div id="maintext">

<input name="client_id"  id="client_id"  type="hidden" readonly="" value="<?php echo($mClient_id);?>">

<form name="MsgTimer">
<div id="hidden" style="display: none;><!--  style="display: none;  -->
<input type="text" size="8" id="NewMessageTimer" name="NewMessageTimer" value="10">
<input type="text" size="8" id="LastMsgID" name="LastMsgID" value="0">
<input type="text" size="8" id="MessageSts" name="MessageSts" value="START">
<input type="text" size="8" id="LastMsgIDDept" name="LastMsgIDDept" value="0">
<input type="text" size="8" id="MessageStsDept" name="MessageStsDept" value="">
</div>
</form> 


<div id="monitormaintext">
     <?php // The monitor-box div is for the rows coming back from xml_teleflow_access.php ?>
     <!-- ================ -->
     <div id="monitor-box"><b>&nbsp;&nbsp;Loading Page...<b></div>        
     <!-- ================ -->    
</div>	
<div class="demos">
<div class="uncontrolled-interval">
	<p>-- Starting up...</p>
</div>
</div>
		
<div id="tab_selected"></div>
<div class="teleflow_tabs" id="tabs">
	<ul>
		<li><a href="#server_LOCALHOST">LOCALHOST</a></li>
	</ul>
	<div class="teleflow_tabs" id="server_LOCALHOST" ip="localhost" port="">LocalHost Server</div>
</div>


<?php  
	// Determine if we should display additional Monitor Information provided by Sentinel 
	/*
	$mTeleFlowLogFolder = getTeleFlowLogFolder($cTeleFlowServer.$cAccessCommand, $cTeleFlowLogMap);
	$mHTMLFileL=$mTeleFlowLogFolder."tfsystemhealth-l.html";
	$mHTMLFileR=$mTeleFlowLogFolder."tfsystemhealth-r.html";
	//echo $mHTMLFile;
	if ((file_exists($mHTMLFileL)) and (file_exists($mHTMLFileR)))
	{ 
	?>
	<div id="monitorsysteminfo">
		<div id="monitorsysteminfoleft">
		<?php
			echo file_get_contents($mHTMLFileL);
		?>
		</div>	
		<div id="monitorsysteminforight">
		<?php
			echo file_get_contents($mHTMLFileR);
		?>
		</div>	
	</div>	
	<?php
	}
	*/
?>

<br />
<br />
<br />	

<!-- Footer standard -->
</div> <!-- maintext -->
</div> <!-- frontpage -->
<?php 
include($incPath."include/footer.php");
?>