<?php
/*
* TeleFlow LogViewer
*
* Copyright (C) 2008 engenic (engenic.com)
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with this program; if not, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
* http://www.gnu.org/copyleft/gpl.html
*/

/*
// eg:  http://localhost/TeleFlow/tflogviewer.php?LogFile=Test08_2008-05-22.log
// eg:  http://localhost/TeleFlow/tflogviewer.php?LogFile=TFVO43_2008-02-12.log
*/
require_once("cr_reference.php");
require_once($incPath.'LocalSettings.php'); 
include($incPath."include/session.php");

require_once($websiteLibrary.'calcWorkUnit.php');   
require_once($websiteLibrary.'httpWorkUnit.php');
require_once('tflogindex.php');
require_once($websiteLibrary.'teleflow-library.php'); 


// Defines for the LogFile scanner
$cStepTitle    = 29;  // Location where step title is displayed
$cUserOut      = 26;  // Location where user messages are displayed
$cStepOut      = 32;  // Location where step properties and info is displayed
$cFatalOut     = 35;  // Location where fatal error messages will occur
$cMsgFatal     = 'Attempting to jump to Fatal Error';
$cMsgFatalL    = strlen($cMsgFatal);
$cMsgRestart   = 'Application restart';
$cMsgRestartL  = strlen($cMsgRestart);
$cMsgInitial   = 'Engenic TeleFlow:';
$cStepPickUp   = 'Pick Up';
$cStepHangUp   = 'Hang Up';
$cStepWaitCall = 'Wait For Call';


// Functions for rows
function GetStepHead($pIc, $pBuff)
{
  $mIc = $pIc+1;
  return '<span class="style15">'.rightstr('00000000'.$mIc,8).' '.substr($pBuff,11,12).'</span>';
}


function GetStepOutput($pStepHead,$pStepBody,$pStepLast,&$pLabelNo)  // Label number is by refernece
{
  $cStepPickUp   = 'Pick Up';
  $cStepHangUp   = 'Hang Up';
  $cStepWaitCall = 'Wait For Call';

  // Was the step a telephony step?
  if ((StrPos($pStepLast, $cStepPickUp) > 0) or 
      (StrPos($pStepLast, $cStepHangUp) > 0) or 
      (StrPos($pStepLast, $cStepWaitCall) > 0))
  {
    // Add a tag so we can jump to it easily
    $mStepLabel = '<a name="StepLocation'.$pLabelNo++.'"></a>';
    return '<tr class="styleCallActivity" valign="top"><td>'.$mStepLabel.$pStepHead.'</td><td>'.$pStepBody.'</p></td></tr>';
  }
  else
  {
    return '<tr valign="top"><td>'.$pStepHead.'</td><td>'.$pStepBody.'</p></td></tr>';
  }
}



$mLogFile = "";
if (isset($_GET['LogFile'])) {
  $mLogFile = (get_magic_quotes_gpc()) ? $_GET['LogFile'] : addslashes($_GET['LogFile']);
}
//$mLogFile = "Test08_2008-05-22.log";


// -------- Pagination for Reports ------------
// Note: Don't forget at the start of this program:  session_start(); 
// Was a page parameter passed
if (isset($_GET['page'])) 
{
  $pageLines  = (isset($_SESSION["pageLines"])) ? $_SESSION["pageLines"] : 0;
  $pageCurr   = (isset($_SESSION["pageCurr"]))  ? $_SESSION["pageCurr"]  : 0;
  $pageMax    = (isset($_SESSION["pageMax"]))   ? $_SESSION["pageMax"]   : 0;
  // Determine the new page to hit
  $pageCurr   = engRepPageSettings($_GET['page'], $pageCurr, $pageMax);
}
else
{
  // Go with new page
  $pageLines  = 1000;
  $pageCurr   = 0;
  $pageMax    = 0; // @@@ -1; // set with count   

  // Get the log folder 
  $_SESSION["LogFileTeleFlow"] = getTeleFlowLogFolder($cTeleFlowServer.$cAccessCommand, $cTeleFlowLogMap).$mLogFile;

  // If the log file on the local drive exists, then update, and get the page
  if (File_Exists($_SESSION["LogFileTeleFlow"]))
  {
    // Update the Log Index File when user first loads the log file 
    // This has been coded to be very efficient - Due to the fact log files can be huge
    $pageMax = ceil(UpdateLogIndex($_SESSION["LogFileTeleFlow"]) / $pageLines)-1;
    $_SESSION["LogFileIndex"] = file_get_contents(GetLogIndex($_SESSION["LogFileTeleFlow"]));
  }
}  
// -------- Pagination for Reports ------------


$SSAdv_colors1 = array("#EAF2F4","#FFFFFF");
$SSAdv_k1 = 0;
$SSAdv_m1 = 0;
$SSAdv_change_every1 = 1;



// -------- Pagination for Reports ------------
// Get the count if there is no page defined
$pageMax = engRepPageMaxNoDB($pageMax, $pageLines);
// Save Session variables
$_SESSION["pageLines"] = $pageLines;
$_SESSION["pageCurr"]  = $pageCurr;
$_SESSION["pageMax"]   = $pageMax;
// From here for line number use: ($counter++)+engRepCounter()
//  engRepOptions();  for the |< < page of x > >| options
// -------- Pagination for Reports ------------

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">	
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>

<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="description" content="Medical Appointment Reminders & Automated Patient Communications: MedicalRelay">
<meta name="keywords" content="IVR, CTI, Virtual Communication, Telephony, Hosted, web-based, Medical, Practitioners, Appointment Reminder, Call-out, Lab Results">
<title>Monitor: Log Viewer</title>
<link href="mainnarrow.css" rel="stylesheet" media="screen,,projection" title="default" type="text/css">
<link href="datepicker.css" rel="stylesheet" media="screen,,projection" title="default" type="text/css"  />
 
<style type="text/css">
<!--
a:link {
	color: #486595;
	text-decoration: none;
}
a:visited {
	text-decoration: none;
	color: #486595;
}
a:hover {
	text-decoration: none;
	color: #000000;
}
a:active {
	text-decoration: none;
}
.style6 {color: #000000; font-weight: bold; }
-->
</style>
<script language="javascript" src="<?php echo($websiteLibrary);?>jslibrary.js"></script>

<script language="JavaScript" type="text/JavaScript">
<!--

function MM_callJS(jsStr) { //v2.0
  return eval(jsStr)
}
//-->
</script>


<style type="text/css">
<!--
.style8 {color: #FFFFFF}
.style11 {
	font-size: 8pt;
	font-weight: bold;
}
.style13 {
	color: #FFFFFF;
	font-size: 8pt;
	font-weight: bold;
}
.style14 {font-size: 8pt}
.style15 {color: #AAAAAA; font-size: 8pt; }
p
{ 
   width: 600px;
   font-size: 8pt;  
   font-family: 'courier new';
   margin-top: 0px;
   margin-bottom: 5px;
   margin-left: 30px
}
pre
{ 
   color: #004400; 
	 font-weight: bold;
   margin-left: 70px
}
.styleStep 
{
   color: #000066; 
   BACKGROUND-COLOR: #EFEFFF;
   font-size: 10pt;  
   font-weight: bold;
   margin-left: 2px
}
.styleMsg
{
   color: #000000; 
   BACKGROUND-COLOR: #FFFFCC;
   font-size: 10pt;  
   font-weight: bold;
}
.styleWarn
{
   color: #FF6600; 
   font-family: 'arial';
   font-size: 10pt;  
}
.styleERROR
{
   color: #000000; 
   BACKGROUND-COLOR: #FF9999;
   font-size: 10pt;  
   margin-top: 5px;
   margin-bottom: 5px;
   padding-left: 5px;
   padding-right: 5px;  
}
a:link
{
  color: #000000; 
}
a:visited
{
  color: #555555; 
}
a:hover
{
  color: #AA0000; 
  text-decoration: underline;
}
.styleProcIn
{
   color: #000000; 
   border: solid #55AA55;
   BACKGROUND-COLOR: #EEFFEE;
   font-size: 10pt;  
   font-weight: bold;
   padding-left: 5px;
   padding-right: 5px;
   margin-top: 3px;
   margin-bottom: 3px;
}
.styleProcOut
{
   color: #000000; 
   border: solid #99DD99;
   BACKGROUND-COLOR: #99DD99;
   font-size: 10pt;  
   font-weight: bold;
   margin-top: 3px;
   margin-bottom: 3px;
}
.styleCallActivity
{
   BACKGROUND-COLOR: #FFFFBB;
   font-size: 10pt;  
   margin-top: 5px;
   margin-bottom: 5px;
   padding-left: 5px;
   padding-right: 5px;   
}
.styleInit
{
   color: #000000; 
   BACKGROUND-COLOR: #FCD3A0;
   font-size: 10pt;  
   margin-top: 3px;
   margin-bottom: 3px;
}
-->
</style>
</head>
<body>



<div id="wrapper">
<div id="mainContainer">
		
<?php include("include/header.php"); ?>

<div id="shader"></div>
<div id="frontpage">
<div id="maintext">
	      <table width="98%" border="0" cellpadding="5">
         <tbody>
            <tr>
              <td colspan="2"><span class="pageheader"><h2>&nbsp;Log File: <b><?php echo $mLogFile?></b></h2></span></span></td>
            </tr>
            <tr>
              <td colspan="2"><!-- <?php echo $_SESSION["LogFileTeleFlow"]?> --></td>
            </tr>
         </tbody>
	        <tr>
	        <td align="left" valign="top">
             <table width="100%" border="0" cellspacing="0" cellpadding="0">
                <tr>
                  <td width="140px" >&nbsp;</td>
                  <!--<form method="GET" name="form1" id="form1">
                      <table width="500" border="0" cellspacing="0" cellpadding="2">
                        <tr class="body">
                          <td width="29%">Select date range:</td>
                          <td width="11%">start:</td>
                          <td width="27%"><span class="bodytextBOLD">
                            <input name="startdate" type="text" id="startdate" value="<?php echo $varstartdate; ?>" size="8" />
                            <img src='images/calendar.gif' border='0' align='top' onclick="displayDatePicker('startdate','','mdy');">
                          </span></td>
                          <td colspan="2">- Choose start date range <a target="_blank"></a></td>
                        </tr>
                        <tr>
                          <td>&nbsp;</td>
                          <td>end:</td>
                          <td><span class="bodytextBOLD">
                            <input name="enddate" type="text" id="enddate" value="<?php echo $varenddate; ?>" size="8" />
                            <img src='images/calendar.gif' border='0' align='top' onclick="displayDatePicker('enddate','','mdy');">
                          </span></td>
                          <td colspan="2">- Choose end date range</td>
                        </tr>
                        <tr>
                          <td>&nbsp;</td>
                          <td>&nbsp;</td>
                          <td>&nbsp;</td>
                          <td width="15%">&nbsp;</td>
                          <td width="18%">&nbsp;</td>
                        </tr>
                        <tr>
                          <td>&nbsp;</td>
                          <td colspan="2">&nbsp;</td>
                          <td>&nbsp;</td>
                          <td><input type="submit" name="Submit" value="Get Report" /></td>
                        </tr>
                      </table>
                  </form></td>
                  -->     </tr>
                <tr>
                  <td colspan=2><h2>Errors in Log</h2></td>
                </tr>
                
    <?php 
    // ---------------------------
    // Show a list of the ERRORS in the log file
    // ---------------------------
    $mArray = explode(chr(13).chr(10),$_SESSION["LogFileIndex"],500);  // Process 500 lines max
    $mMax = 10;
    $mCounter = 1;
    foreach ($mArray as $mLine)
    {
       $mArrayLine = explode(',',$mLine,10);
       //echo $mLine;
       // 0 Date,  1 Time,  2 Row, 3 ByteLoc,  4 Type (Page,Issue), 5 Data (Search info)
       if (($mArrayLine[4] == 'Error') or ($mArrayLine[4] == 'App'))
       {
          // Create the link to get to it quickly
          $mLink = '?LogFile='.$mLogFile.'&page='.Floor($mArrayLine[2]/1000).'#ErrorLocation'.$mArrayLine[2];
          $mStepLink = '<a href="'.$mLink.'">'.
                       GetStepHead($mArrayLine[2], $mArrayLine[0].' '.$mArrayLine[1]).'</a>';
          
          echo '<tr><td>'.$mStepLink.'</td>'.
                '<td class="styleERROR">'.'<b>'.
                $mCounter++.': '.$mArrayLine[4].':</b> '.'<a href="'.$mLink.'">'.$mArrayLine[5].'</a></td></tr>';
          // Stop at some point                
          if ($mCounter > $mMax) 
          {
            echo '<tr><td>&nbsp;</td>'.
                 '<td class="style15"><b>List truncated at '.$mMax.'</b></td></tr>';
            break;
          }
       }
    }
    ?>
                <tr>
                  <td colspan=2><h2>Items on Page</h2></td>
                </tr>
    <?php 
    // ---------------------------
    // Show a list of the ITEMS on the current page in the log file
    // ---------------------------
    $mArray = explode(chr(13).chr(10),$_SESSION["LogFileIndex"],500);  // Process 500 lines max
    $mMax = 10;
    $mCounter = 1;
    $mStepLabNo = 0;
    foreach ($mArray as $mLine)
    {
       $mArrayLine = explode(',',$mLine,10);
       
       //echo $mLine;
       // 0 Date,  1 Time,  2 Row, 3 ByteLoc,  4 Type (Page,Issue), 5 Data (Search info)
       
       // Gather everything on the same page
       if (($mArrayLine[2] >= ($pageLines * $pageCurr)) and
           ($mArrayLine[2] <= ($pageLines * ($pageCurr+1))))
       {    
         // Errors 
         if (($mArrayLine[4] == 'Error') or ($mArrayLine[4] == 'App'))
         {
            // Create the link to get to it quickly
            $mLink = '?LogFile='.$mLogFile.'&page='.Floor($mArrayLine[2]/1000).'#ErrorLocation'.$mArrayLine[2];
            $mStepLink = '<a href="'.$mLink.'">'.
                         GetStepHead($mArrayLine[2], $mArrayLine[0].' '.$mArrayLine[1]).'</a>';
            echo '<tr><td>'.$mStepLink.'</td>'.
                  '<td class="styleERROR">'.'<b>'.
                  $mCounter++.': '.$mArrayLine[4].':</b> '.'<a href="'.$mLink.'">'.$mArrayLine[5].'</a></td></tr>';
         }
         // Telephony
         if (($mArrayLine[4] == 'Step'))
         {
            // Create the link to get to it quickly
            $mLink = '?LogFile='.$mLogFile.'&page='.Floor($mArrayLine[2]/1000).'#StepLocation'.$mStepLabNo++;  // Why +1 ??
            $mStepLink = '<a href="'.$mLink.'">'.
                         GetStepHead($mArrayLine[2], $mArrayLine[0].' '.$mArrayLine[1]).'</a>';
            echo '<tr><td>'.$mStepLink.'</td>'.
                  '<td class="styleCallActivity">'.'<b>'.
                  $mCounter++.': '.$mArrayLine[4].':</b> '.'<a href="'.$mLink.'">'.$mArrayLine[5].'</a></td></tr>';
         }
         
         // Stop at some point                
         if ($mCounter > $mMax) 
         {
           echo '<tr><td>&nbsp;</td>'.
                '<td class="style15"><b>List truncated at '.$mMax.'</b></td></tr>';
           break;
         }
       }
    }
    ?>
                
              </table>
            </td>
          </tr>
        </table>
        
	 <table border="0" cellpadding="0" cellspacing="0">
      <tr>
        <td class="style6"><input name="loaded" type="hidden" id="loaded" value="<?php echo $varloaded; ?>" /><?php echo $varloaded; ?></td>
        <td>&nbsp;</td>
        <td>&nbsp;</td>
      </tr>
      <tr>
        <td colspan="3"><a name="PageTop"></a><?php engRepOptions(); engRepGotoPageBottom(); ?>&nbsp;</td>
      </tr>
      <tr>        
        <td width="120"  bgcolor="#29386B"><span class="style13"># Time</span></td>
        <td              bgcolor="#29386B"><span class="style13">Output</span></td>
        <td width="1%"   bgcolor="#29386B"><span class="style13">&nbsp;</span></td>
      </tr>
      
  <?php 
  
  if (File_Exists($_SESSION["LogFileTeleFlow"]))
  {    
  
    // Page the System
    $counter    = 1; 
    $ic         = 0;
    $ic_start   = (($pageCurr + 0) * $pageLines);  // start at row
    $ic_max     = (($pageCurr + 1) * $pageLines);  // stops after this number of rows
    
    // Open the file
    $handle     = fopen($_SESSION["LogFileTeleFlow"], "r");
    
    $cStepTitle = 29;  // Location where step title is displayed
    $cUserOut   = 26;  // Location where user messages are displayed
    $cStepOut   = 32;  // Location where step properties and info is displayed
    
    // Set text supression
    // - One row per step
    $mStepHead  = GetStepHead($ic_start, '');
    $mStepBody  = '<p>'; 
    $mStepLast  = '';  
    
    // For labels
    $mStepLabNo = 0;
    
    // Preformatted
    $mFormatted = False;
    // Assume initialized
    $mInitiationDone = True;
    
    do 
    {
       $buffer = fgets($handle, 4096);
       if ($ic >= $ic_start)
       {
            // Immedietly check for inititialization completion
            if ((substr($buffer,$cUserOut,3) == '==>') 
             or (strpos($buffer,'<< START LOG >>') > 0))
            {
              $mInitiationDone = True;
              $mStepBody .= '</span>';
            }
            
            // Do we have a new step?    [xx] Step Name
            if ((substr($buffer,$cStepTitle,1) == '[') and (!$mFormatted)) 
            {
                // Dump the data we have collected
                echo GetStepOutput($mStepHead,$mStepBody,$mStepLast,$mStepLabNo); //  '<tr valign="top"><td>'.$mStepHead.'</td><td>'.$mStepBody.'</p></td></tr>';

                // Get the row number and time
                $mStepHead = GetStepHead($ic, $buffer); //'<span class="style15">'.rightstr('000000'.$ic,6).' '.substr($buffer,11,12).'</span>';
                $mStepLast = substr($buffer,$cStepTitle,99);
                // Create the: [xx] Step Name 
                if (isset($_SESSION['StepNames'])) 
                {                
                  //XMLStepInfo 
                  $mStepDetail = explode(']',$mStepLast,2);
                  $mStepInfo = explode(',',XMLStepInfo(trim($mStepDetail[1]))); 
                  $mStepBody = '<span class="styleStep">'.$mStepDetail[0].'] '.$mStepInfo[2].' </span><br>';
                  $mStepBody .= '<p>';  // Start paragraph
                }
                else
                {
                  $mStepBody = '<span class="styleStep">'.$mStepLast.'</span><br>';
                  $mStepBody .= '<p>';  // Start paragraph
                }
            }
            // Do we have a user message or a Proceedure change?
            else if ((substr($buffer,$cUserOut,1) <> ' ')   // Showing something
                 and (substr($buffer,13,1) == ':')          // Probably showing time
                 and (!$mFormatted)
                 and ($mInitiationDone))
            {
                // Test for [[procedure]] change
                if (strpos($buffer,'==>') > 0)
                {
                   $mStepBody .= '</p><span class="styleProcOut">'.
                                 str_ireplace("==>",' <strong>&rarr;</strong> </span><span class="styleProcIn">',substr($buffer,$cUserOut,200)).
                                 '</span><br><p>';
                   // Reset to be certain
                   $mFormatted = False;
                }
                else if (strpos($buffer,'<==') > 0)
                {
                   $mStepBody .= '</p><span class="styleProcIn">'.
                                 str_ireplace("<==",'</span><span class="styleProcOut"> <strong>&larr;</strong> ',substr($buffer,$cUserOut,200)).
                                 '</span><br><p>';
                   // Reset to be certain
                   $mFormatted = False;
                }
                else
                {
                   // Was there an application restart??
                   if (stripos($buffer,$cMsgRestart)> 0) 
                   {
                     // Add a modified line to the step body
                     $mStepBody .= '<a name="ErrorLocation'.rightstr('00000000'.$ic,8).'">'.
                                   '<span class="styleERROR">ERROR FOUND</span></a><br>';
                     $mStepBody .= '<span class="styleMsg">'.substr($buffer,$cUserOut,200).'</span><br>';
                   }
                   else
                   {
                     $mStepBody .= '<span class="styleMsg">'.substr($buffer,$cUserOut,200).'</span><br>';
                   }
                }
            }
            // Regular TeleFlow output
            else
            {
                // If we are in formatted mode, read more of the string
                if ($mFormatted) 
                {
                   $mLine  = substr($buffer,$cUserOut,200); 
                }
                else if ((substr($buffer,13,1) == ':') // Probably reading a regular line
                     and ($mInitiationDone)) 
                {
                   // Are we reading a regular line
                   $mLine  = substr($buffer,$cStepOut,200); 
                }            
                else // Probably reading a line that isnt prefaced with date time
                {
                   // Remove the date and time from inititialization stuff
                   if (substr($buffer,4,1) == '/') // Probably reading a date 
                   {
                      $mLine  = substr($buffer,$cUserOut,200);
                   }
                   else
                   {
                      $mLine  = $buffer; 
                   }
                   
                   // Check to see if this is Application starting
                   if (stripos($buffer,$cMsgInitial) === 0)
                   {
                     $mInitiationDone = False;
                     $mStepBody .= '<span class="styleInit">';
                   }                   
                }
                                 
                
                // Was there a fatal error
                if (stripos($mLine,$cMsgFatal)> 0) 
                {
                  // Change the line, and add a goto label
                  $mLine = '<a name="ErrorLocation'.rightstr('00000000'.$ic,8).'">'.
                           '<span class="styleERROR">ERROR FOUND</span></a><br>'.
                           str_ireplace($cMsgFatal,'<span class="styleERROR">'.$cMsgFatal.'</span>',$mLine);
                }

                
                // Post process addition info
                // Warning:
                if (substr($mLine,0,8) == 'WARNING:')
                {
                  $mLine = '<span class="styleWarn"><b>WARNING:</b> '.substr($mLine,9,200).'</span>';
                }
                
                // See if this there are formatting changes
                if (strpos($mLine, '<----- BEGIN ----->') > 0)
                {
                  $mFormatted = True;
                  $mLine = str_ireplace("<----- BEGIN ----->",'<pre>',$mLine);
                }
                
                // Turn off formatting
                if (strpos($mLine, '<-----  END  ----->') > 0)
                {
                  $mFormatted = False;
                  $mLine = str_ireplace("<-----  END  ----->",'</pre>',$mLine);
                  // Add the line
                  $mStepBody .= $mLine.'<p>';
                }
                else
                {
                  // See how to add the line 
                  if ($mFormatted) 
                  {
                     // Add the line
                     $mStepBody .= $mLine;
                  } 
                  else
                  {
                     // Add it with a break
                     $mStepBody .= $mLine.'<br>';
                  }
                }
            }
            
            //$mRow  = str_ireplace(' ','&nbsp;',substr($buffer,24,999));
       }
    } while (!feof($handle) && ++$ic <= $ic_max );
    fclose($handle);
    
    // Add the last bit
    echo GetStepOutput($mStepHead,$mStepBody,$mStepLast,$ic); 
  }
  ?>
  
      <tr>        
        <td colspan="3" bgcolor="#29386B"><span class="style13">&nbsp;</span></td>
      </tr>
      
      <tr>
        <td colspan="3"><a name="PageBottom"></a><?php engRepOptions(); engRepGotoPageTop(); ?>&nbsp;</td>
      </tr>
          
  </table>
  
	  </div>	
	</div>
			
	</div>
	<?php

include("include/footer.php"); ?>
</div>
</body>
</html>
<?php
?>