<?php

/////////////////////////// MAIN ///////////////////////////////
// Get the full request
//$data         = file_get_contents("php://input");
//$data         = file_get_contents("test_sendtest.xml");  // Debug

// Resposnes provided by the PHP program
$responsecode = "";
$xmlresult    = "<RESULT>ERROR Database or other failure</RESULT>";

// Date and Time defaults
$teleflowDate = Date("Y/m/d");
$teleflowTime = Date("H:i:s");
     // yyyy/mm/dd ==> mm/dd/yyyy
$webDate      = Date("m/d/Y");

//echo("<BR><BR>".$data."<BR><BR>");
decho("STARTED at ".teleflowNowDate()." ".teleflowNowTime()." (".$webDate.")<BR>");

// Set up file names
$stmp        = date("Y-m-d_H-i-s");
$fold        = SYSTEM_LOGFILES;
// Create the log folder
if (!is_dir($fold))
{
    mkdir($fold);
}
$reqf  = $fold.$cSysName."_".$stmp."_request.xml";
$resf  = $fold.$cSysName."_".$stmp."_response.xml";


// Assume an XML document, and process...
$doc = new DOMDocument();

// Get the session user name.  Note: will be "Guest" (GUEST_NAME) if no one has signed on
$request_UserName = $_SESSION['username'];


$request_Command = '';
// Did the user actually send a request?
if ($data <> '')
{
	$doc->loadXML($data);
	// save it for later review
	//$doc->save($reqf);

	// XML Command request
	// -- Find out what the command is (Must be a REQUEST)
	$theFile = $doc->getElementsByTagName('REQUEST')->item(0);

	if ($theFile->hasAttribute('action'))
	{
		$request_Command = $theFile->getAttribute('action');
		// "username" only needs to be send if testing is being done... other wise its a session variable
		if ($theFile->hasAttribute('username'))
		{
			$request_UserName = $theFile->getAttribute('username');
		}

		// Get the client_id
		$mClient_id = $theFile->getAttribute('client_id');
	}
}

// Create the Result XML document
$domobject = new DOMDocument('1.0', 'utf-8');

// Wrap the request
$elementHolder  = $domobject->createElement("RESPONSE", "");
$elementHolder->setAttribute("action", "Invalid"); 
// Default 
$elementResult  = $domobject->createElement("RESULT", "Nothing");  // Used for all results


$error   = 'ERROR';
$success = 'SUCCESS';
// Types --
$db		= 'DB';
$cmd 	= 'CMD';
$read	= 'READ';


// Clear html
$html = '';

// Review the requested Command
if ($request_Command <> "") 
{
	// See if we can select the database 
	// - Try first with the client ID, and then go to the username for in session usages
	if ($mClient_id <> '')
	{
		$db_selected2  = $database->selectClientDatabaseByMasterClientId($mClient_id);
	}
	else
	{
		$db_selected2  = $database->selectClientDatabaseByUsername($request_UserName);
	}
	
	// Success
	if (!$db_selected2)
	{
		$responsecode = "Failed to Connect to Database for ".$request_UserName;
		$elementHolder->setAttribute("action", $request_Command); 
		$elementHolder->setAttribute("result", $error); 
		$elementHolder->setAttribute("type",   $db); 
		// Add verbose TEST 
		$elementHolder->appendChild($domobject->createTextNode($responsecode));
	}
	else
	{  
		/////////////////////////////////////////////////////////
		if ($request_Command == "Hello")
		/////////////////////////////////////////////////////////
		{
			$responsecode = "Hi back: Database is up. We are here to serve";
					
			$elementSuccess  = $domobject->createElement("SUCCESS");
			$elementSuccess->setAttribute("action", $request_Command); 
			$elementSuccess->setAttribute("result", $success); 
			$elementSuccess->setAttribute("type",   $read); 
			// Add verbose TEST 
			$elementSuccess->appendChild($domobject->createTextNode($responsecode));
			// Add to the complete list
			$elementHolder->appendChild($elementSuccess);		   
		}          
		/////////////////////////////////////////////////////////
		else if ($request_Command == "MonitorL")   
		/////////////////////////////////////////////////////////
		{
			$mHTMLFile=getTeleFlowLogFolder($cTeleFlowServer.$cAccessCommand, $cTeleFlowLogMap)."tfsystemhealth-l.html";
			//echo $mHTMLFile;
			if (file_exists($mHTMLFile))
			{ 
				echo file_get_contents($mHTMLFile);
			}
			die;
		}
		/////////////////////////////////////////////////////////
		else if ($request_Command == "MonitorR")   
		/////////////////////////////////////////////////////////
		{
			$mHTMLFile=getTeleFlowLogFolder($cTeleFlowServer.$cAccessCommand)."tfsystemhealth-r.html";
			//echo $mHTMLFile;
			if (file_exists($mHTMLFile))
			{ 
				echo file_get_contents($mHTMLFile);
			}
			die;
		}  // End of RequestCommand

		/////////////////////////////////////////////////////////
		else if ($request_Command == "GetTFSystems")
		/////////////////////////////////////////////////////////
		// NOTE: Returns a SINGLE entry
		{	
			$responsecode = "Response";
			$elementHolder->setAttribute("action", $request_Command); 

			// Get the most recent event timestamp
			$query_rsSystemList = "
SELECT 
	tfr_server_id,
	server_name,
	server_ip_address,
	tf_monitor_ip_port,
	tf_server_yn,
	web_server_yn,
	db_server_yn       
FROM
	tfr_server
WHERE 
	server_status = 'ACTIVE' 
AND tf_server_yn = 'Y'
";
			//echo($query_rsSystemList); die;
			
			$mBuildHTMLTable = '<table>';
			
			// NOTE: We are working against the system database in this instance
			$database->switchToSystemDatabase();
			$rsSystemsList = $database->sqlConvert_sql_query($query_rsSystemList, $database->connectionSystem); // or die(mysql_error());
			if ($database->sqlConvert_sql_numrows($rsSystemsList) > 0)
			{
				$totalResults = 0;
			
				// Have the data, now respond
				$elementHolder->setAttribute("action", $request_Command); 
				$elementHolder->setAttribute("result", $success); 
				$elementHolder->setAttribute("type",   $db); 

				// Now add each job as an element
				while ($row_rsSystemsItems = $database->sqlConvert_sql_fetch_array($rsSystemsList))
				{
					$totalResults++;
					
					$single = $row_rsSystemsItems;
					$elementResult  = $domobject->createElement("SYSTEMRESULT", $single['tfr_server_id']);
					
					// Add the fields from the database
					$elementResult->setAttribute("count",        $totalResults);
				
					$elementResult->setAttribute('server_name' 			, $single['server_name']);				
					$elementResult->setAttribute('server_ip_address' 	, $single['server_ip_address']);				
					$elementResult->setAttribute('tf_monitor_ip_port' 	, $single['tf_monitor_ip_port']);				
					$elementResult->setAttribute('tf_server_yn' 		, $single['tf_server_yn']);				
					$elementResult->setAttribute('web_server_yn' 		, $single['web_server_yn']);				
					$elementResult->setAttribute('db_server_yn ' 		, $single['db_server_yn']);				
				
					$elementHolder->appendChild($elementResult);					

				}
				// Put in the totals
				$elementHolder->setAttribute("total",   $totalResults); 
				
				// Add table if needed
				$mBuildHTMLTable .= '</table>';
				$elementHolder->setAttribute("htmltable",	$mBuildHTMLTable); 
				
			}
			else
			{
				// Add table if needed
				$mBuildHTMLTable .= '<tr class="'.$mClassHeader.'report_row_odd">'.
				'<td colspan="'.$mBuildHTMLCols.'">No entries found</td></tr>'.
				'</table>';
				$elementHolder->setAttribute("htmltable",	$mBuildHTMLTable); 
			
				$responsecode = "Server results not Found";
				$elementHolder->setAttribute("action", $request_Command); 
				$elementHolder->setAttribute("result", $error); 
				$elementHolder->setAttribute("type",   $db); 
				// Add verbose TEST 
				$elementHolder->appendChild($domobject->createTextNode($responsecode));
			}
		}
		/////////////////////////////////////////////////////////
		else if ($request_Command == "GetTFMonitor")
		/////////////////////////////////////////////////////////
		{
			// See if Mandatory data exists
			if(($theFile->hasAttribute('tf_ip_address')) 
			&& ($theFile->hasAttribute('tf_ip_port'))
			)
			{
				$url = $theFile->getAttribute('tf_ip_address').
						':'.$theFile->getAttribute('tf_ip_port').
						$cAccessCommand;
				//echo $url; die;

				// Set up the table
				//echo('<table cellspacing="0" cellpadding="2" border="1" id="monTable"><tbody>'); 
				//echo ( $theMonitor->getElementsByTagName('TFApp')->item(0)->getAttribute("appName")."<br>"); //.$item->nodeValue . "<br />");  // width="850"
				$html .=
				'<fieldset class="teleflow_tabs"  id="teleflowset"><table class="teleflow_table"><tbody>
				   <tr>
					<td colspan="5" class="teleflow_titles_left">Port / Line</td>
					<td colspan="6" class="teleflow_titles_right">Current Activity</td>
				   </tr>
				   
				   <tr>
					<td class="teleflow_col_1  teleflow_titles_left">Sts</td>
					<td class="teleflow_col_2  teleflow_titles_left">Lic</td>
					<td class="teleflow_col_3  teleflow_titles_left">Restarts</td>
					<td class="teleflow_col_4  teleflow_titles_left">Port</td>
					<td class="teleflow_col_5  teleflow_titles_left">ID</td>
					<td class="teleflow_col_6  teleflow_titles_right">Line Name</td>
					<td class="teleflow_col_7  teleflow_titles_right">Application</td>
					<td class="teleflow_col_8  teleflow_titles_right">Procedure</td>
					<td class="teleflow_col_9  teleflow_titles_right">Step</td>
					<td class="teleflow_col_10 teleflow_titles_right">Data</td>
					<td class="teleflow_col_11 teleflow_titles_right">Log</td>
				   </tr>';   
                            
				// Wait for 8 seconds, because this is a pretty light duty
				$authresult = ffl_HttpGet($url, true, 8);
				//$authresult = fHttpGet($cTeleFlowServer, 80, $cAccessCommand); //ffl_HttpGet($url);
				//echo "DF".$authresult['header']."<BR><BR>";
				//echo "DF".$authresult['body']."<BR><BR>";

				// NOTE: $doc contains the XML from the TeleFlow Server
				if (isset($authresult['body']))
				{
					$doc = $authresult['body'];
					//echo $doc;  

					$xmldoc = new DOMDocument();
					$xmldoc->loadXML($doc);
					
					$theMonitor = $xmldoc->getElementsByTagName('TFMonitor')->item(0);
					// Test to see if we have the log directory defined
					$TeleFlowLogFolder = $theMonitor->getAttribute("LogFolder");

					//echo $TeleFlowLogFolder;
					//$mTFLogDir = getTeleFlowLogFolder($cTeleFlowServer.$cAccessCommand, $cTeleFlowLogMap);
					$mTFLogDir = ''; // @@@
					
					// Row colors
					$mClassHeader = strtolower('teleflow').'_';
					$mRowClasses = array($mClassHeader."report_row_odd", $mClassHeader."report_row_even");
					
					$totalResults = 0;
					foreach ($theMonitor->getElementsByTagName('TFApp') AS $item)
					{
						$totalResults++;
						// Color flip flop
						$mRowClass = $mRowClasses[$totalResults % count($mRowClasses)];
						$html .= '<tr class="'.$mRowClass.'">';

						// Determine log file download points
						$showLogs = False;
						//echo ($item->nodeName." "); // . " = " . $item->nodeValue . "<br />";
						switch ($item->getAttribute("status"))
						{
							case "Normal": 
							{
							  $mPopup = "'Functioning with no recent problems'";
							  $mImage = '<img src="'.$incPath.'images/op-normal.gif" alt="Normal" width="18" height="18" border="0" />';      
							  break;
							}
							case "Recovered": 
							{
							  $mPopup = "'Functioning but recently restarted'";
							  $mImage = '<img src="'.$incPath.'images/op-restart-ani.gif" alt="Recovered" width="18" height="18" border="0" />';   
							  $showLogs = True;  
							  break;
							}
							case "Finish": 
							{
							  $mPopup = "'Application ended'";
							  $mImage = '<img src="'.$incPath.'images/op-finish.gif" alt="Finished" width="18" height="18" border="0" />';   
							  break;          
							}
							case "Failed": 
							{
							  $mPopup = "'Application failed, and not yet restarted'";
							  $mImage = '<img src="'.$incPath.'images/op-stop.gif" alt="Stopped" width="18" height="18" border="0" />';      
							  $showLogs = True;  
							  break; 
							}
							default:
							{
							  $mPopup = "'Unknown status'";
							  $mImage = '<img src="'.$incPath.'images/unlicensed.gif" alt="Unknown" width="18" height="18" border="0" />';      
							}
						}
						// Add popups to the image

						// BETTER LINK</a>
						$mPopCol="'#EEEEEE'";
						//$mImageFull = '<a href="'.$webOnlineDoc.'" onmouseover="popup('.$mPopup.','.$mPopCol.')" onmouseout="kill()" title="" onfocus="this.blur()" target="_blank">'.$mImage.'</a>';
						$mImageFull = '<a title="'.$mPopup.'" href="'.$webOnlineDoc.'" target="_blank">'.$mImage.'</a>';
						$html .= '<td>'.$mImageFull.'</td>';   //$item->getAttribute("status").
						
						// Licenses
						if ($item->getAttribute("license") == 'Unlicensed')
						{
							$mPopup = "'This line is unlicenced (only required for commercial use)'";
							$mImage = '<img src="'.$incPath.'images/unlicensed.gif" alt="Unlicenced" width="18" height="18" border="0" />';      
						}
						else
						{
							$mPopup = "'This line is fully licenced'";
							$mImage = '<img src="'.$incPath.'images/licensed.gif" alt="Licenced" width="18" height="18" border="0" />';      
						}
						$mPopCol="'#EEEEEE'";
						$mImageFull = '<a title="'.$mPopup.'" href="'.$cTeleFlowHelpKB.'?title=TeleFlow_Licensing" target="_blank">'.$mImage.'</a>';
						
						$html .= '<td>'.$mImageFull.'</td>'; 
						
						$mRestartMax = $item->getAttribute("restartMax");
						$mText = $item->getAttribute("restarts")." / ".$mRestartMax;
						if ($mRestartMax == -1)
						{
							$mText = $item->getAttribute("restarts").' / &infin;';
						}
						$html .= '<td>'.$mText                            .'</td>';
						
						$mPort = $item->getAttribute("Port");
						if ($mPort == -1)
						{
							$mText = 'n/a';
						}
						else
						{
							$mText = rightstr("0000".$mPort,3);
						}
						$html .='<td>'.$mText                            .'</td>';               
						$html .='<td>'.$item->getAttribute("appID")      .'</td>';             
						$html .='<td><div>'.$item->getAttribute("appName")    .'</div></td>';       
						$mTapFile =  str_ireplace(".tap","",$item->getAttribute("appFile"));
						$html .='<td><div>'. $mTapFile  .'</div></td>';           
						$html .='<td><div>'.$item->getAttribute("currentTAM") .'</div></td>';        
						
						// Build step link back to wiki   
						$mStepNum  = rightstr("0000".$item->getAttribute("stepNumber"),4);
						$mStepName = $item->getAttribute("stepName");

						// Get log file to review
						if  ($showLogs == True)
						{
							$mImageFull1 = '';
							$mImageFull2 = '';

							$mLogFile= $item->getAttribute("appName").'_'.date('Y-m-d', strtotime('-1 day')).'.log';
							if (file_exists($mTFLogDir.$mLogFile))
							{ 
								$mPopup2 = "'Click to review yesterdays logfile for this line.'";
								$mImage = '<img src="'.$incPath.'images/logfile-past.gif" alt="Review Logfile" width="10" height="18" border="0" />';      
								$mPopCol="'#EEEEEE'";
								$mImageFull1 = '<a href="tflogviewer.php?LogFile='.$mLogFile.'" title="'.$mPopup2.'" target="_blank">'.$mImage.'</a>';
							}			
							$mLogFile= $item->getAttribute("appName").'_'.date('Y-m-d', strtotime('-0 day')).'.log';
							
							if (file_exists($mTFLogDir.$mLogFile))
							{ 
								$mPopup2 = "'Click to review todays logfile for this line.'";
								$mImage = '<img src="'.$incPath.'images/logfile-today.gif" alt="Review Logfile" width="10" height="18" border="0" />';      
								$mPopCol="'#EEEEEE'";
								$mImageFull2 = '<a href="tflogviewer.php?LogFile='.$mLogFile.'" title="'.$mPopup2.'"  target="_blank">'.$mImage.'</a>';
							}
							$logIcons = '<td><div>'.$mImageFull1.$mImageFull2.'</div></td>';
						}       
						else
						{
							// No image
							$logIcons = '<td><div></div></td>';
						}

						// Check the description against the XML for the function number
						$mStepInfo = XMLStepInfo($mStepName);
						$mArrayStep = explode(',',$mStepInfo,10);
						$mStepDesc = $mArrayStep[1];
						$mPopup    = "'Click for full list of steps'";  // (".$mStepNum.") 
						$mHelpLink = '?title=TeleFlow_Steps_List';  // Default wiki page
						if (($mArrayStep[0]) <> '')
						{
							$mHelpLink = '?title=TeleFlow_Step_'.$mArrayStep[0];
							$mPopup    = "'".$mStepDesc." - Click for full documentation'";  // (".$mStepNum.") 
						}
						
						//////////////////////////////
						// Popup hint information
						//////////////////////////////
						$mStepFull = '<a href="'.$cTeleFlowHelpKB.$mHelpLink.'" title="'.$mPopup.'" target="_blank">'.$mStepName.'</a>';
						$html .= '<td><div class="teleflow_text_link">'.$mStepFull                     .'</div></td>';         
						$html .= '<td><div>'.$item->getElementsByTagName("SysData")->item(0)->nodeValue .'</div></td>';  

						// Add the log icons at the end
						$html .= $logIcons;

						$html .= "</tr>";
					}    
					// Mark that we did indeed find a server
					$elementHolder->setAttribute("serverlocated", $theFile->getAttribute('tf_ip_address'));
				}
				else
				{
					$html .= '<tr>
					<td colspan="11" class="teleflow_error">Server Not Located</td>
				   </tr>';
					
				}
				
				// Wrap up everyting
				$html .='</tbody></table></fieldset>';
				
				
				
				$elementHolder->setAttribute("htmltable",	$html); 	
			}
		}
	}
}

/*
// Assume an XML document, and process...
$doc = new DOMDocument();
$doc->loadXML($xmldoc);
//echo($authresult['body']);

decho("BAD COMMAND<BR>");
$elementHolder->setAttribute("action", $request_Command);
// Final results
$responsecode = "ERROR: Unknown Command";
$elementResult  = $domobject->createElement("RESULT", $responsecode);
*/

// Put it all together
$elementHolder->appendChild($elementResult);
$domobject->appendChild($elementHolder);

/*
// Save to Log dir .. if there was a request
if ($request_Command <> "") 
{
	// No saving for this app.  Its not creating new info really
	//$domobject->save($resf);
}


// See what we should send back
if ($html == '')
{
	// Return results
	// Displays out to the screen
	echo $domobject->saveHTML();   
}
else
{
	echo $html;
}
*/
?>