<?php
/*
* TeleFlow OpenVoiceMail
*
* Copyright (C) 2008 engenic (engenic.com)
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with this program; if not, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
* http://www.gnu.org/copyleft/gpl.html
*/
// Includes Section
require_once("cr_reference.php");
require_once($incPath.'LocalSettings.php'); 
include($incPath."include/session.php");

require_once($websiteLibrary.'calcWorkUnit.php');   


// Samples
// <REQUEST action="Hello"></REQUEST>
// -- Will give:  <RESPONSE action="Hello"><RESULT>Hi back: We are here to serve</RESULT></RESPONSE>
//
// <REQUEST action="Delete" MsgId="9509"></REQUEST>
// -- Will give: <RESPONSE action="Delete"><Message Delete="Success">1</Message></RESPONSE>
// -- or <RESPONSE action="Delete"><Message Delete="Fail" Reason="MsgId Not Found">0</Message></RESPONSE>
//
// <REQUEST action="Save" MsgId="9509"></REQUEST>
// -- Will give: <RESPONSE action="Save"><Message Saved="Success">1</Message></RESPONSE>
// -- 
//
// <REQUEST action="LastMsgId" UserId="2" MsgId="9510"></REQUEST>
// --  <response action="LastMsgId"><Message Result="NothingNew">9510</Message></response>
// --  <response action="LastMsgId"><Message Result="NewMessage">9515</Message></response>
//
//
header('Content-Type: text/xml');
header("Cache-Control: no-cache, must-revalidate");
//A date in the past
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");

// Constants
$cSysName   = 'xml_voicecmd';

// LIST of STATUS
$cNew    = "New";
$cDELETE = "DELETE";
$cSaved  = "Saved";
$cPURGED = "PURGED";

$cResult = "Result";

// Heard status update
$cHeard  = "Heard";


// Determine how much output we should see
$OutPutMode   = TRUE;

////////////////// FUNCTIONS //////////////////
function decho($pText)
{ 
   //if (!IsSet($OutPutMode))
   //{
   //  echo "CANT SEE YOU!!<BR>";
   //}
   //if ($OutPutMode == TRUE)
   { 
      //echo ($pText);
   }
}  
/////////////////////////// MAIN ///////////////////////////////
// Get the full request
$data         = file_get_contents("php://input");
//$data         = file_get_contents("test_sendtest.xml");  // Debug

// Resposnes provided by the PHP program
$responsecode = "";
$xmlresult    = "<RESULT>ERROR Database or other failure</RESULT>";


// Date and Time defaults
$teleflowDate = Date("Y/m/d");
$teleflowTime = Date("H:i:s");
     // yyyy/mm/dd ==> mm/dd/yyyy
$webDate      = Date("m/d/Y");


//echo("<BR><BR>".$data."<BR><BR>");
decho("STARTED at ".teleflowNowDate()." ".teleflowNowTime()." (".$webDate.")<BR>");

// Set up file names
$stmp        = date("Y-m-d_H-i-s");
$fold        = "log/";
// Create the log folder
if (!is_dir($fold))
{
    mkdir($fold);
}
$reqf  = $fold.$cSysName."_".$stmp."_request.xml";
$resf  = $fold.$cSysName."_".$stmp."_response.xml";


// Assume an XML document, and process...
$doc = new DOMDocument();

$request_Command = '';
// Did the user actually send a request?
if ($data <> '')
{
   $doc->loadXML($data);
   // save it for later review
   //$doc->save($reqf);

   // XML Command request
   // -- Find out what the command is (Must be a REQUEST)
   $theFile = $doc->getElementsByTagName('REQUEST')->item(0);

   if ($theFile->hasAttribute('action'))
   {
      $request_Command = $theFile->getAttribute('action');
   }
}

// Create the Result XML document
$docresult = new DOMDocument('1.0', 'utf-8');

// Wrap the request
$elementHolder  = $docresult->createElement("response", "");
$elementHolder->setAttribute("action", "Invalid"); 
// Default 
$elementResult  = $docresult->createElement("result", "Nothing");  // Used for all results


// Review the requested Command
if ($request_Command <> "") 
{
   // Get started with the voicemail database
   mysql_select_db($database_voicemail, $voicemail);   
   if (!$voicemail)
   {
      $responsecode = "ERROR: Failed to Connect to Database";
      $elementResult  = $docresult->createElement("RESULT", $responsecode);
   }
   else
   {
      /////////////////////////////////////////////////////////
      if ($request_Command == "Hello")
      /////////////////////////////////////////////////////////
      {
         $responsecode = "Hi back: We are here to serve";
         $elementHolder->setAttribute("action", $request_Command); 
         $elementResult  = $docresult->createElement("result", $responsecode);      
      }
      // Process commands
      /////////////////////////////////////////////////////////
      else if ($request_Command == "LastMsgId")
      /////////////////////////////////////////////////////////
      {
         $responsecode = "Response";
         $elementHolder->setAttribute("action", $request_Command); 

         // Get the Attibutes (Fields)
         $reqLastMsgId_UserId        = $theFile->getAttribute('UserId');
         $reqLastMsgId_MsgId         = $theFile->getAttribute('MsgId');
         
         // Are all the fields populated
         if ($reqLastMsgId_UserId <> "" )
         {
           // Were good to go...
           decho("UserId: ".$reqLastMsgId_UserId."<BR>");
           
           // Do we have an entry yet?
           //$q = "select max(msg_id) as maxMsgId from mailbox_message where mbx_id = $reqLastMsgId_MbxId";
           $q = (sprintf(
"SELECT                                          
   max(b.msg_id) as maxMsgId                     
FROM                                            
   user u,                                      
   mailbox m,                                   
   mailbox_message b                            
WHERE                                           
       m.u_id = u.u_id                          
and b.mbx_id = m.mbx_id                         
and b.mbx_msg_status = 'New'
and u.u_id = '%s'", $reqLastMsgId_UserId));

           $result = mysql_query($q, $voicemail) or die(mysql_error());
           // Provide the result
           if ($result) 
           {
              // Final results
              $row_resultList     = mysql_fetch_assoc($result);
              $mMaxMsg          = $row_resultList['maxMsgId'];
              if ($mMaxMsg == '')
              {
                 $elementResult  = $docresult->createElement("Message", 0);
              }
              else
              {
                 $elementResult  = $docresult->createElement("Message", $mMaxMsg);
              }
              
              if ($row_resultList['maxMsgId'] > $reqLastMsgId_MsgId) 
              {
                 $elementResult ->setAttribute($cResult, "NewMessage");
              }
              else
              {
                 // No new messages
                 $elementResult ->setAttribute($cResult, "NothingNew");
              }
           }
           else
           {
              $elementResult ->setAttribute($cResult, "Fail");
              $elementResult ->setAttribute("Reason", "MbxId Not Found");
           }
         }
      }
      /////////////////////////////////////////////////////////
      else if ($request_Command == "LastMsgIdDept")
      /////////////////////////////////////////////////////////
      {
         $responsecode = "Response";
         $elementHolder->setAttribute("action", $request_Command); 

         // Get the Attibutes (Fields)
         $reqLastMsgId_UserId        = $theFile->getAttribute('UserId');
         $reqLastMsgId_MsgId         = $theFile->getAttribute('MsgId');
         
         // Are all the fields populated
         if ($reqLastMsgId_UserId <> "" )
         {
           // Were good to go...
           decho("UserId: ".$reqLastMsgId_UserId."<BR>");
           
           // Do we have an entry yet?
           //$q = "select max(msg_id) as maxMsgId from mailbox_message where mbx_id = $reqLastMsgId_MbxId";
           $q = (sprintf(
"SELECT        
  max(s.msg_id) as maxMsgId
FROM                                                      
   mailbox b, 
   mailbox_message s,  
   message m,       
   group_detail g                                        
WHERE
       sent_date >= adddate(curdate(), INTERVAL -5 DAY)
and s.mbx_id = b.mbx_id 
and g.mbx_id = s.mbx_id
and m.msg_id = s.msg_id
and s.mbx_msg_status in ('New')  
and g.group_id in (select group_id from user_group where u_id = '%s')", $reqLastMsgId_UserId));

           $result = mysql_query($q, $voicemail) or die(mysql_error());
           // Provide the result
           if ($result) 
           {
              // Final results
              $row_resultList   = mysql_fetch_assoc($result);
              $mMaxMsg          = $row_resultList['maxMsgId'];
              if ($mMaxMsg == '')
              {
                 $elementResult  = $docresult->createElement("Message", 0);
              }
              else
              {
                 $elementResult  = $docresult->createElement("Message", $mMaxMsg);
              }
              
              if ($row_resultList['maxMsgId'] > $reqLastMsgId_MsgId) 
              {
                 $elementResult ->setAttribute($cResult, "NewMessage");
              }
              else
              {
                 // No new messages
                 $elementResult ->setAttribute($cResult, "NothingNew");
              }
           }
           else
           {
              $elementResult ->setAttribute($cResult, "Fail");
              $elementResult ->setAttribute("Reason", "MbxId Not Found");
           }
         }
      }
      /////////////////////////////////////////////////////////
      else if ($request_Command == "Delete")
      /////////////////////////////////////////////////////////
      {
         $responsecode = "Response";
         $elementHolder->setAttribute("action", $request_Command); 

         // Get the Attibutes (Fields)
         $reqDelete_MsgId         = $theFile->getAttribute('MsgId');
         
         // Are all the fields populated
         if ($reqDelete_MsgId <> "" )
         {
           // Were good to go...
           decho("MsgId: ".$reqDelete_MsgId."<BR>");
           
           // Do we have an entry yet?
           $q = "select count(*) exist from mailbox_message where msg_id = $reqDelete_MsgId";

           //echo $q."<br><br>";
           $result = mysql_query($q, $voicemail) or die(mysql_error());

           // Provide the result
           if ($result) 
           {
              // Final results
              $row_resultList     = mysql_fetch_assoc($result);
              $totalRows_result   = mysql_num_rows($result);
              //$responsecode = "ERROR: VoiceMail Last Database Error";
              $elementResult  = $docresult->createElement("Message", $row_resultList['exist']);
              //$elementResult ->setAttribute("LastEntryTime",  $row_resultList['filetime']);

              if ($row_resultList['exist'] > 0) 
              {
                 // Update the Message
                 $qUpd = "UPDATE  "
                        ."  message   "
                        ."SET  "
                        ."  msg_status = '$cDELETE'  "
                        ."WHERE   "
                        ."  msg_id   = $reqDelete_MsgId " 
                        ."";
                 //echo($qUpd);
                 
                 $result = mysql_query($qUpd, $voicemail);
                 // What happened?
                 if ($result == TRUE) 
                 {
                      // Update the Message
                      $qUpd = "UPDATE  "
                             ."  mailbox_message   "
                             ."SET  "
                             ."  mbx_msg_status = '$cDELETE'  "
                             ."WHERE   "
                             ."  msg_id   = $reqDelete_MsgId " 
                             ."";
                      $result = mysql_query($qUpd, $voicemail);
                      // What happened?
                      if ($result == TRUE) 
                      {
                           decho("Delete Success<BR>");
                           $elementResult ->setAttribute($cDELETE, "Success");
                      }
                      else
                      {
                           decho("Delete Failed<BR>");
                           $elementResult ->setAttribute($cDELETE, "Fail");
                           $elementResult ->setAttribute("Reason", "MsgId Not Found");
                      } 
                 }
                 else
                 {
                      decho("Delete Failed<BR>");
                      $elementResult ->setAttribute($cDELETE, "Fail");
                      $elementResult ->setAttribute("Reason", "MsgId Not Found");
                 }                 
              }
              else
              {
                 // Does not exist
                 $elementResult ->setAttribute($cDELETE, "Fail");
                 $elementResult ->setAttribute("Reason", "MsgId Not Found");
              }
            }
         }
      }
      /////////////////////////////////////////////////////////
      else if ($request_Command == "Save")
      /////////////////////////////////////////////////////////
      {
         $responsecode = "Response";
         $elementHolder->setAttribute("action", $request_Command); 

         // Get the Attibutes (Fields)
         $reqSave_MsgId         = $theFile->getAttribute('MsgId');
         
         // Are all the fields populated
         if ($reqSave_MsgId <> "" )
         {
           // Were good to go...
           decho("MsgId: ".$reqSave_MsgId."<BR>");
           
           // Do we have an entry yet?
           $q = "select count(*) exist from mailbox_message where msg_id = $reqSave_MsgId";

           //echo $q."<br><br>";
           $result = mysql_query($q, $voicemail) or die(mysql_error());

           // Provide the result
           if ($result) 
           {
              // Final results
              $row_resultList     = mysql_fetch_assoc($result);
              $totalRows_result   = mysql_num_rows($result);
              //$responsecode = "ERROR: VoiceMail Last Database Error";
              $elementResult  = $docresult->createElement("Message", $row_resultList['exist']);
              //$elementResult ->setAttribute("LastEntryTime",  $row_resultList['filetime']);

              if ($row_resultList['exist'] > 0) 
              {
                 // Update the Message
                 $qUpd = "UPDATE  "
                        ."  message   "
                        ."SET  "
                        ."  msg_status = '$cSaved'  "
                        ."WHERE   "
                        ."    msg_id   = $reqSave_MsgId " 
                        ."";
                 //echo($qUpd);
                 
                 $result = mysql_query($qUpd, $voicemail);
                 // What happened?
                 if ($result == TRUE) 
                 {
                      // Update the Message
                      $qUpd = "UPDATE  "
                             ."  mailbox_message   "
                             ."SET  "
                             ."  mbx_msg_status = '$cSaved'  "
                             ."WHERE   "
                             ."  msg_id  = $reqSave_MsgId " 
                             ."";
                      $result = mysql_query($qUpd, $voicemail);
                      // What happened?
                      if ($result == TRUE) 
                      {
                           decho("Save Success<BR>");
                           $elementResult ->setAttribute($cSaved, "Success");
                      }
                      else
                      {
                           decho("Save Failed<BR>");
                           $elementResult ->setAttribute($cSaved, "Fail");
                           $elementResult ->setAttribute("Reason", "MsgId Not Found");
                      } 
                 }
                 else
                 {
                      decho("Save Failed<BR>");
                      $elementResult ->setAttribute($cSaved, "Fail");
                      $elementResult ->setAttribute("Reason", "MsgId Not Found");
                 }                 
              }
              else
              {
                 // Does not exist
                 $elementResult ->setAttribute($cSaved, "Fail");
                 $elementResult ->setAttribute("Reason", "MsgId Not Found");
              }
            }
         }
      }
      /////////////////////////////////////////////////////////
      else if ($request_Command == "Heard")
      /////////////////////////////////////////////////////////
      {
         $responsecode = "Response";
         $elementHolder->setAttribute("action", $request_Command); 

         // Get the Attibutes (Fields)
         $reqHeard_MsgId         = $theFile->getAttribute('MsgId');
         
         // Are all the fields populated
         if ($reqHeard_MsgId <> "" )
         {
           // Were good to go...
           decho("MsgId: ".$reqHeard_MsgId."<BR>");
           
           // Do we have an entry yet?
           $q = "select count(*) exist from mailbox_message where msg_id = $reqHeard_MsgId";

           //echo $q."<br><br>";
           $result = mysql_query($q, $voicemail) or die(mysql_error());

           // Provide the result
           if ($result) 
           {
              // Final results
              $row_resultList     = mysql_fetch_assoc($result);
              $totalRows_result   = mysql_num_rows($result);
              //$responsecode = "ERROR: VoiceMail Last Database Error";
              $elementResult  = $docresult->createElement("Message", $row_resultList['exist']);
              //$elementResult ->setAttribute("LastEntryTime",  $row_resultList['filetime']);

              if ($row_resultList['exist'] > 0) 
              {
                 // Update the Message
                 $qUpd = "UPDATE  "
                        ."  mailbox_message   "
                        ."SET  "
                        ."  heard_once_yn = 'Y'  "
                        ."WHERE   "
                        ."  msg_id   = $reqHeard_MsgId " 
                        ."";
                 $result = mysql_query($qUpd, $voicemail);
                 // What happened?
                 if ($result == TRUE) 
                 {
                      decho("Heard Success<BR>");
                      $elementResult ->setAttribute($cHeard, "Success");
                 }
                 else
                 {
                      decho("Heard Failed<BR>");
                      $elementResult ->setAttribute($cHeard, "Fail");
                      $elementResult ->setAttribute("Reason", "MsgId Not Found");
                 } 
              }
              else
              {
                 // Does not exist
                 $elementResult ->setAttribute($cHeard, "Fail");
                 $elementResult ->setAttribute("Reason", "MsgId Not Found");
              }
            }
         }
      }
      /////////////////////////////////////////////////////////
      else
      /////////////////////////////////////////////////////////
      {
        decho("BAD COMMAND<BR>");
        $elementHolder->setAttribute("action", $request_Command);
        // Final results
        $responsecode = "ERROR: Unknown Command";
        $elementResult  = $docresult->createElement("RESULT", $responsecode);
      }
   }
}
else
{
   decho("NO COMMAND Provided<BR>");
   $elementHolder->setAttribute("action", "NotDefined");
   // Final results
   $responsecode = "ERROR: No Command Provided";
   $elementResult  = $docresult->createElement("RESULT", $responsecode);
}

// Put it all together
$elementHolder->appendChild($elementResult);
$docresult->appendChild($elementHolder);
// Save to Log dir .. if there was a request
if ($request_Command <> "") 
{
    // No saving for this app.  Its not creating new info really
    //$docresult->save($resf);
}

// Return results
echo '<?xml version="1.0" encoding="ISO-8859-1"?>';
// Displays out to the screen
echo $docresult->saveHTML();   
//mysql_free_result($voicemail);
?>