<?php

//container class that holds all the user information required to make direct payments with paypal
class PayPalCustomerDetails
{
	private $street1; 
	private $street2; 
	private	$city; 
	private $province; 
	private $zip; 
	private $countryCode; 
	private $currencyCode; 
	
	private $salutation; 
	private $firstName; 
	private $middleName; 
	private $lastName; 
	
	private $creditCardType; 
	private $ACCT; 
	private $expDate; 
	private $CVV2; 
	
	public function ObtainPostString()
	{
		$postString = "&CREDITCARDTYPE=$this->creditCardType&ACCT=$this->ACCT&EXPDATE=$this->expDate&";
			
			if($this->CVV2 != NULL)
			{
				$postString .= "CVV2=$this->CVV2&";
			}
			
		$postString .= "SALUTATION=$this->salutation&FIRSTNAME=$this->firstName&MIDDLENAME=$this->middleName&LASTNAME=$this->lastName&";
		$postString .= "STREET=$this->street1&STREET2=$this->street2&CITY=$this->city&STATE=$this->province&COUNTRYCODE=$this->countryCode&ZIP=$this->zip&";
		$postString .= "CURRENCYCODE=$this->currencyCode";
		
		return $postString;
	}
	
	//@@@input checking. 
	public function SetCustomerName($salutation,$firstName,$middleName,$lastName)
	{
		$this->salutation = urlencode($salutation); 
		$this->firstName = urlencode($firstName); 
		$this->middleName = urlencode($middleName); 
		$this->lastName = urlencode($lastName); 
	}
	
	public function SetCustomerAddress($street1,$street2,$city, $province,$zip, $countryCode,$currencyCode)
	{
		$this->street1 = urlencode($street1); 
		$this->street2 = urlencode($street2); 
		$this->city = urlencode($city); 
		$this->province = urlencode($province); 
		$this->zip = urlencode($zip); 
		$this->countryCode = urlencode($countryCode); 
		$this->currencyCode = urlencode($currencyCode); 
	}
	
	public function SetCustomerCreditCard($creditCardType, $ACCT, $expDate, $CVV2 = NULL)
	{
		$this->creditCardType = urlencode($creditCardType); 
		$this->ACCT = urlencode($ACCT); 
		$this->expDate = urlencode(str_pad($expDate, 2, '0', STR_PAD_LEFT));//must be padded with zeroes. 
		$this->CVV2 = urlencode($CVV2); 
	}
	
}

?>