<?php

class PayPalHTTPConnection
{
	private $payPalServer; 
	private $payPalServerPath; 
	private $version; 
	
	private $userName; 
	private $password;
	private $signature; 
	private $status = null; 
		
	function PayPalHTTPConnection($server, $userName, $password, $signature,$version = "51.0",$serverPath = "/nvp")
	{
		$this->payPalServer = $server;
		$this->payPalServerPath = $serverPath; 
		$this->version = urlencode($version); 
		
		$this->userName = urlencode($userName); 
		$this->password = urlencode($password); 
		$this->signature = urlencode($signature); 		
	}
	
	public function GetLastStatus()
	{
		return $this->status;
	}
	
	public function SendHTTPPost($postBody, $methodName)
	{
		$methodName = urlencode($methodName); 
		$postData = "METHOD=$methodName&VERSION=$this->version&PWD=$this->password&USER=$this->userName&SIGNATURE=$this->signature" . $postBody;
		
		$postLength = strlen($postData); 
		
		$post = "POST $this->payPalServerPath HTTP/1.1\r\n";///nvp
		$post .= "Host: $this->payPalServer\r\n";//api-3t.sandbox.paypal.com
		$post .= "Accept: */*\r\n";
		$post .= "Content-Length: $postLength\r\n";//293
		$post .= "Content-Type: application/x-www-form-urlencoded\r\n";
		$post .= "\r\n";
		$post .= $postData; 

		$socket = fsockopen("ssl://" . $this->payPalServer/*api-3t.sandbox.paypal.com*/, 443, $errno, $errstr, 30);//default values might change!

		if (!$socket) 
		{
			echo "$errstr ($errno)<br />\n";
		} 
		else
		{
			fwrite($socket, $post);
    
			$payPalData = "";
		
			while (!feof($socket)) 
			{
				$payPalData .= fgets($socket, 1024);
			}
    
			//echo "output::::>> $twitterData"; //delete this line latter !!
			fclose($socket);
		}
				
		//echo $payPalData; 
		//echo "<br>";
		//echo $output["L_AMT0"];
		
		$this->SetPayPalHTTPStatus($payPalData);		
		
		return $payPalData;
	}
	
	private function SetPayPalHTTPStatus($payPalHeader)
	{			
		$httpHeaderArray = explode("HTTP/1.1",$payPalHeader); 
		
		if(isset($httpHeaderArray[1]))
		{
			$this->status = substr($httpHeaderArray[1],1,3);//Get the 'Status:' field from the http header send by the twitter server. 			
		}				
	}	
	
}


?>