<?php

include_once("PayPalHTTPConnection.php");

class PayPalPayment extends PayPalHTTPConnection
{
	function PayPalPayment($API_Server, $API_UserName, $API_Password, $API_Signature, $API_Version = "51.0",$API_ServerPath = "/nvp")
	{
		parent::PayPalHTTPConnection($API_Server,$API_UserName,$API_Password,$API_Signature,$API_Version,$API_ServerPath); 		
	}
	
	// PAYMENTACTION=Sale
	// PAYMENTACTION=Authorization
	public function DoDirectPayment($amount, 
									$ip, 
									$postBody, 
									$pEmail,
									$pItemName,
									$pItemQuantity,
									$pItemCost,
									$pItemDescription,
									$pGeneralNotes, 	// Not used
									$pPaymentAction = "Authorization")	//payment action is either Authorization or Sale. 
	{
		$amount = urlencode($amount); 
		$ip = urlencode($ip);
		$body = urlencode($postBody);
		$mEmail = urlencode($pEmail);
		$mItemName = urlencode($pItemName);
		$mItemQuantity = urlencode($pItemQuantity);
		$mItemCost = urlencode($pItemCost);
		$mItemDescription = urlencode($pItemDescription); 
		$mPaymentAction = urlencode($pPaymentAction); 
		
		$postBody = "&AMT=".$amount.
					"&PAYMENTACTION=".$mPaymentAction.
					"&IPADDRESS=".$ip.
					"&EMAIL=".$mEmail.
					"&L_NAME0=".$mItemName.
					"&L_QTY0=".$mItemQuantity.
					"&L_AMT0=".$mItemCost.
					"&L_DESC0=".$mItemDescription.
					$postBody; //@@@should be passed in from the PayPalPayment class
		
		$responce = parent::SendHTTPPost($postBody, "DoDirectPayment"); 
		
		$status = parent::GetLastStatus();
		
		if($status != "200")
		{
			return NULL;
		}
		
		$response = $this->ParseDoDirectPayment($responce);		
			
		return $response;//returns an array. Important fields in the array is the 'TRANSACTIONID' -> an unique number corresponding to the transaction.  
	}
	
	private function ParseDoDirectPayment($payPalData)
	{
		$array = explode("\r\n\r\n", $payPalData,2);
		
		parse_str($array[1],$output); 
		
		return $output; 
	}
	
}


?>