<?php
/*
* xml_connectrelaycmd.php
*
* Copyright (C) 2008 engenic (engenic.com)
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with this program; if not, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
* http://www.gnu.org/copyleft/gpl.html
*/

/*
==About the Database==
===Table: sr_employee ===
* This table will have multiple rows for multiple jobs by the employee
* Generally employees will have between one and five entries in this table.
* A single entry will be their only job.



==USAGE==
Basic command
* http://localhost/engenic_app_root/eng_staffrelay_xml/xml_staffcmd.php

Command with debug information
* http://localhost/engenic_app_root/eng_staffrelay_xml/xml_staffcmd.php?DEBUG=YES



===Hello===
This will determine if the system is alive with database operations
* http://localhost/engenic_app_root/eng_staffrelay_xml/xml_staffcmd.php
* BODY:  
	<REQUEST action="Hello"></REQUEST>


===LogEvent==
This will add an entry to the Log Table
* http://localhost/engenic_app_root/eng_staffrelay_xml/xml_staffcmd.php
* BODY:
	<REQUEST action="LogEvent"
	evt_code="START"
	call_start="12314.000"
	call_elapse="3.000"
	tf_app="TF_ABSENCETRACKER"
	log_date="2008/10/09"
	log_time="17:22:59"
	evt_port="1"
	site_code=""
	region_code=""
	evt_type=""
	evt_data1="0"
	evt_data2=""
	evt_data3="NULL">
	</REQUEST>

* Example Response
<RESPONSE action="LogEvent"  result="SUCCESS" type="DB">Hi back: Database is up. We are here to serve</RESPONSE>	



===ValidateEmployee===
<REQUEST action="ValidateEmployee" employeeid="3637"></REQUEST>	

* Example Response
<?xml version="1.0" encoding="ISO-8859-1"?>
<RESPONSE action="ValidateEmployee" result="SUCCESS" type="DB" 
fullname="" firstname="Suzy" lastname="Ing" supernum=""></RESPONSE>

	
	
===GetEmployeeJobs===
<REQUEST action="GetEmployeeJobs" employeeid="3637"></REQUEST>	

* Example Response
<?xml version="1.0" encoding="ISO-8859-1"?>
<RESPONSE  action="GetEmployeeJobs" result="SUCCESS" type="DB" 
fullname="" firstname="Suzy" lastname="Ing" supernum="" jobtotal="2">
    <EmployeeJob count="1" job_cd="753"  dept_num="72952012" division="4000" location="4000" 
     dept_name="Extended Care Admin"  org_name="Minoru Residence">SecretaryReceptionist - Minor</EmployeeJob>
    <EmployeeJob count="2" job_cd="842" dept_num="74701000" division="3000" location="3000" 
    dept_name="Social Work" org_name="Richmond Hospital">Social Worker 1-BSW</EmployeeJob>
</RESPONSE>


	
===InsertEmployeeAbsence===
<REQUEST 
action="InsertEmployeeAbsence" employeeid="3637"
fullname="Suzy Ing"
abstype="ABSENT"
absreason="SICK"
confnum="42342"></REQUEST>	

* Example Response
<?xml version="1.0" encoding="ISO-8859-1"?><RESPONSE action="InsertEmployeeAbsence" 
result="SUCCESS" type="DB"></RESPONSE>
	
*/


// Samples
// <REQUEST action="Hello"></REQUEST>
// -- Will give:  <RESPONSE action="Hello"><RESULT>Hi back: We are here to serve</RESULT></RESPONSE>
//
// <REQUEST action="Delete" MsgId="9509"></REQUEST>
// -- Will give: <RESPONSE action="Delete"><Message Delete="Success">1</Message></RESPONSE>
// -- or <RESPONSE action="Delete"><Message Delete="Fail" Reason="MsgId Not Found">0</Message></RESPONSE>
//
// <REQUEST action="Save" MsgId="9509"></REQUEST>
// -- Will give: <RESPONSE action="Save"><Message Saved="Success">1</Message></RESPONSE>
// -- 
//
// <REQUEST action="LastMsgId" UserId="2" MsgId="9510"></REQUEST>
// --  <response action="LastMsgId"><Message Result="NothingNew">9510</Message></response>
// --  <response action="LastMsgId"><Message Result="NewMessage">9515</Message></response>
//
//
header('Content-Type: text/xml');
header("Cache-Control: no-cache, must-revalidate");
//A date in the past
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");


// Override settings with this
define("SYSTEM_SR",  "YES");


$incPath = '../';
require_once($incPath.'LocalSettings.php'); 
require($incPath.$sessionphp);
$_SESSION['IncPath'] = $incPath;
require_once($websiteLibrary.'calcWorkUnit.php');     

/////////////////////////// STAFFCMD FUNCTIONS ///////////////////////////////
// NOTE: This is a holder for the functions that are referenced in body
include('xml_connectrelaycmd_functions.php');
/////////////////////////// STAFFCMD FUNCTIONS ///////////////////////////////


/////////////////////////// MAIN ///////////////////////////////
// NOTE: This section is where data is passed. 
// Get the full request for POST
$data         = file_get_contents("php://input");
//$data         = file_get_contents("test_sendtest.xml");  // Debug

// See if we are GETTING
//$get_cmd=htmlspecialchars($_GET['cmd'],ENT_QUOTES);


/////////////////////////// STAFFCMD BODY ///////////////////////////////
// NOTE: This section works with the value in $data
include('xml_connectrelaycmd_body.php');
/////////////////////////// STAFFCMD BODY ///////////////////////////////



/////////////////////////// FINAL ///////////////////////////////
// NOTE: Determine what to return (see Body for values)
// Return results
echo '<?xml version="1.0" encoding="ISO-8859-1"?>';
// Displays out to the screen
echo $domobject->saveHTML();   
//mysql_free_result($voicemail);
?>