<?php
/* 
calcWorkUnit - Lots of string manipulation and file functions that are common to TeleFlowRelay
- Created by: Vern Baker
- Last updated: 2009
- GPL license
*/

// FUNCTIONS:  Calculations and string manipulation

// Test LIVE by testing for standard codes
function clientType_Live_YN($pClient_Type)
{
	if (strtoupper($pClient_Type) == 'LIVE')
	{
		return true;
	} 
	else if ((strtoupper($pClient_Type) == 'TEST') || (strtoupper($pClient_Type) == 'DEMO'))
	{
		return false;
	}
	// Assume live for blank entries and others
	return true; 
} //clientType_Live_YN

// Test for TEST mode
function clientType_Test_YN($pClient_Type)
{
	return (strtoupper($pClient_Type) == 'TEST');
} //clientType_Test_YN

// Test for DEMO mode
function clientType_Demo_YN($pClient_Type)
{
	return (strtoupper($pClient_Type) == 'DEMO');
} //clientType_Demo_YN

// Test for TRUE or YES
function TrueOrYes($pCode)
{
	if ((strtoupper($pCode) == 'YES')
		|| (strtoupper($pCode) == 'TRUE'))
	{
		return True;
	}
	return False;
}
// Test for TRUE or YES
function FalseOrNo($pCode)
{
	if ((strtoupper($pCode) == 'NO')
		|| (strtoupper($pCode) == 'FALSE'))
	{
		return True;
	}
	return False;
}

// -----------------------

// Copy characters from the right of a string
// tags: RightCopy
function rightstr($pString, $pLen)
{
  $mLen  = strlen($pString);  
  return substr($pString,$mLen-$pLen);
}

// Easy way to quickly zero fill
function zeroFill($pNumber, $pLen)
{
	return rightstr('00000000000000'.$pNumber,$pLen);
}

// String repeating charactes of said character to one
function stripRepeating($pChar,$pString)
{
	return preg_replace('/['.$pChar.']+/', $pChar, $pString);
}


// Strip characters between two points
// eg stripBetweenTwoPoints('ABCDEFGHIJKLM,'CD', 'IJ')
// result: 'ABKLM';
function stripBetweenTwoPoints($pString, $pStart, $pEnd)
{
	$mLen = strlen($pString);
	$mP1 = strpos($pString,$pStart); // First occurance
	$mP2 = strrpos($pString,$pEnd); // Last occurance
	if (( $mP1 > -1) and ($mP2 > -1))
	{
		// return the outside bits
		$mBuild = substr($pString,0,$mP1).substr($pString,$mP2+strlen($pEnd)); //  + lenght of point
		return $mBuild;
	}
	else
	{
		// Nothing found, return the whole thing
		return $pString;
	}	
} // stripBetweenTwoPoints


//  Change a file extention for a file name
function changeFileExtension($filename, $new_extension) 
{
	// Better way, but its really late
	if (substr($filename,0,2) == '..')
	{
		// in case there is a .. folder change change
		return '..'.preg_replace('/\..+$/', '.' . $new_extension, substr($filename,2,999));
	}
	else
	{
		return preg_replace('/\..+$/', '.' . $new_extension, $filename);
	}
} // changeFileExtension


// Get File extention
function getFileExtension($filename)
{
    return end(explode(".", $filename));
}


// Create a range set
// eg: list   of 1,2,4-10,14  will return 1,2,4,5,6,7,8,9,10,14
function RangeSetStringCreate($pRange)
{
	$mResult = '';
	$mComponents = explode(",", $pRange);
	foreach ($mComponents as $mEachOne)
	{
		$mText = trim($mEachOne);
		$mRangeComponents = explode("-", $mEachOne);
		if (isset($mRangeComponents[1]))
		{
			$mVar1 = $mRangeComponents[0];
			$mVar2 = $mRangeComponents[1];
			//echo '--'.$mVar1.'--'.$mVar2."\n\r"; 

			if ((is_numeric($mVar1) && (is_numeric($mVar2))))
			{
				for($mLoop=$mVar1; $mLoop<=$mVar2; $mLoop++)
				{
					if (!$mResult == '')
					{
						$mResult .= ',';
					}
					$mResult .= $mLoop;	
				}
			}
		}
		else
		{			
			if (!$mResult == '')
			{
				$mResult .= ',';
			}
			$mResult .= $mText;
		}
	}	
	
	return $mResult;
}  // RangeSetStringCreate


// takes a string and returns an array of characters 
function toCharArray($input)
{ 
    $len = strlen($input); 
    for ($j=0;$j<$len;$j++)
	{ 
        $char[$j] = substr($input, $j, 1);     
    } 
    return ($char); 
} 

// Insert text into a string
function strInsert($pInsertSource, $pString, $pPos)
{
	// xxxyyy  <-- zzz
	// 012345
	$mVar = substr($pString, 0, $pPos).$pInsertSource.substr($pString, $pPos, 999);
	return($mVar);
}

// Delete text into a string
function strDelete($pString, $pIndex, $pCount)
{
	// xxxyyy  <-- zzz
	// 012345
	$mAdd = $pIndex+$pCount;
	$mVar = substr($pString, 0, $pIndex).substr($pString, $mAdd, 999);
	return($mVar);
}


// Convert hex string to binary string (used in decrypt_data) eg: hex2bin for the PHP bin2hex function
function hex2bin($data) 
{
	$len = strlen($data);
	for($i=0;$i<$len;$i+=2) 
	{
		$newdata .= pack("C",hexdec(substr($data,$i,2)));
	}
	return $newdata;
}

// Add line feeds etc
function addCRLF()
{
	return chr(13).chr(10);
}

// Used for Blowfish encryption to pad
// - Note: find blowfish calls in database.php
function pkcs5_pad($text, $blocksize)
{
    $pad = $blocksize - (strlen($text) % $blocksize);
    return $text.str_repeat(chr($pad), $pad);
}

// Used for Blowfish encryption to remove padding
function pkcs5_unpad($text)
{
    $pad = ord($text{strlen($text)-1});
    if ($pad > strlen($text)) return false;
    if (strspn($text, chr($pad), strlen($text) - $pad) != $pad) return false;
    return substr($text, 0, -1 * $pad);
}

// Sentence case.  
function sentence_case($s) 
{
	$str = strtolower($s);
	$cap = true;
	$ret = '';
	for($x = 0; $x < strlen($str); $x++)
	{
		$letter = substr($str, $x, 1);
		if($letter == "." || $letter == "!" || $letter == "?")
		{
			$cap = true;
		}
		elseif($letter != " " && $cap == true)
		{
			$letter = strtoupper($letter);
			$cap = false;
		}
		$ret .= $letter;
	}
	return $ret;
}

// Sentence case only when everything is capitalized
// eg: SMITH = Smith
// eg: McBOB = McBOB  (no change)
function sentence_case_only_if_all_uppercase($s) 
{
	$ret = $s;
	// Is everything upper case?
	if ($s == strtoupper($s))
	{
		$str = strtolower($s);
		$cap = true;
		$ret = '';
		for($x = 0; $x < strlen($str); $x++)
		{
			$letter = substr($str, $x, 1);
			if($letter == "." || $letter == "!" || $letter == "?")
			{
				$cap = true;
			}
			elseif($letter != " " && $cap == true)
			{
				$letter = strtoupper($letter);
				$cap = false;
			}
			$ret .= $letter;
		}
	}
	return $ret;
}

// Break out a persons name from a credit card
function personsNameExplode($pFullName, &$pFirst, &$pInitial, &$pLast)
{
	$mParts = explode(' ',trim($pFullName));
	
	// Get the count
	$mCount = 0;
	foreach ($mParts as $mEachOne)
	{
		$mCount++;		
	}
	
	// Loop through and associate the names accordingly
	$mLoop = 0;
	foreach ($mParts as $mEachOne)
	{
		$mLoop++;
		$mText = trim($mEachOne);
		// One name only
		if ($mCount == 1)
		{
			$pFirst = $mText;
			break;
		}
		else if ($mCount == 2)
		{
			if ($mLoop == 1)
			{
				$pFirst = $mText;
			}
			else // 2
			{
				$pLast = $mText;
			}
		}
		else
		// 3 or more names
		{
			if ($mLoop == 1)
			{
				$pFirst = $mText;
			}
			elseif ($mLoop == 2)
			{
				$pInitial = substr($mText,0,1);
			}
			else
			{
				// Catch all the rest 
				$pLast = $mText;
			}
		}
	}
	
	// reutnr the number of names
	return $mCount;
} // personsNameExplode

// Echo a message to the screen, and then end progam.  
// - Used for debugging
function echoDie($pActive, $pMessage) 
{
	// Only run this if we have debugging on
	if ($pActive == true)
	{
		echo ($pMessage); 
		die;
	}
}



// Build a lock release code, for a test between a user and an admin
// - Note: This code will expire at the end of the day
function buildUnblockCode($pTextword)
{
	// Build the hash to respond
	$mCodeWord	= strtolower($pTextword);
	$mDate		= date("Y-m-d");

	// Only return the first few chars.  If they match, the user is good to try again.  The Admin will be paying attention at this point
	$mHash 		= substr(strtolower(md5($mCodeWord.$mDate)),0,5);
	
	return $mHash;
} // buildUnblockCode


// Returns the current web page
function currentPage()
{
	$this_page = basename($_SERVER['REQUEST_URI']);
	if (strpos($this_page, "?") !== false) $this_page = reset(explode("?", $this_page));
	return $this_page;
	
	// Another way:
	// return substr($_SERVER["SCRIPT_NAME"],strrpos($_SERVER["SCRIPT_NAME"],"/")+1);
}

// Gets information about the entire path
/*
	$host     = $_SERVER['SERVER_NAME'];
	$uri      = rtrim($_SERVER['PHP_SELF'], "/\\");					
	$thisprog = "http://".$host.$uri;
	echo currentURLPath($thisprog )
*/
function currentURLPath($pURL)
{
	$path_parts = pathinfo($pURL);
	//echo $path_parts['dirname'], "<br>\n";  // http://localhost/engenic_app_root/test
	//echo $path_parts['basename'], "<br>\n";  // test.php
	//echo $path_parts['extension'], "<br>\n";  // php
	//echo $path_parts['filename'], "<br>\n"; // test	
	return $path_parts['dirname'];
}

// Provide standard message
function denyAccessForIPMessage()
{
	header('HTTP/1.1 403 Forbidden');
	print('HTTP/1.1 403 Forbidden: Access is not available from your location (ip: '.$_SERVER["REMOTE_ADDR"].')');
}

// Allow ACCESS ONLY from certain IP addresses
function allowAccessForIPList($pListCommaSeparated)
{

	$mNeedle   = $_SERVER["REMOTE_ADDR"];
	$mHaystack = $pListCommaSeparated;
	//echo $mHaystack ." - ".$mNeedle;
	// NOTE: Make CERTAIN that the search does not start from position 0, because THAT will return a FALSE
	if (strpos( "START,".$mHaystack.",", $mNeedle."," ) > 0)
	{
		return True;
	}
	else
	{
		// Stop dead after return
		denyAccessForIPMessage();
		return False;
	}
}


/*
 * ip_in_range.php - Function to determine if an IP is located in a
 *                   specific range as specified via several alternative
 *                   formats.
 *
 * Network ranges can be specified as:
 * 1. Wildcard format:     1.2.3.*
 * 2. CIDR format:         1.2.3/24  OR  1.2.3.4/255.255.255.0
 * 3. Start-End IP format: 1.2.3.0-1.2.3.255
 *
 * Return value BOOLEAN : ip_in_range($ip, $range);
 *
 * Copyright 2008: Paul Gregg <pgregg@pgregg.com>
 * 10 January 2008
 * Version: 1.2
 *
 * Source website: http://www.pgregg.com/projects/php/ip_in_range/
 * Version 1.2
 *
 * This software is Donationware - if you feel you have benefited from
 * the use of this tool then please consider a donation. The value of
 * which is entirely left up to your discretion.
 * http://www.pgregg.com/donate/
 *
 * Please do not remove this header, or source attibution from this file.
 */


// decbin32
// In order to simplify working with IP addresses (in binary) and their
// netmasks, it is easier to ensure that the binary strings are padded
// with zeros out to 32 characters - IP addresses are 32 bit numbers
Function decbin32 ($dec) {
  return str_pad(decbin($dec), 32, '0', STR_PAD_LEFT);
}

// ip_in_range
// This function takes 2 arguments, an IP address and a "range" in several
// different formats.
// Network ranges can be specified as:
// 1. Wildcard format:     1.2.3.*
// 2. CIDR format:         1.2.3/24  OR  1.2.3.4/255.255.255.0
// 3. Start-End IP format: 1.2.3.0-1.2.3.255
// The function will return true if the supplied IP is within the range.
// Note little validation is done on the range inputs - it expects you to
// use one of the above 3 formats.
Function ip_in_range($ip, $range) 
{
  if (strpos($range, '/') !== false) 
  {
    // $range is in IP/NETMASK format
    list($range, $netmask) = explode('/', $range, 2);
    if (strpos($netmask, '.') !== false) 
    {
      // $netmask is a 255.255.0.0 format
      $netmask = str_replace('*', '0', $netmask);
      $netmask_dec = ip2long($netmask);
      return ( (ip2long($ip) & $netmask_dec) == (ip2long($range) & $netmask_dec) );
    } 
    else 
    {
      // $netmask is a CIDR size block
      // fix the range argument
      $x = explode('.', $range);
      while(count($x)<4) $x[] = '0';
      list($a,$b,$c,$d) = $x;
      $range = sprintf("%u.%u.%u.%u", empty($a)?'0':$a, empty($b)?'0':$b,empty($c)?'0':$c,empty($d)?'0':$d);
      $range_dec = ip2long($range);
      $ip_dec = ip2long($ip);

      # Strategy 1 - Create the netmask with 'netmask' 1s and then fill it to 32 with 0s
      #$netmask_dec = bindec(str_pad('', $netmask, '1') . str_pad('', 32-$netmask, '0'));

      # Strategy 2 - Use math to create it
      $wildcard_dec = pow(2, (32-$netmask)) - 1;
      $netmask_dec = ~ $wildcard_dec;

      return (($ip_dec & $netmask_dec) == ($range_dec & $netmask_dec));
    }
  } 
  else 
  {
    // range might be 255.255.*.* or 1.2.3.0-1.2.3.255
    if (strpos($range, '*') !==false) 
    { // a.b.*.* format
      // Just convert to A-B format by setting * to 0 for A and 255 for B
      $lower = str_replace('*', '0', $range);
      $upper = str_replace('*', '255', $range);
      $range = "$lower-$upper";
    }

    if (strpos($range, '-')!==false) 
    { // A-B format
      list($lower, $upper) = explode('-', $range, 2);
      $lower_dec = (float)sprintf("%u",ip2long($lower));
      $upper_dec = (float)sprintf("%u",ip2long($upper));
      $ip_dec = (float)sprintf("%u",ip2long($ip));
      return ( ($ip_dec>=$lower_dec) && ($ip_dec<=$upper_dec) );
    }

    echo 'Range argument is not in 1.2.3.4/24 or 1.2.3.4/255.255.255.0 format';
    return false;
  }
}

// Allow ACCESS ONLY from certain IP addresses or local IPs (eg: In office, or trusted user networks)
function allowAccessForIPListOrLocalIPs($pListCommaSeparated)
{
	// See if access is local user
	if ((ip_in_range($_SERVER["REMOTE_ADDR"],"192.168.*.*")) ||
        (ip_in_range($_SERVER["REMOTE_ADDR"],"10.*.*.*"))	||
		(ip_in_range($_SERVER["REMOTE_ADDR"],"172.16.0.0-172.31.255.255")))
	{
		// Internal ranges are: 192.168.x.x, 10.x.x.x, and 172.16.0.0-172.31.255.255)
		// 169.254.0.0 through 169.254.255.255 is another range, but is non-standard, and not currently being supported. (APIPA  only)
		return True;	
	}
	// Local will register 
	else if ($_SERVER["REMOTE_ADDR"] == '127.0.0.1' )
	{
		return True;				
	}
	// Test for Linux local host value (  ::1 )
	else if ($_SERVER["REMOTE_ADDR"] == '::1' )
	{
		// This is a linux related issue only
		return True;				
	}
	else
	{
		// Check to see if the numbers is in the ACCESS control list
		$mNeedle   = $_SERVER["REMOTE_ADDR"];
		$mHaystack = $pListCommaSeparated;
		//echo $mHaystack ." - ".$mNeedle;
		// NOTE: Make CERTAIN that the search does not start from position 0, because THAT will return a FALSE
		if (strpos( "START,".$mHaystack.",", $mNeedle."," ) > 0)
		{
			return True;
		}
		else
		{
			// Stop dead after return
			denyAccessForIPMessage();
			return False;
		}
	}
}

// Remove the declaration from the XML
function xml_sanitize($pXML)
{
	$mParts = explode('?>',$pXML);
	return $mParts[1];
} // xml_sanitize


// Log Data to File - Will create and add to a file
// - Tags: Logfile
// LogTextToFile($incPath.SYSTEM_LOGFILES."StaffRelay-".Date('Y-m-d').".log", $data)
function LogTextToFile($pFileName, $pData)
{
	$textFileLog = $pFileName; //$incPath.SYSTEM_LOGFILES."StaffRelay-".Date('Y-m-d').".log";
	// Open to add to log file
	if ($fh = fopen($textFileLog, 'a'))
	{
		fwrite($fh, $pData);
		fclose($fh);
	}
} // LogTextToFile

// Log Data to File - Will create and add to a file, but will prefix a time stanp
// - Tags: Logfile
// LogTextToFileXMLTimeStamp($incPath.SYSTEM_LOGFILES."StaffRelay-".Date('Y-m-d').".log", $data)
// -- Note: session_id and time is added to log
function LogTextToFileXMLTimeStamp($pFileName, $pData)
{
	$textFileLog = $pFileName; //$incPath.SYSTEM_LOGFILES."StaffRelay-".Date('Y-m-d').".log";
	// Open to add to log file
	if ($fh = fopen($textFileLog, 'a'))
	{
		fwrite($fh, '<log t="'.teleflowNowTimeStamp().'" s="'.session_id().'">'.$pData.'</log>'.chr(13).chr(10));
		fclose($fh);
	}
} // LogTextToFileXMLTimeStamp


// Log Data to a System File - Will create and add  date named file to a file
// - Tags: Logfile, system log, 
// eg: LogTextToDateNamedFileSystem($incPath, 'medical-transfer', 'Sent: '.$mFileName);
function LogTextToDateNamedFileSystem($pRelativeLocation, $pFileNameStub, $pData)
{
	// See if we have a system log file location 
	if (defined('SYSTEM_LOGFILES'))
	{
		$logFilesPath = $pRelativeLocation.SYSTEM_LOGFILES;	
	}
	else
	{
		// Just go with a directory named LOG
		$logFilesPath = $pRelativeLocation.'log/';
		if (!file_exists($logFilesPath))
		{
			// Create path if not exist
			make_path($logFilesPath);
		}
	}
	
	// Create the name of the log file	
	$textFileLog = $logFilesPath.$pFileNameStub.'_'.Date('Y-m-d').".log";

	// Open to add to log file
	if ($fh = fopen($textFileLog, 'a'))
	{
		// Put the time in the front
		fwrite($fh, Date("H:i:s").' -'.$pData);
		fclose($fh);
	}
} // LogTextToDateNamedFileSystem


// Determine the log files path
// -- @@@ Slow, we should improve this because of 
function getRelativeSystemLogFilesPath()
{
	// Check if directory already exists
	if (is_dir(SYSTEM_LOGFILES)) 
	{
		return SYSTEM_LOGFILES;
	}
	else if (is_dir('../'.SYSTEM_LOGFILES.'/')) 
	{
		return '../'.SYSTEM_LOGFILES.'/';
	}
} // getRelativeSystemLogFilesPath


/*Create  Directory Tree if Not Exists
 If you are passing a path with a filename on the end, pass true as the second parameter to snip it off 
 Tags: mkdir make_dir
 */
function make_path($pathname, $is_filename=false)
{
	if($is_filename)
	{
		$pathname = substr($pathname, 0, strrpos($pathname, '/'));
	}
	// Check if directory already exists
	if (is_dir($pathname) || empty($pathname)) 
	{
		return true;
	}
	
	// Ensure a file does not already exist with the same name
	$pathname = str_replace(array('/', '\\'), DIRECTORY_SEPARATOR, $pathname);
	if (is_file($pathname)) 
	{
		trigger_error('make_path() File exists', E_USER_WARNING);
		return false;
	}
	
	// Crawl up the directory tree
	$next_pathname = substr($pathname, 0, strrpos($pathname, DIRECTORY_SEPARATOR));
	
	if (make_path($next_pathname, $mode)) 
	{
		if (!file_exists($pathname)) 
		{
			// Cannot create the drive
			// If there is an error here, is the drive mapped???
			return mkdir($pathname, $mode);
		}
	}
	return false;
}  // make_path


// Get a the directory listing recursively
function make_tree($path)
{ //where $path is your source dir.
	$handle=opendir($path);
	while($a=readdir($handle))
	{
		if(!preg_match('/^\./',$a))
		{
			$full_path="$path/$a";
			$list[]=$full_path;
			if(is_dir($full_path))
			{
				$recursive=make_tree($full_path);
				for($n=0; $n<count($recursive); $n++)
				{
					$list[]=$recursive[$n];
				}
			}
		}
	}
	closedir($handle);
	return $list;
} // make_tree


// File Management sections
// -- This section provides tools to scan and move files 
/*
// Other means to find information about files
	$mFs=filesize($mMediaFolder."/". $file);
	$mModdate=date('F j, Y',filemtime($mMediaFolder."/". $file));
*/


// Cut out the file name from its path
// - Also see: "pathinfo+ for all information about a file
function getFileNameFromPath($pLongPath)
{
	// Get just the file name
	$mFilePathParts = explode('\\', slashToBackslash($pLongPath));
	return($mFilePathParts[count($mFilePathParts) - 1]);
}

// Delete an entire directory contents
// -- Deletes one directory
// -- see: cr_media_file_positioner.php for examples
function deleteDirRecurse($pDir) 
{
	deleteDir($pDir);
	// Finally, delete this directory passed
	rmdir($pDir);	
}
// Slide through all directories deleting all files
function deleteDir($pDir) 
{
	$iterator = new RecursiveDirectoryIterator($pDir);
	foreach (new RecursiveIteratorIterator($iterator, RecursiveIteratorIterator::CHILD_FIRST) as $file)
	{
		if ($file->isDir()) 
		{
			// Recursively delete
			deleteDir($file->getPathname());
			rmdir($file->getPathname());
			//output ('Delete Dir'.$file->getPathname());
		} 
		else 
		{
			unlink($file->getPathname());
			//output ('Delete File'.$file->getPathname());
		}
	}
} // deleteDir


// Delete an entire directory contents of date named files
// -- Deletes one directory if all files are 
function deleteDateNamedFiles($pDir, $pDateFieldPos, $pAgeDays) 
{
	$iterator = new RecursiveDirectoryIterator($pDir);
	foreach (new RecursiveIteratorIterator($iterator, RecursiveIteratorIterator::CHILD_FIRST) as $file)
	{
		// Skip folders
		if ($file->isDir()) 
		{
			// Skip folders;
		} 
		else
		{
			// Get the file from the path
			$currentFile =  getFileNameFromPath($file);
			//output('File : '. $currentFile);  die;
			
			// Find the age of the file (by date)
			// Get the create date from the name
			$mParts = explode('_',trim($currentFile));
			
			
			// Get the count
			$mCount = 0;
			foreach ($mParts as $mEachOne)
			{
				//output('Each : '. $mEachOne);
				$mCount++;		
			}
			
			// Do we have a file with the number of parts in it?
			//      0        1               2                        3            4
			// eg: MSG_2009-12-01_1259698004.310_URANUS_3.GSM.NEW.XML
			if ($mCount >= $pDateFieldPos)
			{
				// Get date part for file
				$mDatePart = $mParts[$pDateFieldPos];
			
				// Are we dealing with a date
				if (validTeleFlowDate($mDatePart))
				{					
					// Is it old enough to delete
					if (teleflowDateAdd($mDatePart, $pAgeDays) <= teleflowNowDate())			
					{
						output('DELETE: '.$mDatePart.' - '.teleflowDateAdd($mDatePart, $pAgeDays).' - '.$currentFile);					
						unlink($file->getPathname());
					}
					else
					{
						// Test file age
						output('File Not Old enough: '.$mDatePart.' - '.teleflowDateAdd($mDatePart, $pAgeDays).' - '.$currentFile);					
					}
				}
				else
				{
					output('Ignor File: '.$currentFile);
				}
			}
			
			//die;
		}
	}
	//rmdir($pDir);
} // deleteDir_DatedFileNames


//Delete folders that are date named
function deleteDateFolders($pDir, $pDateFieldPos, $pAgeDays) 
{
	$iterator = new RecursiveDirectoryIterator($pDir);
	foreach (new RecursiveIteratorIterator($iterator, RecursiveIteratorIterator::CHILD_FIRST) as $file)
	{
		if ($file->isDir()) 
		{
			// Make sure that the folder is named to be tested for deleting
			// Get the file from the path
			$currentFile =  getFileNameFromPath($file);
			//output('File : '. $currentFile);  die;
			
			// Find the age of the file (by date)
			// Get the create date from the name
			$mParts = explode('_',trim($currentFile));

			// Get the count
			$mCount = 0;
			foreach ($mParts as $mEachOne)
			{
				//output('Each : '. $mEachOne);
				$mCount++;		
			}
			
			// Do we have a file with the number of parts in it?
			//      0        1               2                        3            4
			// eg: MSG_2009-12-01_1259698004.310_URANUS_3.GSM.NEW.XML
			if ($mCount >= $pDateFieldPos)
			{
				// Get date part for file
				$mDatePart = $mParts[$pDateFieldPos];
			
				// Are we dealing with a date
				if (validTeleFlowDate($mDatePart))
				{					
					// Is it old enough to delete
					if (teleflowDateAdd($mDatePart, $pAgeDays) <= teleflowNowDate())			
					{
						//output('FOLDER DELETE: '.$mDatePart.' - '.teleflowDateAdd($mDatePart, $pAgeDays).' - '.$currentFile);					
			
						// Recursively delete
						deleteDir($file->getPathname());
						rmdir($file->getPathname());
						
					}
					else
					{
						// Test file age
						//output('Folder Not Old enough: '.$mDatePart.' - '.teleflowDateAdd($mDatePart, $pAgeDays).' - '.$currentFile);					
					}
				}
				else
				{
					//output('Ignor Folder: '.$currentFile);
				}
			}
			
			//output ('Delete Dir'.$file->getPathname());
		} 
	}
} // deleteDateFolders

// Return a default value if the first value is empty
function GetNonEmptyValue($pValuePrimary, $pValueIfEmpty)
{
	if (empty($pValuePrimary))
	{
		return $pValueIfEmpty;
	}
	else
	{
		return $pValuePrimary;	
	}
}


// Roll through a SQL command and clean it up, so that it can be passed to the SQL executor
function SQLCommandClean($pCommand)
{
	// Get to the folder where the files are to be worked from
	$mString = '';
	$mCommandLines = explode("\n", $pCommand );
	foreach ($mCommandLines as $mCommandLine)
	{
		// Clean it
		$mText = trim($mCommandLine);
		
		// No comments
		if (substr($mText,0,2) == '--')
		{
			// comments etc
		}
		else
		{
			//echo(substr($mText,0,2));
			$mString .= $mText."\n";
		}
	}	

	// Remove any wider comments
	//eg:  /*!32312 IF NOT EXISTS*/
	$mString = stripBetweenTwoPoints($mString, '/*', '*/');
	
	return $mString;
} // SQLCommandClean


// See if imput is a valid email
function isValidEmail($email)
{
	return eregi("^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3})$", $email);
}

// Reformat a date
// eg: YYYY/MM/DD = YYYY/MM/DD
function dateReformat($pDateIn, $pDateFormatIn, $pDateFormatOut)
{
	$mSepOut = '-';
	$mFormat = strlen(trim($pDateIn));
	//output($mFormat.' '.$pDateIn.' '.$pDateFormatIn.' '.$pDateFormatOut);
	
	// Find the date separator
	// - One of YYYY/MM/DD or YYYY-MM-DD ( slash or dash )
	$mDateSep = '/';
	if (strpos($pDateFormatIn, $mDateSep) === false)
	{
		$mDateSep = '-';								
	}
	// Get the date pieces of the in date
	$mFieldParts = explode($mDateSep, $pDateIn);
	$mMaskParts  = explode($mDateSep, strtoupper($pDateFormatIn));
	// Get the parts according to the mask
	// Find each of them Year
	for ($mLoop=0; $mLoop <= 2; $mLoop++)
	{
		if (substr($mMaskParts[$mLoop],0,1) == 'Y')
		{
			$mD1 = $mFieldParts[$mLoop];
		}
	}
	// Find each of them Month
	for ($mLoop=0; $mLoop <= 2; $mLoop++) 
	{
		if (substr($mMaskParts[$mLoop],0,1) == 'M')
		{
			$mD2 = rightstr('00'.($mFieldParts[$mLoop]),2);
		}
	}
	// Find each of them Day
	for ($mLoop=0; $mLoop <= 2; $mLoop++) 
	{
		if (substr($mMaskParts[$mLoop],0,1) == 'D')
		{
			$mD3 = rightstr('00'.($mFieldParts[$mLoop]),2);
		}
	}
	
	// Do we have the components for a date
	if (($mD1 <> '') && ($mD2 <> '') && ($mD3 <> ''))
	{
		// Create a new date field
		// How big does it have to be?
		$mFormat = strlen(trim($pDateFormatOut));
		if (($mFormat == 8) || ($mFormat == 10))
		{
			$mBuild = substr('            ',0,$mFormat);

			// Enter the Year
			$mPos = strpos(strtoupper($pDateFormatOut), 'Y');
			if ($mFormat == 8) 
			{
				$mBuild = strDelete($mBuild,$mPos,2);
				// Find the separator .. YY types must be in third location
				$mSepOut = substr($mBuild,2,1);
			}
			elseif ($mFormat == 10) 
			{
				$mBuild = strDelete($mBuild,$mPos,4);
				// Find the separtor... depending where the YYYY is located
				if (substr(strtoupper($pDateFormatOut),0,1) == 'Y') 
				{
					// YYYY at front
					$mSepOut = substr($pDateFormatOut,4,1);
				}
				else
				{
					// YYYY elsewhere
					$mSepOut = substr($pDateFormatOut,2,1);
				}
			}

			// If we are going for a YY to YYYY, then, add 20 in front of it
			if ((strlen($mD1) == 2)) 
			{
				$mD1 = '20'.$mD1;
			}
			$mBuild = strInsert($mD1,$mBuild,$mPos);

			// Enter the Month
			$mPos = strpos(strtoupper($pDateFormatOut), 'M');
			$mBuild = strDelete($mBuild,$mPos,2);
			$mBuild = strInsert($mD2,$mBuild,$mPos);

			// Enter the Day
			$mPos = strpos(strtoupper($pDateFormatOut), 'D');
			$mBuild = strDelete($mBuild,$mPos,2);
			$mBuild = strInsert($mD3,$mBuild,$mPos);

			// Slashes in the right place
			while (strpos($mBuild, ' ') > 0)
			{
				$mPos = strpos($mBuild, ' ');

				$mBuild = strDelete($mBuild,$mPos,1);
				$mBuild = strInsert($mSepOut,$mBuild,$mPos);
			}

			// Return the new date
			return($mBuild);
		} // mFormat
	}
}  // dateReformat

// Modify the time according to convert string
// eg: timeReformat('1:20:10pm','HH:MM:SS','');
// eg: timeReformat('1:20:10pm','HH:MM','AMPM');
function timeReformat($pTimeIn, $pTimeFormatOut, $pConvert)
{
	$mHours	= 0;
	$mFind	= 0;
	$mT1	= '';
	$mT2	= '';
	$mT3	= '';
	$mBuild	= '';
	$mResult = '';

	$mTimeParts = explode(' ',$pTimeIn);
	
	// Work through the parts looking for a time type
	foreach ($mTimeParts as $mTimePart)
	{
		
		// Do we have a time part?
		$mFind =  strpos($mTimePart, ':');
		if ($mFind > 0)
		{
			// 12345678
			// hh:mm:ss
			if ($mFind == 2)
			{
			   $mT1 = substr($mTimePart,0,2);
			   $mT2 = substr($mTimePart,3,2);
			   $mT3 = substr($mTimePart,6,2);
			}
			else
			// h:mm:ssp
			{
			   $mT1 = substr($mTimePart,0,1);
			   $mT2 = substr($mTimePart,2,2);
			   $mT3 = substr($mTimePart,5,2);
			}
			
			$mHours = 0;
			if (is_numeric($mT1))
			{
				$mHours = $mT1;
			}

			// Are we needing a daytime 24 time?
			// - 24 will assume PM hours for time less than 6
			if (strtoupper($pConvert) == 'D24')
			{
				// if 12 time < 6 then add 12
				// - anything less than 6AM becomes PM
				if ($mHours < 6)
				{
					$mHours = $mHours + 12;
				}
			}
			else if (strtoupper($pConvert) == 'AMPM')
			{
				//echo ($mTimePart.'='.$mHours); die;
				// 12pm is noon, so make sure less
				if (strpos(strtoupper($mTimePart), 'P') !== false)
				{
					if ($mHours < 12)
					{
						$mHours = $mHours + 12;
					}
				}
				// 12am is midnight, so, make sure is 0
				if (strpos(strtoupper($mTimePart), 'A') !== false)
				{
					if ($mHours == 12)
					{
						output('SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS'.$pTimeIn); die;
						$mHours = 0;
					}
				}
			}

			// Reconstitute
			$mBuild = rightstr('00'.($mHours),2).':'.$mT2;

			// See if we include seconds
			if (strlen($pTimeFormatOut) > 5)
			{
				if ($mT3 <> '')
				{
					$mBuild = $mBuild.':'.rightstr('00'.$mT3,2);
				}
				else
				{
					$mBuild = $mBuild.':00';
				}
			}

			// Put it back into the time part
			// Not a Time part... perhaps a date or something else
			if ($mResult <> '')
			{
				$mResult .= ' ';
			}
			$mResult .= $mBuild;
			
		} // is a time part
		else
		{
			// Not a Time part... perhaps a date or something else
			if ($mResult <> '')
			{
				$mResult .= ' ';
			}
			$mResult .= $mTimePart;
		}
	} // foreach
	
	return($mResult);
}  // Time format


// TeleFlow Time 
// gets 15:40:00 from datetime
function teleflowTimeFromDateTime($str) 
{
    list($date, $time) = explode(' ', $str);
    list($year, $month, $day) = explode('-', $date);
    list($hour, $minute, $second) = explode(':', $time);
    //$timestamp = mktime($hour, $minute, $second, $month, $day, $year);
    //return $timestamp;
	return $hour.':'.$minute.':'.$second;
}

// TeleFlow Date
// gets 2008-10-30 from datetime
function teleflowDateFromDateTime($str) 
{
    list($date, $time) = explode(' ', $str);
    list($year, $month, $day) = explode('-', $date);
    list($hour, $minute, $second) = explode(':', $time);
    //$timestamp = mktime($hour, $minute, $second, $month, $day, $year);
    //return $timestamp;
	return $year.'-'.$month.'-'.$day;
}

// Do we have a valid teleflow date
function validTeleFlowDate($pDate)
{
    list($year, $month, $day) = explode('-', $pDate);
	if (($year > 0) && ($month > 0) && ($day > 0))
	{
		return true;
	}
	return false;
}

// eg:  YYYY-MM-DD
function teleflowNowDate()
{
   $teleflowDate = Date("Y-m-d");
   return $teleflowDate;
}

// eg: HH:MM:SS
function teleflowNowTime()
{
   $teleflowTime = Date("H:i:s");
   return $teleflowTime;
}

// eg YYYYMMDDHHNNSS
function teleflowNowTimeStamp()
{
   $teleflowTimeStamp = Date("Ymd").Date("His");
   return $teleflowTimeStamp;
}

// Takes a date and zero files eg:  2010-1-9  becomes 2010-01-09
function teleflowZeroFill($pDate)
{
	return teleflowDateAdd($pDate,0);
}

// Add days to TeleFlow date
// - eg: teleflowDateAdd('2009-04-19', 31) = 2009-05-20
function teleflowDateAdd($pDate,$pDays)
{
	$mDateBits = explode('-',SlashToDash($pDate));
	$mDate = mktime(0,0,0,$mDateBits[1],$mDateBits[2],$mDateBits[0]) + ($pDays * 24 * 60 * 60);
	$mAddedDate = date("Y-m-d",$mDate);
	return $mAddedDate;
}

// return the week number of a date
function teleflowWeekNumber($date)
{
    return ( date( 'W', strtotime( $date ) )); 
}

// Make a human readable date for TeleFlow date
// - eg: Thu Jan 08,
function teleflowDatetoHumanReadable($pDate)
{
	$mDateBits = explode('-',SlashToDash($pDate));
	$mDate = mktime(0,0,0,$mDateBits[1],$mDateBits[2],$mDateBits[0]);
	$mHumanDate = date("D M d",$mDate);
	//echo 'Date is: '.$teleflowTimeStamp.'<br /><br />';
	return $mHumanDate;
}

// Make a human readable date for TeleFlow date
// - eg: Thursday January 08
function teleflowDatetoHumanReadableVerbose($pDate)
{
	$mDateBits = explode('-',SlashToDash($pDate));
	$mDate = mktime(0,0,0,$mDateBits[1],$mDateBits[2],$mDateBits[0]);
	$mHumanDate = date("l, F d",$mDate);
	//echo 'Date is: '.$teleflowTimeStamp.'<br /><br />';
	return $mHumanDate;
}

// Make a human readable date for TeleFlow date
function teleflowDatetoDayOfWeek($pDate)
{
	$mDateBits = explode('-',SlashToDash($pDate));
	$mDate = mktime(0,0,0,$mDateBits[1],$mDateBits[2],$mDateBits[0]);
	$mDayOfWeek = date("w",$mDate)+1;
	//echo 'Date is: '.$teleflowTimeStamp.'<br /><br />';
	return $mDayOfWeek;
}

// Time 24 format to 12 hour format
// eg:  01:01 becomes  1:01am
function converttime24to12($pTime24)
{
	// Make sure we only get HH and MM
	$mTime24 = substr($pTime24,0,5);
	return date("g:ia", strtotime($mTime24));
}

// Time 24 format to 12 hour format with seconds
// eg:  01:01:01 becomes  1:01:01am
function converttime24to12seconds($pTime24)
{
	// Make sure we only get HH and MM
	$mTime24 = substr($pTime24,0,8);
	return date("g:i:sa", strtotime($mTime24));
}

// Time 12 format to 24 hour format
// eg:  1:01am  becomes   01:01
function converttime12to24($pTime12)
{
	return date("H:i", strtotime($pTime12));
}

// Take a number, and turn it into time format.  
// - Note: This is NOT clock time, but hours:mins:seconds.  eg: 99:59:59
function convertSecondsToTime($pSeconds)
{
	$mHours = round($pSeconds / 3600);
	$mMins	= round(($pSeconds - ($mHours * 3600)) / 60);
	$mSecs  = round(($pSeconds - ($mHours * 3600) - ($mMins * 60)));
	
	if ($mHours > 99)
	{
		return '99:59:59';
	}
	return  rightstr('00'.($mHours),2).':'. 
			rightstr('00'.($mMins),2).':'.
			rightstr('00'.($mSecs),2);
	//return date("g:i:s", time(0)+$pSeconds);
} // convertSecondsToTime


// Strips out all non-numbers
function stripNonNumeric($pString)
{
	return preg_replace('`[^0-9]`i','',$pString);
}


// Convert  YYYY/MM/DD to  YYYY-MM-DD
function SlashToDash($pDate)
{
	return str_replace("/", "-", $pDate);
}


function slashToBackslash($pString)
{
	return str_replace("/", "\\", $pString);
}

function backslashToSlash($pString)
{
	return str_replace("\\", "/", $pString);
}

function doubleQuoteToSingle($pString)
{
	return str_replace('"', "'", $pString);
}


// For filenames and typed information
function stripToReadable($pString)
{
	// Allows letters a-z, digits, space (\\040), hyphen (\\-), underscore (\\_) and backslash (\\\\), everything else is removed from the string.
	$allowed = "/[^a-z0-9\\040\\.\\-\\_\\\\]/i";
	return preg_replace($allowed,"",$pString);
}

// For data entry
function stripToBasicText($pString)
{
	// Allows letters a-z, period, space (\\040), hyphen (\\-),  everything else is removed from the string.
	$allowed = "/[^a-z\\040\\.\\-]/i";
	return preg_replace($allowed,"",$pString);
}

// For CSV loading 
function stringToSafeChars($pString)
{
	// Allows letters a-z, digits, space (\\040),!,#,$,%,&,(,),*,+,Comma,[,\,],^,_,@
	// - No quotes, <, >, or 
	$allowed = "/[^a-z0-9\\040-\\041\\043-\\046\\050-\\057\\072\\073\\075\\077\\100\\133\\134\\135\\136\\137\\173\\174\\175\\176]/i";
	return preg_replace($allowed,"",$pString);
}


// Display a telephone number for North America  
function TelephoneFormat($pTelNo)
{
	$mTel = $pTelNo."Z";
	if (strlen($mTel)==11) // +1 for Z
	{ 
		$mCode = substr($mTel,0,3).".".
		substr($mTel,3,3).".".
		substr($mTel,6,4);
	}
	else
	{
		$mCode = $pTelNo;
	}     
	return($mCode);
}

// Display a telephone number for North America  
function telephoneFormatClassic($pTelNo)
{
	$mTel = trim($pTelNo)."Z";
	if (strlen($mTel)==11) // +1 for Z
	{ 
		$mCode = "(".substr($mTel,0,3).") ".
		substr($mTel,3,3)."-".
		substr($mTel,6,4);
	}
	else
	{
		$mCode = $pTelNo;
	}     
	return($mCode);
}

// Display a telephone number for North America  
function telephoneFormatClassicNoSpace($pTelNo)
{
	$mTel = $pTelNo."Z";
	if (strlen($mTel)==11) // +1 for Z
	{ 
		$mCode = "(".substr($mTel,0,3).")".
		substr($mTel,3,3)."-".
		substr($mTel,6,4);
	}
	else
	{
		$mCode = $pTelNo;
	}     
	return($mCode);
}

// Takes a string, and returns the string's numeric digit string in touch tones
// - echo TTLetterDigits('Vern Baker');  // shows: 837622537
// - echo TTLetterDigits('Jenny2');  // shows: 536692
function TTLetterDigits($pStringToConv)
{
	$mConvString = ''; 
	$mConvertedString  = ''; 
	$mSingleChar  = ''; 

	$mConvString = strtoupper($pStringToConv);
	$mConvertedString = '';

	// Loop through string, 1 character at a time, converting the numbers to their
	// telephone keypad/touch tone equivalent.
	for ($mIndex = 0; $mIndex < strlen($mConvString); $mIndex++)
	{
		$mSingleChar = $mConvString[$mIndex];
		$mCharInt    = ord($mSingleChar);

		if (($mSingleChar == '0') ||
			($mSingleChar == '1') ||
			($mSingleChar == '2') ||
			($mSingleChar == '3') ||
			($mSingleChar == '4') ||
			($mSingleChar == '5') ||
			($mSingleChar == '6') ||
			($mSingleChar == '7') ||
			($mSingleChar == '8') ||
			($mSingleChar == '9') ||
			($mSingleChar == '*'))
		{
			// Standard digits go in regardless
			$mConvertedString .= $mSingleChar;
		}
		// ABC
		else if ((($mCharInt >= 65) && ($mCharInt <= 67))  || ($mSingleChar == '2'))
		{
			$mConvertedString .= '2';
		}
		// DEF
		else if ((($mCharInt >= 68) && ($mCharInt <= 70))  || ($mSingleChar == '3'))
		{
			$mConvertedString .= '3';
		}
		// GHI
		else if ((($mCharInt >= 71) && ($mCharInt <= 73))  || ($mSingleChar == '4'))
		{
			$mConvertedString .= '4';
		}
		// JKL
		else if ((($mCharInt >= 74) && ($mCharInt <= 76))  || ($mSingleChar == '5'))
		{
			$mConvertedString .= '5';
		}
		// MNO
		else if ((($mCharInt >= 77) && ($mCharInt <= 79))  || ($mSingleChar == '6'))
		{
			$mConvertedString .= '6';
		}
		// PQRS
		else if ((($mCharInt >= 80) && ($mCharInt <= 83))  || ($mSingleChar == '7'))
		{
			$mConvertedString .= '7';
		}
		// TUV
		else if ((($mCharInt >= 84) && ($mCharInt <= 86))  || ($mSingleChar == '8'))
		{
			$mConvertedString .= '8';
		}
		// WXYZ
		else if ((($mCharInt >= 87) && ($mCharInt <= 90))  || ($mSingleChar == '9'))
		{
			$mConvertedString .= '9';
		}
	}
	return $mConvertedString;
} // TTLetterDigits

// Get a zime zone code description for a UTC offset
function getZoneCodeFromUTCOffset($pUTCOffset)
{
	$mRound = $pUTCOffset*10;
	switch ($mRound)
	{
	case -100: return "HAST"; //"Hawaii-Aleutian Standard Time",
	case -90:  return "AKST"; //"Alaska Standard Time",    	
	case -80:  return "PST";  //"Pacific Standard Time",           
	case -70:  return "MST";  //"Mountain Standard Time",          
	case -60:  return "CST";  //"Central Standard Time",           
	case -50:  return "EST";  //"Eastern Standard Time",           
	case -40:  return "AST";  //"Atlantic Standard Time",          
	case -35:  return "NST";  //"Newfoundland Standard Time",   
	}
} // getZoneCodeFromUTCOffset


// Get the UTC offset for a zime zone code description
function getUTCOffsetFromZoneCode($pZoneCode)
{
	switch ($pZoneCode)
	{
	case "HAST": return -10;  
	case "AKST": return -9;   
	case "PST":  return -8;   
	case "MST":  return -7;   
	case "CST":  return -6;   
	case "EST":  return -5;   
	case "AST":  return -4;   
	case "NST":  return -3.5;   
	}    
} // getUTCOffsetFromZoneCode

// Get the UTC offset for a time zone name description
function getUTCOffsetFromZoneName($pZoneName)
{
	switch ($pZoneName)
	{
	case "Hawaii": 		return -10;  
	case "Alaska":		return -9;   
	case "Pacific":		return -8;   
	case "Mountain":	return -7;   
	case "Central":		return -6;   
	case "Eastern":		return -5;   
	case "Atlantic":	return -4;   
	case "Newfoundland": return -3.5;   
	}    
} // getUTCOffsetFromZoneCode



function buildProvStateListDropdown($pSelectedCode)
{
	$mStateArray = array (
	"AL,Alabama ",
	"AK,Alaska ",
	"AZ,Arizona ",
	"AR,Arkansas ",
	"CA,California ",
	"CO,Colorado ",
	"CT,Connecticut ",
	"DE,Delaware ",
	"DC,District of Columbia ",
	"FL,Florida ",
	"GA,Georgia ",
	"HI,Hawaii ",
	"ID,Idaho ",
	"IL,Illinois ",
	"IN,Indiana ",
	"IA,Iowa ",
	"KS,Kansas ",
	"KY,Kentucky ",
	"LA,Louisiana ",
	"ME,Maine ",
	"MD,Maryland ",
	"MA,Massachusetts ",
	"MI,Michigan ",
	"MN,Minnesota ",
	"MS,Mississippi ",
	"MO,Missouri ",
	"MT,Montana ",
	"NE,Nebraska ",
	"NV,Nevada ",
	"NH,New Hampshire ",
	"NJ,New Jersey ",
	"NM,New Mexico ",
	"NY,New York ",
	"NC,North Carolina ",
	"ND,North Dakota ",
	"OH,Ohio ",
	"OK,Oklahoma ",
	"OR,Oregon ",
	"PA,Pennsylvania ",
	"RI,Rhode Island ",
	"SC,South Carolina ",
	"SD,South Dakota ",
	"TN,Tennessee ",
	"TX,Texas ",
	"UT,Utah ",
	"VT,Vermont ",
	"VA,Virginia ",
	"WA,Washington ",
	"WV,West Virginia ",
	"WI,Wisconsin ",
	"WY,Wyoming ",
	"PR,Puerto Rico ",
	"VI,Virgin Islands ",
	"GU,Guam ",
	"AB,Alberta ",
	"BC,British Columbia ",
	"MB,Manitoba ",
	"NB,New Brunswick ",
	"NF,Newfoundland ",
	"NT,Northwest Territories ",
	"NS,Nova Scotia ",
	"NU,Nunavut ",
	"ON,Ontario ",
	"PE,Prince Edward Island ",
	"QC,Quebec ",
	"SK,Saskatchewan ",
	"YT,Yukon ",
	"__,Other "
	);

	
	// Create drop List for states, with select
	$mOptions = '';

	// Add a default select if there is nothing 
	if ($pSelectedCode == '')
	{	
		$mOptions .= '<option value="" selected="selected">Select </option>';
	}	
	
	// Add each state to the options list.  If we have a match, mark it as selected
	for($mLoop=0;$mLoop<count($mStateArray);$mLoop++)
	{
		$mParts = explode(',', $mStateArray[$mLoop]);
		
		// if we have this one, then select it
		if ($pSelectedCode == $mParts[0])
		{
			$mOptions .= '<option value="'.$mParts[0].'" selected="selected">'.$mParts[1].'</option>';
		
		}
		else
		{
			$mOptions .= '<option value="'.$mParts[0].'">'.$mParts[1].'</option>';			
		}
	}
	//print_r($days);die;
	
	return $mOptions;
} // buildProvStateListDropdown


// Create a drop down option for countries
function buildCountryListDropdown($pSelectedCode)
{
	$mCountryArray = array (
		"US,United States ",
		"CA,Canada "
	);

	// Create drop List for states, with select
	$mOptions = '';

	// Add a default select if there is nothing 
	if ($pSelectedCode == '')
	{	
		$mOptions .= '<option value="" selected="selected">Select </option>';
	}	
	
	// Add each state to the options list.  If we have a match, mark it as selected
	for($mLoop=0;$mLoop<count($mCountryArray);$mLoop++)
	{
		$mParts = explode(',', $mCountryArray[$mLoop]);
		
		// if we have this one, then select it
		if ($pSelectedCode == $mParts[0])
		{
			$mOptions .= '<option value="'.$mParts[0].'" selected="selected">'.$mParts[1].'</option>';
		
		}
		else
		{
			$mOptions .= '<option value="'.$mParts[0].'">'.$mParts[1].'</option>';			
		}
	}
	
	return $mOptions;
} // buildCountryListDropdown


// Returns the IP addess of the client accessing system
function getClientIpAddress()
{
	if (!empty($_SERVER['HTTP_CLIENT_IP']))   //check ip from share internet
	{
		$ip=$_SERVER['HTTP_CLIENT_IP'];
	}
	elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR']))   //to check ip is pass from proxy
	{
		$ip=$_SERVER['HTTP_X_FORWARDED_FOR'];
	}
	else
	{
		$ip=$_SERVER['REMOTE_ADDR'];
	}
	return $ip;
} // getClientIpAddress

// Get the current assigned name of the computer.  eg: JUPITER
function getHostComputerName()
{
	return $mCompName = php_uname('n');
}

// handy humansize function:
// input is number of bytes, output is a "human-readable" filesize string
function formatReadableSize($size) 
{
    // Setup some common file size measurements.
    $kb = 1024;         // Kilobyte
    $mb = 1024 * $kb;   // Megabyte
    $gb = 1024 * $mb;   // Gigabyte
    $tb = 1024 * $gb;   // Terabyte

    if($size < $kb) return $size." B";
    else if($size < $mb) return round($size/$kb,0)." KB";
    else if($size < $gb) return round($size/$mb,0)." MB";
    else if($size < $tb) return round($size/$gb,0)." GB";
    else return round($size/$tb,2)." TB";
}


// Display a graphic, and return GB of information
// - If Size = 0, then dont display image
/* Example
	$free =0;
	$total=0;
	$mFile = 'diskfree2.png';
	$mSize = 100;
	getDiskSpaceImage("C:",$mSize,$mFile,$free,$total);
	<img id="diskspace" height="'.$mSize.'" width="'.$mSize.'" src="'.$mFile.'"/>
*/
function getDiskSpaceImage($pDrive, $pSize, $pFile, &$pFreeGB, &$pTotalGB)
{
	try // note: Error handling for disk_total_space and disk_free_space are not handled with try / catch
	{
		// or this... apparently
		/*
		if (!dir($pDrive.'/'))
		{
			echo 'Bad';
			return false;
		}
		*/

		$total 		= round(disk_total_space($pDrive)/1024/1024,2);
		$free 		= round(disk_free_space($pDrive)/1024/1024,2);
		
		$pFreeGB 	= round($free/1024);
		$pTotalGB 	= round($total/1024);

		// Only draw a graphic if asked to
		if ($pSize >0)
		{
			$used = $total - $free; //Find used space

			$used = round(($used/$total)*100); //Calculate used space when rounded
			$free = round(($free/$total)*100); //Calculate free space

			//Generate pie chart
			define("WIDTH", $pSize); //Width may break if changed
			define("HEIGHT", $pSize); //Again height may break it when changed
			$data[0] = $used;
			$data[1] = $free;

			$img = imagecreate(WIDTH, HEIGHT); //Start the images
			// imageantialias($img, true); will only work if the GD Library is enabled

			$background = $white = imagecolorallocate($img, 255,255,255); //Set background - 112,128,144
			$black = imagecolorallocate($img, 0, 0, 0); //Set colours, black in this case

			$center_x = (int)WIDTH/2; //Calculate image centre for x
			$center_y = (int)HEIGHT/2; //Calculate image centre for y

			// Rectangle
			//imagerectangle($img, 0, 0, WIDTH-1, HEIGHT-1, $black); //Draw the backrgound border
			
			$color[0] = imagecolorallocate($img, 239,150,119); // Used  159,182,205
			$color[1] = imagecolorallocate($img, 162,239,149); // Free 198,226,255
			$last_angle = 0;

			//Draw the pie chart on the percentage of disk space
			for($i=0; $i<count($data); $i++) 
			{
				$arclen = (360 * $data[$i]) / 100;
				imagefilledarc($img, 
								$center_x, $center_y, 
								(HEIGHT-(INT)$pSize/10), 
								(HEIGHT-(INT)$pSize/10), 
								$last_angle, 
								($last_angle + $arclen), 
								$color[$i],
								IMG_ARC_PIE);
				$last_angle += $arclen;
			}

			//Turn the used space into gigabytes
			/* Not used
			$used = round(($used*$total)/100/1024,2);
			imagestring($img, 5, 250, $center + 30,
			"Used Space: ".$data[0]."%", $color[0]); //Draw info onto the main shape
			imagestring($img, 5, 250, $center + 60,
			"Free Space: ".$data[1]."%", $color[1]);
			imagerectangle($img, 240, $center+10, 390, $center+100, $black);
			imagestring($img, 5, $center_x, $center + 200,
			$used."Gb / ".($total/1024)."Gb", $black);
			*/

			// Used space / Total Space
			if ($pFile <> '')
			{
				imagepng($img, $pFile); // save image
			}
			imagedestroy($img); //Destroy the image resource
		}
		
		return true;
	}
	catch(Exception $e)
	{
		// Problem encountered 
		$pFreeGB = -1;
		$pTotalGB = -1;
		
		// echo $e->getMessage();
		return false;
	}
} // DisplayDiskSpace


// Security related

// Test  to ensure we are running secure for some items
function redirectToHTTPS()
{
  if($_SERVER['HTTPS']!=="on")
  {
     $redirect= "https://".$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
     header("Location:$redirect");
  }
}


// Menu structure
function CheckCurrentMenu($pCurrPage, $pTitle, $pText, $pBackImage)
{
  if (strpos($pCurrPage,$pTitle))
  {
    $mMenu = '<span style="float: left; background:url('.$pBackImage.'); left top no-repeat; ">'.
             '<a class="active" href="'.$pTitle.'">'.$pText.'</a></span>';
    return ($mMenu);
  }   
  else
  {
	// Return non active title
    return ('<a href="'.$pTitle.'" target="_self"><span>'.$pText.'</span></a>');
  } 
}

// Creates inactive test
function CheckMenuText($pText)
{
   return ('<p><span>'.$pText.'</span></p>');
}
  
// Echo a line and put a break on it.
function echoline($pEcho)
{
  echo "".$pEcho."<br />";
}

// Break out the names from a full name
function breakOutNames($pFullName, &$pFirstName, &$pMiddleName, &$pLastName)
{
   // Figure out comma last name
   $nameArrayComma = split(",",$pFullName);
   $pLastName = "";
   
   // Do we have comma separated name?
   if (count($nameArrayComma) > 1)
   {
      $pLastName = $nameArrayComma[0];
      $nameArray = split(" ",trim($nameArrayComma[1]));
      
      // echo "LAST: ".$pLastName."<br>";
      $pFirstName  = $nameArray[0];
      $pMiddleName = $nameArray[1];
      for ($i=1;$i<count($nameArray);$i++) 
      {
        if ($pLastName == "") 
        {
           $pLastName = $nameArray[$i];
        }
      }
     
      // ensure we are not using the same name
      if ($pMiddleName == $pLastName) 
      { 
         // We have a blank middle name
         $pMiddleName = "";
      }
      //echo "FIRST: ".$pFirstName."<br>";
   }
   else
   {
      //echo "FULL: ".$pFullName."<br>";
      $nameArray = split(" ",$pFullName);
      
      if (count($nameArray) > 2)
      {
         $pFirstName  = $nameArray[0];
         $pMiddleName = $nameArray[1];
         $pLastName   = $nameArray[2];
      }
      else
      {
         $pFirstName  = $nameArray[0];
         $pLastName   = $nameArray[1];
      }
   }
}

// Used in some applications to aid with inserting and updating posted fields
function GetSQLValueString($theValue, $theType, $theDefinedValue = "", $theNotDefinedValue = "") 
{
  //$theValue = (!get_magic_quotes_gpc()) ? addslashes($theValue) : $theValue;
  $theValue = GetSQLSafeValues($theValue);
  switch ($theType) 
  {
    case "text":
      $theValue = ($theValue != "") ? "'" . $theValue . "'" : "NULL";
      break;    
    case "long":
    case "int":
      $theValue = ($theValue != "") ? intval($theValue) : "NULL";
      break;
    case "double":
      $theValue = ($theValue != "") ? "'" . doubleval($theValue) . "'" : "NULL";
      break;
    case "date":
      $theValue = ($theValue != "") ? "'" . $theValue . "'" : "NULL";
      break;
    case "defined":
      $theValue = ($theValue != "") ? $theDefinedValue : $theNotDefinedValue;
      break;
  }
  return $theValue;
}

// Make SQL safe from SQL injects
function GetSQLSafeValues($theValue)
{
	// Ensure no SQL injections attacks
	return strtr($theValue, array(
	  "\x00" => '\x00',
	  "\n" => '\n', 
	  "\r" => '\r', 
	  '\\' => '\\\\',
	  "'" => "\'", 
	  '"' => '\"', 
	  "\x1a" => '\x1a'
	));
}


// REPORTING SECTION

// Determine where the graphics should show from
// - This is used for the engenic GPL and open environment
function IncPath()
{
  if (isset($_SESSION['IncPath']))
  { 
    return ($_SESSION['IncPath']);
  }
  else
  {
    return '';
  }
}


// Manage paging
function engRepPageSettings($pCommand, $pPageCurr, $pPageMax)
{                            
  // Determine the new page to hit
  if ($pCommand == "first")
  {
    return 0;
  }
  if ($pCommand == "prior") 
  {
    return max($pPageCurr-1, 0);
  }
  if ($pCommand == "next") 
  {
    return min($pPageCurr+1, $pPageMax);
  }
  if ($pCommand == "last")
  {
    return $pPageMax;
  }
  if (is_numeric($pCommand ))
  {
    return $pCommand;
  }
}                         

// Determine how many pages we should have
function engRepPageMax($pPageMax, $pPageLines, $pQuery_from, $database)
{
  if ($pPageMax == -1) 
  {
    $query_rsCount = "SELECT count(*) c ".$pQuery_from;
    //$rsCount       = mysql_query($query_rsCount, $database) or die(mysql_error()); //.'<br />'.$query_rsCount);
    $rsCount       = mysql_query($query_rsCount) or die(mysql_error()); //.'<br />'.$query_rsCount);
    $row_rsCount   = mysql_fetch_assoc($rsCount);  
    return floor($row_rsCount['c'] / $pPageLines);
  } 
  else
  {
    return $pPageMax;
  }
}

// Determine how many pages we should have
function engRepPageMaxNoDB($pPageMax, $pPageLines)
{
  if ($pPageMax == -1) 
  {
    //return floor($row_rsCount['c'] / $pPageLines);
    return $pPageMax+1;  // Go up by one for now
  } 
  else
  {
    return $pPageMax;
  }
}


// For counting up the lines
function engRepCounter()
{
  return $_SESSION["pageCurr"] * $_SESSION["pageLines"];
}

// Determine the limit clause
function engRepLimit($pPageCurr, $pPageLines)
{
   return $pageLimit = " LIMIT ".($pPageCurr*$pPageLines).",".$pPageLines;
}

function engRepGotoPageTop()
{
  $mCurUri  = rtrim($_SERVER['REQUEST_URI'], "/\\").'#PageTop';  // REQUEST_URI  PHP_SELF
  echo ('&nbsp;&nbsp;&nbsp;<a href="#PageTop"><img src="'.IncPath.'../images/GotoPageTop.gif" alt="Page Top" width="11" height="12" border="0" /></a>&nbsp;');  
}
function engRepGotoPageBottom()
{
  $mCurUri  = rtrim($_SERVER['REQUEST_URI'], "/\\").'#PageBottom';  // REQUEST_URI  PHP_SELF
  echo ('&nbsp;&nbsp;&nbsp;<a href="#PageBottom"><img src="'.IncPath.'../images/GotoPageBottom.gif" alt="Page Top" width="11" height="12" border="0" /></a>&nbsp;');  
}

// Displays the options for the report
// <img src="../images/First.gif" alt="First Page" width="11" height="12" border="0" />
function engRepOptions()
{
  $mCurUri  = rtrim($_SERVER['REQUEST_URI'], "/\\");  // REQUEST_URI  PHP_SELF
  
  // Remove all previous commands
  // Note: "page" command must be at end of list, or update this code with regular expressions
  $mFind = strpos($mCurUri,'&page=');
  if ($mFind > 0)
  {
     $mCurUri = substr($mCurUri,0,$mFind);
  }
  else
  {
    $mFind = strpos($mCurUri,'?page=');
    if ($mFind > 0)
    {
       $mCurUri = substr($mCurUri,0,$mFind);
    }
  }
  
  // &page=next   &page=prior  &page=first  &page=last
  /*
  $mCurUri = str_replace("&page=next",  '', $mCurUri);
  $mCurUri = str_replace("&page=prior", '', $mCurUri);
  $mCurUri = str_replace("&page=first", '', $mCurUri);
  $mCurUri = str_replace("&page=last",  '', $mCurUri);
  $mCurUri = str_replace("?page=next",  '', $mCurUri);
  $mCurUri = str_replace("?page=prior", '', $mCurUri);
  $mCurUri = str_replace("?page=first", '', $mCurUri);
  $mCurUri = str_replace("?page=last",  '', $mCurUri);
  */

  
  // Check to see if there are already parameters
  $mAddType = '?';
  if (strpos( $mCurUri, "?") > 0) 
  {
     $mAddType = '&';
  }  

  // If we havent defined the report yet, then show nothing
  if ($_SESSION["pageMax"] == -1)
  {
     $mOption1 = '<img src="'.IncPath().'../images/FirstOff.gif" alt="First Page"    width="11" height="12" border="0" />&nbsp;';
     $mOption2 = '<img src="'.IncPath().'../images/PrevOff.gif"  alt="Previous Page" width="9"  height="12" border="0" />&nbsp;';
     $mPageInfo = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
     $mOption3 = '<img  src="'.IncPath().'../images/NextOff.gif"  alt="Next Page"     width="9"  height="12" border="0" />&nbsp;';
     $mOption4 = '<img  src="'.IncPath().'../images/LastOff.gif"  alt="Last Page"     width="11" height="12" border="0" />&nbsp;';
  
  }
  else
  {
     $mPageInfo = ($_SESSION["pageCurr"]+1)." of ".($_SESSION["pageMax"]+1)."&nbsp;";
     
     // If we are on the first page, then dont allow the previous stuff
     if ($_SESSION["pageCurr"] == 0) 
     {
       $mOption1 = '<img src="'.IncPath().'../images/FirstOff.gif" alt="First Page"    width="11" height="12" border="0" />&nbsp;';
       $mOption2 = '<img src="'.IncPath().'../images/PrevOff.gif"  alt="Previous Page" width="9"  height="12" border="0" />&nbsp;';
     }
     else
     {
       $mOption1 = '<a href="'.$mCurUri.$mAddType.'page=first"><img src="'.IncPath().'../images/First.gif" alt="First Page"    width="11" height="12" border="0" /></a>&nbsp;';
       $mOption2 = '<a href="'.$mCurUri.$mAddType.'page=prior"><img src="'.IncPath().'../images/Prev.gif"  alt="Previous Page" width="9"  height="12" border="0" /></a>&nbsp;';
     }
     // If we are on the last page, then dont allow the last stuff 
     if ($_SESSION["pageCurr"] == $_SESSION["pageMax"]) 
     {
       $mOption3 = '<img  src="'.IncPath().'../images/NextOff.gif"  alt="Next Page"     width="9"  height="12" border="0" />&nbsp;';
       $mOption4 = '<img  src="'.IncPath().'../images/LastOff.gif"  alt="Last Page"     width="11" height="12" border="0" />&nbsp;';
     }
     else
     {
       $mOption3 = '<a href="'.$mCurUri.$mAddType.'page=next"><img  src="'.IncPath().'../images/Next.gif"  alt="Next Page"     width="9"  height="12" border="0" /></a>&nbsp;';
       $mOption4 = '<a href="'.$mCurUri.$mAddType.'page=last"><img  src="'.IncPath().'../images/Last.gif"  alt="Last Page"     width="11" height="12" border="0" /></a>&nbsp;';
     }
  }
  
  $mSpacer  = "&nbsp;&nbsp;";
  echo($mOption1.$mSpacer.
       $mOption2.$mSpacer.
       $mPageInfo.$mSpacer.
       $mOption3.$mSpacer.
       $mOption4);
}


// Export a SQL statement to CSV filename
function export_sql2csv($sql, $filename, $del)
// This function takes an SQL query and the field delimiter
// to send the result of the query to a file on the client's computer
{
    $existed = file_exists($filename); // test the file
	if ($existed) 
	{
		$permission = is_writable($filename);
		if (!$permission) 
		{
			echo "<script> alert('Export file not writeable!'); window.history.go(-1);</script>\n";
			exit();
		} // if
	} // if

	$file=fopen($filename, "w");


	// Check to see if the necessary tables exist
	$qry = $sql; //SELECT * FROM '.$table;
	if (!$result = mysql_query($qry))
	{
		echo("ERROR: SQL Statement read\n"); 
		die(mysql_error());
		exit();
	}

	
	// Generate the whole thing as HTML
	if (1 == 2)
	{
		$row = mysql_fetch_assoc($result);
		print '<table><tr>';
		foreach($row as $name => $value) 
		{
			print "<th>$name</th>";
		}
		print '</tr>';
		while($row) 
		{
			print '<tr>';
			foreach($row as $value) 
			{
				print "<td>$value</td>";
			}
			print '</tr>';
			$row = mysql_fetch_assoc($result);
		}
		print '</table>';	
	}
	
	
	
  	// set delimiter to a default value if not set...
  	if (!($del)) $del=", "; 

	//mysql_fetch_object($result);
	$data=""; // var to hold the processed results
	
	// lines in the csv file
	$row = mysql_fetch_assoc($result);
	if ($row)
	{
		// only the first field does not get a delimiter
		$writeDelimiter = FALSE;
		foreach($row as $name => $value) 
		{
			if($writeDelimiter) $data .= $del;
			$data .= $name;
			$writeDelimiter = TRUE;
		}
		$data .= "\n";
	}
	
	do // We got the first row above, so process it again for the line	
	{
		//echo "---------------------------------".$row[job_desc]. "\n";

        // only the first field does not get a delimiter
		$writeDelimiter = FALSE;
		// fields in the csv file
		foreach ($row as $field)
		{
			// Replaces a double quote with two double quotes
			$field=str_replace("\"", "\"\"", $field);
			
			// Adds a delimiter before each field (except the first)
			if($writeDelimiter) $data .= $del;

			// If we have a comma in the field, then quote wrap the field
			if (strpos($field, ","))
			{
				// Wrap 
				$data .= '"'.$field.'"';				
			}
			else
			{
				$data .= $field;
			}
			$writeDelimiter = TRUE;
		} // foreach
		// add a newline to every line
		$data .= "\n";
		//echo $data;
  	} while ($row=mysql_fetch_array($result, MYSQL_ASSOC));
	
	if ($data <> "")
	{
		fwrite($file, $data);
		fclose($file);

		return true;
	}
	else
	{
		fclose($file);
		unlink($file);
		// nothing to write
		return false;
	}
	
} // end function
?>
