<?php
// Simple functions for dictation system

function tack_orig($pfilename)
{
	return (str_replace('.', '_orig.', $pfilename));
}

function untack_orig($pfilename)
{
	return (str_replace('_orig.', '.', $pfilename));
}

function filename_xfer($pfilename)
{
	return (str_replace(FTPWAVEXT, FTPXFEREXT, $pfilename));
}

// Generate the name of what the original dictation should be for the web site
// eg: webDictationFile($incPath, $_SESSION['userclientid'], $row_rsSearchResultDate['file_name'])
function webDictationFileName($pIncPath, $pClientId, $pDictationOriginalFileName)
{
	// Find the file root for the webside
	// $row_rsSearchResultDate['web_dir_loc']
	$clientMediaWeb = $pIncPath.CLIENT_MEDIA_AREA.'/'.'client_'.zeroFill($pClientId,5);				
	
	// Add the download reference - The new name would not include the _orig.
	// -- See if it is in the first level directory
	$mWavFile = $clientMediaWeb.'/'.
				untack_orig($pDictationOriginalFileName);
	if (file_exists($mWavFile))
	{
		return $mWavFile;	
	}
	
	// If they are in the recordings directory
	$mWavFile = $clientMediaWeb.'/recordings/'.
				untack_orig($pDictationOriginalFileName);
	if (file_exists($mWavFile))
	{
		return $mWavFile;	
	}
	
	// If nothing found...
	return null;
}

// Wrap file with link 
function webDictationFileLink($pWavFile, $pFileLinkDetail, $pClass)
{
	$mWavLink =	'<a href="'.$pWavFile.'"';
	if ($pClass <> '')
	{
		$mWavLink .=	' class="style10"';
	}
	// Wrap it
	$mWavLink .=	'>'.$pFileLinkDetail.'</a>';
	return $mWavLink;
}

// Generate the name of what the original dictation should be for the web site
// eg: webDictationFile($incPath, $_SESSION['userclientid'], $row_rsSearchResultDate['file_name'])
function webPhysicianFileName($pIncPath, $pClientId, $pFileName)
{
	// Find the file root for the webside
	// $row_rsSearchResultDate['web_dir_loc']
	$clientMediaWeb = $pIncPath.CLIENT_MEDIA_AREA.'/'.'client_'.zeroFill($pClientId,5);				
	
	// Add the download reference - The new name would not include the _orig.
	$mWavFile = $clientMediaWeb.'/'.
				untack_orig($pFileName);
	return $mWavFile;
}

?>