<?php
/* 
emailWorkUnit - Email creation and sending using Swift for TeleFlowRelay
- Created by: Vern Baker
- Last updated: 2009
- GPL license
*/

// Send a comma separted list of emails
function sendRelayEmail($pToEmailList, $pCCEmailList, $pTitle, $pMsg)
{
	//Connect to SMTP
	$smtp = new Swift_Connection_SMTP(EMAIL_SMTP, EMAIL_PORT);
	$smtp->setUsername(EMAIL_STMP_USER);
	$smtp->setpassword(EMAIL_STMP_PASS);
	$smtp->attachAuthenticator(new Swift_Authenticator_LOGIN());
	$swift = new Swift($smtp);

	
	// Create the message using LocalSettings_EmailTemplates.php
	$message = new Swift_Message($pTitle, $pMsg, "text/html"); 
	 
	$recipients 		=& new Swift_RecipientList();

	// Get the TO list
	$mComponents = explode(",", $pToEmailList);
	foreach ($mComponents as $mEachOne)
	{
		$mText = trim($mEachOne);
		$recipients->addTo($mText, $mText); 
	}		

	// Get the CC list
	if ($pCCEmailList <> '')
	{
		$mComponents = explode(",", $pCCEmailList);
		foreach ($mComponents as $mEachOne)
		{
			$mText = trim($mEachOne);
			$recipients->addCc($mText, $mText); 
		}		
	}
	
	//Now check if Swift actually sends it
	if ($swift->send($message, $recipients, EMAIL_FROM_ADDR))
	{	
		//echo "Sent!!";
		return true;  //Reset pass sent succesfully
	}
	else
	{
		//else echo "Failed";
		return false;  //Reset pass attempt failed
	}
} // sendRelayEmail


/*
	// Connect to client
	$db_selected_yn  = $database->selectClientDatabaseByMasterClientId($mClient_id);
	
	$mResult = 'Nothing happened';	
	//Connect to SMTP - Prepare to email
	if (EMAIL_SMTP <> "")
	{
		$msg = '';
		// Mark the exception
		$msg .= '<b>ATTENTION: This is ONLY a test message</b><br /><br />';				
		$msg .= 'The following information is meaningless';		
		
		try
		{
			// Create a Swift email connection
			$smtp = new Swift_Connection_SMTP(EMAIL_SMTP, EMAIL_PORT);
			$smtp->setUsername(EMAIL_STMP_USER);
			$smtp->setpassword(EMAIL_STMP_PASS);
			$swift = new Swift($smtp);
					
			// Create the message contents
			$mSubject = "TEST EMAIL";
			$message = new Swift_Message($mSubject, $msg, "text/html");

			// Create the recipients list 
			// HELP: http://www.swiftmailer.org/wikidocs/v3/sending/multiple
			$recipients =& new Swift_RecipientList();

			// Add the recipents as found in the Client database
			$mResult = EmailUserBroadcast('CLIENT', $recipients);					
			
			// ====================================================
			// Blind send using: Swift_Address(email address, Sender name)
			$swift->send($message, $recipients, new Swift_Address(EMAIL_FROM_ADDR, EMAIL_MARKETINGNAME));
			// ====================================================
			
		}				
		catch(Exception $e)
		{
			//return 2; // Outright ERROR
			echo "Error!";
		}		
	}
	else
	{
		// STMP is disabled
		//return 2; // SMTP is blank
		echo "Error!";
	}
		
	echo "Result: ".$mResult;
*/


// Send a Swift Recipients object, and add users that are applicable from the current database
// * Returns number of users emailed
// * A return of -1 = General error
// eg:  email_broadcast_groups may contain someting like:  'CLIENT_CC,SPECIAL';
function EmailUserBroadcast($pBroadcastGroup, &$pRecipients)
{
	global $database;
	
	//LogTextToFile('emailed.log', "Email Attempt for ".$pBroadcastGroup." \n");	

	$q = "
SELECT 
	u_full_name,
	u_first,
	u_last,
	u_email,
	email_broadcast_setting,
	email_broadcast_groups,
	u_permissions_level,
	u_timestamp	
FROM 
	".TBL_USERS."
WHERE 
	email_broadcast_setting = 'ACTIVE'
and u_status = 'ACTIVE'
ORDER BY 
	u_first,
	u_last
";
	
	//echo $q; //die;
	//LogTextToFile('emailed.log', $q."\n");	

	$result = $database->query($q);
	//$result = mysql_query($q);

	/* Error occurred, return given name by default */
	$num_rows = mysql_numrows($result);
	if(!$result || ($num_rows < 0))
	{		
		//LogTextToFile('emailed.log', "ERROR \n");	
		return -1; //"Error displaying info";
	}
	
	if($num_rows == 0)
	{
		//LogTextToFile('emailed.log', "Empty \n");	
		return 0; //"Database table empty";
	}
	
	$mEmailList = '';
	$mCount = 0;
	// List all email recipients
	for($mLoop=0; $mLoop<$num_rows; $mLoop++)
	{
		$u_full_name 				= mysql_result($result, $mLoop, "u_full_name");
		$u_first 					= mysql_result($result, $mLoop, "u_first");
		$u_last 					= mysql_result($result, $mLoop, "u_last");
		$u_email 					= mysql_result($result, $mLoop, "u_email");
		$email_broadcast_setting 	= mysql_result($result, $mLoop, "email_broadcast_setting");
		$email_broadcast_groups 	= mysql_result($result, $mLoop, "email_broadcast_groups");
        $u_permissions_level 		= mysql_result($result, $mLoop, "u_permissions_level");
		$u_timestamp				= mysql_result($result, $mLoop, "u_timestamp");
         
		//LogTextToFile('emailed.log', "Groups: ".$email_broadcast_groups."\n");	 
		
		// See if we have the group as mentioned
		$mEmailGroups = explode(",", $email_broadcast_groups );
		foreach ($mEmailGroups as $mGroup)
		{
			//echo "Checking: ".$pBroadcastGroup." against ".$mGroup."<br />";
			if (strpos(','.strtoupper($mGroup), strtoupper($pBroadcastGroup)) > 0)
			{
				//LogTextToFile('emailed.log', 'Found: '.$mGroup."\n");
			
				$mEmailSettings 	= explode("_", $mGroup );
				$mEmailGroup 		= $mEmailSettings[0]; 
				if (isset($mEmailSettings[1]))
				{
					$email_broadcast_level	= strtoupper($mEmailSettings[1]); 
				}
				else
				{
					$email_broadcast_level	= 'TO';
				}
								
				//echo ('Emailing '.$mEmailGroup.' by '.$mEmailLevel."<br />"); 
				// Found one
				// Make sure valid email
				if ($u_email <> '')
				{	
					// Found another one
					$mCount++;
					$mEmailList = $email_broadcast_level.': '.$u_email.' '.$mName.' ';
					
					// Check for admin
					$mName = trim($u_first.' '.$u_last);
					if ($u_permissions_level == 9) // Admin
					{
						$mName .= ' (Admin)';
					}

					// Only display non-deleted                      			
					if ((strtoupper($email_broadcast_level) == 'TO') ||
						(strtoupper($email_broadcast_level) == ''))               
					{		
						//echo('Adding To '.$mName);
						$pRecipients->addTo($u_email, $mName);   // They want this one
					}
					else if (strtoupper($email_broadcast_level) == 'CC')                  
					{		
						//echo('Adding Cc '.$mName);
						$pRecipients->addCc($u_email, $mName);
					}
					else if (strtoupper($email_broadcast_level) == 'BCC')                  
					{		
						//echo('Adding Bcc '.$mName);
						$pRecipients->addBcc($u_email, $mName);
					}
				}
			}
		} // Loop through groups
		 
	}
	
	if ($mCount > 0)
	{
		//LogTextToFile('emailed.log', 'Email List: '.$mEmailList."\n");	
	}
	return  $mCount;  // Return the number of people emailed
} // EmailUserBroadcast

