<?php
// Simple functions for file management

// Get a list of all the files in a single directory
function dirList($directory) 
{

    // create an array to hold directory list
    $results = array();

    // create a handler for the directory
    $handler = opendir($directory);

    // keep going until all files in directory have been read
    while ($file = readdir($handler)) {

        // if $file isn't this directory or its parent, 
        // add it to the results array
        if ($file != '.' && $file != '..')
            $results[] = $file;
    }

    // tidy up: close the handler
    closedir($handler);

    // done!
    return $results;
}


// Delete files of an ext type that are 
/*
	// Delete MP3 and WAV files that are older than 24 hours
	$fileExts = array();
	$fileExts[] = 'mp3';
	$fileExts[] = 'wav';
	$mTotal = deleteOldFiles('.', $fileExts, 24*3600);
*/
function deleteOldFiles($pDir, $pFileExtList, $pAgeSeconds)
{
	$mDeleteCount = 0;
	$mList = dirlist($pDir);
	
	// Make sure we have a trailing slash
	$mDir = $pDir;
	if (rightstr($mDir,1) <> '/')
	{
		$mDir .= '/';
	}
	
	// Each file
	foreach ($mList  as $mFile)
	{
		$mExt = strtolower(getFileExtension($mFile));
		if (in_array($mExt, $pFileExtList))
		{
			// Read file creation time
			$mFileCreationTime = filectime($mDir.$mFile);
			// Calculate file age in seconds
			$mFileAge = time() - $mFileCreationTime; 
			
			if ($mFileAge > $pAgeSeconds)
			{
				//echo ($mFile.' '.$mFileAge.'<br />');
				unlink($mDir.$mFile);
				$mDeleteCount++;
			}
		}
	}
	
	return $mDeleteCount++;	
} // deleteOldFiles


?>