<?php
/*
* TeleFlow Library
*
* Copyright (C) 2008 engenic (engenic.com)
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with this program; if not, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
* http://www.gnu.org/copyleft/gpl.html
*/

// Get the TeleFlow Log Folder 
function getTeleFlowLogFolder($pUrl, $pMapOverRide)
{
	// If we are provided with a mapped location, override immediately
	if (($pMapOverRide <> '') && (file_exists($pMapOverRide)))
	{
		return $pMapOverRide;
	}
	else
	{
		$authresult = ffl_HttpGet($pUrl);
		$doc = $authresult['body'];
		$xmldoc = new DOMDocument();
		$xmldoc->loadXML($doc);

		$theMonitor = $xmldoc->getElementsByTagName('TFMonitor')->item(0);
		// Test to see if we have the log directory defined
		$TeleFlowLogFolder = $theMonitor->getAttribute("LogFolder");
		//echo $TeleFlowLogFolder; die;
		
		return $TeleFlowLogFolder;
	}
}  // getTeleFlowLogFolder


// Scan the list for the Step Title
// Note:  XMLStepInformationLoad must be called, and session_start() called to use this 
// See - tfmonitor.php
// Usage: $mArray =  explode(',',XMLStepInfo("Play"),2);   // ID, Description, and link
// [0] =  Id
// [1] = Hint
// [2] = Link
function XMLStepInfo($pSearchStep) // eg:  'Wait' or "Wait For Call'
{
	global $websiteLibrary, $cTeleFlowStepsXML, $cTeleFlowHelpKB, $incPath;

    // Default return for no find
    $mResult = ',,'.$pSearchStep;
    
    // Find the name of a step
	if (!isset($_SESSION['StepNames']) || ($_SESSION['StepNames'] == '')) 
	{
		// Load the Step XML
		$_SESSION['StepNames'] = XMLStepInformationLoad($websiteLibrary.$cTeleFlowStepsXML, $cTeleFlowHelpKB);
	}	
	//LogTextToFile($incPath.SYSTEM_LOGFILES."Debug.log", $_SESSION['StepNames']);  // ".Date('Y-m-d')."
	
    $mArray = explode(chr(13).chr(10),$_SESSION['StepNames'],200); // scan 200 steps max
    $mMax = 10;
    $mCounter = 1;
    $mStepLabNo = 0;
    foreach ($mArray as $mLine)
    {
       $mArrayLine = explode(',',$mLine,10);
       
       // Make certain the "Wait" does not find "Wait for Call" by including a comma
       if (stripos($mArrayLine[0].',', $pSearchStep.',') === 0)
       {
          $mResult = $mArrayLine[1].",".$mArrayLine[2].",".$mArrayLine[3];
          break;
       }
    }     
    return $mResult;
} // XMLStepInfo


// Load XML information into a session variable
// [0] = Title
// [1] =  Id
// [2] = Hint
// [3] = Link
function XMLStepInformationLoad($pStepsXML,$pWebKB)
{
	$mStepRec = '';

	$mXMLFile = $pStepsXML;

	if (file_exists($mXMLFile))
	{ 		
		$xml = simplexml_load_file($mXMLFile);

		foreach($xml->children() as $child)
		{
			//echo $child->getName() . ": " . $child . "<br />";
			if ($child->getName() == "TeleFlowStep")
			{
				$mTitle = '';
				$mID = '';
				$mHint = '';
				foreach($child->attributes() as $a => $b)
				{
					if ($a == "Title")
					{
						//echo $a,'="',$b,"\"</br>";
						$mTitle = $b;
					}
					if ($a == "ID")
					{
						//echo $a,'="',$b,"\"</br>";
						$mID = $b;
					}
					if ($a == "Hint")
					{
						//echo $a,'="',$b,"\"</br>";
						$mHint = $b;
					}
				}
			  
				// Add to the list if its valid
				if (($mTitle <> '') and ($mTitle <> '@@@'))
				{
					// Process the Link definition
					$mHelpLink = '?title=TeleFlow_Step_'.$mID;
					$mStepLink = '<a href="'.$pWebKB.$mHelpLink.'" target="_blank">'.$mTitle.'</a>';           
					$mStepRec .= $mTitle.','.$mID.','.$mHint.','.$mStepLink.chr(13).chr(10);
					//echo $mTitle.','.$mID.','.$mHint."</br>";
				}
			}
		}		
	}		
	return $mStepRec;
}  // XMLStepInformationLoad
?>